#include "general.h"
#include <errno.h>
#define PM 0644		   /* Mode r&w for owner, r for everyone else */
extern long lb;		   /* last byte handled (zeroed when file returned) */
static int fd1;            /* file descriptor */

bgetfd(fn,iact)
/* For a fn filename, returns the fd attached to it. 
   It is opened (if iact<=0) or created (if iact>0) and placed in the table.
   An error message is printed and the program aborted if:
        1. A file to be opened cannot be.
        2. A file to be created cannot be.
*/
char *fn;
int iact;
{
   extern int errno;
   struct stat finfo;
   int i,ity,ier;
   static char oldfn[NAMLN];	/* name of the current file */

   if (strcmp(fn, oldfn) == 0)
         return(fd1);
   breturned();
   if(iact<=0){				/*file to be read or overwritten*/
      ier = stat(fn,&finfo);	        /*so check status of it*/
      if(ier==-1){
         fprintf(stderr,"Status of file %s unknown.\n",fn);
         if(errno==13)
            fprintf(stderr,"Not permitted to examine it -");
         fprintf(stderr," program aborts...\n");
         exit(15);
      }
      if(finfo.st_uid==getuid()){	/*see if the file has the same uid as the process*/
         ity=open(fn,O_RDWR,PM);		/*if so, open for read and write, since we may want both*/
         if(ity==-1){		/*error off on failed open*/
            fprintf(stderr,"File %s could not be opened.\n",fn);
            fprintf(stderr,"Program aborts...\n");
            exit(15);
         }
      }
      else{					/*if not*/
         ity=open(fn,O_RDONLY,PM);		/*open for read only*/
         if(ity==-1){		/*error off on failed open*/
            fprintf(stderr,"File %s could not be opened.\n",fn);
            fprintf(stderr,"Read permission not available - program aborts...\n");
            exit(15);
         }
      }
      lseek(ity,0L,0);		/*rewind to start of file*/
   }
   else{		/*create file, truncating to zero in case an old one exists*/
      ity=open(fn,O_RDWR|O_CREAT|O_TRUNC,PM);
      if(ity==-1){
         fprintf(stderr,"Could not create file %s. Program aborts.\n",fn);
         exit(15);
      }
      close(ity);			/*have to return and then open file to*/
      ity=open(fn,O_RDWR,PM);		/*be able to read it in same program call*/
      lseek(ity,0L,0);
   }
   fd1 = ity;
   strcpy(oldfn, fn);
   return(ity);
}

breturned()
/* routine for closing the current file */
{
   close(fd1);
   lb = 0L;
   fd1 = -1;
   return;

}
