#include "general.h"
#include <errno.h>
#include <string.h>
#include <sys/uio.h>
#include <unistd.h>
long lb;	/*position last reached*/

bioreder(fn,rl,rh,nbr,lastp)
/*  Prints out error message on read; if >0 bytes are read, gives the  */
/*  probable last term of the file, otherwise prints out most likely   */
/*  source of error */
char *fn;	/* file name */
int nbr;	/* number of bytes read */
long rl,rh,lastp;	/* reading margins and last point read */
{
   extern int errno;
/*   extern char *sys_errlist[]; */
   fprintf(stderr,"Error in reading from file %s\n",fn);
   fprintf(stderr,"Terms to be read were %ld through %ld.\n",rl,rh);
   if(nbr>0){
      fprintf(stderr,"Partial read - last point read was %d\n",lastp);
      fprintf(stderr,"Program aborts...\n");
   }
   else if (nbr==0)
      fprintf(stderr,"Attempt to read after EOF. Program aborts...\n");
   else {
      fprintf(stderr,"Bad read: ( %s ), program aborts...\n",strerror(errno));
   }
}

byteio_(list,rlx,rhx,filename,fnlength,nrecx,dum1)
/* Fortran callable routine for reading and writing bytes on disk */
/* Arguments:  list - buffer; rlx - byte # to start reading/writing from; */
/* rhx - byte # to stop reading/writing at; filename - name of disk file; */
/* fnlength - length of the file name; nrecx - action */
/* (0 read, -1 write, 1 write over existing file) */
/* Note: this procedure does very much differ from realio, etc. - at any */
/* particular moment there is only one open file; file gets automatically */
/* closed when calling routine asks to open next file or when program */
/* terminates.  Function getfd() used in this procedure also differs from */
/* standard getfd() which is part of NIOLIB. */


char filename[];
short *fnlength;
short list[];
long *rlx,*rhx;
long *nrecx;
long dum1;
{
   int i,lun,nb,nbr,nrec;
   long lastp,rl,rh,sp,offset;
   char fn[NAMLN];
   
   rl = *rlx;
   rh = *rhx;
   nrec = *nrecx;
   for (i=0; i<(*fnlength); i++)
      fn[i] = filename[i];    /* need filename in normal (0 terminated) form */
   fn[i] = '\0';

   lun = bgetfd(fn,nrec);	/* let's get file descriptor */
   /* find place to start, and seek to there, either from start of file */
   /* or last place touched within it */
   sp = rl - 1 + OFFST;	/*start byte in the file*/
   nb = rh-rl+1;		/*number of bytes to read*/
   offset = sp-lb;
   if(offset< -lb/2)
      lseek(lun,sp,SEEK_SET);
   else
      lseek(lun,offset,SEEK_CUR);
   if(nrec!=0){
      nbr = write(lun,list,nb);		/*write bytes*/
      if(nb!=nbr){
         fprintf(stderr,"Error in BYTEIO in writing to file %s\n",fn);
         fprintf(stderr,"Terms to be written were %ld through %ld, or %d bytes.\n",rl,rh,nb);
         fprintf(stderr,"%d bytes actually written. Program aborts.\n",nbr);
         exit(15);
      }
   }
   else {
      nbr = read(lun,list,nb);		/*read bytes*/
      if(nb!=nbr){
         lastp = (sp-OFFST+nbr);
         bioreder(fn,rl,rh,nbr,lastp); 
         exit(15);
      }
   }
   lb = sp+nb;		/*store place stopped at for later use*/
   return;
}
