gbytes_(ia,ib,ns,nb,is,n)
/*
 $$$$$ calls gbyte $$$$$

     gbytes is a general purpose byte unpacker meant to be fortran
     callable:

            dimension ia(),ib()
            call gbytes(ia,ib,ns,nb,is,n)

     where ia is treated as a bit string.  n bytes of length nb bits
     each are extracted from ia and placed in sucessive words of ib
     (padded to the left with zeros).  ns bits of ia are skipped
     before extracting the first byte.  is bits are skipped between
     sucessive bytes.  Programmed on 3 December 1979 by R. Buland.
*/
int ia[],ib[],*ns,*nb,*is,*n;
{
int i,incr,skip;

skip = *ns;  /* skip is the absolute skip to the next byte */
incr = *nb+*is;
for(i = 0;i < *n;++i) {
  gbyte_(ia,&ib[i],&skip,nb);  /* extract the next byte */
  skip = skip+incr;
  }
return;
}

#define WORDSIZE  32				/* vax, 32 bits/'word' */
#define MASK	  (unsigned)0xffffffff		/* word full of 1's (vax) */

gbyte_(ia,ib,ns,nb)
/*
 $$$$$ calls no other routine $$$$$

     gbyte_ is a general purpose byte unpacker meant to be fortran
     callable:

            dimension ia()
            call gbyte(ia,ib,ns,nb)

     where ia is treated as a bit string.  ns bits of ia are skipped
     (nb: bits are skipped starting with high-order bit of word - dh)
     and a byte of nb bits is extracted and placed in the low order
     end of ib (zero padded to the left).  Programmed on 3 December
     1979 by R. Buland.
     vaxinated 7/85  dh
     made it work correctly 4/86 dh
*/
int ia[],*ib,*ns,*nb;
{
int word,bit;

word = *ns/WORDSIZE;  		/* find the word of ia where the byte begins */
bit = *ns%WORDSIZE+*nb;  	/* find the bit of ia where the byte ends */

if(bit <=WORDSIZE) *ib = (ia[word]>>(WORDSIZE-bit))&(MASK>>(WORDSIZE-*nb)); 
else *ib = ((ia[word]<<(bit-WORDSIZE))&(MASK>>(WORDSIZE-*nb)))|
             ((ia[word+1]>>((WORDSIZE*2)-bit))&(MASK>>((WORDSIZE*2)-bit)));
return;
}
