sbytes_(ia,ib,ns,nb,is,n)
/*
 $$$$$ calls sbyte_ $$$$$

     sbytes is a general purpose byte packer meant to be fortran
     callable:

            dimension ia(10),ib(10)
            call sbytes(ia,ib,ns,nb,is,n)

     where ia is treated as a bit string.  The meaning of the arguments
     is identical to gbytes_ except that the low order nb bits of each
     of the first n words of ib are inserted into the appropriate bytes
     of ia.  Bits of ia which are skipped are left undisturbed.
     Programmed on 3 December 1979 by R. Buland.
*/
int ia[],ib[],*ns,*nb,*is,*n;
{
int i,skip,incr;

skip = *ns;  /* skip is the absolute skip to the next byte */
incr = *nb+*is;
for(i = 0;i < *n;++i) {
  sbyte(ia,&ib[i],&skip,nb);  /* insert the next byte */
  skip=skip+incr;
  }
return;
}
#define WORDSIZE	32			/* 32 bits/integer (vax) */
#define MASK	    0xffffffff			/* vax */

sbyte_(ia,ib,ns,nb)
/*
 $$$$$ calls no other routine $$$$$

     sbyte_ is a general purpose byte packer meant to be fortran
     callable:

            dimension ia(10)
            call sbyte(ia,ib,ns,nb)

     where ia is treated as a bit string.  The meaning of the arguments
     is identical to gbyte_ except that the low order nb bits of ib are
     inserted into ia after skipping ns bits.  The rest of ia is left
     undisturbed.  Programmed on 3 December 1979 by R. Buland.
     vaxinated 7/85  dh
*/
int ia[],*ib,*ns,*nb;
{
int word,bit,cnt;
unsigned ic,m1,mask = MASK;

word = *ns/WORDSIZE;  /* find the word of ia where the byte begins */
bit = *ns%WORDSIZE+*nb;  /* find the bit of ia where the byte ends */
m1 = mask>>(WORDSIZE-*nb);  /* m1 is zero except the low order nb bits */
cnt = abs(WORDSIZE-bit);
ic = *ib&m1;  /* keep only the low order nb bits of ib */
if(bit<=WORDSIZE) ia[word]=(ia[word]&(~(m1<<cnt)))|(ic<<cnt);
else {
  ia[word]=(ia[word]&(~(m1>>cnt)))|(ic>>cnt);
  cnt=(WORDSIZE<<1)-bit;
  ia[word+1]=(ia[word+1]&(~(m1<<cnt)))|(ic<<cnt);
  }
return;
}
