      subroutine edcon2(ifed,ned,gap,ioff,idir,ifl)
c
c  Edcon modified so that file number (ifed) is a parameter.
c
c  Goes between edits file on disk and arrays gap and ioff.  Gap(1,n) is
c  term number of last good point before the n-th data gap; gap(2,n) is 
c  term number of first good point after it; and ioff(n) is the offset
c  across it.
c
c  If idir > 0 fills arrays from edits file. Ned is input as the external
c  dimension of gap and ioff (and hence the maximum number of edits that 
c  can be handled), and returned as the actual number of edits.
c  Ifl is the file length; edits which are after this point will be ignored,
c    unless ifl is set to 0
c
c  If idir <= 0 writes out edits file from data in arrays; edits file
c  will have a minimum length set by the common block minedt (below)
c
c  Calls intio,return
c
      dimension ied(3,50),gap(2,ned),ioff(ned)
      mlen = 480
c Mlen is the minimum size of file to write, specified as number of edits
      irl = 2
      irs = 1
      nc = 1
      jj = 1
      ndum = 0
      if(idir.le.0) go to 11
      call intio(nedac,1,1,ifed,0)
      if(nedac.eq.0) then
	 ned=nedac
         return
      endif
      if(nedac.le.ned) go to 3
c Error off - more edits in file than there are room for
      write(6,102) nedac,ned
 102  format(' there are',i4,' edits in this file, more than the',i4,
     1 ' allowed for')
      stop
c Read in edits 50 at a time
 3    ned = nedac
      nedsec = (ned-1)/50 + 1
      irnt = 3*ned + 1
      do 7 kk = 1,nedsec
      irl = 2 + 150*(kk-1)
      irh = min(irl+149,irnt)
      call intio(ied,irl,irh,ifed,0)
      ned = ned - 50
      jjl = min(50,ned+50)
      do 5 jj =1,jjl
c Skip over dummy edits
      if(ied(1,jj).eq.30000.and.ied(2,jj).eq.0.and.ied(3,jj).eq.1)
     1    irs = irs + 30001 
      if(ied(1,jj).eq.30000.and.ied(2,jj).eq.0.and.ied(3,jj).eq.1)
     1    go to 5
      gap(1,nc) = irs + ied(1,jj)
      gap(2,nc) = gap(1,nc) + ied(3,jj)
      ioff(nc) = ied(2,jj)
      irs = gap(2,nc)
      nc = nc + 1
c check for edit that is off end-truncate or discard edit, and exit
      if(ifl.gt.0.and.gap(2,nc).gt.ifl) then
         if(gap(1,nc).le.ifl) gap(2,nc) = ifl
         if(gap(1,nc).gt.ifl) nc = nc - 1
         go to 9
      endif          
 5    continue
 7    continue
 9    ned = nc-1
      call retnio(ifed)
      return
c
c  Write out edits - first write out a file 1441 terms long, for conformity
c    with the number used in the header
c
 11   continue
      do 10 kd=1,ned
      if(gap(2,kd)-gap(1,kd).ge.32767) write(6,111)
     1                                      gap(1,kd),gap(2,kd)
 111  format(' edit from ',f7.0,' to ',f7.0,' is too long',/,
     1 ' for a short-integer edits file--use a long-integer one')
 10   continue
      nxx=0
      call intio(nxx,1441,1441,ifed,1)
      if(ned.eq.0) then
         write(6,103) ifed
 103     format(' Zero edits in file',i5)
         call retnio(ifed)
         return
      endif
c  first scan through to see number of dummy edits
 115  if(gap(1,nc)-irs.lt.32767) go to 12
      ndum = ndum + 1
      irs = irs + 30001
      go to 115
 12   irs = gap(2,nc)
      nc = nc + 1
      if(nc.ne.ned+1) go to 115
      irs = 1
      nc = 1
      ndum = ned + ndum
c write out the number of edits
      call intio(ndum,1,1,ifed,-1)
 13   if(gap(1,nc)-irs.lt.32767) go to 15
c Insert dummy edits
      ied(1,jj) = 30000
      ied(2,jj) = 0
      ied(3,jj) = 1
      irs = irs + 30001
      jj = jj + 1
      if(jj.ne.51) go to 13
      go to 17
 15   ied(1,jj) = gap(1,nc) - irs
      ied(2,jj) = ioff(nc)
      ied(3,jj) = gap(2,nc) - gap(1,nc)
      irs = gap(2,nc)
      jj = jj + 1
      nc = nc + 1
      if(jj.ne.51.and.nc.ne.ned+1) go to 13
      if(nc.eq.ned+1) go to 19
c End of a section
 17   irh = irl + 149
      call intio(ied,irl,irh,ifed,-1)
      jj = 1
      irl = irh + 1
      go to 13
c End of edits
 19   irh = irl + 3*(jj-1) - 1
      call intio(ied,irl,irh,ifed,-1)
      irh = max(irh,3*mlen+1)
      write(6,104) irh, nc-1, ifed
 104  format(i7,' terms (',i4,' edits) in file',i5)
      call retnio(ifed)
      return
      end
