      subroutine edcon4(ned,igap,ioff,idir,ifl)
c
c  goes between edits file on disk and arrays igap and ioff.  igap(1,n) is
c  term number of last good point before the n-th data gap; igap(2,n) is 
c  term number of first good point after it; and ioff(n) is the offset
c  across it.
c
c  if idir > 0 fills arrays from edits file. ned is input as the external
c  dimension of igap and ioff (and hence the maximum number of edits that 
c  can be handled), and returned as the actual number of edits.
c  ifl is the file length; edits which are after this point will be ignored.
c
c  if idir <= 0 writes out edits file from data in arrays; edits file
c  will have a minimum length set by the common block minedt (below)
c
c   calls intio,return
c
      dimension ied(3,50),igap(2,ned),ioff(ned)
      dimension idum(150)
c mlen is the minimum size of file to write, specified as number of edits
      common/minedt/mlen
      data idum/150*0/
      if(ned.le.0.and.idir.le.0) return
      irl = 2
      irs = 1
      nc = 1
      jj = 1
      ndum = 0
      if(idir.le.0) go to 11
      write(6,100)
 100  format(' edits file in; ',$)
      ifed = ffin(1,not)
      if(ifed.eq.0) go to 21
      call intio(nedac,1,1,ifed,0)
      if(nedac.eq.0) then
         ned=nedac
         return
      endif
      if(nedac.le.ned) go to 3
c error off - more edits in file than there are room for
      write(6,102) nedac,ned
 102  format(' There are',i5,' edits in this file, MORE than the',i5,
     1 ' allowed for')
      stop
c read in edits 50 at a time
 3    ned = nedac
      nedsec = (ned-1)/50 + 1
      irnt = 3*ned + 1
      do 7 kk = 1,nedsec
      irl = 2 + 150*(kk-1)
      irh = min0(irl+149,irnt)
      call intio(ied,irl,irh,ifed,0)
      ned = ned - 50
      jjl = min0(50,ned+50)
      do 5 jj =1,jjl
c skip over dummy edits
      if(ied(1,jj).eq.30000.and.ied(2,jj).eq.0.and.ied(3,jj).eq.1)
     1    irs = irs + 30001 
      if(ied(1,jj).eq.30000.and.ied(2,jj).eq.0.and.ied(3,jj).eq.1)
     1    go to 5
      igap(1,nc) = irs + ied(1,jj)
      igap(2,nc) = igap(1,nc) + ied(3,jj)
      ioff(nc) = ied(2,jj)
      irs = igap(2,nc)
      nc = nc + 1
c check for edit that is off end-truncate or discard edit, and exit
      if(ifl.gt.0.and.igap(2,nc).gt.ifl) then
         if(igap(1,nc).le.ifl) igap(2,nc) = ifl
         if(igap(1,nc).gt.ifl) nc = nc - 1
         go to 9
      endif
 5    continue
 7    continue
 9    ned = nc-1
      call retnio(ifed)
      return
c
c  write out edits - first scan through to see any really long edits,
c  and number of dummy edits (for long stretches between edits)
c
 11   continue
      do 10 kd=1,ned
      if(igap(2,kd)-igap(1,kd).ge.32767) write(6,111)
     1                                      igap(1,kd),igap(2,kd)
 111  format(' edit from ',i9,' to ',i9,' is too long',/,
     1 ' for a short-integer edits file--use a long-integer one')
 10   continue
      write(6,101)
 101  format(' edits file out; ',$)
      ifed = ffin(1,not)
      if(ifed.eq.0) go to 21
 119  if(igap(1,nc)-irs.lt.32767) go to 12
      ndum = ndum + 1
      irs = irs + 30001
      go to 119
 12   irs = igap(2,nc)
      nc = nc + 1
      if(nc.ne.ned+1) go to 119
      irs = 1
      nc = 1
      ndum = ned + ndum
      nedac = max(3*ndum+1,3*mlen+1)
c nedac is now the file length to be written out -first fill with zeros
      call intio(ndum,1,1,ifed,1)
      il = 2
 121  ih = min(il+149,nedac)
      call intio(idum,il,ih,ifed,-1)
      il = ih + 1
      if(il.le.nedac) go to 121
 13   if(igap(1,nc)-irs.lt.32767) go to 15
c insert dummy edits
      ied(1,jj) = 30000
      ied(2,jj) = 0
      ied(3,jj) = 1
      irs = irs + 30001
      jj = jj + 1
      if(jj.ne.51) go to 13
      go to 17
 15   ied(1,jj) = igap(1,nc) - irs
      ied(2,jj) = ioff(nc)
      ied(3,jj) = igap(2,nc) - igap(1,nc)
      irs = igap(2,nc)
      jj = jj + 1
      nc = nc + 1
      if(jj.ne.51.and.nc.ne.ned+1) go to 13
      if(nc.eq.ned+1) go to 19
c end of a section
 17   irh = irl + 149
      call intio(ied,irl,irh,ifed,-1)
      jj = 1
      irl = irh + 1
      go to 13
c end of edits
 19   irh = irl + 3*(jj-1) - 1
      call intio(ied,irl,irh,ifed,-1)
      irh = max0(irh,3*mlen+1)
      write(6,104) irh, nc-1, ifed
 104  format(i6,  ' terms (',i6,' edits) in file',i5)
      call retnio(ifed)
      return
 21   ned = 0
      return
      end
