      subroutine regap(ifed,sp,ep,nsec,fl)
c  takes data from an edit file ifed and creates pairs of points, sp and
c  ep, which specify where data is good. nsec is the number of pairs and
c  fl the file length (which may be set to less than the actual length
c  if so desired).  nsec is read in as the (external) dimension
c  of sp and ep; if the actual number of sections exceeds this, the
c  program prints an error message and returns.
      dimension sp(nsec),ep(nsec),ied(3,50)
      common/spec/gpsz,scsz
c  the parameters in spec allow some latitude in producing the pairs
c  that specify good data.  gaps in good data that are less than gpsz
c  long will be ignored (assumed to be good data), and stretches of
c  good data less than scsz long (including ok gaps) will not be included.
      data gpsz/0./,scsz/1./
      rs = 1.
      is = 1
      iflg = 0
      call intio(ned,1,1,ifed,0)
c  edits are taken in sections of 50
      nedsec = (ned-1)/50 + 1
      iedmx = 3*ned+1
c  loop through edit sections
      do 15 kk = 1,nedsec
      irl = 2 + 150*(kk-1)
      irh = min0(irl+149,iedmx)
      call intio(ied,irl,irh,ifed,0)
      ned = ned - 50
      jjl = min0(50,ned+50)
c  loop through individual edits
      do 12 jj = 1,jjl
c  if iflg = 0, we are starting on a new stretch of good data.
c  if iflg = 1, we are looking for the end of such a stretch (a gap
c  longer than gpsz).  when we find the end, check to make sure that
c  stretch is longer than scsz.
      if(iflg.ne.0) go to 3
c  put in start point
      sp(is) = rs
      re = rs
 3    re = re + ied(1,jj)
c  check to make sure that we do not go off end of file
      if(re.ge.fl) go to 18
      if(ied(3,jj).ge.gpsz) go to 9
c  now are looking for end point
      iflg = 1
      re = re + ied(3,jj)
      if(re.ge.fl) go to 18
      go to 12
c  found an end term - update  rs
 9    ep(is) = re
      rs = re + ied(3,jj)
c  if section is long enough, increment is
      if(ep(is)-sp(is)+1..ge.scsz) is = is + 1
      if(is.gt.nsec) go to 21
      iflg = 0
 12   continue
 15   continue
c
c  finish up, putting end point at end of file if ok
c
      if(iflg.ne.0) go to 18
      nsec = is - 1
      if(fl-rs.lt.scsz) go to 23
      sp(is) = rs
 18   ep(is) = fl
      nsec = is
      go to 23
 21   write(6,100) nsec, re
 100  format(' too many sections for number given in main program ('
     & ,i3,').  last section ends at',f8.0)
 23   call retnio(ifed)
      return
      end

