      subroutine firres(ew,ow,n,ic,it,om,amp)
c   computes response of a finite impulse response filter with linear 
c   phase.  weights are in ew (even or real part) and iw (imaginary or
c   odd part).  ic = 0 if filter weights are purely real. n is the 
c   length of ew and ow.  weights are assumed to be given from center 
c   to right.  it is 1 if the total number of weights is odd,
c   zero if not (the number of weights must be odd for there to be no
c   phase shift at all).  om is the frequency, normalized so the
c   nyquist is at .5.  amp is the amplitude response.
c
      complex eom,a,b,d
      dimension  ew(n), ow(n)
      data tp/6.283185308/
      om = tp*om
      cs = cos(om)
      c = 2.*cs
      m = n - it
      if(ic.eq.0) go to 4
      a = cmplx(0.,0.)
      b = cmplx(0.,0.)
c   do fourier transform using goertzal's algorithim
      do 3 i = 1,m
      d = cmplx(ew(n-i+1),ow(n-i+1)) + c*a - b
      b = a
 3    a = d
      go to 6
 4    ar = 0
      br = 0
      do 5 i = 1,m
      dr = ew(n-i+1) + c*ar - br
      br = ar
 5    ar = dr
      d = cmplx(dr,0.)
      b = cmplx(br,0.)
 6    eom = cmplx(cs,sin(om))
      d = d - eom*b
      if(it.eq.1) go to 7
      d = d*cmplx(cos(om/2),-sin(om/2))
      amp = abs(2.*real(d))
      return
 7    d = d*cmplx(cs,-sin(om))
      amp = abs(ew(1) + 2.*real(d))
      return
      end

