      subroutine polyre(freq,rp,op,del)
c     finds real and imaginary parts of a rational function, and ite
c     group delay (derivative of phase with respect to frequency).
c     function is assumed to have a numerator of degree
c     nnum and denominator of degree nden, and is evaluated
c     with argument i*freq. coefficiants of numerator are in array cnum,
c     of denominator in array cden, in both cases with degree zero first.
c
      complex fr,den,num,dden,dnum
      common /polys/nnum,nden,cnum(20),cden(20)
      delay(den,dden)=(real(den*conjg(dden)))/((cabs(den))**2)
      data rlo/1.e-35/
      fr = cmplx(0.,freq)
      dden = cmplx(0.,0.)
      dnum = dden
      den = cden(nden+1)
      if(nden.ne.0) dden=den
      if(nden.lt.2) go to 5
      do 3 i = 1,nden-1
      den = fr*den + cden(nden-i+1)
 3    dden = fr*dden + den
 5    if(nden.ne.0) den = fr*den + cden(1)
      num = cnum(nnum+1)
      if(nnum.ne.0) dnum=num
      if(nnum.lt.2) go to 9
      do 7 i = 1,nnum-1
      num = fr*num + cnum(nnum-i+1)
 7    dnum = fr*dnum + num
 9    if(nnum.ne.0) num = fr*num + cnum(1)
      if(cabs(den).gt.rlo) go to 20
      write(6,100) freq
 100  format(1x,'at frequency ',g11.4,' overflow likely. real and ',
     1    'imaginary parts set to 1 and 0.')
      rp = 1.
      op = 0.
      del = 0.
      return
 20   del = -delay(den,dden)
      if(cabs(num).gt.rlo) del = del + delay(num,dnum)
      den = num/den
      rp = real(den)
      op = aimag(den)
      return
      end

