      subroutine topo(slat,slong,rlat,rlong,del,az)
c  for small distances, computes the distance from point s to point r
c  del is the distance in km, az the azimuth (cw from n)
c   uses "topographic" formula (bomford, 4th ed, p. 123)
      data dr/.017453293/,flt/3.35289e-3/,eqr/6378.15/
      if(rlat.eq.slat.and.rlong.eq.slong) then
        del=0.
        az=0.
        return
      endif
      e = sqrt(2*flt - flt*flt)
      phm = .5*dr*(slat+rlat)
      sphm = sin(phm)
      rho = eqr*(1-e*e)*(1 + 1.5*(e*sphm)**2)
      rnu = eqr*(1 + .5*(e*sphm)**2)
      da = dr*(rlong-slong)*sphm
      az = atan2(rnu*dr*(rlong-slong)*cos(phm),rho*dr*(rlat-slat))
     1     - .5*da
      caz = cos(az+.5*da)
      saz = sin(az+.5*da)
      if(abs(caz).gt.abs(saz)) del = dr*rho*(rlat-slat)/caz
      if(abs(caz).le.abs(saz)) del = dr*rnu*cos(phm)*(rlong-slong)/saz
      az = az/dr
      return
      end
      subroutine topod(slat,slong,del,az,rlat,rlong)
c  for small distances, computes the coordinates of point r relative
c  to point s, for del the distance in km, az the azimuth (cw from n)
c   uses "topographic" formula (bomford, 4th ed, p. 119)
      data dr/.017453293/,flt/3.35289e-3/,eqr/6378.15/
      e = sqrt(2*flt - flt*flt)
      phm = dr*slat
      sphm = sin(phm)
      rho = eqr*(1-e*e)*(1 + 1.5*(e*sphm)**2)
      rnu = eqr*(1 + .5*(e*sphm)**2)
      azt = dr*az
c  need preliminary estimate of new longitude and latitude
      rlong = slong + (del/rnu)*sin(azt)/(dr*cos(phm))
      rlat = slat + (del/rho)*cos(azt)/dr
c  now redo spheriod computations
      phm = .5*dr*(slat+rlat)
      sphm = sin(phm)
      rho = eqr*(1-e*e)*(1 + 1.5*(e*sphm)**2)
      rnu = eqr*(1 + .5*(e*sphm)**2)
      da = dr*(rlong-slong)*sphm
      rlat = slat + (del/rho)*cos(azt+.5*da)/dr
      rlong = slong + (del/rnu)*sin(azt+.5*da)/
     1                (dr*cos(phm+.5*dr*(slat-rlat)))
      return
      end
