/* Modified 12/31/04 translate BSD style termial commands using */
/* ioctl and sgtty into Linux style termios.h commands Walter Szeliga */
/*** modified 15 aug 85: put terminal into non-echo mode too ***/
/*** dh  ***/
#include <termios.h>

static struct termios stored_settings;

void
raw(int lu)  /* Set logical unit lu to raw mode. */
{
 struct termios tty;

 tcgetattr(lu,&stored_settings);
 tty = stored_settings;
 /* Turn echo off */
 tty.c_lflag &= (~ECHO);
 /* Disable canonical mode and set buffer size to 1 byte */
 tty.c_lflag &= (~ICANON);
 tty.c_cc[VTIME] = 0;
 tty.c_cc[VMIN] = 1;

 tcsetattr(lu,TCSANOW,&tty);

 return;
}

void
cooked(int lu)
{
 tcsetattr(lu,TCSANOW,&stored_settings);
 return;
}
