      subroutine headco(nhf,idir)
c
c   moves header information between disk file nhf
c   and labelled common.
c   idir = 1    -    reads from disk
c   idir = 0    -    writes onto disk
c
c   file numbers in arrray nchf are set to agree with
c   form of nhf (ie, tens of thousands will be set according
c   to number in nhf). to be properly referenced, data
c   files must be in same directory as header. 
c
c
      character*1 charo,charn
      integer*2 idum
      character*8 source,chanid
      character*4 stc,commen
      double precision scans
      dimension idum(586),charn(1172),charo(1172),idum2(293)
      common/head/scans,calc(4),clkc(2),sampin,nchann,iblock,istart(5),
     1     iend(5),nchf(17),ichnm(16),ncal(4),source,chanid(16),stc,
     2     commen(200)
      equivalence (scans,charn(1))
      equivalence (idum(1),charo(1))
      equivalence (idum2(1),charo(1))
      ndir = nhf/10000
      jhf=nhf-10000*ndir
      long=0
      if((jhf.gt.1000.and.jhf.lt.2000).or.
     1   (jhf.gt.3000.and.jhf.lt.4000)) long=1
      if(idir.eq.0) go to 7
c-------------------------------------------------
c
c   read data from disk
c
c-------------------------------------------------
c  check to see if it is a header file (at least in length)
      if(long.eq.0) nbytes=2*longis(nhf)
      if(long.eq.1) nbytes=4*longis(nhf)
      if(nbytes.ne.1172) then
         write(6,100) nhf
 100     format(' File ',i6,' is not a header file. Program quits')
         stop
      endif
c   read from disk
      if(long.eq.0) call shrtio(idum,1,586,nhf,0)
      if(long.eq.1) call intio(idum2,1,293,nhf,0)
      call retnio(nhf)
c   rearrange character array so that information from disk will match the new
c    (April 2004) arrangement of the common block
      do i=1,8
         charn(i)=charo(i+84)
      enddo
      do i=9,24
         charn(i)=charo(i+4)
      enddo
      do i=25,32
         charn(i)=charo(i+4)
      enddo
      do i=33,36
         charn(i)=charo(i+60)
      enddo
      do i=37,84
         charn(i)=charo(i)
      enddo
      do i=85,152
         charn(i)=charo(i+12)
      enddo
      do i=153,216
         charn(i)=charo(i+12)
      enddo
      do i=217,232
         charn(i)=charo(i+140)
      enddo
      do i=233,240
         charn(i)=charo(i-228)
      enddo
      do i=241,368
         charn(i)=charo(i-12)
      enddo
      do i=369,372
         charn(i)=charo(i-368)
      enddo
      do i=373,1172
         charn(i)=charo(i)
      enddo
c   reset channel file numbers to agree with header
c   file number stored in header are those on disk, plus 10000
c   times ndir. now do reconstruction 
      do i = 1,17
         if(nchf(i).gt.0) nchf(i) = nchf(i) + ndir*10000
         if(nchf(i).lt.0) nchf(i) = nchf(i) - ndir*10000
      enddo
      return
c-------------------------------------------------
c
c   write out data to disk
c
c-------------------------------------------------
c   reset channel numbers to keep in range independent of whether or not
c   file is being accessed from another directory
 7    do i = 1,17
         if(nchf(i).gt.0) nchf(i) = nchf(i) - ndir*10000
         if(nchf(i).lt.0) nchf(i) = nchf(i) + ndir*10000
      enddo
c   rearrange character array so that information on disk will match the old
c    arrangement of the common block--and all past files.
      do i=1,4
         charo(i)=charn(i+368)
      enddo
      do i=5,12
         charo(i)=charn(i+228)
      enddo
      do i=13,28
         charo(i)=charn(i-4)
      enddo
      do i=29,36
         charo(i)=charn(i-4)
      enddo
      do i=37,84
         charo(i)=charn(i)
      enddo
      do i=85,92
         charo(i)=charn(i-84)
      enddo
      do i=93,96
         charo(i)=charn(i-60)
      enddo
      do i=97,164
         charo(i)=charn(i-12)
      enddo
      do i=165,228
         charo(i)=charn(i-12)
      enddo
      do i=229,356
         charo(i)=charn(i+12)
      enddo
      do i=357,372
         charo(i)=charn(i-140)
      enddo
      do i=373,1172
         charo(i)=charn(i)
      enddo
      if(long.eq.0) call shrtio(idum,1,586,nhf,1)
      if(long.eq.1) call intio(idum2,1,293,nhf,1)
      call retnio(nhf)
      return
      end
