      subroutine headco(nhf,idir)
c
c   moves header information between disk file nhf
c   and labelled common.
c   idir = 1    -    reads from disk
c   idir = 0    -    writes onto disk
c
c   file numbers in arrray nchf are set to agree with
c   form of nhf (ie, tens of thousands will be set according
c   to number in nhf). to be properly referenced, data
c   files must be in same directory as header. 
c
c
      integer*2 idum
      character*8 source,chanid
      character*4 stc,commen
      double precision scans
      dimension idum(586)
      common/head/scans,calc(4),clkc(2),sampin,nchann,iblock,istart(5),
     1     iend(5),nchf(17),ichnm(16),ncal(4),source,chanid(16),stc,
     2     commen(200)
C old    common/head/stc,source,calc(4),clkc(2),nchann,iblock,istart(5)
C old   1     iend(5),scans,sampin,nchf(17),ichnm(16),chanid(16),ncal(4)
C old   2     commen(200
      equivalence (stc,idum(1))
      if(idir.eq.0) go to 7
      nbytes=2*longis(nhf)
c  check to see if it is a header file (at least in length)
      if(nbytes.ne.1172) then
         write(6,100) nhf
 100     format(' File ',i6,' is not a header file. Program quits')
         stop
      endif
c   read from disk, and readjust array to match HP alignment
      call shrtio(idum,1,586,nhf,0)
      call retnio(nhf)
c   reset channel file numbers to agree with header
      ndir = nhf/10000
c   file number stored in header are those on disk, plus 10000
c   times ndir. now do reconstruction 
      do 5 i = 1,17
  5   nchf(i) = nchf(i) + ndir*10000
      return
c   write out data to disk
 7    ndir = nhf/10000
c   reset channel numbers 
      do 9 i = 1,17
 9    nchf(i) = nchf(i) - 10000*ndir
c   and realign the data to make consistent with the old format
C     do 11 i=43,586
C11   idum(i)=idum(i+2)
c   also reset (but do not alter) header to be short integer if it is long
      jhf=nhf-10000*ndir
      if((jhf.gt.1000.and.jhf.lt.2000).or.jhf.gt.3000) jhf=jhf-1000
      jhf=jhf+10000*ndir
      call shrtio(idum,1,586,jhf,1)
c   now re-realign the data, in case we will be writing more headers
      call retnio(jhf)
      return
      end
