      function headrd(nch,casnam,chnam,numcha,iact)
c  Reads the first (header) record of a station tape file and decodes it.
c    If iact is zero it returns only the variables casnam and chnam
c  (the cassette and channel names), and the channel number numcha;
c  the last two are the only things that vary between headers for
c  different channels).
c    If iact is 1 the whole header is also unpacked and the contents
c  put in the common blocks head and auxinf.
c    If iact is -1, unpacks the whole header, using what was read before
c  into the buffer--does not read from tape
c    Nch is the tape drive unit number. 
c  The function itself returns a value of 1 if the header was read, 
c  and 0 if the attempt to read it encountered an EOF; since the header 
c  should begin the file such an encounter would indicate an EOI. 
c 
c     calls magrd,etoa
c 
      static headd
      character*8 source,chanid,casnam,chnam
      character*4 stc,commen,slash,blank
      character*1000 headd
      double precision scans
      common/head/scans,calc(4),clkc(2),sampin,nchann,iblock,istart(5),
     1     iend(5),nchf(17),ichnm(16),ncal(4),source,chanid(16),stc,
     2     commen(200)
C old    common/head/stc,source,calc(4),clkc(2),nchann,iblock,istart(5)
C old   1     iend(5),scans,sampin,nchf(17),ichnm(16),chanid(16),ncal(4)
C old   2     commen(200
      common/auxinf/nchnm(4)
      data slash/'////'/,blank/'    '/,n/1000/
      headrd = 1
c   read the header record
      if(iact.ge.0) then
         n=1000
         call magrd(nch,headd,n,ifl)
         if(ifl.gt.0.or.n.eq.0) then
c  found eof (probable eoi) while looking for header
            if(ifl.gt.0.and.n.ne.0) write(6,101)ifl
 101        format(' Read error - ifl=',i2)
            headrd = 0
            return
         endif
c   decode the header
         call etoa(n,headd)
      endif
      if(iact.eq.0) then
         read(headd,103) chnam,casnam
 103     format(10x,a8,51x,a8)
         read(headd(81:102),105) numcha
 105     format(19x,i3)
      elseif(iabs(iact).eq.1) then
         read(headd,107) stc,chnam,istart,iend,scans,source
 107     format(5x,a4,1x,a8,1x,5i4,2x,5i4,f7.0,1x,a8)
         read(headd(81:152),109) sampin,clkc,numcha,iblock,(nchnm(j),
     1    calc(j),j=1,4)
 109     format(3x,f6.0,2f5.1,i3,i2,i3,f9.2,i3,f9.2,i3,f9.2,i3,f9.2)
c   reconstruct the comments field
         do 7 i=1,200
 7       commen(i)=headd(4*i+157:4*i+160)
         k=200
         do 9 i=1,10
         do 9 j=1,20
         if(commen(k).ne.blank) go to 11
 9       k=k-1
         i=11
 11      k=(11-i)*20+1
         if(k.lt.200) commen(k)=slash
         casnam = source 
      endif
      return
      end
