      subroutine jacobi(h,eigen,nn,mm,err)
c$$$$$ calls no other routines
c  jacobi diagonalization for symmetric matrices
c  a version for dealing with hermitian matrices is available
c  h  is the symmetruc matrix to be diaginalized (with physical dimensions mm,mm
c  and mathematical dimensions nn,nn)
c  eigen is a real    matrix (dimensioned like h) into with the normalized eigen
c -vectors go.the eigen values appear as diagonal elements in h
c  of h.
c  err is an error criterion - the sum of the absolute values of the eigen-value
c -s must exceed the largest off-diag term by at least 1/err times.
c  the routine uses the jacobi method
c  for details see wilkinson 'the algebraic eigen-value problem'
      dimension h(mm,mm),eigen(mm,mm)
      integer p,q,rots
c
      n=nn
      rots=0
c  the eigen values ate found as the product matrix of all the elementary unitar
c -y transforms that rotate  h into diagonal form. we set eigen to the unit matr
c -x
      do 110 j=1,n
      do 100 i=1,n
100   eigen(i,j)=0.0
110   eigen(j,j)=1.0
c  find the largest off-diagonal elemnt and put its position in p,q
c  also sum the diagonal elements' absolute values
 200  big=0.0
      diag=0.0
      do 210 j=1,n
      do 210 i=1,j
      hij=h(i,j)
      if (i.eq.j) go to 205
      habs=abs(hij)
      if (big.gt.habs) go to 210
      big=habs
      p=i
      q=j
      go to 210
205   diag=diag+abs(hij)
210   continue
c  checks error criterion
      if (big.gt.diag*err) go to 300
      return
c
c  sets up various constants to transform current h
300   continue
      rots=rots+1
      hpq=h(p,q)
      hpp=h(p,p)
      hqq=h(q,q)
      x=hpq*sign(2.0,hpp-hqq)
      y=abs(hpp-hqq)
      d=0.5/sqrt(x*x+y*y)
      c2=0.5+y*d
      c=sqrt(c2)
      cs=x*d
      s=cs/c
      s2=s*s
c
c  applies elementary unitary transforms to eigen, and similarity-type trans    
c -form to h
      do 310 i=1,n
      eignip=eigen(i,p)
      eigniq=eigen(i,q)
      eigen(i,p)=eignip*c+eigniq*s
      eigen(i,q)=eigniq*c-eignip*s
      if (i.eq.q .or. i.eq.p) go to 310
      hip=h(i,p)
      hiq=h(i,q)
      h(i,p)=hip*c+hiq*s

      h(p,i)=h(i,p)
      h(i,q)=hiq*c-hip*s
      h(q,i)=h(i,q)

310   continue
c
c  deals with the special elements at p,p q,q and p,q
      h(p,p)=hpp*c2+hqq*s2+2.0*cs*hpq
      h(q,q)=hpp*s2+hqq*c2-2.0*cs*hpq
      h(p,q)=0.0
      h(q,p)=0.0
c
c  repeats iteration
      go to 200
      end

