#include "niostf.h"
#define TEMPORARY 1
#define TEMPPATH "/tmp"
#define MAXPATH 200
#include <strings.h>

munman(numb,filnam)
/*  For a file number numb, returns a file name in the string filnam.  */
/*  If mmm are the last three digits, k the thousands digit, and j the  */
/*  tens of thousands (always nonnegative), the assignment of names goes like:  */
/*  For j=0:  */
/*      A)  numb < 0, k=0:  Rmmm.D  (real)  */
/*      B)  numb > 0, k=0:  Immm.D  (short integer)  */
/*      C)  numb > 0, k=1:  Lmmm.D  (long integer)  */
/*      D)  numb < 0, k=2:  /tmp/xxxRmmm.D  (real)  */
/*      E)  numb > 0, k=2:  /tmp/xxxImmm.D  (short integer)  */
/*      F)  numb > 0, k=3:  /tmp/xxxLmmm.D  (long integer)  */
/*     where xxx is the working directory pathname with /'s replaced by  */
/*     _'s.  This is a way of producing unique filenames in the temporary  */
/*     area.  								*/
/*  For j>0: 								*/
/*     Cases A-C above apply, but each value of j has a pathname entered  */
/*     by the user that goes with it. A maximum of 200 pathnames are retained.*/
/*     Note that even if numb changes a previously-used pathname will be  */
/*     applied so long as j remains the same. These names are stored internally  */
/*     to this program   */
/* All other possible numbers are illegal.  */

char filnam[NAMLEN];
int numb;
{
   char pth[NAMLEN];		/*space for pathname*/
   char tb[7];			/*space for Xmmm.D construction*/
   int i,ip,num,num2;
   size_t bs;
   static int maxp = 0;
   static int sonum[MAXPATH];		/*array of j's used already*/
   static char souts[MAXPATH][NAMLEN];	/*matching array of pathnames*/
   filnam[0] = '\0';			/*flush old filename*/
   bs=NAMLEN;
   num = abs(numb);
   num2 = num%1000;
   if(num/10000>0) {			/*have number needing pathname*/
      ip = -1;
      for(i=0; i<=maxp; i++) {		/*search to see if in use*/
         if(num/10000==sonum[i])
            ip = i;
      }
      if(ip==-1 && maxp>MAXPATH-1) {	/*if new name needed but no room*/
         fprintf(stderr," No further pathnames allowed - program aborts.\n");
         exit(15);
         }
      if(ip == -1) {			/*otherwise get new name and store it*/
         i = i-1;
         fprintf(stderr," Enter pathname for directory of file;; ");
         scanf("%s",&souts[i][0]);
         if(souts[i][strlen(&souts[i][0])-1] != '/')
            strcat(&souts[i][0],"/");
         sonum[i] = num/10000;
         ip = i;
         maxp++;
         if(maxp>MAXPATH-1) {			/*warn user if headed for trouble*/
            fprintf(stderr," At most %d pathnames may be accessed during",MAXPATH);
            fprintf(stderr," execution - \n   %s is the last one allowed.\n",&souts[i][0]);
            }
         }
      strcpy(filnam,&souts[ip][0]);		/*load pathname into output string*/
   }
   if((num/1000 - 10*(num/10000))/2 ==TEMPORARY) {	/*if need be*/
      strcpy(filnam,TEMPPATH);			/*get temporary name*/
      getcwd(pth,bs);				/*and append */
      pthcon(pth);				/*altered pathname*/
      strcat(filnam,pth);
      strcat(filnam,"_");
   }
   if (numb < 0)			/*make up the last part of the filename*/
      sprintf(tb,"R%d.D",num2);
   else if ((num/1000 - 10*(num/10000))%2==1)
      sprintf(tb,"L%d.D",num2);
   else
      sprintf(tb,"I%d.D",num2);
   strcat(filnam,tb);		/*and load it into the output string*/
}

pthcon(s)

/*convert /'s in pthname to _'s, except for the first character */

char *s;
{
   s++;
   while (*s) {
      if(*s == '/')
         *s = '_';
      s++;
   }
}
