      subroutine rmconj(cmin,nin,cmout,nout,dum,key)
c  from a list of nin complex numbers in array cmin, returns nout
c  in cmout, sorted with real parts increasing and complex
c  conjugate values removed.  dum and key are working arrays,
c  and must be externally dimensioned nin
c     calls shells
      complex cmin,cmout
      dimension cmin(*),cmout(*),dum(*),key(*)
      data rndoff/1.e-6/
      nout = 1
      if(nin.eq.0) nout = 0
      if(nin.eq.0) return
      do 1 i=1,nin
 1    dum(i) = real(cmin(i))
c  sort into decreasing order by real parts (this makes complex conjugates
c  contiguous)
      call shells(dum,key,nin)
      cmout(1)=cmin(key(1))
      if(nin.eq.1) return
c  sort through complex numbers. if one is the complex conjugate of the
c  one before it (to within roundoff error), skip it;
c  but save pairs of identical reals
      lastok = key(1)
      do 5 i=2,nin
      if(aimag(cmin(key(i))).eq.0) go to 3
      delrel =  abs(real(cmin(key(i))) - real(cmin(lastok)))
      delimg = abs(aimag(cmin(key(i))) +aimag(cmin(lastok)))
      if (delrel/abs(real(cmin(key(i)))).lt.rndoff.and.
     1  (delimg/abs(aimag(cmin(key(i)))).lt.rndoff)) go to 5
c  save root in output list; its imaginary part is the one we use
c  for future comparisons (this is acceptable because of the sort)
 3    nout=nout+1
      cmout(nout) = cmin(key(i))
      lastok = key(i)
 5    continue
c  make all imaginary parts positive
      do 7 i=1,nout
 7    if(aimag(cmout(i)).lt.0) cmout(i) = conjg(cmout(i))
      return
      end

