      subroutine mcco(a,b)     
c   computes a and b tidal potential coefficients as in munk and cartwright     
c    1966, in meters for a sphere with the earths equatorial radius.     
c   coefficients are returned in a and b, in order of increasing l (l = 2 or 3) 
c    and for each l in order of increasing m.  b(1) and b(4) are zero.   
c  
      dimension a(7),b(7),rk(4),c(7),cl(4),sl(4),pa(2),rnorm(7)   
c   common with solar and lunar positions    
      common/bpos/coor(8),par,sdist   
c   tidal coefficients are from 1976 iau constants  
      data rk/.3583728,.0059463,.16457875,.00000702/,cl(1)/1./,sl(1)/0./ 
      data ifl/0/,fpi/12.566370614/,c(1)/1./ 
c   on first call compute normalizing coefficiants  
      if(ifl.ne.0) go to 3     
      ifl = 1    
      do 1 i = 2,7      
 1    c(i) = (i-1.)*c(i-1)     
      do 2 l = 2,3      
      mu = l + 1 
      do 2 m = 1,mu     
      i = 3*(l/3) + m   
      t = 1. + (m+1)/3  
 2    rnorm(i) =((-1)**(m+1))*t*sqrt((fpi*c(l-m+2))/((2.*l+1)*c(l+m)))   
c   find normalized parallax   
 3    pa(1) = par/3422.448     
      pa(2) = 1./sdist  
      do 4 i = 1,7      
      a(i) = 0.  
 4    b(i) = 0.  
      do 6 n = 1,2      
c   n = 1 for lunar part, 2 for solar 
      do 5 i = 1,3      
      cl(i+1) = coor(4*n)*cl(i) - coor(4*n-1)*sl(i) 
 5    sl(i+1) = coor(4*n)*sl(i) + coor(4*n-1)*cl(i) 
      cz = coor(4*n-2)  
      sz = coor(4*n-3)  
      c(1) = (3.*cz*cz - 1.)/2.
      c(2) = 3.*cz*sz   
      c(3) = 3.*sz*sz   
      c(4) = (5./3.)*cz*(c(1) - .4)   
      c(5) = 1.5*sz*(5.*cz*cz - 1.)   
      c(6) = 5.*cz*c(3) 
      c(7) = 5.*sz*c(3) 
      do 6 l = 2,3      
      mu = l + 1 
      do 6 m = 1,mu     
      k = 3*(l/3) + m   
      c(k) = rnorm(k)*rk(2*n+l-3)*(pa(n)**(l+1))*c(k)      
      a(k) = a(k) + c(k)*cl(m) 
 6    b(k) = b(k) + c(k)*sl(m) 
      return     
      end 

