c   program for correcting a data series (real or integer) using 
c   an edit file produced by credit.  see subroutine xedit for 
c   further details. 
c   type of output file is independent of type of input.  If number
c   of output file is 0, data will be treated as integer but not 
c   written out (to check for possible overflow) 
c
c
c      calls iolib
c
      character*1 ifil,not
      dimension ix(1200),ied(3,200),x(1200) 
      data isted,iened/2*1/,ierl/2/,ll/1/,offs/0./izp/0/
c
 3    write(6,100)
 100  format(' What option (h for help)     ; ',$)
      dum=ffin(1,ifil)
      if(ifil.ne.'h' .and. ifil.ne.'n' .and. ifil.ne.'o' .and.
     1   ifil.ne.'c' .and. ifil.ne.'f' .and. ifil.ne.'s') go to 3
      if(ifil.eq.'h') write(6,101)
 101  format(' There are four options for editing a file:',/,
     1'  n - interpolate, with offset (normal)',/,
     2'  s - add slope to bad data and offset',/,
     3'  o - interpolate, no offset',/,
     4'  c - fill with constant, with offset',/,
     5'  f - fill with constant, no offset',/,
     6'  and to get a binary edits file (1''s where there are edits',/,
     7'  and 0''s elsewhere) use any option with an input file number',
     8/,'  of zero (length <0 to pad z-l edits)',//)
      if(ifil.eq.'h')go to 3
      write(6,102)
 102  format(' Input file number and length (-1 for all) ; ',$)
      ifin = ffin(1,not)
      irntot = ffin(1,not)
      if(irntot.lt.0.and.ifin.ne.0) irntot = longis(ifin)
      if(irntot.lt.0.and.ifin.eq.0) then
         izp=1
         irntot = -irntot
      endif
      write(6,103)
 103  format(' Output file number                        ; ',$)
      ifout = ffin(1,not)
      if(iabs(ifout).eq.iabs(ifin)) ifout = ifin
      write(6,104)
 104  format(' Edits file number                         ; ',$)
      ifed = ffin(1,not)
      if(ifin.ne.0) then
         if(ifil.eq.'c'.or.ifil.eq.'f') then
           write(6,106)
 106       format(' Fill constant                             ; ',$)
           fill=ffin(1,not)
         endif
         if(ifil.eq.'n'.or.ifil.eq.'c'.or.ifil.eq.'s') then
            write(6,110)
 110        format(' Initial offset                           ; ',$)
            offs = ffin(1,not)
         endif
      endif
c  read in the first block of edits
      call intio(ned,1,1,ifed,0)
      itned = 3*ned + 1
      ierh = min(itned,601)
      call intio(ied,ierl,ierh,ifed,0)
c  open output file
      if(ifout.ne.0.and.ifin.ne.ifout) then
         if(ifout.gt.0) call intio(ix,1,1,ifout,1)
         if(ifout.lt.0) call realio(x,1,1,ifout,1)
      endif
      if(ifin.eq.0) go to 401
c 
c 
c   done with setup - loop through edits (plus one for last part) 
c   ll is counter in edit buffer - updated as needed
c 
      do 171 l = 1,ned+1 
c   set offset in edits file to zero if we don't want any
      if(ifil.eq.'o'.or.ifil.eq.'f') ied(2,ll) = 0
c 
c   from here through the "go to 115", we are dealing with the part of 
c   the file between edits. iened is the end point of the last edit, 
c   isted the start of the next (both point to good values)
c 
      if(l.le.ned) isted = min(iened + ied(1,ll),irntot) 
      if(l.gt.ned) isted = irntot 
c   if we are copying the file, or offsetting the data, 
c   need to read and write
      if(ifout.ne.ifin.or.offs.ne.0.) then
         irl = iened 
 115     irh = min(irl+1199,isted) 
         ie = irh - irl + 1 
         if(ifout.gt.0) then
            call intio(ix,irl,irh,ifin,0) 
c  this addition of an offset is unneeded in some cases but done in all
c   modified to use integer value for offs 12/8/2010
            do 117 i = 1,ie 
 117        ix(i) = ix(i) + nint(offs)
            if(ifout.ne.0) call intio(ix,irl,irh,ifout,-1) 
         endif
         if(ifout.lt.0) then
            call realio(x,irl,irh,ifin,0) 
            do 119 i = 1,ie 
 119        x(i) = x(i) + offs
            call realio(x,irl,irh,ifout,-1) 
         endif
         irl = irh + 1 
         if(irh.lt.isted) go to 115
      endif
c   if we have done up to end of file, exit 
      if(isted.eq.irntot) stop
c 
c   now deal with edit (area of bad data), resetting iened to be the 
c   end of this particular edit. (the bad points are isted+1 through 
c   iened-1). special treatment is needed to deal with the case
c   where the file "ends" inside an edit
c 
      iened = isted + ied(3,ll) 
      if(isted+ied(3,ll).gt.irntot) iened=isted 
c   interpolate across gap unless there is not one,
c   reading in data from around edit as needed
      if(ied(3,ll).eq.1) go to 167 
      if(ifil.ne.'c'.and.ifil.ne.'f') then
c get the values around the edited area
         if(ifout.gt.0) then
            rs = ix(ie) 
            call intio(ix,isted,isted,ifin,0) 
            if(ifin.eq.ifout.and.offs.eq.0.) rs = ix(1) 
            call intio(ix,iened,iened,ifin,0) 
            xd = ix(1)
         endif
         if(ifout.lt.0) then
            rs = x(ie)
            call realio(x,isted,isted,ifin,0) 
            if(ifin.eq.ifout.and.offs.eq.0.) rs = x(1)
            call realio(x,iened,iened,ifin,0) 
            xd = x(1) 
         endif
c  compute the slope of the line to interpolate or add
         if(ifil.eq.'n'.or.ifil.eq.'o')
     1       dec = (xd+offs+ied(2,ll)-rs)/ied(3,ll)
         if(ifil.eq.'s') dec = float(ied(2,ll))/float(ied(3,ll))
         is = 0
c   if edit falls on end of file, reset end point to last term
         if(isted+ied(3,ll).gt.irntot) iened=irntot+1
      endif
c   now fill in the edited area
      irl = isted + 1
 125  irh = min(irl+1199,iened-1)
      ie = irh - irl + 1 
      if(ifout.gt.0) then
         if(ifil.eq.'s') call intio(ix,irl,irh,ifin,0)
         do 127 i = 1,ie
         if(ifil.eq.'f' .or. ifil.eq.'c') ix(i) = nint(fill)
         if(ifil.eq.'n' .or. ifil.eq.'o') ix(i) = nint(rs + (is+i)*decr)
 127     if(ifil.eq.'s') ix(i) = ix(i) + nint((is+i)*dec + offs)
         if(ifout.ne.0) call intio(ix,irl,irh,ifout,-1) 
      endif
      if(ifout.lt.0) then
         if(ifil.eq.'s') call realio(x,irl,irh,ifin,0)
         do 129 i = 1,ie
         if(ifil.eq.'f' .or. ifil.eq.'c') x(i) = fill
         if(ifil.eq.'n' .or. ifil.eq.'o') x(i) = rs + (is+i)*dec 
 129     if(ifil.eq.'s') x(i) = x(i) + (is+i)*dec 
         call realio(x,irl,irh,ifout,-1) 
      endif
      irl = irh + 1
      is = is + ie
      if(irh.lt.iened-1) go to 125
      if(irh.eq.irntot) stop
 167  offs = offs + ied(2,ll) 
      ll = ll + 1 
      if(ll.gt.200) then
c    read in next batch of edits
         ll = 1
         ierl = ierh + 1
         ierh = min(itned,ierl+599)
         call intio(ied,ierl,ierh,ifed,0) 
      endif
 171  continue
      stop
c
c this section is for the binary output file
c
401   call intio(ix,irntot,irntot,ifout,-1)
      do 423 k=1,ned+1
      if(k.le.ned) isted = min(iened + ied(1,ll),irntot) 
      if(k.gt.ned) isted = irntot 
      irl = iened 
405   irh = min(irl+1199,isted) 
      ie = irh - irl + 1 
      do i = 1,ie 
         ix(i) = 0
      enddo
      call intio(ix,irl,irh,ifout,-1) 
      irl = irh + 1 
      if(irh.lt.isted) go to 405
      irl = isted + 1
c  if we have done up to end of file, exit 
      if(isted.eq.irntot) stop
      iened = isted + ied(3,ll)
      if(isted+ied(3,ll).gt.irntot) iened=isted 
      if(ied(3,ll)+izp.ne.1) then
C         is =40
c  if edit falls on end of file, reset end point to last term
         if(isted+ied(3,ll).gt.irntot) iened=irntot+1
 413     irh = min(irl+1199,iened-1+izp)
         ie = irh - irl + 1 
         do i = 1,ie
           ix(i)=1
         enddo
         call intio(ix,irl,irh,ifout,-1) 
         irl = irh + 1
         is = is + ie
         if(irh.lt.iened-1) go to 413
         if(irh.eq.irntot) stop
      endif
      ll = ll + 1 
      if(ll.gt.200) then
c   read in next batch of edits
         ll = 1
         ierl = ierh + 1
         ierh = min(itned,ierl+599)
         call intio(ied,ierl,ierh,ifed,0) 
       endif
 423  continue
      stop
      end
