c  program bsmflat
c
c    computes a drift curve for a borehole strainmeter, and subtracts
c  it from the data; drift may include up to 5 exponentials, a trend,
c  and an offset.
c
c    $calls hedlib,iolib
c
      character*1 not,ished,mode
      double precision aexp,off,sl
      dimension aexp(5),texp(5),x(600),y(600)
      dimension it(5),it2(5),itr(5)
      data irlo/1/,irli/1/,mode/'d'/
      data nexp/1/
      write(6,100)
 100  format(' Reference time (y,d,h,m,s); ',$)
      do i=1,5
         itr(i) = ffin(1,not)
      enddo
      write(6,102)
 102  format(' Start time (y,d,h,m,s, or nnnh for header); ',$)
      it(1) = ffin(1,ished)
      if(ished.ne.'h') then
         do i=2,5
            it(i) = ffin(1,not)
         enddo
         if(it(1).lt.1900) stop
         write(6,104)
 104     format(' Number of terms; ',$)
         irnt = ffin(1,not)
         write(6,106)
 106     format(' Sample interval (sec); ',$)
         isamp = ffin(1,not)
      endif
      if(ished.eq.'h') then
c   get time from header (it2 will have end time--not used)
         nfl=it(1)
         call hedtim(nfl,it,it2,irnt,samp)
         isamp=nint(samp)
      endif
c find number of terms between term 1 of series and the reference time
      ioff=iscnsp(itr,it,isamp,mode)
 3    write(6,110)
 110  format(' Scale factor; ',$)
      scl=ffin(1,not)
      write(6,111)
 111  format(' Number of exponentials (5 max); ',$)
      nexp=ffin(1,not)
      if(nexp.gt.5) go to 3
      if(nexp.gt.0) then
        do i=1,nexp
          write(6,112) i
 112      format(' Enter amplitude and time constant for number ',
     1        i1,'; ',$)
          aexp(i)=scl*ffin(1,not)
          texp(i)=ffin(1,not)
c
c normalize to actual sample interval, and adjust amplitudes to be at
c term 1 of series, rather than the reference time
c
          texp(i)=texp(i)*(isamp/86400.)
          aexp(i)=aexp(i)*exp(ioff*texp(i))
        enddo
      endif
      write(6,114)
 114  format(' Trend and offset; ',$)
      sl=scl*ffin(1,not)
      sl=sl*(isamp/86400.)
      off=scl*ffin(1,not)
      off=off+sl*ioff
      write(6,120)
 120  format(' Input file (0 if none); ',$)
      ifin = ffin(1,not)
      if(ifin.ne.0) then
         if(irnt.le.0) irnt=longis(ifin)
         write(6,122)
 122     format(' First term to take (start time assumed @ term 1); ',$)
         irli = ffin(1,not)
         if(irli.gt.1) irnt = irnt + irli - 1
      endif
      write(6,126)
 126  format(' Output file; ',$)
      ifout = ffin(1,not)
c
c  set up coefficients for the start point
c
      nt=irli-1
      off=off+sl*nt
      do i=1,nexp
        aexp(i)=aexp(i)*exp(nt*texp(i))
      enddo
      call realio(x,1,1,ifout,1)
 31   irhi = min(irli+599,irnt)
      np = irhi - irli + 1
      irho = irlo + np - 1
c
c  compute the correction series
c
      do j=1,np
         x(j)=off+sl*(j-1)
         do i=1,nexp
            x(j) = x(j) + aexp(i)*exp((j-1)*texp(i))
         enddo
      enddo
      if(ifin.ne.0) then
         call realio(y,irli,irhi,ifin,0)
         do j=1,np
           x(j) = y(j) - x(j)
         enddo
      endif
      call realio(x,irlo,irho,ifout,-1)
c
c increment coefficents for the next segment
c
      off=off+sl*np
      do i=1,nexp
        aexp(i)=aexp(i)*exp(np*texp(i))
      enddo
      if(irhi.eq.irnt) go to 37
      irli = irhi + 1
      irlo = irho + 1
      go to 31
 37   write(6,130) irho
 130  format(i8,' terms written out')
      stop
      end
