c      program comtid
c
c  does cross-spectrum between two tidal series, 
c  sampled at 3 hour intervals, and prints out results
c  section by section to check for admittance changes
c
c    calls sft,dtren,realio
c
      character*1 not
      dimension x(1100),cspc(5),qspc(5),asi(5),aso(5),
     1 psi(4),pso(4),csq(4),cohp(4),uncp(4),radm(4),urad(4),
     2 tpow(5),rc(5,2),rs(5,2),sno(10,2),cno(10,2),ampl(200),
     3 ph(200),date(200),ibe(1100)
      dbz(dum) = 10.*alog10(dum+1.e-9)
      data pi/3.1415926536/,cspc,qspc,tpow,asi,aso/25*0./,
     1 psi,pso,csq,cohp,uncp,radm/24*0./,cno,sno/40*0./,
     2  yl/8766./,nfno/10/
      rd = 180./pi
      write(6,100)
 100  format(' Input (noise-free) file and start term; ',$)
      ifi = ffin(1,not)
      irli = ffin(1,not)
      write(6,101)
 101  format(' Time of first point taken (y,d,h):; ',$)
      iy = ffin(1,not)
      id = ffin(1,not)
      ih = ffin(1,not)
      stt = iy + (24.*id+ih)/yl
      write(6,102)
 102  format(' Output file and start term; ',$)
      ifo = ffin(1,not)
      irlo = ffin(1,not)
      write(6,104)
 104  format(' Number of terms; ',$)
      irnt = ffin(1,not)
      write(6,105)
 105  format(' Type 1 for O1, 2 for M2; ',$)
      ityte = ffin(1,not)
      write(6,106)
 106  format(' Transform length; ',$)
      itl = ffin(1,not)
      write(6,107)
 107  format(' Type 1 for spectrum in physical units; ',$)
      iphz = ffin(1,not)
      pcor = 0.
      if(iphz.ne.1) go to 3
      write(6,120)
 120  format(' Units per l.c.; ',$)
      gain = ffin(1,not)
      pcor = 43.445 + 20.*alog10(gain)
 3    nsec = 2*irnt/itl -1.
      write(6,108)
 108  format(' Number of harmonics to average over (odd); ',$)
      nhav = ffin(1,not)
c  find the harmonics at which the tidal groups are centered, for
c  3 hour data and the given section length
      cf = (.966136708*itl)/8.
      nch = cf + .5
      fbg = (.036601102*itl)/8.
      nhg = fbg + .5
      if(nsec.lt.1) stop
      write(6,200)
 200  format(' Binary edits file (0 if none); ',$)
      ibfl = ffin(1,not)
      if(ibfl.ne.0) then
         write(6,202)
 202     format(' Minimum acceptable fraction; ',$)
         okno = ffin(1,not)
      endif
      wnorm = 0.
      do 55 i = 1,itl
 55   wnorm = wnorm + 1. - cos((2.*pi*(i-1.))/itl)
      kksec = 1
      do 25 ii = 1,nsec
      irhi = irli + itl -1.
      irho = irlo + itl -1.
      time = stt + (3*(irli-1.+itl/2.))/yl
      do 20 kk = 1,2
      if(kk.eq.1) call realio(x,irli,irhi,ifi,0)
      if(kk.eq.2) call realio(x,irlo,irho,ifo,0)
      if(ibfl.ne.0) then
         call intio(ibe,irlo,irho,ibfl,0)
         wt = 0
         do 57 i = 1,itl
 57      if(ibe(i).eq.0) wt = wt + 1. - cos((2.*pi*(i-1.))/itl)
         wt = wt/wnorm
      endif
      call dtren(x,itl)
      do 5 i = 1,itl
      x(i) = x(i)*(1. - cos((2.*pi*(i-1.))/itl))
      if(ibfl.ne.0) x(i)=x(i)*(1-ibe(i))
 5    continue
      om = ityte*nch - (nhav/2) 
      if(ityte.eq.1) om = om - nhg
      dom = 1./itl
      om = om/itl
      call sft(x,itl,om,dom,nhav,rs(1,kk),rc(1,kk))
c  evaluate noise at bottom edge of tidal band
      om = ityte*nch - (nhav/2) - 4*nhg - nfno
      om = om/itl
      dom = 1./itl
      call sft(x,itl,om,dom,nfno,sno(1,kk),cno(1,kk))
 20   continue
c advance by half a section (for next pass) and if there are enough
c data, do the rest of the analysis
      irli = irli + itl/2
      irlo = irlo + itl/2
      if(ibfl.ne.0.and.wt.lt.okno) go to 25
      do 21 j = 1,nhav
      cspc(j) =  rs(j,1)*rs(j,2) + rc(j,1)*rc(j,2)
c  sign convention for quadrature spectrum is -i (delay gives
c  a phase lag)
      qspc(j) =  -rs(j,1)*rc(j,2) + rc(j,1)*rs(j,2)
      sp = rc(j,1)**2 + rs(j,1)**2
      sp2 = rc(j,2)**2 + rs(j,2)**2
      asi(j) =  sp
      aso(j) =  sp2
 21   tpow(j) =  sqrt(sp*sp2)
      psi(1) =0.
      pso(1) = 0.
      cohp(1) =0.
      uncp(1) = 0.
      radm(1) = 0.
      do 35 i = 1,nhav
      psi(1) = psi(1) + asi(i)
      pso(1) = pso(1) + aso(i)
      cohp(1) = cohp(1) + cspc(i)
      uncp(1) = uncp(1) + qspc(i)
 35   radm(1) = radm(1)  + tpow(i)
      p = nhav*int(1.4*irnt/itl)
      df = 2.*p
      rnt = 1.5*itl*nhav
c  compute various cross-spectral parameters
      csq(1) = (cohp(1)**2+uncp(1)**2)/(psi(1)*pso(1))
      radm(1) = cohp(1)/psi(1)
      urad(1) = uncp(1)/psi(1)
      x(1) = sqrt(radm(1)**2+urad(1)**2)
      x(31) = (180./pi)*atan2(urad(1),radm(1))
      if(x(31).le.-90) x(31)=x(31)+360
      psi(1) = dbz(psi(1)/rnt) 
 40   pso(1) = dbz(pso(1)/rnt) + pcor
      psi(2) = 0.
      pso(2) = 0.
      do 50 j = 1,nfno
      psi(2) = psi(2) + cno(j,1)**2 + sno(j,1)**2
 50   pso(2) = pso(2) + cno(j,2)**2 + sno(j,2)**2
      ornt = 1.5*itl*nfno
      psi(2) = dbz(psi(2)/ornt)
      pso(2) = dbz(pso(2)/ornt) + pcor
      err = pso(1)-pso(2)
      err = 10.**(err/10.)
      err = sqrt(1./(2.*err))
      perr = rd*atan(err)
c now write out the results
      if(ii.eq.1.and.ibfl.eq.0) write(6,110)
 110  format(3x,'time',t10,'amplitude',t23,'phase',t36,'sig in',
     1 t49,'noise in',t62,'sig out',t75,'noise out',//)
      if(ibfl.eq.0) write(6,112) time,x(1),x(31),(psi(i),pso(i),i=1,2)
 112  format(2x,f7.2,6g13.5)
      if(ibfl.ne.0.and.ii.eq.1) write(6,111)
 111  format(3x,'time',t10,'amplitude',t36,'phase',t62,'weight')
      if(ibfl.ne.0) write(6,113)  time,x(1),err,x(31),perr,wt
 113  format(f9.4,5g13.5)
      ia = 3*kksec
      ib = ia-1
      ic = ib -1
      date(ia) = time
      date(ib) = time
      date(ic) = time
      ampl(ia) = x(1) - err
      ampl(ib) = x(1) 
      ampl(ic) = x(1) + err
      ph(ia) = x(31) + perr
      ph(ib) = x(31)
      ph(ic) = x(31) - perr
      kksec = kksec + 1
 25   continue
      call retnio(ibfl)
      call retnio(ifi)
      call retnio(ifo)
      write(6,150)
 150  format(' Files for time, amp, ph; ',$)
      ifi = ffin(1,not)
      if(ifi.eq.0) stop
      ifo = ffin(1,not)
      ia  = ffin(1,not)
      irr = 3*nsec
      call realio(date,1,irr,ifi,1)
      call retnio(ifi)
      call realio(ampl,1,irr,ifo,1)
      call realio(ph,1,irr,ia,1)
      write(6,152) irr
 152  format(i8,' terms written to each file')
      stop
      end
