c  ncredit
c   program for looking at data on tektronix and using cursor to locate
c   points within it.  can be used in two modes: display (look at points,
c   perhaps with decimation), and edit (specify locations of bad data
c   and amounts of offset to be put in).  in edit mode the original
c   file is not touched, but a file of edit commands is written to disk.
c
c     link with ncredsubs, dshoget, curs, xedit, secdat, predic, grafic,dumio
c
      character*1 not,icmd1,icmd2,modtim
      character*8 source,chanid
      character*4 stc,commen
      character*4 month 
      character*3 weekd
      character*10 dumm
      logical iblank,allblk,blnkit,sync,cline
      double precision scans
      integer ioff
      dimension x(1020),icmd1(11),icmd2(31),
     1 itim0(5),itim1(5),itim2(6),month(12) 
      dimension jgap(2,500),joff(500)
c   block containing information on series displayed (see shoget)
      common/sam/itl,ith,idec,ie,ymin,ymax,isc,ifil,irntot
c   block containing control information for screen printing
      common/tkcon/isp,nmsec
c   block containing edit commands (see xedit)
      common/edits/igap(2,4000),ioff(4000),ned
c   block containing information for prediction (see predic)
      common/pred/errmax,ibef,iaft,ibecon,fm,sd,tsd,ivrj,smsq
c   block containing prelabelled bad points (see predic)
      common/scrpd/ibadpt(500),ibpind,numbad,modepr
c   block containing information about blanking the plot
      common/fade/iblank(1020),allblk,blnkit,sync
c   block containing information to be passed to fedcon
      common/minedt/mlen
c   block containing header information (used for start time)
      common/head/scans,calc(4),clkc(2),sampin,nchann,iblock,istart(5),
     1     iend(5),nchf(17),ichnm(16),ncal(4),source,chanid(16),stc,
     2     commen(200)
C old    common/head/stc,source,calc(4),clkc(2),nchann,iblock,istart(5)
C old   1     iend(5),scans,sampin,nchf(17),ichnm(16),chanid(16),ncal(4)
C old   2     commen(200
c
      data isc,ifl4,ifl5,ifl6,ifl7,ned/6*0/,idcd,ibpind,
     1 ibecon/3*1/,ers/1./,ibpct,ivrj/0,0/,numbad/500/,modepr/0/,
     2 smsq/0./,blnkit/.true./,sync/.true./modtim/'d'/
c  number of "pre-edit", "offset" and "all-edit" commands
      data nxc1/18/,nxc2/8/,nxc3/13/iflmt/0/
      data ileft/0/,iright/0/,iedtot/0/
      data icmd1/'?','x',' ','l','d','u','s','m','v','c','b'/
      data icmd2/'?','h','e','f','p','z','t','k','y','b','n','a',
     1           '8','9','7','-','=','S',
     2           'g','o','1','2','!','3','4','5','6','`','r','i','q'/
      data month/'Jan ','Feb ','Mar ','Apr ','May ','June','July',
     1 'Aug ','Sept','Oct ','Nov ','Dec '/
      data cline/.false./
c
c   get preliminary information
c
      if(iargc().eq.1) then
        write(6,1090)
 1090   format('  credit file start-term old-edits new-edits ')
        stop
      endif
      if(iargc().eq.4) cline = .true.
      ned = 0
      mlen = 480
 5    continue
      if(.not.cline) then
        write(6,1100)
 1100   format(' File number        ',$)
        ifil = ffin(1,not)
      endif
      if(cline) then
        call getarg(1,dumm)
        read(dumm,1092) ifil
 1092   format(i7) 
      endif
      irntot = longis(ifil)
      if(irntot.le.0) write(6,1102)
 1102 format(' Bad file number - try again')
      if(irntot.le.0.and..not.cline) go to 5
      if(irntot.le.0.and.cline) stop
      if(.not.cline) then
         write(6,1104)
 1104    format(' Start term         ',$)
         start = ffin(1,not)
      endif
      if(cline) then
        call getarg(2,dumm)
        read(dumm,1094) start
 1094   format(f7.0) 
      endif
      if(start.lt.0) then
        sync=.false.
        start=-start
      endif
      if(.not.cline) call limset(ymin,ymax,isc,1)
      if(cline) then
        isc=1
        ymin=0
        ymax=0
      endif
C      write(6,*) ymin,ymax,isc
      if(.not.cline) then
        write(6,1108)
 1108   format(' Mode of operation (1 for editing, 0 for display)'
     1   ,6x,' ',$)
        ifl1 = ffin(1,not)
        if (ifl1.le.0) ifl1 = 0
        if (ifl1.ge.1) ifl1 = 1
      endif
      if(cline) ifl1=1
      if(.not.cline) then
 55     write(6,1110)
 1110   format(' Decimation factor (typically 1 for editing)'
     1   ,11x,' ',$)
        idcd = ffin(1,not)
        if (idcd.lt.1) go to 55
        if (idcd.ne.1) then
         write (6,1112)
 1112    format(' Type of decimation (0 for straight, 1 for min/max)'
     1    ,4x,' ',$)   
         idebt = ffin(1,not)
        endif
        if (idcd.gt.1.and.idebt.eq.0.and.ifl1.eq.1) write(6,1114)
 1114   format(' Warning: If you choose to edit with straight',
     1   ' decimation, you will not see every point.')
      endif
      if(cline) idcd=1
      if(.not.cline) then
        write(6,1116)
 1116   format(' Number for previous edits file (0 for none):'
     1    ,3x,' ',$)
        ifiled = ffin(1,not)
      endif
      if(cline) then
        call getarg(3,dumm)
        read(dumm,1092) ifiled
      endif
      ifirntt = longis(ifiled)
      if(ifirntt.le.0) go to 3
      ifirntt = longis(ifil)
      if (ifl1.eq.0) go to 3
      if(.not.cline) then
        write(6,1118)
 1118   format(' Apply edits (1) or simply show them (0):'
     1   ,14x,' ',$)
        itest = ffin(1,not)
      endif
      if(cline) itest=1
      if (itest.eq.1) then
         ned = 4000
         call fedcon(ned,igap,ioff,1,ifirntt,ifiled)
      endif
 3    continue
      if(.not.cline) then
        write(6,1120)
 1120   format(' Predictor weights (type 1 if wanted, -1 for prelab) ',
     1     1x,' ',$)
        ifl7 = ffin(1,not)
      endif
      if(cline) ifl7=0
      if (ifl1.ne.0) then
 188    continue
        if(.not.cline) then
          write(6,1130)
 1130     format(' File number for writing out edits:',20x,' ',$)
          ifed = ffin(1,not)
        endif
        if(cline) then
          call getarg(4,dumm)
          read(dumm,1092) ifed
        endif
        if (ifed.lt.100.and.ifed.gt.-100) go to 188
        if (ifed.eq.ifiled.and.itest.ne.1) then
           write (6,1132)
           go to 188
 1132   format ('Edits file OUT cannot be the same as file IN '
     1   ,'when only displaying the old edits file.')
        endif
CC        call intio(nex,1,1,ifed,1)
        if(ifirntt.gt.0) call fedcon(ned,igap,ioff,0,ned,ifed)
      endif
      if(ifl7.eq.-1) then
         numbad=500
         write(6,1133)
 1133    format(' Edits file containing flagged points; ',15x,' ',$)
         ifedfl=ffin(1,not)
         call edcon3(ifedfl,numbad,jgap,joff,1,0)
         do kk=1,numbad
            ibadpt(kk)=jgap(1,kk)
         enddo
         modepr=ifl7
         ifl7=1
      endif
      if(ifl7.ne.1) go to 8
c   next 9 statements handle prediction error detection and
c   display of bad data after error is found.  this block
c   can only be reached from above or from statement 37.
 4    ibecon = max(ibecon,igap(2,ned))
      call predic(x,ibpl,res)
      if(ibpl.lt.1) go to 9
      call limset(ymin,ymax,isc,-1)
      if (idebt.eq.1) then
         call dshoget(x,ers,ned*ifl1)
      else
         call shoget(x,ers,ned*ifl1)
      endif
      if(ifirntt.gt.0) call showedits(ifiled,ifirntt)
      call resett(isp)
      if(ivrj.eq.0.and.modepr.eq.0) write(6,1122) ibpl,res
 1122 format(11x,'Term',i8,' is bad, with residual',g13.5)
      if(ivrj.ne.0.and.modepr.eq.0) write(6,1124) ibpl,res,res/sd
 1124 format(1x,'Term',i8,' is bad, with residual',g13.5,
     1 ' (',g13.5,' st. dev.)')
      if(modepr.eq.-1) then
          write(6,1126) ibpl
 1126     format(1x,'Term',i8,' is bad (preset)')
          if(ibpind.gt.numbad) then
             write(6,1127)
 1127        format('---This is THE LAST bad point ')
             ibpind=ibpind-1
          endif
      endif
      isp = isp + 1
      go to 30

c**************************************************************
c
c  **done with preliminaries**
c
c**************************************************************
 8    itl = start
C      if(cline) write(6,*) ifil,itl,ifl1,isc,ifiled,ifed
C      if(cline) stop
c
c   display a page of data
c
      oldst = itl
      ith = itl+idcd*1000 -1
      call limset(ymin,ymax,isc,-1)
      if (idebt.eq.1) then
         call dshoget(x,ers,ned*ifl1)
      else
         call shoget(x,ers,ned*ifl1)
      endif
      if(ifirntt.gt.0) call showedits(ifiled,ifirntt)
c   move forward by one page
      if(ith+idec.lt.irntot) start = ith + idec
c   if we have reached the end of the file, print a warning
c   (this is the entry point for return from commands for formatting reasons)
 9    if(ith+idec.ge.irntot) then
          write(6,1140)
 1140     format(' End of series - type "s" to reset start term, ',
     1     '"x" to exit')
          isp = isp + 1
      endif
c   issue a prompt, and get non-cursor commands
      call curs(11,icmd1,ix,iy,ifl2,0)
c
c  go to various points, depending on non-cursor command
c
      go to (12,15,18,21,24,25,27,28,29,30,26) ifl2
c   ? - list non-cursor commands
 12   write(6,1142)
 1142 format(' Commands are:',/2x,'<cr> to continue on',
     1 /5x,'c to get cursor',/,5x,'l to reset plot limits',
     2 /,5x,'s to reset start term',/5x,'d to reset decimation',
     3 ' factor',/,5x,'m to reset largest ok residual',/5x,
     4 'v to get (and reset) current estimate of variance',
     5 /,5x,'u to unblank (or reblank) edits',
     5 /,5x,'b to change banner edits file',
     6 /,5x,'x to exit')
      isp = isp + 11
      go to 9
c_______________________________________________
c   x - exit, writing file of edits if necessary
 15   if(ifl1.ne.0) then
        itmp = ned
        call fedcon(ned,igap,ioff,0,ned,ifed)
        write(6,1144) ifil
 1144   format(' Data file edited was number ',i6)
        write(6,1146) ned,ifed
 1146   format(i3,' edits written to file ', i6)
      endif
      if(sync) call crsync(itl,ith,iedtot,0)
      stop
c_______________________________________________
c   <cr> - continue paging
 18   go to 8
c_______________________________________________
c   l - reset limits
 21   call limset(ymin,ymax,isc,1)
      isp = isp + 1
      go to 9
c_______________________________________________
c   d - reset decimation factor (not allowed in edit mode)
 24   if(ifl1.eq.1) go to 9
      write(6,1110)
      idcd = ffin(1,not)
      isp = isp + 1
      go to 9
c_______________________________________________
c   u - flip state of blanking
 25   blnkit = .not.blnkit
      if(blnkit) write(6,1150)
      if(.not.blnkit) write(6,1152)
 1150 format(' Edits will be blanked out ')
 1152 format(' Edits will not be blanked out ')
      isp = isp + 1
      go to 9
c_______________________________________________
c   b - change edits file for flagging
 26   write(6,1116)
      isp=isp+1
      ifiled = ffin(1,not)
      ifirntt = longis(ifiled)
      if(ifirntt.le.0) go to 9
      ifirntt = longis(ifil)
      go to 9
c_______________________________________________
c   s - alter start term
  27  write(6,1104)
      start = ffin(1,not)
      isp = isp + 1
      go to 9
c_______________________________________________
c   m - change size of largest allowable residual (or, if we are using a
c       time-varying error criterion, change allowable no. of std. dev.'s)
c       (not allowed unless prediction error scanning is being used)
 28   if(ifl7.ne.1) go to 9
      write(6,1154)
 1154 format(' Largest acceptable residual ',$)
      errmax = ffin(1,not)
      tsd = errmax
      if(ivrj.ne.0) errmax=tsd*sd
      isp = isp + 1
      go to 9
c_______________________________________________
c   v - get current estimate of variance, and change it if so desired
c       (not allowed except in edit mode and with time-varying
c       prediction error criterion enabled).
 29   if(ivrj.eq.0) go to 9
      write(6,1156) sd
 1156 format(' Estimated standard deviation of residuals is',
     1 g13.5,/5x,'enter new one (0 to leave as is) ',$)
      isp = isp + 2
      sd = ffin(1,not)
      if(sd.le.0.) go to 9
      smsq = (sd**2)*fm
      go to 9
c===============================================================
c===============================================================
c
c   c - display cursor and accept commands.  only exit from this
c       part of the program to that above is to type 'e' or 'f'.
c
c===============================================================
c===============================================================
 30   call curs(31,icmd2,ix,iy,ifl3,1)
      dx = 1020.*idec/(ith-itl)
      nt = nint(ix/dx + 1.)
      if(nt.gt.ie) then
         write(6,1158)
 1158    format(' cursor not on plot')
         go to 30
      endif
      isp=isp+1
c   itn is term number (in series) and nt the element of x selected
      itn = itl + (nt-1)*idec
c   edit commands not allowed in display mode, and commands that fill
c   edit array not allowed unless prepared for (ifl6.ne.0), and then
c   must be entered propeirly (1,2,(3,4,5,6), in order, but non-edit
c   commands may be interspersed).
      if  ((ifl1.eq.0.and.ifl3.gt.nxc1.and.ifl3.le.nxc1+nxc3).or.
     1  ((ifl3.gt.nxc1+2.and.ifl3.le.nxc1+nxc2+2).and.
     2 ((ifl6.eq.0).or.
     3  (ifl6.eq.1.and.ifl3.ne.nxc1+3).or.
     4  (ifl6.eq.2.and.ifl3.ne.nxc1+4).or.
     5  (ifl6.eq.3.and.ifl3.le.nxc1+4)))
     6 .or.(ifl6.ne.0.and. (ifl3.ge.nxc1+nxc2+3.or.
     7 (ifl3.gt.nxc1.and.ifl3.le.nxc1+2)))) then
         write(6,1160)
 1160    format(' Command Unacceptable')
         go to 30
      endif
      go to (33,35,36,37,39,42,45,451,50,51,52,54, 
     1    120,125,130,42,42,42,
     2       60,60,65,70,73,75,80,85,90,95,100,105,110) ifl3
C      data nxc1/18/,nxc2/8/,nxc3/13/iflmt/0/
C      data icmd1/'?','x',' ','l','d','u','s','m','v','c','b'/
C      data icmd2/'?','h','e','f','p','z','t','k','y','b','n','a',
C     1           '8','9','7','-','=','S',
C     2           'g','o','1','2','!','3','4','5','6','`','r','i','q'/
c_______________________________________________
c   ? - list commands
  33  write(6,1162)
 1162 format(' Commands are:',/,5x,'p to get term number'
     1,'and value',/,5x,'z to zoom in or out',/,5x,
     1 '8 for left zoom limit',/,5x,'9 for right zoom limit',
     1 /,5x,'7 for old zoom limits',/,5x,
     2 'y to get y cursor value',/,5x,'t to get time of a ',
     3 'term',/,5x,'k to reset the time information',/,5x,
     4 'f to resume prediction scanning',/,5x,
     5 'b to advance start point of prediction scanning',/5x,
     6 'n to note a bad point',/,5x,'a to overplot another file',
     7 /,5x,'g to edit a glitch',/,5x,'o to edit an offset',/,
     8 5x,'r to reject a new edit',/,5x,'i to increment an ',
     9 'offset',/,5x,'q to find out about last edit',/5x,
     1 'h to hold (exit with same start as entered with)',/5x,
     2 'e to exit (with new start)')
      isp = isp + 15
      go to 30
c_______________________________________________
c   h - return to non-cursor part, but with start point reset to value
c       it had upon entering
 35   start = oldst
      go to 9
c_______________________________________________
c   e - return to non-cursor part
 36   go to 9
c_______________________________________________
c   f - resume prediction error scanning
 37   if(ifl7.ne.1) then
         write(6,1160)
         go to 30
      endif
      go to 4
c_______________________________________________
c   p - give term number and value
 39   thepold=thepnew
      thepnew=x(nt)
      write(6,1164) itn, x(nt), thepold-thepnew
 1164 format(' Term number ',i8,' with value',g13.5,
     1 ' Diff(values): ',g13.5)
      go to 30
c_______________________________________________
c   z : zoom in or out around cursor
c   - : zoom with half the range as before
c   = : zoom with twice the range as before
c   S : replot with limits taken from synch file
 42   ioldleft=itl
      ioldright=ith 
C     write(6,*) itl,ith,idec,ix,iy,ifl3,ileft,iright
C     if(ifl3.gt.0) stop
c   cursor must be on plot
      if (ileft.lt.iright) then
         itl = ileft
         ith = iright
      else
         if(ifl3.eq.6) then
            write(6,1166)
 1166       format(' Width (+ and -) ',$)
            iw = ffin(1,not)
         endif
         if(ifl3.eq.16) then
            iw=4.*(ith-itl)/2.
         endif
         if(ifl3.eq.17) then
            iw=.25*(ith-itl)/2.
         endif
         itl = itn-iw
         ith = itn+iw
         if(ifl3.eq.18.and.sync) call crsync(itl,ith,iedtot,-1)
      endif
      ileft=iright
      call limset(ymin,ymax,isc,-1)
      if (idebt.eq.1) then
         call dshoget(x,ers,ned*ifl1)
      else
         call shoget(x,ers,ned*ifl1)
      endif
      if(ifirntt.gt.0) call showedits(ifiled,ifirntt)
      go to 30
c_______________________________________________
c   t - find time of term.  ifl4 governs asking of preliminary questions,
c       and ifl5 = 1 if seconds may be fractional.  secdat and 
c       datsec reckon in days from start of current year, so we set
c       up a reckoning in days from the start of the last preceding
c       leap year (nyr) to supplement it.  calendar algorithims assume
c       that all years divisible by 4 are leap years.
c   k - additional entry point in case the start time was wrong
 451  ifl4=0
 45   if(ifl4.eq.0) then
         ifl4 = 1
c   k - additional entry point in case the start time was wrong
         write(6,1168)
 1168    format(' Start time of series (y,d,h,m,s)',
     1    ' [nnnh for header file]: ',$)
         itim0(1) = ffin(1,not)
         if(not.eq.'h') then
	    call headco(itim0(1),1)
            do i=1,5
              itim0(i) = istart(i)
            enddo
	    isamp = sampin
         else
            do i = 2,4
              itim0(i) = ffin(1,not)
            enddo
            sec = ffin(1,not)
            itim0(5) = sec
            rem = sec - itim0(5)
            if (rem.ge.1.e-3) ifl5 = 1
            write(6,1170)
 1170       format(' Sample interval (sec): ',$)
            samp = ffin(1,not)
            isamp=samp
            rsamp=samp-isamp
            if(rsamp.gt.1.e-2) ifl5 = 1
         endif
         isp=isp+2
      endif
      if(ifl5.ne.1) then
         call timfnd(itim0,isamp,itn-1,itim1,modtim)
         call toymd(itim1,itim2)
         call weekday(itim2,weekd,'m')
         write(6,1172) itim1,weekd,month(itim2(2)),itim2(3)
 1172    format(' Term is at time ',i6,i5,3i4,4x,'(',a3,1x,a4,i3,')')
         go to 30
      endif
c   fractional seconds
      if(ifl5.eq.1) then
C         rem = dmod(ks,1.d0)
C         sec = kct(4) + rem
C         write(6,1174) kyr, (kct(i),i=1,3),sec
          write(6,1174) 
 1174 format(' Fractional seconds not supported')
      endif
      go to 30
c_______________________________________________
c   y - give location of horizontal cursor (y coordinate)
 50   if(ymin.ne.ymax) yv = ymin + (iy/780.)*(ymax-ymin)
      if(ymin.eq.ymax) yv = ymin
      yoldpos=ynewpos
      ynewpos=yv
      write(6,1176) yv,yoldpos-ynewpos
 1176 format(' Horizontal cursor is at ',g13.5, '  Diff: ',g13.5)
      go to 30
c_______________________________________________
c   b - reset pointer for start of convolution
 51   ibecon = itn
      go to 30
c_______________________________________________
c   n - note the location of a bad point for later editing
c       (not allowed unless we are using prediction error )
 52   if(ifl7.ne.1) then
         write(6,1160)
         go to 30
      endif
      if(numbad.eq.500) then
         write(6,1180)
 1180    format(' List of bad points full - do some edits')
         go to 30
      endif
      ibpct = mod(ibpct,500) + 1
      ibadpt(ibpct) = itn
      numbad = numbad +1
      write(6,1182) itn,numbad
 1182 format(' Term',i8,' noted as bad. list position',i3)
      go to 30
c_______________________________________________
c   a - overplot another series from a different file. note that until
c       a series from the main file is replotted, the data in x will be
c       from the other file.
 54   write(6,1184)
 1184 format(' File number (trailing O to offset in x, C or c '
     1      ,'to clear screen)       ',$)
      nt = ifil
      ifil = ffin(1,not)
      itlo = itl
      itho = ith
      if(not.eq.'O') then
	 write(6,1186)
 1186    format(' Number of terms to offset additional series by ',$)
         iadoff = ffin(1,not)
	 itl = itl - iadoff
	 ith = ith - iadoff
      endif
      ersa=0.
      if(not.eq.'C'.or.not.eq.'c') ersa=1
      call limset(ymin,ymax,isc,0)
      isp = isp + 3
      if (idebt.eq.1) then
         call dshoget(x,ersa,0)
      else
         call shoget(x,ersa,0)
      endif
      itl = itlo
      ith = itho
c  ierror=0 if file was read without errors - if an error, reset plot limits
c  to old value
      if(ierror.ne.0) then
         call limset(ymin,ymax,isc,-1)
         ierror=0
      endif
      ifil = nt
      go to 30
c_______________________________________________
c
c   g - edit a glitch (no offset allowed) [ifl3 = nxc1+1] or
c   o - edit a glitch with possible offset [ifl3 = nxc1+2]
 60   ifl6 = 1
      ifl8 = ifl3 - nxc1
      write(6,1190)
 1190 format(' Set cursor on last good point and type 1,',/
     1 ,'   then on first good point and type 2')
      isp = isp + 1
      go to 30
c_______________________________________________
c   1 - cursor on last good point before glitch.
c  
 65   ione = itn 
      ifl6 = 2
      go to 30
c_______________________________________________
c   2 - cursor on first good point after glitch.  find length of it.
 70   if(itn.le.ione) then
c   error message for backwards edits
         write(6,1192)
 1192    format(' Improper edit')
         go to 30
      endif
      itwo = itn
c   set offset to 0 and update edit counter.
      ichange = 0
      ijunkioff=0
      if(ifl8.ne.2) go to 300
c
c   have an offset to remove
c
      write(6,1194)
 1194 format(' Remove offset; options 3,4,5,6 (! for help)')
      isp = isp + 1
      ifl6 = 3
      go to 30
c_______________________________________________
c   ! - list offset options
 73   write(6,1196)
 1196 format(' Offset options:',/,5x,
     1 '3 - set point selected by vertical cursor to',
     2 'level of horizontal cursor (invalid when overplotting)',
     3 /5x,'4 - enter the offset at the keyboard',/5x,
     4 '5 - make the offset -1 times the last one'/5x,
     5 '6 - offset set by linear interpolation')
      isp = isp + 4
      go to 30
c_______________________________________________
c   3 - find size of offset
 75   if(ymin.ne.ymax) yv = ymin + (iy/780.)*(ymax-ymin)
      if(ymin.eq.ymax) yv = ymin
      if(itn.le.ione) ichange = x(nt) - yv + ijunkioff
      if(itn.ge.itwo)  ichange = yv - x(nt) + ijunkioff
      if(itn.gt.ione.and.itn.lt.itwo) then
         write(6,1198)
 1198    format(' Vertical cursor set on glitch - try again')
         go to 30
      endif
      go to 300
c_______________________________________________
c   4 - enter offset from keyboard
 80   write(6,1200)
 1200 format(' Offset to apply to series following bad area: ',$)
      ichange = ffin(1,not)
      isp = isp + 1
      go to 300
c_______________________________________________
c   5 - make offset the opposite of the last one
 85   continue
      ichange =  -1*ioff(iloc)
      go to 300
c_______________________________________________
c   6 - linear interpolation
 90   write(6,1210)
 1210 format(' Set cursor to left of gap, then right of gap, to',/,
     1   '   define areas to fit lines to; type a grave accent for',
     2   ' each one')
      isp=isp+3
      go to 30
c  entry point for "'" command: what happens depends on iflmt, which is
c  incremented for the various steps. For iflmt=0, act as for "o" command;
c  for 1 and 2, find the fits to either side
 95   if(iflmt.eq.0) then
         iflmt=1
C         go to 60
      endif
      if(iflmt.eq.1) then
        if(itn.ge.ione) then
           write(6,1211) itn,ione
 1211      format(' Selected term at ',i8,' is after start of gap',
     1       ' at',i8,'--try again')
           isp=isp+1
           go to 30
        endif
        if(ione-itn.ge.10000) then
           write(6,1212) itn,ione
 1212      format(' Selected term at ',i8,' is more than 10000 terms',
     1       ' before start of gap at',i8,'--try again')
           isp=isp+1
           go to 30
        endif
        iflmt=2
        call getlinfit(itn,ione,ione,a1,b1)
        isp=isp+5
        go to 30
      endif
      if(itn.le.itwo) then
        write(6,1214) itn,itwo
 1214      format(' Selected term at ',i8,' is before end of gap',
     1       ' at',i8,'--try again')
        isp=isp+1
        go to 30
      endif
      if(itn-itwo.ge.10000) then
        write(6,1215) itn,itwo
 1215   format(' Selected term at ',i8,' is more than 10000 terms',
     1     ' after end of gap at',i8,'--try again')
        isp=isp+1
        go to 30
      endif
      call getlinfit(itwo,itn,ione,a2,b2)
        isp=isp+5
      ichange = -nint(a2-a1+0.5*(b2-b1)*(itwo-ione))
C  debugging code, to require an extra command before replotting
C      if(iflmt.le.1) then
C        iflmt=2
C        go to 30
C      endif
      iflmt=0
      go to 300
c_______________________________________________
c   r  - throw out last edit by resetting ned
 100  if(ned.eq.0) then
         write(6,1220)
 1220    format(' No edits to reject')
         isp = isp + 1
         go to 30
      endif
      irem = 1
      iedtot=iedtot+1
      if(sync) call crsync(itl,ith,iedtot,1)
      go to 112
c_______________________________________________
c   i - go around again to change an offset of specified edit.
 105   if (ned.eq.0) then
         write (6,1222) 
 1222    format (' No edits to alter')
         isp=isp+1
         go to 30
      endif
      i=1
      if (igap(1,1).gt.itn) then
        i=1
        go to 108
      endif
      do i=1,ned-1
          if(igap(1,i).le.itn.and.igap(1,i+1).ge.itn) go to 108
      enddo
      i=ned
 108  write(6,1224) i
 1224 format('Altering offset for edit ',i3,
     1  ' ; options 3,4,5,6 (! for help)')
      isp = isp + 4
      ijunkioff = ioff(i)
      ioff(i) = 0
      ione = igap(1,i)
      itwo = igap(2,i)
      ifl6 = 3
      iflmt=0
      go to 30
c_______________________________________________
c   q - give information about certain edit
 110  irem = 0
      if (ned.eq.0) then 
         write (6,1226)
 1226    format ('No edits to ask about')
         isp = isp +1
         go to 30
      endif
 112  do i = 1, ned
         if (itn.ge.igap(1,i).and.itn.le.igap(2,i)) then 
           if (irem.eq.0) then
             write (6,1228) i,igap(1,i), igap(2,i), ioff(i)
 1228        format('Edit number ',i4,' runs from ',i9,' to ',i9,
     1              ' with offset ',i8 )
             isp = isp +1
             go to 30
           else
             go to 116
           endif
         endif
      enddo
c no edit found in scanning through
      write(6,1230)
 1230 format(' You are not in the middle of an edit!')
      isp = isp + 1
      write (6,1232)
 1232 format ('Enter number of edit (0 for last) ')
      isp=isp+1
      i = ffin(1,not)
      if (i.gt.ned.and.irem.eq.1) write (6,1234)
 1234 format ('No edits rejected')
      if (i.gt.ned.and.irem.eq.1) isp = isp +1
      if (i.gt.ned) go to 30
      if (i.le.0) i = ned
      if (irem.eq.0) then
         write (6,1228) i,igap(1,i), igap(2,i), ioff(i)
         isp=isp+1
         go to 30
      endif
c have an edit to remove
 116  igt1=igap(1,i)
      igt2=igap(2,i)
      igone=i
      itoff=ioff(i)
      if (i.ne.ned) then
         do j=i+1, ned
            igap(1,j-1) = igap(1,j)
            igap(2,j-1) = igap(2,j)
            ioff(j-1) = ioff(j)
         enddo
      endif
      ned = ned - 1
      call limset(ymin,ymax,isc,-1)
      if (idebt.eq.1) then
         call dshoget(x,ers,ned*ifl1)
      else
         call shoget(x,ers,ned*ifl1)
      endif
      if(ifirntt.gt.0) call showedits(ifiled,ifirntt)
      write (6,1236) igone,igt1,igt2,itoff
 1236 format('Edit number ',i3,' running from ',i9,' to ',i9,
     1 ' with offset ',i5,' - Rejected' )
      isp = isp +1
      if (ifl1.ne.0) call fedcon(ned,igap,ioff,0,ned,ifed)
      go to 30
c_______________________________________________
c   8 - set the left bound for plotting
 120  ileft = itn
      write(6,1250)
 1250 format('Left bound set.') 
      isp=isp+1
      go to 30
c_______________________________________________
c   9 - set the right bound for plotting, and plot
 125  iright = itn
      if(iright.le.ileft) then
         write(6,1252)
 1252    format('Right bound left of left bound') 
         isp=isp+1
         go to 30
      endif
      ioldleft=itl
      ioldright=ith 
 127  itl = ileft
      ith = iright
      ileft=iright
      call limset(ymin,ymax,isc,-1)
      if (idebt.eq.1) then
         call dshoget(x,ers,ned*ifl1)
      else
         call shoget(x,ers,ned*ifl1)
      endif
      if(ifirntt.gt.0) call showedits(ifiled,ifirntt)
      go to 30
c_______________________________________________
c   7 - set the bounds back to their previous values
 130  iright = ioldright
      ileft = ioldleft
      go to 127
C     write(6,1254)
C1254 format('Got old bounds.') 
C     isp=isp+1
C     go to 30
c-------------------------------------------------------------
c
c    END OF CURSOR COMMANDS
c
c-------------------------------------------------------------
c
c   have a finished edit; insert it into the edits list
c
 300  ig1 = ione
      ig2 = itwo
      moffs = ichange
c  now search through edits file until start of new edit is before
c  end of an old edit
      if(ned.eq.0) iloc = 1
      if(ned.eq.0) go to 311
      do 305 iloc=1,ned
      if(ig1.ge.igap(2,iloc)) go to 305
c  new edit overlaps or is before old edit - if no overlap, go to 307
      if(ig2.lt.igap(1,iloc)) go to 307
c  have overlap
      go to 313
 305  continue
c  new edit is after all old edits
      iloc = ned + 1
      go to 311
c  no overlap, so move old edits and insert new one
 307  do j=iloc,ned
         k = ned + iloc - j + 1
         igap(1,k) = igap(1,k-1)
         igap(2,k) = igap(2,k-1)
         ioff(k) = ioff(k-1)
      enddo
 311  igap(1,iloc) = ig1
      igap(2,iloc) = ig2
      ioff(iloc) = moffs
      ned = ned + 1
      go to 319
c  have overlap - combine new and old edit
 313  igap(1,iloc) = min(igap(1,iloc),ig1)
      igap(2,iloc) = max(igap(2,iloc),ig2)
      ioff(iloc) = ioff(iloc) + moffs
      if(iloc.eq.ned) go to 319
c  see if new gap covers any later ones - read in the next one,
c  shift down, and loop
      if(igap(2,iloc).lt.igap(1,iloc+1)) go to 319
      ig1 = igap(1,iloc+1)
      ig2 = igap(2,iloc+1)
      moffs = ioff(iloc+1)
      ned = ned - 1
      if(iloc.eq.ned) go to 313
      do j=iloc+1,ned
        igap(1,j) = igap(1,j+1)
        igap(2,j) = igap(2,j+1)
        ioff(j) = ioff(j+1)
      enddo
      go to 313
c
c   done with edit
c
 319  continue
      call limset(ymin,ymax,isc,-1)
      if (idebt.eq.1) then
         call dshoget(x,ers,ned*ifl1)
      else
         call shoget(x,ers,ned*ifl1)
      endif
      if(ifirntt.gt.0) call showedits(ifiled,ifirntt)
      isp=isp+1
      write(6,1260) iloc,ned
 1260 format('Edit #',i4,' completed, ',i4,' edits total.')
      iedtot=iedtot+1
      if(sync) call crsync(itl,ith,iedtot,1)
      if(ned.ne.200.and.ifl1.ne.0) call fedcon(ned,igap,ioff,0,ned,ifed)
      ifl6 = 0
      go to 30
      end
