c  program cutout
c
c    cut out selected segments for up to 16 data files and create a header
c      file for them
c
c    calls genlib,hedlib,iolib
c
      character*8 source,chanid
      character*8 sout, chout
      character*4 stc,commen
      character*4 stcout
      character*1 not,mode
      double precision scans
      dimension ihd(50),it1(5),it2(5),ibeg(50),ifin(50)
      dimension nchfo(17),icho(16),chout(16)
      common/head/scans,calc(4),clkc(2),sampin,nchann,iblock,istart(5),
     1     iend(5),nchf(17),ichnm(16),ncal(4),source,chanid(16),stc,
     2     commen(200)
      data mode,iuse/'d',0/,isign/1/
      write(6,100)
100   format(' File listing header files (0 if none); ',$)
      ilist = ffin(1,not)
      if (ilist.ne.0)  then
         call intio(ihd,1,1,ilist,0)
         nhd=ihd(1)
         call intio(ihd,2,nhd+1,ilist,0)
         call retnio(ilist)
      endif
      if (ilist.eq.0)  then
c manual mode
        write(6,102)
 102    format(' Number of headers to be entered; ',$)
        nhd=ffin(1,not)
        write(6,104)
 104    format(' Their numbers; ',$)
        do i=1,nhd
          ihd(i)=ffin(1,not)
        enddo
      endif
c read in header file numbers from ilist
      write(6,106)
 106  format(' Start time (y,d,h,m,s); ',$)
      do i=1,5
         it1(i)=ffin(1,not)
      enddo
      write(6,108)
 108  format(' End time ',12x,' ; ',$)
      do i=1,5
         it2(i)=ffin(1,not)
      enddo
      write(6,110)
 110  format(' Sample interval for output; ',$)
      isampo=ffin(1,not)
      write(6,112)
 112  format(' Station name for output (4 char.); ',$)
      read(5,114) stcout
 114  format(a4)
      write(6,116)
 116  format(' Source name for output (8 char.); ',$)
      read(5,118) sout
 118  format(a8)
      write(6,120)
 120  format(' Output header file #; ',$)
      ihedot = ffin(1,not)
c
c get the station and start time of cassette from each header file; flag
c undoable cases by setting the header file number to 0
c
      do i=1,nhd
        call headco(ihd(i),1)
        call retnio(ihd(i))
        iuse=iuse+nchann
        if(nint(sampin).ne.isampo) then
          write(6,130) ihd(i),nint(sampin)
 130      format(' Header ',i6,' has sample interval of ',i7)
          ihd(i)=0
          go to 13
        endif
c
c check for out of range at beginning and end. If no overlap, set header to
c zero to keep from doing anything with it.
c
        ibeg(i) = iscnsp(istart,it1,isampo,mode) + 1
        ifin(i) = iscnsp(istart,it2,isampo,mode) + 1
        if(ibeg(i).gt.scans.or.ifin(i).lt.1) then
          write(6,132) ihd(i)
 132      format(' Header ',i6,' falls completely outside time span')
          ihd(i)=0
          go to 13
        endif
        if(ibeg(i).ge.1.and.ifin(i).gt.scans) then
          write(6,134) ihd(i)
 134      format(' Header ',i6,' series ends too soon')
          go to 13
        endif
        if(ibeg(i).lt.1.and.ifin(i).le.scans) then
          write(6,136) ihd(i)
 136      format(' Header ',i6,' series starts too late')
          go to 13
        endif
c check sign of data files; if any are real, we make all output files
c real
        do k=1,nchann
          if(nchf(k).lt.0) isign=-1
        enddo
 13     continue
      enddo
      if(iuse.gt.16) then
        write(6,138) iuse
 138    format(' There are ',i6,' channels to copy--more than 16')
        stop
      endif
      k=1
      if(isign.gt.0) ifn=ihedot+1
      if(isign.le.0) ifn=-(ihedot+1)
      iscano = iscnsp(it1,it2,isampo,mode)+1
      do i=1,nhd
        if(ihd(i).ne.0) then
          call headco(ihd(i),1)
          ib=max(ibeg(i),1)
          ibout=1
          if(ibeg(i).lt.1) ibout=2-ibeg(i)
          ie=min(ifin(i),nint(scans))
          ito=ibout+ie-ib
          do j=1,nchann
C             write(6,*) nchf(j),ib,ie,ifn,ibout,ito,iscano
c create file, since filcop does not
            if(ifn.gt.0) call intio(ix,1,1,ifn,1)
            if(ifn.lt.0) call realio(x,1,1,ifn,1)
            call filcop(nchf(j),ib,ie,ifn,ibout)
c extend file if need be
            if(ito.lt.iscano) then
                if(ifn.gt.0) call intio(ix,iscano,iscano,ifn,-1)
                if(ifn.lt.0) call realio(x,iscano,iscano,ifn,-1)
            endif
            call retnio(nchf(j))
            call retnio(ifn)
            nchfo(k)=ifn
            icho(k)=k
            chout(k)=chanid(j)
            if(isign.gt.0) ifn=ifn+1
            if(isign.le.0) ifn=ifn-1
            k=k+1
          enddo
        endif
      enddo
      k=k-1
cccccccccccccccccccccccc
c                      c
c prepare the header   c
c                      c
cccccccccccccccccccccccc
c maximum number of stations is 16
      nchf(17)=ihedot
      scans = iscano
      do i=1,k
        ichnm(i)=icho(i)
        chanid(i)=chout(i)
        nchf(i) = nchfo(i)
      enddo
c load start and end time, blank out the comment block, zero
c calibration channels and clock correction
      do j=1,5
        istart(j)=it1(j)
        iend(j)=it2(j)
      enddo
      commen(1)='////'
      do j=1,4
        ncal(j)=0
      enddo
      clkc(1)=0.0
      clkc(2)=0.0
      sampin=isampo
      source=sout
      stc=stcout
      nchann=k
      call headco(ihedot,0)
      stop
      end
