c     program dectid
c 
c   decimates and joins a number of files to provide a single file of data
c   with a uniform spacing in time.  points are those on even times (e.g., if de
c   cimated interval is one hour, values will be those at n hr, 0 min, 0 sec).
c    the new interval must therefore be a multiple of the original interval,
c   which, subject to this restriction, may vary from file to file. 
c      input files must be integer and have header files
c      output will be integer 
c      gaps between files are filled by linear interpolation
c 
c******* calls secdat, hedlib iolib genlib 
c 
c 
      character*1 not,iicmtb
      character*8 src,source,chanid
      character*4 stc,commen
      double precision js, ks, scans, tof, resam
      dimension ihf(60), ix(1200), ksta(5), kchwn(16)
      common/head/scans,calc(4),clkc(2),sampin,nchann,iblock,istart(5),
     1     iend(5),nchf(17),ichnm(16),ncal(4),source,chanid(16),stc,
     2     commen(200)
C old    common/head/stc,source,calc(4),clkc(2),nchann,iblock,istart(5)
C old   1     iend(5),scans,sampin,nchf(17),ichnm(16),chanid(16),ncal(4)
C old   2     commen(200
      data ileap/0/,iflg/1/,irlo/1/ 
      write(6,100)
 100  format(' how many tapes to join?  ',$)
      nhd = ffin(1,not)
      if(nhd.ge.1) go to 999
      write(6,130)
 130  format(' file of header files ',$)
      lis = ffin(1,not)
      call intio(nhd,1,1,lis,0)
      call intio(ihf,2,nhd+1,lis,0)
      call retnio(lis)
      go to 998
 999  write(6,102)
 102  format(' their header file names, in chronological order:  ') 
      do 1 i = 1,nhd
      write(6,101) i
 101  format(' header no. ',i3,2x,$) 
 1    ihf(i) = ffin(1,not)
 998  write(6,103)
 103  format(' new interval, in seconds (divisible by old):  ',$) 
      resam = ffin(1,not) 
      write(6,104)
 104  format(' type 1 for running mean, 0 for straight decimation ',$) 
      ifilt = ffin(1,not) 
      write(6,105)
 105  format(' are data on a common time base (y/n)? ',$)
      idum = ffin(1,iicmtb)
      write(6,106)
 106  format(' number of first output file  ',$)
      ioutb = ffin(1,not)
c   find approximate length of output file
      call headco(ihf(1),1) 
      iyr = istart(1) 
      if(mod(iyr,4).eq.0) ileap = 1 
      call datsec(js,istart(2),0) 
      if(nhd.gt.1) call headco(ihf(nhd),1)
      call datsec(ks,iend(2),0) 
c   allow for intervening years 
      nyr = iend(1) - iyr 
      ld = (mod(iyr-1,4)+nyr)/4 
      ks = ks - js + nyr*31536d03 + ld*864d02 
      samps = ks/resam + 1.
      nrec = (samps+59.)/60.
      write(6,107)
 107  format(' how many channels to join ',$) 
      nchw = ffin(1,not)
      write(6,108)
 108  format(' their numbers ',$) 
      do 2 i=1,nchw 
 2    kchwn(i) = ffin(1,not)
      do 21 kkj=1,nchw
      irlo = 1
      iflg = 1
c   do initial setup for first file.  for subsequent files much of this is
c         done in a loop
      i = 1 
      call headco(ihf(1),1) 
      call datsec(js,istart(2),0) 
      do 3 jjj=1,nchann 
      if(ichnm(jjj).eq.kchwn(kkj)) go to 4
 3    continue
      go to 669 
c   at this point kkj is the index of the loop through the wanted channels; 
c   jjj is the position number of that channel in this header 
 4    iout = ioutb + kkj - 1
      call intio(ix,1,2,iout,1)
c   find how many points to skip at start and number to be transferred
      tof = dmod(resam-dmod(js,resam),resam)
      nskst = tof/sampin
c   nskst is number of scans to skip at start of each input file
      call secdat(js+tof,ksta(2)) 
      ksta(1) = iyr 
      if(ksta(2).gt.365+ileap) ksta(1) = ksta(1) + 1
      if(ksta(2).gt.365+ileap) ksta(2) = ksta(2) -365 - ileap 
c   check for divisibility
      if(amod(sngl(resam),sampin).ne.0) go to 666 
c   beginning of loop through headers 
 5    nf = resam/sampin 
      nfilt = ifilt*(nf/2)
c   find number of last scan to be read 
      js = sampin*(scans-1.-nskst)
      tof = dmod(js,resam)
      decnd = 1. + nskst + (js-tof)/sampin
c   decnd is number of scans in decimated series from each file 
c 
c   transfer data 
      irl = 1 + nskst 
      k = 0 
      inf = nchf(jjj) 
 6    irh = min(irl+1199,nint(decnd))
      call intio(ix,irl,irh,inf,0)
      np = 1 + nf - amod(k*1200.,float(nf)) 
      if(np.eq.1+nf) np = 1 
      ndec =  ((irh-irl)-(np-1))/nf + 1 
c  if running mean is done do it on all points but those at 
c  buffer ends
      ix(1) = ix(np)
      do 9 j = 2,ndec-1 
      ind = np + (nf*(j-1)) 
      scr = 0.
      do 7 ii = ind-nfilt, ind+nfilt
 7    scr = scr + ix(ii)
 9    ix(j) = scr/(2*nfilt+1) 
      ix(ndec) = ix(np+nf*(ndec-1)) 
      irho = irlo + ndec - 1 
c   irlo and irho are pointers for output series
      call intio(ix,irlo,irho,iout,-1)
      irl = irh + 1
      irlo = irho + 1
      k = k + 1 
      if(irh.lt.decnd) go to 6 
      call retnio(inf)
c   find time of last scan taken and save it
      iyr = iend(1) 
      call datsec(js,iend(2),0) 
      js = js - tof 
      if(js.lt.0d00) iyr = iyr - 1
      ileap2 = 0
      if(mod(iyr,4).eq.0) ileap2=1
      if(js.lt.0d00) js = js + 31536d03 + 864d02*ileap2 
      src = source
c   if this was the last file, exit 
 10   if(i.eq.nhd) go to 17 
      i = i + 1 
c   find number of scans to interpolate 
c   get next header and find next start time
c   but first see if the channel being handled is there 
      call headco(ihf(i),1) 
      do 11 jjj=1,nchann
      if(ichnm(jjj).eq.kchwn(kkj)) go to 12 
 11   continue
c   channel not found - go to next header 
      go to 10
 12   if(amod(sngl(resam),sampin).ne.0) go to 666 
      call datsec(ks,istart(2),0) 
      tof = dmod(resam-dmod(ks,resam),resam)
      ks = ks + tof 
      nyr = istart(1) - iyr 
      ld = (mod(iyr-1,4) + nyr)/4 
      ks = ks - js + nyr*31536d03 + ld*864d02 
c   (here ks is the time between the last sample of one file and the first of 
c          the next)
      pint = ks/resam - 1. + .0001
c                      (this small amount is to take care of roundoff)
c   check ordering of headers - be less critical if time base not fixed
      if((iicmtb.eq.'y'.and.pint.lt.0.).or.ks.lt.0.) go to 668
c   gap too large to do in integers 
      if(pint.gt.32768.) go to 667
      nskst = tof/sampin
      if(pint.lt.1.) go to 5
c   interpolation 
      mint = pint 
      pint = mint 
      ival = ix(ndec) 
      inf = nchf(jjj) 
      call intio(ix,nskst+1,nskst+1,inf,0)
      slp = (ix(1) - ival)/(mint+1.)
      ft = irlo
      irl = 1 
 13   irh = min(irl+1199,nint(pint)) 
      np = irh - irl + 1
      do 15 ii = 1,np 
 15   ix(ii) = ival + (irl + ii - 1.)*slp
      irho = irlo + irh - irl 
      call intio(ix,irlo,irho,iout,-1)
      irl = irh + 1
      irlo = irho + 1
      if(irh.ne.pint) go to 13 
c   print out location for interpolated points
      if(iflg.eq.1) write(6,109)
 109  format(' interpolated terms:',/)
      iflg = 0
      write(6,110) ft, irlo-1, src, source
 110  format(1x,f8.0,' through',i8,' (between ',a8,' and ',a8,')') 
      go to 5 
c   abnormal exits
 666  write(6,112) source, sampin, sngl(resam)
 112  format(1x,a8,' has interval',f8.0,' which does not divide ',f8.0, 
     $ //)
      if(i.ne.1) go to 17 
      write(6,113)
 113  format(' nothing done') 
      stop
 667  call secdat(js,iend(2)) 
      iend(1) = iyr 
      write(6,114) src, iend, source, istart, pint
 114  format(' gap between ',a8,' ending at ',5i6,' and ',a8,' start
     $ing at ',5i6,/,' is ',f8.0,' points, which is too many',//) 
      go to 17
 668  call secdat(js,iend(2)) 
      iend(1) = iyr 
      write(6,116) src, iend, source, istart
 116  format(1x,a8,' ends at ',5i6,' and ',a8,' starts at ',5i6,//) 
      go to 17
 669  write(6,117) kchwn(kkj) 
 117  format(' first header does not mention channel ',i3)
      go to 21
c   normal end
 17   write(6,119) irho,iout
 119  format(i8,' terms written to file ',i5)
      call secdat(js,iend(2)) 
      iend(1) = iyr 
      write(6,120) ksta 
 120  format(' start time ',5i6)
      write(6,122) iend 
 122  format(' end time ',5i6,//) 
      call retnio(iout) 
 21   continue
      stop
      end 
