c
c  program deice - unpacks Ice-9 files into header and data files
c
      integer*2 ibuf,idata,iflag,lenstr,lf
      character*80 file
      character*4 clog
      character*8 source,chanid
      character*4 stc,commen
      double precision scans
      logical*1 timlim,shift
c  ibuf holds the entire 16-bit part of the file, read in at the start
c  idata holds the individual channels
c      dimension ibuf(3456204),idata(90000),itmc(5),iflag(90000)
      dimension ibuf(11760000),idata(90000),itmc(5),iflag(90000)
      dimension igap(2,30000),joff(30000)
      dimension ihw(8)
c
c common block with byte count for header, start of last scan, last byte
c
      common/lengt/nbhed,nblasc,nbfinl
c common block with flag for limited-time unpacking, clock-shifting,
c and clock shift and start and end times
      common/times/jstart(5),jend(5),ioff,intval,timlim,shift
      common/nrg/narg
      common/head/scans,calc(4),clkc(2),sampin,nchann,iblock,istart(5),
     1     iend(5),nchf(17),ichnm(16),ncal(4),source,chanid(16),stc,
     2     commen(200)
      data maxsc/90000/
      data clog/'ABCD'/
      data nhw/0/,narg/0/
      data timlim/.false./,shift/.false./
      data stc/'    '/,source/'        '/
      data chanid/16*'        '/
      data commen/200*'        '/
      do i=1,maxsc
        iflag(i)=0
      enddo
c
c  get information off the command line--optional material passed in
c    common blocks
c
      call comget(file,ihd)
c
c  get information from the start of the data file
c
      call getich(file)
c
c  start unpacking here
c
      irlo=nbhed/2+1
      irho=nbfinl/2
      nchf(17)=ihd
      if(timlim) maxsc = iscnsp(jstart,jend,intval,'d')+1
c
c read in the datalogger file after the header; get the # channels for
c the first scan
c
      lf=lenstr(file)
      call byteio(ibuf,nbhed+1,nbfinl-1,file,lf,0)
      nchan=ibuf(8)
c
c  Get the start time. If we have set the start time on the command line,
c    take whichever time is later.
c
      call thyme(ibuf(3),istart)
      if(timlim.and.iscnsp(jstart,istart,intval,'d').lt.0) then
         do i=1,5
           istart(i)=jstart(i)
         enddo
      endif
c
c Go through channel by channel, and for each channel,
c   scan by scan (some excess computing here)
c
      kc=0
      ifoff=0
      do k=1,nchan
        kc=kc+1
c kc is count of channels 1-16; resets when new header needed
        if(kc.gt.16) then
          kc=kc-16
          ifoff=ifoff+1
        endif
        do kk=1,maxsc
          idata(kk)=0
        enddo
        isc=1
c
c   do-while loop here unpacks each scan until we are to the end of the
c     buffer as read in
c
 11     continue
        call thyme(ibuf(isc+2),itmc)
        nchant=ibuf(isc+7)
        nscan= iscnsp(istart,itmc,intval,'d')+1
        if(nchan.ne.nchant) then
          write(6,100) nchant,nchan,itmc, isc
100       format(i3,' not ',i3,' channels at ',5i5,' (buffer count ',
     1       i7,') ')
c if the year is zero, just advance through the buffer assuming nchan
c channels
          if(itmc(1).eq.0) then
            isc=isc+8+nchan
            go to 11
          else
            write(6,102)
 102        format('STOP')
          endif
        endif
c either put all the data into the file, or just that within the time
c   limits--in either case need to keep updating the final values
c   so we end either when we hit the end time or the EOF
        if(nscan.ge.1.and.nscan.le.maxsc) then
           numsc=nscan
           scans=nscan
           idata(nscan)=ibuf(isc+7+k)
           iflag(nscan)=1
           do i=1,5
              iend(i)=itmc(i)
           enddo
        endif
        isc=isc+8+nchant
        if(isc.lt.irho-irlo+1) go to 11
c
c done with moving data into the file, write it out and fill
c out another channel's worth of information in the header
c
      
        ifile=ihd+k+ifoff
        call shrtio(idata,1,numsc,ifile,1)
        call retnio(ifile)
        nchf(kc)=ifile
        ichnm(kc)=k
        nchann=kc
        write(chanid(kc),200) k
 200    format("Chan ",i3)
        if(kc.eq.16.or.k.eq.nchan) then
           nhw=nhw+1
           ihw(nhw)=nchf(17)
           write(source(4:4),210) ' '
           write(source(5:7),205) istart(2)
 205       format(i3)
           write(source(8:8),210) clog(ifoff+1:ifoff+1)
 210       format(a1)
           sampin=intval
           call headco(ihw(nhw),0)
           nchf(17)=ihw(nhw)+nchann+1
        endif
      enddo
      if(nscan.gt.maxsc) write(6,215) nscan,maxsc
 215  format(' Scan count goes to ',i9,', > max allowed (',i5,')')
c------------------------------------------------------------
c  Finished with unpacking the data
c------------------------------------------------------------
c  Now check for missing scans; write out an
c    edits file to show this (including the case of no edits)
c------------------------------------------------------------
c
      ned=0
      nscan=nint(scans)
      if(iflag(1).eq.0) then
        ned=ned+1
        igap(1,ned)=0
      endif
      do i=2,nscan
        if(iflag(i).eq.0.and.iflag(i-1).ne.0) then
          ned=ned+1
          igap(1,ned)=i-1
        endif
        if(iflag(i).ne.0.and.iflag(i-1).eq.0) then
          igap(2,ned)=i
          joff(ned)=0
        endif
      enddo
      if(iflag(nscan).eq.0) then
        igap(2,ned)=nscan+1
      endif
c
c  fill any gaps (missing data) with linear interpolation
c
      if(ned.gt.0) then
        do l=1,nhw
          call headco(ihw(l),1)
          do i=1,nchann
            do k=1,ned
              call linter(nchf(i),igap(1,k),igap(2,k))
            enddo
            call retnio(nchf(i))
          enddo
        enddo
      endif
      ifed=nchf(nchann)+2
      call edcon3(ifed,ned,igap,joff,0,nscan)
      nchf(17)=ifed-1
      write(source(8:8),210) 'E'
      nchann=1
      nchf(1)=ifed
      scans=1441.
      chanid(1)='ED  DROP'
      ichnm(1)=1
      do i=1,5
       iend(i)=istart(i)
      enddo
      sampin=0
      call headco(ifed-1,0)
      stop
      end
