       program deki
c  new and revised version of deki, with all known bugs removed
c  program inputs a series of arbitrary length, passes a convolution
c  filter over it and outputs to a file.  filter serties may be gen-
c  erated internally (then it is symmetric, ie non-phase-shifthing)
c  or may be read from a file or the teletype.
c$$$$$$ link with krner,ai0,toffs,secdat,datsec,iolib
c
      double precision yk
      character*8 source,chanid
      character*4 stc,commen
      double precision scans
      dimension y(600),w(4001),x(9000)
      common/head/scans,calc(4),clkc(2),sampin,nchann,iblock,istart(5),
     1     iendt(5),nchf(17),ichnm(16),ncal(4),source,chanid(16),stc,
     2     commen(200)
C old    common/head/stc,source,calc(4),clkc(2),nchann,iblock,istart(5)
C old   1     iendt(5),scans,sampin,nchf(17),ichnm(16),chanid(16),ncal(4)
C old   2     commen(200
      common/time/jdat(4),sam
      data maxw /4001/,max/9000/
c
      write(6,100)
 100  format(' Input file number; ',$)
      infile = ffin(1,not)
      write(6,110)
 110  format(' Output file number; ',$)
      iout = ffin(1,not)
      iout = -iabs(iout)
      write(6,120)
 120  format(' Begin and end terms of input series; ',$)
      ibegin = ffin(1,not)
      iend = ffin(1,not)
      if(iend.le.ibegin) iend=longis(infile)
      itot=iend-ibegin+1
      write(6,130)
 130  format(' Decimation integer; ',$)
      nd = ffin(1,not)
      write(6,140)
 140  format(' Do you want internal (1) or external (0) weights?; ',$)
      iq = ffin(1,not)
      if(iq.ge.1) call getfilt(nd,maxw,nw,w)
      if(iq.lt.1) then
c
c  reads weight series from disk
c
         write(6,250)
 250     format(' File of weights; ',$)
         ifw = ffin(1,not)
         write(6,260)
 260     format(' Numbers of 1st, last weights; ',$)
         iw1 = ffin(1,not)
         iw2 = ffin(1,not)
         nw=iw2-iw1+1
         if (nw .gt. maxw) then
            write(6,270) maxw
 270        format(' Too many weights - maximum allowed is ',i5)
            stop
         endif
         call realio(w,iw1,iw2,ifw,0)
         call retnio(ifw)
      endif
c
c  determine how to start (series as is, with leading zeroes, padded with
c  value of first term, or begun at a 'nice' point.
c
 2800 write(6,280)
 280  format(' Startup option (-10 for choices); ',$)
      isop = ffin(1,not)
      if(isop.eq.-10) then
       write(6,252)
 252   format(' Available options are:',/,10x,'0 - no padding: in',
     1 ' doing convolution first term of input',/,14x,'will be multipl',
     2 'ied by first weight',/,10x,'1 - pad beginning of series with ',
     3 'npad zeroes',/,10x,'2 - pad beginning of series with npad',
     4 ' numbers equal to',/,14x,'the first term of the input series',/,
     5 14x,'(for both 1 and 2, npad will be such that for a zero phase',
     6 /,14x,'shift filter (with an odd number',/,14x,'of weights)',
     7 ' the first output point',/,14x,'will be at',
     8 ' the same time as the first input point,',/,14x,'for -1 or ',
     9 '-2, npad will equal the number of weights)',/,10x,'3 - start ',
     1 'convolution within series at a place that will put the',/,14x,
     2 'first output point at a nice time (for a zero phase shift',
     3 ' filter)',/,10x,'-3 - as 3, but get time from header')
       go to 2800
      endif
      i1 = 1
      if(isop.gt.3.or.isop.lt.-3) go to 2800
      if(isop.eq.0) go to 2000
      if(isop.eq.3) then
        write(6,255)
 255    format(' time of beginning term of input series (d,h,m,s); ',$)
        do i = 1,4
          jdat(i) = ffin(1,not)
        enddo
        write(6,257)
 257    format(' sample interval of series (sec); ',$)
        sam = ffin(1,not)
        call toffs(nw,nd,noff)
        i1 = 1
        ibegin = ibegin + noff -1
        go to 2000
      endif
      if(isop.eq.-3) then
        write(6,256)
 256    format(' Header file with time; ',$)
        nfl=ffin(1,not)
        call headco(nfl,1)
        do i=1,4
          jdat(i) = istart(i+1)
        enddo
        sam = sampin
        call toffs(nw,nd,noff)
        i1 = 1
        ibegin = ibegin + noff -1
        go to 2000
      endif
c
c   Options +-1, +-2
c
      dintv = 0.
      if(iabs(isop).eq.2) call realio(dintv,ibegin,ibegin,infile,0)
      do 2810 i = 1,nw
 2810 x(i) = dintv
      i1 = nw
      if(isop.gt.0) i1 = (nw/2) + 1
c
c#######################################################################
c  initial load into xc  and set variables
 2000 iy1=1
      k=0
      ix1=ibegin
      nout=1
      if (max-i1+1 .gt. itot) max=itot-1+i1
      if (ix1+max-i1 .gt. iend) max=iend-ix1+i1
      lend=nw
C      write(6,*) 'a',max,ix1,ix1+max-i1,i1
      call realio(x(i1),ix1,ix1+max-i1,infile,0)
      go to 3200
c
c  fill buffer in  x  taking special measures at end of series
 3000 ix1=ix1+lw+nd-i1
      i1=1
      lend=nw
      if (ix1.ge.iend) go to 4000
      if (ix1+max-1 .gt. iend) max=iend-ix1+1
C      write(6,*) 'b',max,ix1,ix1+max-i1,i1
      call realio(x,ix1,ix1+max-1,infile,0)
      go to 3200
c
c  convolves and dumps 60-word buffers of  y  to disk
 3100 lend=nd + lend
 3200 if(lend .gt. max) go to 3000
      lw=lend + 1
      yk=0.0
      do 3300 iw=1,nw
      lw=lw-1
 3300 yk=w(iw)*x(lw) + yk
      k=1 + k
      y(k)=yk
      if (k.lt.600) go to 3100
      call realio(y,iy1,iy1+599,iout,nout)
      nout=-1
      iy1=600+iy1
      k=0
      go to 3100
c
c  at end dumps dregs of  y  to disk
c
 4000 if (k.ne.0) call realio(y,iy1,iy1+k-1,iout,nout)
      iy1=iy1+k-1
      write(6,400) iy1,iout
 400  format(i10,' terms written to file ',i6)
      if(isop.eq.-3) then
        write(6,402)
 402    format(' Header file for output; ',$)
        nfl=ffin(1,not)
        do i=1,4
          istart(i+1) = jdat(i)
        enddo
        sampin=nd*sampin
        do i=1,nchann
          nchf(i)=nchf(i) + (iout-infile)
        enddo
        call timfnd(istart,iy1-1,int(sampin),iendt,'d')
        scans=iy1
        nchf(17)=nfl
        write(6,404) istart,iendt,iy1
 404    format(' Output runs from ',5i5,' to ',5i5,' with ',i8,' terms')
        if(nfl.ne.0)call headco(nfl,0)
      endif
      stop
      end
      subroutine getfilt(nd,maxw,nw,w)
c
c nd is decimation factor; returns nw filter weights in w
c maxw is limit on weights
c
c   calls krner,ai0
c
      character*1 not
      dimension w(1),c(4001)
      data c/4001*0.0/
c  get filter parameters and compute weights
      write(6,102)
 102  format(' Nyquist frequency of input series; ',$)
      fny = ffin(1,not)
 10   write(6,104)
 104  format(' Attenuation in stopband(s), in db (>0); ',$)
      al = ffin(1,not)
 13   write(6,106)
 106  format(' Width of transition band(s); ',$)
      de = ffin(1,not)/fny
      fk = 1.8445
      if(al.ge.21) fk = .13927*(al-7.95)
      nw = int((fk/(2.*de)) + .75)
      write(6,108) 2*nw+1
 108  format(' Total number of weights required is ',i4)
      if(2*nw+1.gt.maxw) then
         write(6,109) maxw
 109     format(' Too many weights, maximum allowed is ',i5)
         go to 10
      endif
      write(6,110)
 110  format(' Type 1 if ok, 0 if not; ',$)
      iqq = ffin(1,not)
      if(iqq.lt.1) go to 10
      write(6,112)
 112  format(' Filter type (1 for lowpass, 2 highpass, 3',
     1' bandpass, 4 bandstop); ',$)
      itype = ffin(1,not)
      if(nd.eq.1.or.itype.eq.1.or.itype.eq.3) go to 16
      write(6,114)
 114  format(' Decimation is not allowed with this type of filter')
      stop
 16   if(itype.ge.3) go to 18
      write(6,116)
 116  format(' Corner frequency (center of transition band); ',$)
      be = ffin(1,not)/fny
      be2 = be
      go to 20
 18   write(6,118)
 118  format(' Center point of lower transition; ',$)
      be = ffin(1,not)/fny
      write(6,120)
 120  format(' Center point of upper transition; ',$)
      be2 = ffin(1,not)/fny
      if(be2-be.gt.de) go to 20
      write(6,122)
 122  format(' Not enough space between transitions - try again')
      go to 10
 20   if((be-de/2.).gt.0) go to 22
      write(6,124)
 124  format(' Transition point too low - try again')
      go to 10
 22   rnqy = 1./nd
      if((be2+de/2.).lt.rnqy) go to 24
      write(6,126)
 126  format(' Upper transition too high, and series will be aliased',
     1' - try again')
      go to 10
c
c    generate filter weights
c
 24   call krner(al,be,de,be2,0,itype,maxw,nw,w)
 33   write(6,132)
 132  format(' Start, end, interval freq (0 0 0 to go on); ',$)
      sf = ffin(1,not)
      ef = ffin(1,not)
      fi = ffin(1,not)
      if(fi.eq.0) go to 36
      nf =  (ef-sf)/fi + 1
      do 34 i = 1,nf
      f = sf + fi*(i-1)
      fn = f/(2.*fny)
      call firres(w,c,nw,0,1,fn,re)
      db = 20.*alog10(re+1.e-25)
      write(6,134) f,re,db
 134  format(2x,g13.5,g15.7,'     (',f6.1,' dB)')
 34   continue
      go to 33
c
c  shift weights to make a 2-sided filter.
c
 36   do 40 i = 1,nw+1
 40   w(2*nw+2-i) = w(nw+2-i)
      do 42 i = 1,nw
 42   w(i) = w(2*nw+2-i)
      nw = 2*nw + 1
      return
      end
