        program demean
c
c  in-place demean of series; makes two passes to make sure
c
c  based on double precision stats
c
        character*15 arg
	double precision wdotu,r,u1,d,rnorm
	dimension x(600),ix(600)
	data ibuf/600/,irls/1/,ipass/1/
        if(iargc().lt.1.or.iargc().gt.4) then
          write(6,100)
 100      format(/,
       1   ' Usage:  demean   file-number ',/,
       2   '     rewrites the file onto itself, with mean removed',//,
       3   '         demean   file1  file2',/,
       4   '     writes file1 into file2, with mean removed',//,
       5   '         demean   term1 term2 file-number ',/,
       6   '     rewrites the file onto itself, removing mean found',
       7   ' between term1 and term2',//,
       8   '         demean   file1  term1 term2 file2',/,
       9   '     writes file1 into file2, removing mean found',
       1   ' between term1 and term2',//,
       2   '   In all cases entire file is copied/overwritten',/)
          stop
        endif
        call getarg(1,arg)
        read(arg,102) ifile
 102	format(i5)
        ntot=longis(ifile)
        irnt=ntot
        jfile=ifile
        if(iargc().eq.2) then
           call getarg(2,arg)
           read(arg,102) jfile
        endif
        if(iargc().eq.3) then
           call getarg(2,arg)
           read(arg,*) irls
           call getarg(3,arg)
           read(arg,*) irnt
        endif
        if(iargc().eq.4) then
           call getarg(2,arg)
           read(arg,*) irls
           call getarg(3,arg)
           read(arg,*) irnt
           call getarg(4,arg)
           read(arg,102) jfile
        endif
c
c  buffers in data into array  x  using sequential householder
c  rotations on each buffer-load for mean and variance calculations
 5	r=0.0
	d=0.0
	esq=0.0
	itot=0
        irl=irls
 7  	n=min0(irnt-irl+1,ibuf)
        call realio(x,irl,irl+n-1,ifile,0)
	itot=n + itot
    	rnorm=sqrt(r*r + n)
	u1=r+sign(rnorm,r)
	r=-sign(rnorm,r)
	wdotu=d*u1
	do i=1,n
     	  wdotu=x(i) + wdotu
        enddo
	c=2.0*wdotu/(n + u1*u1)
	d=d - c*u1
	do i=1,n
     	   esq=(x(i)-c)**2 + esq
        enddo
        irl=n + irl
	if (irl.le.irnt) go to 7
c
c  job done--now write out entire file
c
	xmean=d/r
        irl=1
 9  	n=min0(ntot-irl+1,ibuf)
        if(ifile.lt.0) then
            call realio(x,irl,irl+n-1,ifile,0)
            do i=1,n
              ix(i)=nint(x(i))
            enddo
        endif
        if(ifile.gt.0) then
            call intio(ix,irl,irl+n-1,ifile,0)
            do i=1,n
              x(i)=ix(i)
            enddo
        endif
        if(jfile.gt.0) then
           ixm=nint(xmean)
           do i=1,n
             ix(i)=ix(i)-ixm
           enddo
           call intio(ix,irl,irl+n-1,jfile,1)
        endif
        if(jfile.lt.0) then
           do i=1,n
             x(i)=x(i)-xmean
           enddo
           call realio(x,irl,irl+n-1,jfile,1)
        endif
        irl=n + irl
	if (irl.le.ntot) go to 9
c
c iterate only if the file is being overwritten
c
        if(iargc().eq.2.or.iargc().eq.4) then
          if(jfile.gt.0) write(6,104) ixm
 104      format(i12)
          if(jfile.lt.0) write(6,106) xmean
 106      format(g17.7)
          stop
        endif
        if((iargc().eq.1.or.iargc().eq.3).and.ipass.eq.1) then
          if(jfile.gt.0) write(6,104) ixm
          if(jfile.lt.0) write(6,106) xmean
        endif
        if(ipass.eq.3) stop
        ipass=ipass+1
        go to 5
	end
