c  program stpmap
c   for a given point source (of faulting) writes out an array giving
c response on the surface of a half-space (but done in lat and long)
c for plotting with contour
c
c   $$$calls stpsub,seggest,topo,fdefor,stran,van
c
c
      character*1 iobs,not
      character*20 filnam
      dimension e1(3),t1(3),d1(3),e2(3),t2(3),d2(3),x(200)
      dimension e2t(3),t2t(3),d2t(3)
      write(6,100)
 100  format(' Range of n lats (south first) ; ',$)
      rlatd = ffin(1,not)
      rlatu = ffin(1,not)
      write(6,102)
 102  format(' Range of e longs (w first) ; ',$)
      rlongl = ffin(1,not)
      rlongr = ffin(1,not)
c get fault information
      call segget(nsegs)
 3    write(6,104)
 104  format(' Azimuth (if needed) and type of datum (h for help) ; ',$)
      dir = ffin(1,iobs)
      if(dir.ne.666) dir = 180-dir
      if(iobs.eq.'x') go to 13
      if(iobs.eq.'h') write(6,106)
 106  format(' Types of data allowed are:',/,5x,
     1 '   z - vertical displacement',/,5x,
     2 'nnnd - horizontal displacement at azimuth nnn',/,5x,
     3 '       (azimuth of 666 means max displacement)',/,5x,
     4 'nnnl - extension at azimuth nnn',/,5x,
     5 '       (azimuth of 666 means max extension)',/,5x,
     6 '   v - volume strain (for poisson''s ratio 0.25)',/,5x,
     7 'nnns - shear strain at azimuth nnn',/,5x,
     8 'nnnt - tilt at azimuth nnn',/,5x,
     9 '       (azimuth of 666 means max tilt)',/,5x,
     1 '   b - rotation (change in azimuth)',/,5x,
     1 '   r - rms extension ',/,5x,
     1 '   x - exit from program')
      if(iobs.eq.'h') go to 3
      write(6,108)
 108  format(' 1 for log (SI), 2 for linear (nrad, ne, mm) ; ',$)
      logit = ffin(1,not)
      scale = 1.e9
      if(iobs.eq.'z'.or.iobs.eq.'d') scale = 1000
      write(6,110)
 110  format(' Number of points on a side ; ',$)
      np=ffin(1,not)
      write(6,112)
 112  format(' Name of output file ;; ',$)
      read(5,*) filnam
      lu = 1
      open(lu,file=filnam,status='unknown')
c
c now loop in lat, then in long, and (innermost) in fault segments
      do i=1,np
        rlat = rlatu - (i-1)*(rlatu-rlatd)/(np-1.)
        do j=1,np
          rlong = rlongl - (j-1)*(rlongl-rlongr)/(np-1.)
c set parameters to zero, in preparation for summing over fault segments
          do l=1,3
            d2(l)=0
            e2(l)=0
            t2(l)=0
          enddo
c first call to segget gets parameters, second steps through fault segments,
c with a loop to the beginning (so we can call this routine nseg times for
c each point)
          do k=1,nsegs
            call segget(nsegs)
            call stpsub(rlat,rlong,e2t,t2t,d2t)
            do l=1,3
              d2(l)=d2(l)+d2t(l)
              e2(l)=e2(l)+e2t(l)
              t2(l)=t2(l)+t2t(l)
            enddo
          enddo
          call strinv(e2,erms,exmax,efx,shmax)
          if(iobs.eq.'z') x(j) = d2(3)
          if(iobs.eq.'r') x(j) = erms
          if(iobs.eq.'v') x(j) = .6667*(e2(1)+e2(2))
          if(iobs.eq.'b') x(j) = t2(3)
          if(dir.ne.666) then
             call van(d2,dir,d1)
             call van(t2,dir,t1)
             call stran(e2,dir,e1)
             if(iobs.eq.'d') x(j) = d1(1)
             if(iobs.eq.'t') x(j) = t1(1)
             if(iobs.eq.'l') x(j) = e1(1)
             if(iobs.eq.'s') x(j) = e1(3)
          else
             if(iobs.eq.'d') x(j) = sqrt(d2(1)**2 + d2(2)**2)
             if(iobs.eq.'t') x(j) = sqrt(t2(1)**2 + t2(2)**2)
             if(iobs.eq.'l') x(j) = exmax
             if(iobs.eq.'s') x(j) = shmax
          endif
          if(logit.eq.1) x(j) = alog10(abs(scale*x(j)))
        enddo
        if (logit.eq.1) write(1,120) (x(j),j=1,np)
 120    format(10f8.4)
        if (logit.eq.2) write(1,122) (x(j),j=1,np)
 122    format(5g13.5)
      enddo
      close(lu)
      go to 3
 13   write(6,150) np,np
 150  format('To plot, use contour, with   read ',i3,i3,' 1')
      stop
      end
