      subroutine dshoget(x,erase,ied)
      logical iblank,allblk,blnkit,sync
c   Basically the exact same as shoget, but it was the routine used in
c   the program debt, (a program like credit, but when the series was
c   decimated, would show the min and max between the decimated points)
c   The only thing that has been changed is that now, instead of sorting
c   all of the points, we simply take the min and max values by inspection.
c    
c
c   gets a data series off disc file ifl and displays it on screen,
c   decimating as necessary to get it to one screen's worth.  data
c   shown is returned in x.  screen is erased if erase ne 0.  if ied ne
c   0, call a program to edit data before displaying it.
      common/sam/itl,ith,idec,ie,ymin,ymax,isc,ifl,irntot
      common/edits/igap(2,4000),ioff(4000),ned
c   itl, ith are input as beginning, end term numbers of series as wanted
c   and are returned as beginning and end terms displayed
c   idec is decimation factor
c   ie is number of points in x
c   ymin, ymax are limits on series as plotted
c   if isc = 1, data is self-scaled, and ymin and ymax are set from it
c   if isc not = 1, data is clipped to fall between ymin and ymax
c   irntot is the total number of terms in the file
      common/tkcon/isp,nmsec
c   isp governs positioning of alpha cursor.
      common/fade/iblank(1020),allblk,blnkit,sync
c   if iblank(i) is true, lift pen when plotting to the i-th point
c   if allblk is true, plot no points; if blnkit is false, ignore
c   both of these and plot everything
c
c  calls send12 (in grafic), realio (in libnio), dxedit
c
      dimension x(1020),buf(510),iused(510)
c  check for file readability and return if not OK (plotting other files only)
      lll = longis(ifl)
      if(erase.ne.0.or.(ith.le.lll.and.lll.gt.0)) go to 25
      if(lll.le.0) write(6,102) ifl
 102  format(' File ',i8,' could not be found')
      if(lll.gt.0.and.ith.gt.lll) write(6,104) ifl
 104  format(' File ',i8,' is too short')
      return
 25   continue
      do 23 i=2,1020
 23   iblank(i) = .false.
      allblk = .false.
c  if necessary the above will be reset by dxedit
      itl = max0(itl,1)
      ith = min0(ith,irntot)
      if(sync)call crsync(itl,ith,iedtot,1)
c   blank screen (if requested) before getting data, reset alpha
c   cursor counter, and wait after blanking screen
      ioffsofar=0
      if(erase.ne.0) then
         call send12(-9,0,0)
         isp = 3
         do 1 i=1,96
 1       call send12(-10,0,0)
      endif
      idec = (ith-itl)/1020 +1
      if(idec.ne.1) then
c   decimate, using min-max decimation in segments 2*idec long
         lseg = 2*idec
         nseg = 510/lseg
         lbuf = nseg*lseg
         kseg = 1
         ie = 1
         ib1 = itl
c make a buffer load an integer number of segments, except at end
 2       ib2 = min(ib1+lbuf-1,ith)
         call realio(buf,ib1,ib2,ifl,0)
         if (ied.ne.0) call makeused(iused,ib1,buf,ioffsofar)
         nt=  ib2 + 1 - ib1
         mseg = nt/lseg
         if(mseg.ge.1) then
c  in each segment select the min and max
c  (packing them alternately to make a smoother plot)

            do 3 k = 1,mseg
            themax= -2147483647.0
            themin=  2147483647.0
            do 33 kk = 1, lseg
            if (buf((k-1)*lseg+kk).gt.themax) then
             if (iused((k-1)*lseg+kk).ne.1) then
                themax=buf((k-1)*lseg+kk) 
             endif
              
            endif
            if (buf((k-1)*lseg+kk).lt.themin) then
             if (iused((k-1)*lseg+kk).ne.1) then
                 themin=buf((k-1)*lseg+kk) 
             endif
            endif
 33	    continue
            if(mod(kseg,2).eq.0) then
               x(ie) = themin
               if (themin.ge.2147483647.0) iblank(ie) = .true.
               x(ie+1) = themax
               if (themax.le.-2147483647.0) iblank(ie+1) = .true.
c            if (themax.ne.0.0) print *,'Max ',themax,iblank(ie+1)
c            if (themin.ne.0.0) print *,'Min ',themin,iblank(ie)
            else
               x(ie+1) = themin
               if (themin.ge.2147483647.0) iblank(ie+1) = .true.
               x(ie) = themax
               if (themax.le.-2147483647.0) iblank(ie) = .true.
c            if (themax.ne.0.0) print *,'Max ',themax,iblank(ie)
c            if (themin.ne.0.0) print *,'Min ',themin,iblank(ie+1)
            endif
            kseg = kseg+1
            ie = ie + 2
 3          continue

         endif
         if(mseg*lseg.lt.nt) then
c  sort the last segment (of shorter length)
            themax= -2147483647.0
            themin=  2147483647.0
            do 34 kk = 1, nt-mseg*lseg
            if (buf(mseg*lseg+kk).gt.themax) then
             if (iused(mseg*lseg+kk).ne.1) 
     1           themax=buf(mseg*lseg+kk) 
            endif
            if (buf(mseg*lseg+kk).lt.themin) then
             if (iused(mseg*lseg+kk).ne.1) 
     1            themin=buf(mseg*lseg+kk) 
            endif
 34	    continue
            x(ie) = themin
            if (themin.ge.2147483647.0) iblank(ie) = .true.
            x(ie+1) = themax
            if (themax.le.-2147483647.0) iblank(ie+1) = .true.
            ie = ie + 1
         endif
         ib1 = ib2 + 1
         if(ib1.le.ith) go to 2

         if(mseg*lseg.eq.nt) ie = ie - 1
c        if(ned.ne.0.and.ied.ne.0) call dxedit(x)
c   get data without decimating
      elseif(idec.eq.1) then
         call realio(x,itl,ith,ifl,0)
         if(ierror.eq.1) return
         ie = ith - itl + 1.
         if(ied.ne.0) call xedit(x)
      endif
      if(isc.ne.1) go to 9
c   self-scale limits
      ymin = 2147483647
      ymax = -2147483647
      do 8 i = 2,ie

      if(idec.eq.1) then
         ymin = amin1(ymin,x(i))
         ymax = amax1(ymax,x(i))
      else
         if(iblank(i)) then
           nothing=0
         else
           ymin = amin1(ymin,x(i))
           ymax = amax1(ymax,x(i))
         endif
      endif

  8   continue
      go to 13
c   clip data to limits
  9   do 11 i = 1,ie
      x(i) = amin1(x(i),ymax)
 11   x(i) = amax1(x(i),ymin)
c   prepare to plot
 13   dy = ymax - ymin
      if (dy.le.0.) dy = 1.
      fac = 780./dy
      delx = 1020./(ie-1.)
      write(6,110) ymin,ymax,itl,ith
 110  format(3x,'plot lying between ',2g12.5/
     1  2x,'sample ',i8,' to sample ',i8)
c   go into graphics mode and display data, unless there are only
c   edited points to plot and they will be blanked
      if(allblk.and.blnkit) go to 20

      if (idec.eq.1) then
         do 19 j = 1,ie
         if((.not.blnkit.or.(.not.iblank(j))).and.j.ne.1)
     1     call send12(int(delx*(j-1)),int((x(j)-ymin)*fac),1)
 19      if((blnkit.and.iblank(j)).or.j.eq.1)
     1     call send12(int(delx*(j-1)),int((x(j)-ymin)*fac),2)
      else
         j=1
         call send12(int(delx*(j-1)),int((x(j)-ymin)*fac),2)
         idrawing=1

         do 21 j=2,ie
         if (idrawing.eq.1.and.(.not.iblank(j))) then
           call send12(int(delx*(j-1)),int((x(j)-ymin)*fac),1)
         else
           if (idrawing.eq.0.and.(.not.iblank(j))) then
              call send12(int(delx*(j-1)),int((x(j)-ymin)*fac),2)
              call send12(int(delx*(j-1)),int((x(j)-ymin)*fac),1)
              idrawing=1
           else
              if (idrawing.eq.1.and.iblank(j)) then
              idrawing=0
              endif
           endif
         endif
 21   continue    
      endif

c      return to alpha mode
      call send12(-11,0,0)
      call send12(0,0,-1)
 20   if(erase.eq.0.and.ied.eq.0) call retnio(ifl)
      return
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Subroutine makeused
c
c  This routine creates an array of used points.  A point is used if
c  it is in the middle of an edit.
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine makeused(iused,ifirst,buf,ioffsofar)
      dimension iused(510)
      dimension buf(510)
      common/edits/igap(2,4000),ioff(4000),ned
      inedit = 0
      if (ned.eq.0) then
         j=0 
         goto 70
      endif 
      do 10 i=1, ned
         if (igap(1,i).lt.ifirst.and.igap(2,i).gt.ifirst) then
            inedit = 1
            ii=i
            goto 50
         endif
         if (igap(1,i).ge.ifirst) then
            inedit = 0
            ii=i
            goto 50
         endif
 10   continue
 50   do 20 j=1, 510
      iused(j) = inedit
      buf(j) = buf(j) + ioffsofar
c      if(iused(j).eq.1) print *,j,j+ifirst-1
      if (inedit.eq.0) then
         if (igap(1,ii).eq.j+ifirst-1) then
         inedit = 1
         endif
      else
         if (igap(2,ii).eq.j+ifirst-1) then
         inedit = 0
         ioffsofar=ioffsofar+ioff(ii)
         buf(j)=buf(j)+ioff(ii)
         ii=ii+1
         iused(j) = 0
            if (ii.gt.ned) then
               jj=j
               goto 70
            endif 
         endif
      endif
 20   continue
 30   return

 70   do 90 i=jj+1, 510
      iused(i) = 0
      buf(i)=buf(i)+ioffsofar
 90   continue
      goto 30
      end
      subroutine dxedit(x)
      logical iblank,allblk,blnkit,sync
c   subroutine for editing a (possibly decimated) series, described
c   by the data in common block sam, according to the edit
c   commands in common block edits.  the number of edits is ned,
c   and the bounding points of the edits are in igap
c
      dimension x(1020)
      common/edits/igap(2,4000),ioff(4000),ned
      common/sam/itl,ith,idec,ie,ymin,ymax,isc,ifil,irntot
      common/fade/iblank(1020),allblk,blnkit,sync
      nt0 = 1
      offset = 0.
c   loop through edits
      do 13 i = 1,ned
      isted = igap(1,i)
      iened = igap(2,i)
c   if end of edit falls before start of series, go to next one
      if(iened.le.itl) go to 13
c   if start of edit falls after end of series, do final offsetting
      if(isted.gt.ith) go to 15
c   compute where in array edit edges fall
      nt1 = (isted-itl)/idec + 1
      nt2 = (iened-itl+idec-1)/idec + 1
c   see if either edge of edit is outside series examined;  if both are,
c   fill with a number and return
      if(isted.lt.itl.and.iened.gt.ith) go to 19
      if(isted.lt.itl) go to 5
      if(iened.gt.ith) go to 9
      do 1 n = nt0, nt1
 1    x(n) = x(n) + offset
      offset = offset + ioff(i)
      x(nt2) = x(nt2) + offset
c   interpolate across gap, taking offset into account
      do 3 n = nt1,nt2
      jjjj = 1
      if(iblank(n)) then
        x(n) = x(nt1) + ((x(nt2)-x(nt1))/(nt2-nt1))*(n-nt1)
      endif
 3    continue
      nt0 = nt2 + 1
      go to 13
c   gap includes first points
 5    do 7 n = 1,nt2
      jjjjj = 1
 7    if (iblank(n)) x(n) = x(nt2)
       nt0 = nt2 + 1
      go to 13
c   gap includes last points
 9    do 11 n = nt1,ie
      if(n.ne.ie) jjjjj=1
 11   if (iblank(n)) x(n) = x(nt1)
      return
 13   jjjjj = 1
c   either next edit is out of range, or we have used them all -
c   offset remaining points
 15   do 17 n = nt0,ie
 17   x(n) = x(n) + offset
      return
c   no data in range
 19   do 21 i = 1,min0(nt2,1000)
 21   x(i) = 666.
      allblk = .true.
      return
      end
