      program dtrend
c  finds the mean and trend of a series, and may remove them;
c  alternatively, may "center" series so that extreme values are symmterical
c  about zero.
c        calls iolib
c
c  modified to correct i/o problems in some cases.
c  march 15 1983  nguyen-phan-trung.
c  option to de-mean only 18 nov 1993 d agnew
c
c
      double precision w
      dimension rd(2000), id(2000)
      character*1 iopt
      data iout/0/
      write(6,100)
 100  format(' File number, and start and end terms of portion',
     1 ' to analyze; ',$)
      ifl = ffin(1,not)
      ist = ffin(1,not)
      ien = ffin(1,not)
      if(ien.lt.ist) ien=longis(ifl)
      itot=ien
      tn = ien - ist + 1
      ict = ist - 1
      call realio(rd,ist,ist,ifl,0)
      up = rd(1)
      dow = rd(1)
      s11 = 12./(tn*(tn**2-1.))
      s12 = 6./(tn*(tn-1.))
      s22 = (2.*(2.*tn + 1.))/(tn*(tn-1.))
      v = 0.
      w = 0.
      irl = ist
 15   irh = min0(irl+1999,ien)
      call realio(rd,irl,irh,ifl,0)
      len = irh - irl + 1
      do 20 i = 1,len
      up = amax1(up,rd(i))
      dow = amin1(dow,rd(i))
      v = v + rd(i)
      w = w + rd(i)*(irl+(i-1) - ict)
 20   continue
      irl = irh + 1
      if(irl.le.ien) go to 15
      a = s22*v - s12*w
      b = s11*w - s12*v
      rme = v/tn
      cen = (up+dow)/2.
      rang = (up-dow)/2.
      ioff = ist
      write(6,110)a,b,rme,up,dow
 110  format(' Best fit is',g15.6,' + i*',g15.7,/'  (for the i-th'
     1         ,' term of this portion)',/,'   mean value is ',
     2 g15.5,/,'    extremes are ',g15.6,' and',g15.6)
      write(6,120)
 120  format(' output file (0 for no output) ; ',$)
      ifo = ffin(1,not)
      if (ifo.eq.0) stop
      if(ifo.ne.ifl) then
         if(ifo.lt.0)call realio(rd,1,1,ifo,1)
         if(ifo.gt.0)call intio(id,1,1,ifo,1)
      endif
 25   write(6,130)
 130  format(' what option? (h for help); ',$)
      idum = ffin(1,iopt)
      if(iopt.eq.'d'.or.iopt.eq.'c'.or.iopt.eq.'m') go to 30
      if(iopt.ne.'h') go to 25
      write(6,140)
 140  format(' Options are:',/,5x,'d - remove mean and trend',/,5x,
     1 'm - remove mean only',/,5x,
     2 'c - subtract out value centered between extremes')
      go to 25
 30   if(iopt.eq.'c')write(6,150)rang
 150  format(' new extremes will be +- ',g15.5)
      write(6,155)
 155  format(' Enter start and end term to apply corrections to ; ',$)
      ist=ffin(1,not)
      ien=ffin(1,not)
      if(ien.le.ist) ien=itot
      idel=ist-ioff
      a = a + b*idel
      if(idel.ne.0.and.iopt.eq.'d') write(6,160)a,b
 160  format(' Trend removed is ',g15.6,' + i*',g15.7,/,
     1 '  (for the i-th term of section corrected)')
      ict=ist-1
      irl = ist 
 35   irh = min0(irl+1999,ien)
      call realio(rd,irl,irh,ifl,0)
      len = irh - irl + 1
      do 40 i = 1,len
      if(iopt.eq.'c') rd(i) = rd(i) - cen
      if(iopt.eq.'d') rd(i) = rd(i) - b*(irl+(i-1)-ict) - a
      if(iopt.eq.'m') rd(i) = rd(i) - rme
      iout = iout + 1
 40   continue
      if (ifo.lt.0) call realio(rd,irl-ict,irh-ict,ifo,-1)
      if (ifo.gt.0) then
         do 50 i = 1,len
 50      id(i) = nint(rd(i))
         call intio(id,irl-ict,irh-ict,ifo,-1)
      endif
      irl = irh + 1
      if(irl.le.ien) go to 35
      write(6,170)iout,ifo
 170  format(2x,i7,' terms written to file ',i8)
      stop
      end
