c   program edtonio
c
c     converts from ascii to binary (iolib) version of edits file
c
c   calls timsubs, edcon3, headco
c
      character*80 line
      character*20 dumm
      character*8 source,chanid
      character*4 stc,commen
      double precision scans
      character*1 reason,mode
      dimension igap(2,12000),ioff(12000),reason(12000)
      dimension lgp(5),lfgp(5)
      dimension mgp(6),mfgp(6),istm(6)
      common/head/scans,calc(4),clkc(2),sampin,nchann,iblock,istart(5),
     1     iend(5),nchf(17),ichnm(16),ncal(4),source,chanid(16),stc,
     2     commen(200)
      common /scanrem/irc
      data reason/12000*'.'/,mode/'d'/,ned/12000/,iquit/1/
c
c  get information from command line
c
      if(iargc().eq.3) then 
         call getarg(1,dumm)
         read(dumm,100) ifl
 100     format(i20)
         if(ifl.lt.0) call userr
         call getarg(2,dumm)
         read(dumm,100) ifh
         if(ifh.lt.0) call userr
         call headco(ifh,1)
         isamp=sampin
         len=nint(scans)
         call getarg(3,mode)
         if(mode.ne.'d'.and.mode.ne.'m') call userr
         if(mode.eq.'m') then
            call toymd(istart,istm)
            do i=3,5
              istm(i+1)=istart(i)
            enddo
         endif
      endif
      if(iargc().eq.9.or.iargc().eq.10) then 
         call getarg(1,dumm)
         read(dumm,100) ifl
         if(ifl.lt.0) call userr
         call getarg(2,mode)
         if(mode.ne.'d'.and.mode.ne.'m') call userr
         call getarg(3,dumm)
         read(dumm,100) istart(1)
         istm(1)=istart(1)
         itl=4
         if(mode.eq.'m') itl=5
         do i=1,itl
            call getarg(3+i,dumm)
            if(mode.eq.'d') read(dumm,100) istart(i+1)
            if(mode.eq.'m') read(dumm,100) istm(i+1)
         enddo
         ico=7
         if(mode.eq.'m') ico=ico+1
         call getarg(1+ico,dumm)
         read(dumm,100) isamp
         if(isamp.lt.0) then
           iquit=0
           isamp=-isamp
         endif
         call getarg(2+ico,dumm)
         read(dumm,100) len
      endif
      if(iargc().ne.9.and.iargc().ne.10.and.iargc().ne.3) call userr
c
c   convert to binary file
c
      ned=1
 7    read(5,110,end=13) line
 110  format(a)
      if(line(1:1).ne." ") go to 7
      if(mode.eq.'d') then
       read(line,104) stc,chanid(1),lgp,lfgp,ioff(ned),reason(ned)
 104   format(1x,a4,1x,a8,1x,i4,i4,3i3,3x,i4,i4,3i3,2x,i8,2x,a1)
       igap(1,ned) = iscnsp(istart,lgp,isamp,mode)+1
       igap(2,ned) = iscnsp(istart,lfgp,isamp,mode)+1
      endif
      if(mode.eq.'m') then
       read(line,106) stc,chanid(1),mgp,mfgp,ioff(ned),reason(ned)
 106   format(1x,a4,1x,a8,1x,i4,5i3,3x,i4,5i3,2x,i8,2x,a1)
       igap(1,ned) = iscnsp(istm,mgp,isamp,mode)+1
       igap(2,ned) = iscnsp(istm,mfgp,isamp,mode)+1
      endif
c  loop if edit is entirely out of range
      if(igap(1,ned).gt.len.or.igap(2,ned).lt.1) go to 7
c
c   In the case in which the sample interval is larger than,
c    but a multiple of the one in the original edits, the
c    conversion from time to scan count will round down to the nearest
c    scan; we will want to round up the end of the gap if the remainder
c    for this (irc, which is in seconds) is nonzero.
c
      if(irc.ne.0) igap(2,ned)=igap(2,ned)+1
      ned=ned+1
      go to 7
 13   ned=ned-1
c
c  Combine any edits that cover the same interval (possible if the
c    original sample interval was smaller than the new one), and
c    shift the list and number of edits down.
c
      ic=1
 17   continue
      if(igap(1,ic+1).eq.igap(1,ic).and.
     1   igap(2,ic+1).eq.igap(2,ic)) then
         ioff(ic)=ioff(ic)+ioff(ic+1)
         do i=ic+2,ned
           igap(1,i-1)=igap(1,i)
           igap(2,i-1)=igap(2,i)
           ioff(i-1)=ioff(i)
         enddo
         ned=ned-1
         ic=ic-1
      endif
      ic=ic+1
      if(ic.lt.ned) go to 17
c
c  check edits for overlaps, or being out of order
c
      do i=2,ned
        do ii=1,i-1
          if(igap(2,ii).gt.igap(1,i)) then
            if(mode.eq.'d') then
             call timfnd(istart,igap(2,ii)-1,isamp,lgp,mode)
             call timfnd(istart,igap(1,i)-1,isamp,lfgp,mode)
             write(6,120) ii,lgp,i,lfgp
 120         format('Edit ',i5,' ending ',i4,i4,3i3,' overlaps'
     1          ,' edit ',i5,' starting ',i4,i4,3i3)
            endif
             if(mode.eq.'m') then
             call timfnd(istart,igap(2,ii)-1,isamp,mgp,mode)
             call timfnd(istart,igap(1,i)-1,isamp,mfgp,mode)
             write(6,121) ii,mgp,i,mfgp
 121         format('Edit ',i5,' ending ',i4,5i3,' overlaps'
     1           ,' edit ',i5,' starting ',i4,5i3)
            endif
            if(iquit.eq.1) then
              write(6,122)
 122          format(' ********EDTONIO QUITS********** ')
              stop
            endif
          endif
        enddo
      enddo
      call edcon3(ifl,ned,igap,ioff,0,len)
      stop
      end
      subroutine userr
c
c  error message, giving usage
c
      write(6,100)
 100  format(/,'Usage (Mode I):',/,
     1 '       cat ascii-edits | edtonio edfilnum headerfilnum tmode ',/,
     5 ' to convert from an edits file in ASCII and one in binary',/,
     6 '   (iolib), using the timing information in the',
     7 ' header file',/,
     8 ' tmode must be m or d, for ascii as y-m-d or y-d respectively',
     9 /)
      write(6,101)
 101  format(/,'Usage (Mode II):',/,
     1 '    cat ascii-edits | edtonio edfilnum',
     2 ' d year day hr min sec samp length',/,'      or ',/,
     1 '    cat ascii-edits | edtonio edfilnum',
     2 ' m year month day hr min sec samp length',/,
     5 ' to convert from an edits file in ASCII and one in binary',/,
     6 '   (iolib), using the timing information on the',
     7 ' command line',/,
     8 ' tmode must be m or d, for ascii as y-m-d or y-d',
     9 ' respectively',/,
     1 ' In this mode, a negative sample interval will keep the',/,
     2 ' program from quitting when an overlapping edit is found',
     3 /)
      stop
      end
