        program join
c
c       for a description of the program see statement 510 and 520.
c
c       modified to handled multiple sets of input series using the
c       same 'join' specifications.
c       march 18 1983  nguyen-phan-trung.
c
c       calls iolib, didlib.
c
      dimension x(1200),ix(1200), ifl(100),ist(100),tn(100),fp(100)
      character*1 ihelp,more
      data tp/0.0/
      write(6,500)
 500  format(' type h for help;; ',$)
      read(5,501) ihelp
 501  format(a1)
      if(ihelp.ne.'h')goto 5
      write(6,510)
 510  format(' This program joins series for up to 100 data files into'
     1,' a single long series.',/,' The constituent series go in the '
     2,'order in which their file numbers are',/,' entered. For each '
     3,'input series, the parameters to be entered are (in order) :',/,
     45x,'file number (negative for real files)',/,5x,
     5'Number of the first term to be taken',/,5x,
     6'Number of the last term to be taken',/,5x,
     7'Number of filler points to be placed',
     8'between this series and the next one',/,13x,
     9' (0 after the last series)',/,
     1' Filler points are linearly interpolated between',
     2' files.',/,' Output file is real unless all files are integer.'
     3,/,' Parameters are read using ffin.',//)
 5    write(6,530)
 530  format(' How many input series?; ',$)
      nser = ffin(1,not)
      if(nser.le.0) stop
      if(nser.le.100) go to 10
      write(6,540)
 540  format(' No more than 100 series allowed')
      go to 5
 10   if(ihelp.ne.'h')write(6,550)
 550  format(' For each series enter file number, start term, end'
     1,' term, and # of filler points to follow: ')
 13   ifg=1
      ifga=1
      irlo=1
      do 15 i=1,nser
      write(6,560)i
 560  format(' series number ',i2,' ; ',$)
      ifl(i) = ffin(1,not)
      if(more.eq.'y')goto 15
      ist(i) = ffin(1,not)
      endt = ffin(1,not)
      if(endt.lt.0) endt=longis(ifl(i))
      fp(i) = ffin(1,not)
      tn(i) = endt-ist(i)+1.
      tp = tp + tn(i) + fp(i)
 15   continue
      tp = tp - fp(nser)
 20   write(6,570)
 570  format(' output file; ',$)
      iout = ffin(1,not)
      isv = iout
      if(iout.lt.0) ifg = 0
      do 25 i = 1,nser
      if(iabs(iout).eq.iabs(ifl(i))) write(6,580)
 580  format(' output file cannot be the same as an input file')
      if(iabs(iout).eq.iabs(ifl(i))) go to 20
      if(ifl(i).lt.0) ifg = 0
 25   continue
c done with questions
c
c if we are to work in integers only, skip
      if(ifg.eq.1) go to 50
      call realio(x,1,2,iout,1)
      do 45 i = 1,nser
      fin = ist(i) + tn(i) -1.
      irh = ist(i) - 1
 30   irl = irh + 1
      irh = min0(irl+1199,int(fin))
      call realio(x,irl,irh,ifl(i),0)
      irho = irlo + irh - irl
      call realio(x,irlo,irho,iout,-1)
      irlo = irho + 1
      if(irh.ne.fin) go to 30
c done with a file. close it and interpolate if necessary
      call retnio(ifl(i))
      if(i.eq.nser.or.fp(i).eq.0) go to 45
c interpolate
      ft = irlo
      vlas = x(irh-irl+1)
      call realio(du,ist(i+1),ist(i+1),ifl(i+1),0)
      diff = (du-vlas)/(fp(i)+1.0)
      irl = 1
 35   irh = min0(irl+1199,int(fp(i)))
      np = irh-irl+1
      do 40 j=1,np
      x(j) = vlas + (irl+j-1)*diff
 40   continue
      irho = irlo + irh - irl
      call realio(x,irlo,irho,iout,-1)
      irlo = irho + 1
      irl = irh + 1
      if(irh.ne.fp(i)) goto 35
c done interpolating - print out location of points
      if(ifga.eq.1)write(6,590)
 590  format(' terms produced by interpolation (inclusive) :')
      ifga = 0
      if(fp(i).eq.1.)write(6,600)ft
 600  format(2x,f8.0)
      if (fp(i).gt.1.)write(6,610) ft, ft+ fp(i) -1.
 610  format(2x,f8.0,' through ',f8.0)
 45   continue
      go to 75
c
c join integer files - proceed as above
c
 50   call intio(ix,1,2,iout,1)
      do 70 i=1,nser
      fin = ist(i) + tn(i) -1.
      irh = ist(i) - 1
 55   irl = irh + 1
      irh = min0(irl+1199,int(fin))
      call intio(ix,irl,irh,ifl(i),0)
      irho = irlo + irh - irl
      call intio(ix,irlo,irho,iout,-1)
      irlo = irho + 1
      if(irh.ne.fin) go to 55
      call retnio(ifl(i))
      if(i.eq.nser.or.fp(i).eq.0) go to 70
      ft = irlo
      vlas = ix(irh-irl+1)
      call intio(idu,ist(i+1),ist(i+1),ifl(i+1),0)
      diff = (idu-vlas)/(fp(i)+1.0)
      irl = 1
 60   irh = min0(irl+1199,int(fp(i)))
      np = irh-irl+1
      do 65 j = 1,np
      ix(j) = vlas + (irl+j-1)*diff
 65   continue
      irho = irlo + irh - irl
      call intio(ix,irlo,irho,iout,-1)
      irlo = irho + 1
      irl = irh + 1
      if(irh.ne.fp(i)) goto 60
      if(ifga.eq.1)write(6,590)
      ifga = 0
      if(fp(i).eq.1.)write(6,600)ft
      if (fp(i).gt.1.)write(6,610)ft, ft+fp(i)-1.0
 70   continue
 75   isv = iabs(isv)
      if(ifg.ne.1) isv = -isv
      write(6,620) tp,isv
 620  format(/,1x,f9.0,' terms written to file ',i7,/)
      call retnio(iout)
      write(6,630)
 630  format(' do you want to edit another set of input',/,
     *' series using the same specifications ?; ',$)
      idum=ffin(1,more)
      if(more.eq.'y')write(6,640)
 640  format(' for each series enter file number :')
      if(more.eq.'y')goto 13
      stop
      end
