c     program erthtd
c
c     BOMM subroutine written by Jon Berger  November 1969
c     astronomy revised by Judah Levine (after J C Harrison) Sept 1973
c     updated by Karen Young  March 1977, for pdp 11
c     emended by Duncan Agnew June 1978 to speed execution
c     solar astronomy redone and rigid-earth potential added by Duncan
c     Agnew June 1979
c     tide generating part put in separate subroutine and computation
c     of Munk-Cartwright coefficients added by Duncan Agnew Feb 1981,
c     July 1982
c     Ability to get times from header files added by Duncan Agnew Jul 2003
c      
c     tides are calculated from harmonics 2 through 3 for
c     the lunar terms, 2 for the solar terms.
c     love numbers h(n), k(n), and l(n) are set by data statements.
c
c     gravity tide is in microgals, plus for up acceleration
c     rigid-earth potential is in meters (v/g), plus for up
c     tilt tide is in nanoradians (nr)......  1 nr = 2.063e-4 arcsec
c     strain tide is in parts in e9, plus for extension
c
c     azimuths for strain and tilt are reckoned
c     positive clockwise from north (east from north)
c
      character*1 not,ioptn
      double precision tt,ts,te,d,zhr,yhr,t
      real iyr,jyr,iday,jday,k,l,lamda
      dimension serout(60,7),ntw(3),tilt(2),strain(3),a(14),iget(7),
     1 ispc(4)
      dimension ist(5),ien(5)
      common/bpos/dsz,dcs,dsl,dcl,ssz,scz,ssl,scl,dpar,sdist
      common/love/h(3),k(3),l(3)
      common/azimut/azt(3,2),azs(3,3)
      common/tdiff/etmut
      common/sunny/moon
      data h/.6114,.2891,.175/,k/.304,.09421,.043/,
     1 l/.0832,.0145,.0103/
      data irl/1/,iflag/0/,ntotl/0/,iget/7*0/,ispc/4*0/,ntw/3*0/,
     1 moon/0/
      write(6,701)
701   format(' Start time- - -  (year,day,hour)   ',t43,'; ',$)
      iyr=ffin(1,not)
      if(not.eq.'h') then
c   get time from header (it2 will have end time--not used)
        nfl=iyr
        call hedtim(nfl,ist,ien,irnt,samp)
        iyr=ist(1)
        iday=ist(2)
        zhr=ist(3)+ist(4)/60.+ist(5)/3600.
        jyr=ien(1)
        jday=ien(2)
        yhr=ien(3)+ien(4)/60.+ien(5)/3600.
        d=samp/3600.
        go to 4
      endif
      iday=ffin(1,not)
      zhr=ffin(1,not)
      write(6,702)
702   format(' End time- - -  (year,day,hour)  ',t43,'; ',$)
      jyr=ffin(1,not)
      jday=ffin(1,not)
      yhr=ffin(1,not)
      write(6,703)
703   format(' Time interval (hours)-     ; ',$)
      d=ffin(1,not)
c   find times in hours from 0 hr, 1 jan 1900
 4    iyr=iyr-1900
      jyr=jyr-1900
      ts=zhr+24.d0*(iday-1)+8760.d0*iyr+24.d0*int((iyr-1)/4)
      te=yhr+24.d0*(jday-1)+8760.d0*jyr+24.d0*int((jyr-1)/4)
      terms=(te-ts)/d + 1.
      nrec=1
 5    write(6,7035)
 7035 format(' Type t for theoretical tides, m for Munk-'
     1 ,'Cartwright coefficients; ',$)
      dum = ffin(1,ioptn)
      if(ioptn.ne.'m'.and.ioptn.ne.'t') go to 5
      if(ioptn.eq.'t') go to 69
      nrec = 1
 6    write(6,7036)
 7036 format(' Type 2 for order 2, 3 for 3, 4 for both; ',$)
      iord=ffin(1,not)
      if(iord.lt.2.or.iord.gt.4) go to 6 
      nspc = min0(iord+1,4)
      write(6,7037)
 7037 format(' Type 1 to get long-period tides; ',$)
      ispc(1) = ffin(1,not)
      write(6,7038)
 7038 format(' Type 1 to get diurnal tides; ',$)
      ispc(2) = ffin(1,not)
      write(6,7039)
 7039 format(' Type 1 to get semidiurnal tides; ',$)
      ispc(3) = ffin(1,not)
      if(nspc.eq.4) write(6,7040)
 7040 format(' Type 1 to get terdiurnal tides; ',$)
      if(nspc.eq.4) ispc(4) = ffin(1,not)
      do 20 i=1,nspc
      if(ispc(i).le.0) go to 20
      if((iord.eq.2.or.iord.eq.4).and.i.le.3) iget(i)=1
      if(iord.ge.3) iget(i+3) = 1
 20   continue
      ntotl = 0
      do 21 i=1,7
 21   if(iget(i).eq.1) ntotl=ntotl+1
      go to 741
 69   write(6,704)
704   format(' North latitude-     ; ',$)
      theta=ffin(1,not)
      write(6,705)
705   format(' East longitude-     ; ',$)
      lamda=ffin(1,not)
      write(6,706)
 706  format(' Number of gravity (0 to 1), tilt (0-2), and'
     $,' strain (0-3) tides wanted ; ',$)
      do 710 i=1,3
      ntw(i) = ffin(1,not)
  710 ntotl = ntotl + iabs(ntw(i))
      if(ntw(2).eq.0) go to 732
      write(6,707)
 707  format(' Tiltmeter azimuth(s) - positive clockwise from'
     $ ,' north; ',$)
      do 731 i = 1,ntw(2)
      azt(1,i)= ffin(1,not)
      azt(2,i) = cos(azt(1,i)/57.2958)
 731  azt(3,i) = sin(azt(1,i)/57.2958)
 732  if(ntw(3).eq.0) go to 741
      write(6,708)
 708  format(' Strainmeter azimuth(s) - positive clockwise from'
     $ ,' north; ',$)
      do 733 i = 1,ntw(3)
      azs(1,i) = ffin(1,not)
      azs(2,i) = cos(azs(1,i)/57.2958)
 733  azs(3,i) = sin(azs(1,i)/57.2958)
 741  write(6,709)
 709  format(' Number of first output file (rest follow'
     $ ,' in sequence); ',$)
      ifil = ffin(1,not)
      ifil = iabs(ifil)
      write(6,903) ts,te,d
 903  format(' Time runs from',f14.4,' to',f14.4,
     $' with interval',f12.4)
c
c                  begin execution
c
      i = 1
      tt = ts
      call sph(theta,lamda,0.)
      etmut = 41.184 + iyr - 70
 10   if(tt.gt.te+1.e-5) go to 749
      t = (tt+12.d0 + (etmut/3600.d0))/876600.d0
c   t is ephemeris time in julian centuries from 12 hr 0 jan 1900
      call ephem(t)
      if(ioptn.eq.'m') go to 80
c
c     calculate normailzed total tides
c
      call elastd(grav,tilt,strain,ntw)
      if(ntw(1).eq.0) go to 71
c   gravity
      serout(i,1) = 1.e8*grav
      if(ntw(1).eq.-1) serout(i,1) = grav
 71   if(ntw(2).eq.0) go to 73
c   tilt
      do 72 kk = 1,ntw(2)
      idd = iabs(ntw(1)) + kk
 72   serout(i,idd) = 1.e9*tilt(kk)
 73   if(ntw(3).eq.0) go to 3
c   strain
      do 74 kk = 1,ntw(3)
      idd = iabs(ntw(1)) + ntw(2) + kk
 74   serout(i,idd) = 1.e9*strain(kk)
      go to 3
 80   call mcco(a,a(8))
      idd = 0
      do 81 kk =1,7
      if(iget(kk).eq.0) go to 81
      idd = idd + 1
      serout(i,idd) = a(kk)
      serout(i+1,idd) = a(7+kk)
 81   continue
c  double increment for mc coefficients
      i = i + 1
 3    i = i + 1
      tt = tt + d
      if(i.eq.61) go to 750
      go to 10
 749  iflag = 1
      if(i.eq.1) go to 770
c
c      the following pertains to the i/o program written for disk files
c
750   irh = irl + i - 2
      do 751 kk = 1,ntotl
      nnn = -(ifil+kk-1)
 751  call realio(serout(1,kk),irl,irh,nnn,nrec)
      nrec=-1
      i = 1
      irl = irh + 1
      if(iflag.eq.0) go to 10
770   write(6,771) irh
771   format(//' each output series is ',i8,' terms long'/)
      if(ioptn.eq.'m') go to 780
      if(ntw(1).eq.1)  write(6,772) -ifil
 772  format(' gravity tide in file ',i6)
      if(ntw(1).eq.-1) write(6,773) -ifil
 773  format(' potential tide in file ',i6)
      if(ntw(2).eq.0) go to 776
      do 774 i = 1,ntw(2)
 774  write(6,775) azt(1,i), -ifil-iabs(ntw(1))-i+1
 775  format(' tilt tide for azimuth',f6.1,' in file',i6)
 776  if(ntw(3).eq.0) stop
      do 777 i = 1,ntw(3)
 777  write(6,778) azs(1,i), -ifil-iabs(ntw(1))-ntw(2)-i+1
 778  format(' strain tide for azimuth',f6.1,' in file',i6)
      stop
 780  idd = -ifil + 1
      do 781 i=1,7
      if(iget(i).eq.0) go to 781
      idd = idd -1
      j = mod(i-1,7)
      iord = (j+1)/4 + 2
      nspc = j - 3*(iord/3)
      write(6,782) iord,nspc,idd
 782  format(' mcc(',i1,',',i1,') in file ',i5)
 781  continue
      stop
      end
