       program extend
c
c   used to copy some portion of one file into a new file, with
c   an optional padding of zeroes; if there is no input file,
c   an all-zero output is created. input and output may be real or
c   integer independently, so program may be used to convert from
c   one type to another
c   multiple input files are allowed, and except for zero input file,
c   non-zero input file(s) entry must end with input file 0.
c   output files' numbers for multiple input files will be consecutive
c   to the one specified by user.
c
c   the program can also be used to 'flip' or reverse a series or a portion
c   of it. in this mode, no padding is allowed.
c
c    d. agnew 14 nov 1980
c    multiple inputs added, nguyen p. trung 15 nov 1982
c    flip option added, nguyen p. trung oct 1983
c    correct 0 padding problem, npt dec 84
c    allow padding with first/last value  dca  apr 2009
c
c     calls intio,realio,ffin,listin,return
c
      dimension x(600),ix(600),inf(100),x2(600)
      character*1 iflip
      data n/-1/,ifpad,irpad/2*0/
      write(6,100)
 100  format(' input file (0 if none)::; ',$)
      call listin(inf,n,0)
      if (n.eq.0) inf(1)=0
      if(inf(1).eq.0) then
c
c  create an empty file
c
        write(6,102)
 102    format(' output file; ',$)
        ioutf = ffin(1,not)
        write(6,104)
 104    format(' length of file; ',$)
        itout = ffin(1,not)
        if(ioutf.gt.0) call intio(ix,itout,itout,ioutf,1)
        if(ioutf.lt.0) call realio(x,itout,itout,ioutf,1)
        stop
      endif
 3    write(6,102)
      ioutf = ffin(1,not)
      do k =1,n
         do i = 1,n
           if((ioutf+(i-1)*isign(1,ioutf)).eq.inf(k)) then
             write(6,106)
 106         format(' input and output must be different')
             go to 3
           endif
           enddo
      enddo
 5    write(6,108)
 108  format(' first and last terms to take from input; ',$)
      ist = ffin(1,not)
      iend = ffin(1,not)
      if(iend.le.0) iend=longis(inf(1))
      if(ist.le.0.or.ist.gt.iend) go to 5
      write(6,110)
 110  format(' do you want to flip (reverse) it (y/n) ?; ',$)
      idum=ffin(1,iflip)
      if(iflip.eq.'n')then
         write(6,112)
 112     format(' number of zeros to pad on front; ',$)
         ifpad = ffin(1,not)
         write(6,114)
 114     format(' number of zeros to pad on rear; ',$)
         irpad = ffin(1,not)
      endif
      itout=iabs(ifpad)+iend-ist+1+iabs(irpad)
cccccccccccccccccccccccccccccc
c
c  Loop through multiple inputs
c
cccccccccccccccccccccccccccccc
      do k=1,n
         do i=1,600
          x(i) = 0.
          ix(i) = 0
         enddo
         irl=1
         if(iflip.eq.'y')irh=itout
         if(ioutf.gt.0) call intio(ix,1,1,ioutf,1)
         if(ioutf.lt.0) call realio(x,1,1,ioutf,1)
         if(ifpad.ne.0) then
c
c  pad the front, with zeros of the first term
c
            pad=0.
            jpad=0
            if(ifpad.lt.0) then
               call realio(x,ist,ist,inf(k),0)
               jpad=nint(x(1))
               pad=x(1)
            endif
            do i=1,600
             x(i) = pad
             ix(i) = jpad
            enddo
 11         irh = min0(irl+599,iabs(ifpad))
            if(ioutf.gt.0) call intio(ix,irl,irh,ioutf,-1)
            if(ioutf.lt.0) call realio(x,irl,irh,ioutf,-1)
            irl = irh + 1
            if(irl.le.iabs(ifpad)) go to 11
         endif
c
c  if iflip = 'n', copy the original, otherwise flip it
c
c                irl,irh : output pointers
c             irli, irhi : input pointers
c
         irli = ist
 13      irhi = min0(irli+599,iend)
         np = irhi - irli + 1
         call realio(x,irli,irhi,inf(k),0)
         if(iflip.eq.'n') irh=irhi-irli+irl
         if(iflip.ne.'n') then
            irl=irh-(irhi-irli)
            idx=np
            do i=1,np
               x2(i)=x(idx)
               x(i)=x2(i)
               idx=idx-1
            enddo
         endif
         if(ioutf.gt.0) then
cc   transfer reals to integers
            do i=1,np
               ix(i) = nint(x(i))
            enddo
            call intio(ix,irl,irh,ioutf,-1)
         endif
         if(ioutf.lt.0) call realio(x,irl,irh,ioutf,-1)
         irli = irhi + 1
         if(iflip.eq.'n')irl = irh +1
         if(iflip.eq.'y')irh = irl -1
         if(irli.le.iend) go to 13
c
c pad the end
c
         if(irpad.ne.0) then
            pad=0.
            jpad=0
            if(irpad.lt.0) then
               call realio(x,iend,iend,inf(k),0)
               jpad=nint(x(1))
               pad=x(1)
            endif
            do i=1,600
             x(i) = pad
             ix(i) = jpad
            enddo
 17         irh = min0(irl+599,itout)
            if(ioutf.gt.0) call intio(ix,irl,irh,ioutf,-1)
            if(ioutf.lt.0) call realio(x,irl,irh,ioutf,-1)
            irl = irh + 1
            if(irl.le.itout) go to 17
         endif
         if(iflip.eq.'y')write(6,116) itout,inf(k),ioutf
         if(iflip.eq.'n')write(6,118) itout,inf(k),ioutf
 116     format(1x,i7,' terms from file',i6,' reversed and'
     *  ,' written to file',i6)
 118     format(1x,i7,' terms written from file',i6,
     1   ' to file',i6)
         call retnio(inf(k))
         call retnio(ioutf)
         if(ioutf.gt.0) ioutf=ioutf+1
         if(ioutf.lt.0) ioutf=ioutf-1
      enddo
c
c end of loop over multiple files
c
      ishf = iabs(ifpad)-ist + 1
      if(ishf.ne.0.and.iflip.ne.'y') write(6,120) ishf
 120  format(2x,i7,' term shift applied to transferred data')
      stop
      end
