      program fourier
c  program finds forward and inverse fourier transforms
c  the time-domain is always assumed to be real, so that only
c  the positive frequencies are considered, their negative
c  counterparts being construed so as to ensure reality of the
c  time-domain functions.
c$$$$$ link with fft,realtr,iolib
c----- note forward transform with  exp(-i*omega*t) -------
c+++++      inverse transform with  exp(+i*omega*t) ++++++
c
      character*1 not
      dimension x(250000),st(2),infile(2),jout(2)
      common /space/ ispace
c
 1000 write(6,100)
 100  format(' enter 1 for forward, -1 for inverse transform; ',$)
      iplex=1
      iway = ffin(1,not)
      if (iway.gt.0) go to 1300
 110  format(10i5)
      write(6,120)
 120  format(' enter 1 for multiplexed input, 2 for separate files; ',$)
 1100 iplex = ffin(1,not)
      igo=1
      if (iplex.ne.1 .and. iplex.ne.2) go to 9100
 1300 write(6,130)
 130  format(' enter [real] file number(s) of input series; ',$)
      do 633 i=1,iplex
 633  infile(i) = ffin(1,not)
      write(6,140)
 140  format(' enter start term(s); ',$)
      do 634 i=1,iplex
 634  st(i) = ffin(1,not)
 145  format(10f10.0)
      write(6,150)
 1500 tot = ffin(1,not)
 150  format(' enter total number of terms to read from file(s); ',
     &$)
      if (iplex.eq.1 .and. amod(tot,2.0).ne.0.0) go to 9200
c
c  read in data from specified files
      ispace=iplex
      go to (2100,2200),iplex
 2100 call realio(x,int(st(1)),int(st(1)+tot-1.0),infile(1),0)
      n=tot
 777  format(10g13.5)
      go to 2500
 2200 tot=2.0*tot
      call realio(x(1),st(1),st(1)+tot-1.0,infile(1),0)
      call realio(x(2),st(2),st(2)+tot-1.0,infile(2),0)
      n=tot
c
c  perform transform in store
 2500 if (iway) 3100,3100,3500
c
c  inverse transform
 3100 write(6,300)
 300  format(' type -1 if you want transform of complex conjugate; ',$)
      konj = ffin(1,not)
      change=-.5*isign(1,konj)
      do 3150 i=1,n,2
      x(i)=.5*x(i)
 3150 x(i+1)=change*x(i+1)
      n=n-2
      call realtr(x,x(2),n/2,-2)
      call fft(x,x(2),n/2,n/2,n/2,-2,ierr)
      if (ierr.ne.0) go to 9000
      write(6,310)
 310  format(/,'real series has been found and is currently in memory'/
     &'enter file number for this series; ',$)
      iout = ffin(1,not)
      ispace=1
      call realio(x,1,(n),iout,1)
      write(6,315) iout,n
 315  format(/,'series written to file ',i6,' with ',
     &i8,' terms')
      stop
c
c  forward transform
 3500 call fft(x,x(2),n/2,n/2,n/2,2,ierr)
      if (ierr.ne.0) go to 9000
      call realtr(x,x(2),n/2,2)
      scale=1.0/n
      do 3510 i=2,n+2,2
      x(i-1)=x(i-1)*scale
 3510 x(i)=-x(i)*scale
      write(6,350)
 350  format(/,'complex series has been found and is currently ' 
     &,'in memory'
     &/' it has been normalized by 1/(number of terms in series)'
     &/' type 1 for multiplexed output file, 2 for separate'
     &,' real and imaginary files; ',$)
 3550 iplex = ffin(1,not)
      igo=2
      if (iplex.ne.1 .and. iplex.ne.2) go to 9100
      write(6,360)
      do 635 i=1,iplex
 635  jout(i)=ffin(1,not)
 360  format(/,'enter file number(s) for series; ',$)
c
c  output series, either multiplexed or as separate files
      ispace=iplex
      go to (3700,3800),iplex
 3700 tot=n+2
      call realio(x,1,n+2,jout(1),1)
      write(6,315) jout(1),n+2
      stop
 3800 n=n+2
      call realio(x(1),1,n,jout(1),1)
      call realio(x(2),1,n,jout(2),1)
      n=n/2
      write(6,380) jout,n
 380  format(/,'real part of transform written to ',i4,
     &', imaginary part to ',i4/
     &' each series contains ',i4,' terms')
      stop
c
c  error messages for wrong number of terms
 9000 write(6,900)
 900  format(/,'inadmissable number of terms in series to be transformed.
     &  please start again')
      stop
 9100 write(6,910)
 910  format(/,'number must be 1 or 2.  try again; ',$)
      go to (1100,3550),igo
 9200 write(6,920)
 920  format('series must contain an even number of terms. try
     &again; ',$)
      go to 1500
      end

