c   program fromtimed
c
c      given a mode (d or m), start time (y,d,h,m,s for mode d, y,m,d,h,m,s
c    for mode m) and sample interval (sec) on the command line, reads in data
c    with calendar times from the standard input, and writes out a data file
c    and edits file.
c
c      calls iscnsp, getarg (the latter is Unix)
c
      character*40 arg
      character*1 mode
      dimension ist(6),iloc(6)
      dimension vals(2000000),iflag(2000000),ivals(2000000)
      dimension igap(2,30000),joff(30000)
      data iscold/0/
      data iflag/2000000*0/
      data vals/2000000*0.0/
      data ivals/2000000*0/
      data marray/2000000/
      if(iargc().lt.12) then
        write(6,100) marray
 100    format('Usage: fromtimed [m|d] start-time sample len a b',
     1  ' dataout edout',/,
     2  'where  start-time is y d h m s for d, y m d h m s for m',/,
     3  '       sample is interval in seconds',/,
     4  '       len is length to write out (max ',i8,')',/,
     5  '       a and b are scaling and offset to be applied',/,
     6  '       dataout and edout are file numbers for data and edits')
        stop
      endif
      call getarg(1,arg)
      read(arg,*) mode
      if(mode.eq.'m') narg = 7
      if(mode.eq.'d') narg = 6
      do 3 i=2,narg
      call getarg(i,arg)
      read(arg,*) ist(i-1)
 3    continue
      call getarg(narg+1,arg)
      read(arg,*) isam
      call getarg(narg+2,arg)
      read(arg,*) len
      if(len.gt.marray) then
         write(6,102) len,marray
 102     format('Length of ',i8,' greater than ',i8,' allowed')
      endif
      call getarg(narg+3,arg)
      read(arg,*) a
      call getarg(narg+4,arg)
      read(arg,*) b
      call getarg(narg+5,arg)
      read(arg,*) ifileout
      call getarg(narg+6,arg)
      read(arg,*) iedout
 5    read(5,*,end=7) (iloc(i),i=1,narg-1),x
      isc = 1 + iscnsp(ist,iloc,isam,mode)
      if(isc.gt.0.and.((len.gt.0.and.isc.le.len).or.len.le.0)) then
        vals(isc)=a*x+b
        ivals(isc)=nint(a*x+b)
        iflag(isc)=1
        if(isc.gt.iscold) iscold=isc
      endif
      go to 5
 7    continue
      write(6,110) iscold
 110  format('Last term is ',i9)
      if(len.le.0) len=iscold
      if(ifileout.lt.0) call realio(vals,1,len,ifileout,1)
      if(ifileout.gt.0) call intio(ivals,1,len,ifileout,1)
c-----------------------------------------------------------
c  Now check for missing scans; write out an
c    edits file to show this (including the case of no edits)
c------------------------------------------------------------
c
      ned=0
      nscan=len
      if(iflag(1).eq.0) then
        ned=ned+1
        igap(1,ned)=0
      endif
      do i=2,nscan
        if(iflag(i).eq.0.and.iflag(i-1).ne.0) then
          ned=ned+1
          igap(1,ned)=i-1
        endif
        if(iflag(i).ne.0.and.iflag(i-1).eq.0.) then
          igap(2,ned)=i
          joff(ned)=0
        endif
      enddo
      if(iflag(nscan).eq.0) then
        igap(2,ned)=nscan+1
      endif
c
c  fill any gaps (missing data) with linear interpolation, or a constant
c     if the edit runs to the end or the start
c
      if(ned.gt.0) then
         do k=1,ned
              if(igap(1,k).ge.1.and.igap(2,k).le.len) then
                   call linter(ifileout,igap(1,k),igap(2,k))
              endif
              if(igap(1,k).lt.1) then
                   i2=igap(2,k)
                   if(ifileout.gt.0) then
                     call intio(jj,i2,i2,ifileout,0)
                     call intio(jj,1,1,ifileout,1)
                   endif
                   if(ifileout.lt.0) then
                     call realio(rr,i2,i2,ifileout,0)
                     call realio(rr,1,1,ifileout,1)
                   endif
                   call linter(ifileout,1,i2)
                   igap(1,k)=1
              endif
              if(igap(2,k).gt.len) then
                   i1=igap(1,k)
                   if(ifileout.gt.0) then
                     call intio(jj,i1,i1,ifileout,0)
                     call intio(jj,len,len,ifileout,1)
                   endif
                   if(ifileout.lt.0) then
                     call realio(rr,i1,i1,ifileout,0)
                     call realio(rr,len,len,ifileout,1)
                   endif
                   call linter(ifileout,i1,len)
                   igap(2,k)=len
              endif
         enddo
      endif
      if(iflag(nscan).ne.0) call edcon3(iedout,ned,igap,joff,0,nscan)
      if(iflag(nscan).eq.0) call edcon3(iedout,ned,igap,joff,0,nscan+1)
      write(6,120) ned
 120  format(i5,' edits written out')
      stop
      end
