      program gapsta
c   program for reading a series of edits files and printing out a list of
c  how many edits are of a given length, and how much loss of data
c  they cause.  division points between gap lengths may be set arbitrarily
c  or to be multiples of some amount.  in entering list of separation 
c  points, typing -1 ends the list; typing -1 immediately gets the
c  option of having the points multiples of some length.
c
c     calls regap, iolib
c
      dimension sp(50000),ep(50000),ibs(60),pcs(60),cpcl(60)
     &,ngp(60),npig(60),iedf(40),serl(40)
      data ns/50000/,maxgap,nzlg/2*0/,ngp,npig/120*0/,pcs/60*0./,
     & cpcl/60*100./,ibs(1)/0/,rnt/0./
      write(6,100)
 100  format(' number of files to look at ',$)
      ifed = ffin(1,not)
      write(6,101)
 101  format(' for each file, enter number of edits file, and length'
     1,' of source file',/)
      do 3 i = 1,ifed
      write(6,102) i
 102  format(' file #',i3,2x,$)
      iedf(i) = ffin(1,not)
      serl(i) = ffin(1,not)
 3    rnt = rnt + serl(i)
 4    write(6,104)
 104  format('  enter separation points for gap sizes ',$)
      do 5 i = 2,60
      ibs(i) = ffin(1,not)
      if(ibs(i).le.0) go to 10
 5    continue
      write(6,106)
 106  format('  too many bins - try again')
      go to 4
 10   ngpb = i - 1
      if(ngpb.ne.1) go to 13
      write(6,108)
 108  format(1x,'bin size, # of bins ',$)
      ibss = ffin(1,not)
      ngpb = ffin(1,not)
      ngpb = min0(ngpb,60)
      if(ibss.le.0) ngpb = 15
      do 12 i = 2,ngpb
      ibs(i) = ibss*(i-1)
 12   if(ibss.le.0) ibs(i) = 2**(i-1)
 13   ibs(ngpb+1) = 32000
      do 27 kk = 1,ifed
      ns = 50000
      call regap(iedf(kk),sp,ep,ns,serl(kk))
      do 21 j = 1,ns-1
      ngpl = sp(j+1) - ep(j) -1
      maxgap = max0(maxgap,ngpl)
      if(ngpl.eq.0) nzlg = nzlg + 1
      if(ngpl.eq.0) go to 21
      do 15 i = 1,ngpb
      if(ibs(i).lt.ngpl.and.ibs(i+1).ge.ngpl) go to 18
 15   continue
 18   ngp(i) = ngp(i) + 1
      npig(i) = npig(i) + ngpl
      pcs(i) = pcs(i) + (100.*ngpl)/rnt
 21   continue
 27   continue
      do 24 i = 1,ngpb
      do 24 j = 1,ngpb - i + 1
 24   cpcl(i) = cpcl(i) - pcs(ngpb-j+1)
      write(6,109)
 109  format(' type 1 to get plot files ',$)
      ikn = ffin(1,not)
      if(ikn.eq.1) go to 30
      write(6,110)
 110  format(1x,'gap length',15x,'no. of gaps',15x,'no. of points'
     &,15x,'% of series',15x,'% series available if removed',//)
      write(6,112)(ibs(i)+1,ibs(i+1),ngp(i),npig(i),pcs(i),cpcl(i),
     & i = 1,ngpb)
 112  format(2x,i5,'-',i5,17x,i5,15x,i6,16x,f6.2,17x,f6.2)
      write(6,114) maxgap
 114  format(/,1x,'maximum gap is ',i8,' points long')
      stop
 30   do 33 i = 1,ngpb
      j = 3*i
      sp(j) = 0.
      sp(j-1) = pcs(i)
      sp(j-2) = pcs(i)
      ep(j-1) = ibs(i+1)
      ep(j) = ibs(i+1)
 33   ep(j+1) = ibs(i+1)
      ep(1) = 0.
      irk = 3*ngpb
      write(6,116)
 116  format(' output files (x + y) ',$)
      ifx = ffin(1,not)
      ify = ffin(1,not)
      call realio(ep,1,irk,ifx,1)
      call retnio(ifx)
      call realio(sp,1,irk,ify,1)
      stop
      end

