c
c          program gener  - generates various functions (others
c           are done by white)
c
c    $calls iolib
c
      character*1 not,isam
      integer*4 jcc
      dimension ix(1000), x(1000),a(20),t(20),p(20)
      data tpi/6.283185308/,dr/.01745325/
      data nfunc/6/,irl,jcc,nrec/3*1/
    1 write(6,9999)
 9999 format(' Function type (h for help)            ; ',$)
      ift   =   ffin(1,not)
      if(not .eq. 'h') go to 10
      if(not .eq. '0') go to 20
      go to 1
   10 write(6,9998)
 9998 format(' gener  will construct the following types of series',/,
     &10x,'1.  a sum of sinusoids',/,
     &10x,'2.  a symmetric square wave',/,
     &10x,'3.  a linear ramp',/,
     &10x,'4.  a triangle wave',/,
     &10x,'5.  an inverse gaussian function',/,
     &10x,'6.  a (natural) exponential function')
      go to 1
   20 if(ift .lt. 1 .or. ift .gt. nfunc) go to 1
      write(6,9997)
 9997 format(' Output file                           ; ',$)
      iout=ffin(1,not)
      itype=iout/iabs(iout)
      write(6,9996)
 9996 format(' Number of terms                       ; ',$)
      irnt =  ffin(1,not)
      go to (100,200,300,400,1000,600),ift
c
c***************************************************************
c
c                question-asking section
c
c***************************************************************
c
c     sum of sinusoids
c
  100 write(6,9994)
 9994 format(' Sample interval (number then letter (hms), e.g.'
     1,' 1h or 30m); ',$)
      sam = ffin(1,isam)
      if(isam.ne.'m'.and.isam.ne.'h'.and.isam.ne.'s'.and.isam.ne.'0')
     1 go to 100
      if(isam.eq.'h') sam = 3600*sam
      if(isam.eq.'m') sam = 60*sam
      write(6,9993)
 9993 format(' Enter amp, phase, and period (with unit) for each (0',
     &' for no more)')
      nh = 1
  110 write(6,9992) nh
 9992 format(' Number ',i3,'     ; ',$)
      a(nh)  =   ffin(1,not)
      if(a(nh).eq.0) go to 130
      p(nh)  =   ffin(1,not)
      p(nh) = p(nh)*dr
      t(nh)  =   ffin(1,isam)
      if(isam.ne.'m'.and.isam.ne.'h'.and.isam.ne.'s'.and.isam.ne.'0')
     1 go to 110
      if(isam.eq.'h') t(nh) = 3600.*t(nh)
      if(isam.eq.'m') t(nh) = 60.*t(nh)
      nh =   nh + 1
      go to 110
  130 nh = nh - 1
      jcc = 0
      go to 1000
c
c     square wave
c
 200  write(6,9991)
 9991 format(' Wave amplitude and period             ; ',$)
      amp     =   ffin(1,not)
      per     =   ffin(1,not)
      if(per .ge. 2.) go to 210
      write(6,9989)
9989  format(' Period must be >= 2')
      go to 200
 210  jcc     =   -1
      go to 1000
c
c     linear ramp 
c
 300  write(6,9990)
 9990 format(' Start value and increment (slope) of ramp    ; ',$)
      start   =    ffin(1,not)
      amp     =    ffin(1,not)
      jcc     =    0
      go to 1000
c
c     triangle wave
c
 400  write(6,9991)
      amp     =   ffin(1,not)
      per     =   ffin(1,not)
      if(per .ge. 2.) go to 410
      write(6,9989)
      go to 400
 410  jcc     =   0
      go to 1000
c
c     gausian function (500's) is calculated below (in function generating)
c
c     exponential function 
c
 600  write(6,9988)
 9988 format(' Amplitude, exponent, and offset of exponential',/,
     &1x,     '(with unity interval steps, beginning at zero)  ; ',$)
      amp     =    ffin(1,not)
      bexp    =    ffin(1,not)
      start   =    ffin(1,not)
      jcc     =    0
      go to 1000
c
c*******************************************************************
c
c                   function generation section
c
c*******************************************************************
 1000 irh = min0(irl+999,irnt)
      mt = irh-irl+1.
      go to (1100,1200,1300,1400,1500,1600), ift
c
c  sum of sinusoids
c
 1100 do 145 k = 1,mt
      s     =   0.
      do 140 i = 1,nh
      start = (jcc*sam*tpi/t(i)) + p(i)
  140 s     =   s + a(i)*cos(start)
      jcc = jcc + 1
  145 x(k) = s
      go to 3000
c
c  square wave
c
 1200 do 220 i = 1,mt
      jcc = jcc + 1
  220 x(i)=-sign(amp,amod(float(jcc),per)-per/2 +.5)
      go to 3000
c
c  ramp
c
 1300 do 320 i = 1,mt
      x(i) = start + amp*jcc
 320  jcc = jcc + 1
      go to 3000
c
c  triangle wave
c
 1400 do 420 i=1,mt
      j = amod(float(jcc),per)
      x(i) = amp *((4*j/per) - 1)
      if(j.ge.per/2) x(i) = 2*amp - x(i)
 420  jcc = jcc + 1
      go to 3000
c
c  inverse gaussian function
c
 1500 do 520 i=1,mt
      pp = jcc/(irnt+1.)
      dd = pp
      if(dd.gt.0.5) dd = 1.- pp
      tt = sqrt(-2.0*alog(dd))
      x(i) = tt    -    (2.515517 + tt*(.802853 + tt*.010328))/
     1       (1.   + tt*(1.432788 + tt*(.189269 + tt*.001308)))
      if(pp.lt.0.5) x(i) = -x(i)
 520  jcc = jcc + 1
      go to 3000
c
c  (natural) exponential
c
 1600 do 620 i = 1,mt
      x(i) = start + amp*exp(jcc*bexp)
 620  jcc = jcc + 1
      go to 3000
c
c*****************************************************************
c
c                    write buffer out to file
c
c*****************************************************************
 3000 if(itype.lt.0) go to 3200
      do 3100 k=1,mt
 3100 ix(k) = nint(x(k))
 3200 if(itype.gt.0) call intio(ix,irl,irh,iout,nrec)
      if(itype.lt.0) call realio(x,irl,irh,iout,nrec)
      nrec = -1
      irl = irh + 1.
      if(irl.le.irnt) go to 1000
      write(6,998) irnt,iout
  998 format(4x,i8,' terms written to file  ',i6)
      stop
      end
