      subroutine getboh(file)
c
c   subroutine to get the header information for a bottle file
c   1-2   2       short   magic number: 349 if byte order is the same
c                         in the machine as in the file, 23809 if the
c                         reverse
c   3-4   2       short   unused
c   5-8   4       int     header size (always 40)
c  9-16   8       double  start time, Unix sec
c 17-20   4       float   sample interval
c 21-24   4       int     number of data points in file
c     information is passed back to main program in common blocks
c   for header
c
c   the argument  file   is the file name
c
      character*(*) file
      character*8 source,chanid
      character*4 stc,commen
      double precision scans
      integer*2 lf,lenstr
      integer*2 ihbuf(20),ihbufs(20),ihbufd(20)
      integer*4 lhbuf(10)
      dimension rhbuf(10)
      dimension lbtime(5)
      double precision dhbuf(5)
      common/extra/isc,iswap
      common/head/scans,calc(4),clkc(2),sampin,nchann,iblock,istart(5),
     1     iend(5),nchf(17),ichnm(16),ncal(4),source,chanid(16),stc,
     2     commen(200)
      equivalence (ihbufs(1),lhbuf(1))
      equivalence (ihbufs(1),rhbuf(1))
      equivalence (ihbufd(1),dhbuf(1))
      data lbtime/1970,1,0,0,0/
c
c read the header
c
      lf=lenstr(file)
      call byteio(ihbuf,1,40,file,lf,0)
c
c swap the data from PC to workstation order, if need be
c
      magic=ihbuf(1)
      if(ihbuf(1).eq.23809) then
        call swap4(40,ihbuf,ihbufs)
        call swap8(40,ihbuf,ihbufd)
        iswap=1
        magic=ihbufs(2)
      endif
      if(magic.ne.349) then
        write(6,100) magic
 100    format(' Bad magic number ',i6,' --not a bottle file')
      endif
      ioff=nint(dhbuf(2))
      call timfnd(lbtime,ioff,1,istart,'d')
      sampin=rhbuf(5)
      isamp=nint(rhbuf(5))
      scans=lhbuf(6)
      isc=lhbuf(6)-1
      call timfnd(istart,isc,isamp,iend,'d')
      isc=lhbuf(6)
      return
      end
