c         program getpz
c
c    converts a rational function given as a ratio of polynomials to
c    one which is the ratio of products of poles and zeroes, and 
c    writes the result to a disk file. polynomials may be input from 
c    the keyboard or disk.
c    also reads in pole and zero files from the terminal or from a 
c    database and writes them out to disk.
c
c*************************************************************************
c
c      order of polynomial data on a disk file:
c          degree of numerator
c          degree of denominator
c          coefficients of numerator, degree zero first
c          coefficients of denominator, degrre zero first
c      order of pole-zero data on a disk file:
c          leading normalization coefficient
c          number of zeroes
c          number of poles
c          zeroes, given as alternating real and imaginary parts, and
c                  only one of a complex conjugate pair included
c          poles, given as for zeroes
c
c*************************************************************************c
c   $$ calls findpz,rmconj,shells,iolib
c
      character*1 not,ifor
      complex pole,zer,pax,zax
      double precision cnum,cden
      dimension pole(100),zer(100),deg(3),zax(100),pax(100),
     1 dum(100),ky(100),tnum(100),tden(100)
      common/polys/nnum,nden,cnum(100),cden(100)
 1    write(6,100)
 100  format(' Input form (p - polynomial, r - poles and zeroes); ',$)
      id = ffin(1,ifor)
      if(id.ne.0.or.(ifor.ne.'p'.and.ifor.ne.'r')) go to 1
      if(ifor.eq.'r') go to 21
      write(6,102)
 102  format(' Input file for polynomial (0 if from keyboard); ',$)
      ifile = ffin(1,not)
      if(ifile.ne.0) then
         call realio(deg,1,2,ifile,0)
         nnum = deg(1)
         nden = deg(2)
         call realio(tnum,3,3+nnum,ifile,0)
	 do 3 i=1,nnum+1
 3       cnum(i) = tnum(i)
         call realio(tden,4+nnum,4+nnum+nden,ifile,0)
	 do 5 i=1,nden+1
 5       cden(i) = tden(i)
         call retnio(ifile)
      elseif(ifile.eq.0) then
         write(6,106)
 106     format(' Degree of numerator; ',$)
         nnum = ffin(1,not)
         write(6,108)
 108     format(' Coefficients, degree zero first; ',$)
         do i=1,nnum+1
           cnum(i)=ffin(1,not)
         enddo
         write(6,110)
 110     format(' Degree of denominator; ',$)
         nden = ffin(1,not)
         write(6,108)
         do i=1,nden+1
           cden(i)=ffin(1,not)
         enddo
      endif
      call findpz(npd,nzd,pax,zax,cf)
      write(6,*) nzd,(zax(i),i=1,nzd)
 9    np = npd
      nz = nzd
      if(npd.gt.0) call rmconj(pax,npd,pole,np,dum,ky)
      if(nzd.gt.0) call rmconj(zax,nzd,zer,nz,dum,ky)
      write(6,112)
 112  format(' Type 1 to list poles and zeroes; ',$)
      ityp = ffin(1,not)
      if(ityp.eq.1) then
         write(6,114) cf
 114     format(' Leading coefficient ',g15.5)
         if(np.ne.0) write(6,116) (pole(i),i=1,np)
 116     format(' Poles are:',/,2(3x,2g15.7))
         if(nz.gt.0) write(6,117) (zer(i),i=1,nz)
 117     format(' Zeroes are:',/,2(3x,2g15.7))
         write(6,118)
 118     format(' Is this a z-transform filter? (y/n); ',$)
         idum = ffin(1,ifor)
         if(ifor.eq.'y') then
            write(6,119)
 119        format(' In the z-plane:')
         if(np.ne.0) write(6,116) (1./pole(i),i=1,np)
         if(nz.gt.0) write(6,117) (1./zer(i),i=1,nz)
         endif
      endif
      write(6,120)
 120  format(' File for poles and zeroes (0 if none); ',$)
      ifile = ffin(1,not)
      if(ifile.eq.0) stop
      deg(1) = cf
      deg(2) = nz
      deg(3) = np
      call realio(deg,1,3,ifile,1)
      call realio(zer,4,3+2*nz,ifile,-1)
      call realio(pole,4+2*nz,3+2*nz+2*np,ifile,-1)
      call retnio(ifile)
      stop
c
c   remaining section deals with poles and zeroes directly
c
 21   write(6,122)
 122  format(' Input mode (0 from terminal, 1 from database); ',$)
      ifl = ffin(1,not)
      if(ifl.lt.0.or.ifl.gt.1) go to 21
      if(ifl.eq.1) go to 33
      write(6,124)
 124  format(' Leading coefficient; ',$)
      cf = ffin(1,not)
      write(6,126)
 126  format(' Number of poles; ',$)
      npd = ffin(1,not)
      if(npd.eq.0) go to 25
      write(6,128)
 128  format(' Enter poles, real and imaginary parts alternating; ',$)
      do 23 i=1,npd
      d1 = ffin(1,not)
      d2 = ffin(1,not)
 23   pax(i) = cmplx(abs(d1),d2)
 25   write(6,130)
 130  format(' Number of zeroes; ',$)
      nzd = ffin(1,not)
      if(nzd.eq.0) go to 9
      write(6,132)
 132  format(' Enter zeroes, real and imaginary parts alternating; ',$)
      do 27 i=1,nzd
      d1 = ffin(1,not)
      d2 = ffin(1,not)
 27   zax(i) = cmplx(abs(d1),d2)
      go to 9
 33   write(6,140)
 140  format(' Option not yet implemented')
      stop
      end
