c      program happdat
c
c   Adds a set of files specified by one or two headers, to another set.
c    So, assumes all files to be at the same sample interval, and the 
c      channels to be the same for both headers.
c
c    $$$$calls timsubs,iosubs,hedlib,iolib
c
      character*80 dumm
      character*8 name,chid,chnbf
      character*4 stc,comm
      character*1 mode
      double precision scans
      dimension ibeg(5),ifin(5),icnmb(16),icflb(16),chnbf(16)
      common/head/scans,calc(4),clkc(2),samp,nchan,iblock,ist(5),
     1     ien(5),nchf(17),ichnm(16),ncal(4),name,chid(16),stc,
     2     comm(200)
      data mode/'d'/
      if(iargc().lt.2) then
         write(6,100)
 100     format(/,'   Usage: happdat header1 header2 ',/,
     1'     to append all data files referenced by header2 to',/,
     2'     the data files referenced by header1',/,
     3'     header1 is modified as needed',/,
     4'      e.g.',/,
     5'  happdat 100 2100',
     6 /)
         stop
      endif
      call getarg(1,dumm)
      read(dumm,101) ihdb
 101  format(i6)
      call getarg(2,dumm)
      read(dumm,101) ihda
      call headco(ihdb,1)
      isample = samp
      irlb=1
      irhb=nint(scans)
c save channel numbers, file numbers, start and end times
      do j=1,nchan
         icnmb(j) = ichnm(j)
         chnbf(j) = chid(j)
         icflb(j) = nchf(j)
      enddo
      do j=1,5
         ibeg(j) = ist(j)
         ifin(j) = ien(j)
      enddo
      nc = nchan
c-----------------------------------------
c  read add-on header and do some checks
c-----------------------------------------
      call headco(ihda,1)
c
c  sample intervals consistent
c
      if(isample.ne.int(samp)) then
         write(6,102) isample, int(samp)
 102     format('Cannot append data: base interval ',i6,' and new'
     1         ,'interval is ',i6,'  Program stops')
         stop
      endif
c
c  times in increasing order
c
      if(iscnsp(ifin,ist,isample,mode).lt.0) then
         write(6,104) ifin,ist
 104     format('Cannot append data: base ends at ',i5,i4,3i3,' and'
     1         ,' appended data starts at ',i5,i4,3i3,'  Program stops')
         stop
      endif
c
c  same numbers of channels
c
      if(nchan.ne.nc) then
         write(6,106) nc,nchan
 106     format('Cannot append data: base has ',i3,' channels and',
     1         ' appended data has ',i3,'  Program stops')
         stop
      endif
c
c  channel numbers match
c
      do j=1,nchan
        if(icnmb(j).ne.ichnm(j)) then
          write(6,108) j,icnmb(j),ichnm(j)
 108      format('Cannot append data: j-th channel number goes from ',i3
     1         ,' to ',i3,'  Program stops')
          stop
        endif
C        if(chnbf(j).ne.chid(j)
      enddo
c----------------------------------------------------
c  have all input information
c----------------------------------------------------
c  find locations for the start and end of the appended data
      irla = iscnsp(ibeg,ist,isample,mode) + 1
      irha = iscnsp(ibeg,ien,isample,mode) + 1
      irl=1
      irh=nint(scans)
c
c  now copy, looping through channels (niolib appends as needed)
      do i=1,nchan
        call filcop(nchf(i),irl,irh,icflb(i),irla)
      enddo
c
c  linear interpolation between last point of base piece and start of appended,
c     if needed.
c
      if(irla.gt.irhb+1) then
        do i=1,nchan
          call linter(icflb(i),irhb,irla)
        enddo
      endif
c-----------------------------------------
c  finish up by recovering and then modifying the base header
c-----------------------------------------
      do j=1,5
         ifin(j) = ien(j)
      enddo
      call headco(ihdb,1)
      scans = irha
      do i=1,5
        ien(i) = ifin(i)
      enddo
      call headco(ihdb,0)
      stop
      end
