c      program happed
c
c   combines a pair of sets of of edits files specified by a header,
c   overwriting the first set with the combined set.
c    Necessarily assumes all files edited to be at the same sample interval,
c    (which is gotten from a third header)
c     and the channels to be the same for both headers.
c
c    $$$$calls timsubs,iosubs,hedlib,iolib,editlib
c
      character*80 dumm
      character*8 name,chid,chnbf
      character*4 stc,comm
      character*1 mode
      double precision scans
      dimension kstar(5),kend(5),icnmb(16),icflb(16),chnbf(16)
      common/head/scans,calc(4),clkc(2),samp,nchan,iblock,ist(5),
     1     ien(5),nchf(17),ichnm(16),ncal(4),name,chid(16),stc,
     2     comm(200)
C old    common/head/stc,name,calc(4),clkc(2),nchan,iblock,ist(5),
C old   1     ien(5),scans,samp,nchf(17),ichnm(16),chid(16),ncal(4),
C old   2     comm(200)
      data mode/'d'/
      if(iargc().lt.3) then
         write(6,100)
 100     format(/,'   Usage: happed header1 header1a header2',/,
     1'    to append all edits files referenced by header2 to',/,
     2'    the edits files referenced by header1',/,
     3'    header1 is modified as needed',/,
     4'    header1a  is the header for the data files which are',/,
     4'     edited by the edits files (needed for sample interval and',/,
     4'       end time.   An example:',/,
     5'  happdat 300 100 2300',
     6 /)
         stop
      endif
      call getarg(1,dumm)
      read(dumm,101) ihd1
 101  format(i6)
      call getarg(2,dumm)
      read(dumm,101) ihd1a
      call headco(ihd1a,1)
      isample = samp
      do i=1,5
         kstar(i)=ist(i)
         kend(i) =ien(i)
      enddo
      nt=nint(scans)
      call getarg(3,dumm)
      read(dumm,101) ihd2
c 
c done reading command line
c
      call headco(ihd1,1)
c save channel numbers, file numbers, start time
      do j=1,nchan
         icnmb(j) = ichnm(j)
         chnbf(j) = chid(j)
         icflb(j) = nchf(j)
      enddo
      nc = nchan
      do j=1,5
         if(kstar(j).ne.ist(j)) then
           write(6,102)
 102       format(' Header start times do not match')
           stop
         endif
      enddo
c-----------------------------------------
c  read add-on header and do some checks
c-----------------------------------------
      call headco(ihd2,1)
c
c  times in increasing order
c
      if(iscnsp(kstar,ist,isample,mode).lt.0) then
         write(6,104) kstar,ist
 104     format('Cannot append edits: base starts at ',i5,i4,3i3,' and'
     1         ,' appended edits start at ',i5,i4,3i3,'  Program stops')
         stop
      endif
c
c  same numbers of channels
c
      if(nchan.ne.nc) then
         write(6,106) nc,nchan
 106     format('Cannot append edits: base has ',i3,' channels and',
     1          ' appended edits has ',i3,'  Program stops')
         stop
      endif
c
c  channel numbers match (commented out for now)
c
C      do j=1,nchan
C        if(icnmb(j).ne.ichnm(j)) then
C          write(6,108) j,icnmb(j),ichnm(j)
C 108      format('Cannot append edits: j-th channel number goes from ',i3
C     1         ,' to ',i3,'  Program stops')
C          stop
C        endif
C        if(chnbf(j).ne.chid(j)
C      enddo
c----------------------------------------------------
c  have all input information
c----------------------------------------------------
c  find offset between the two start times
      ioff = iscnsp(kstar,ist,isample,mode)
c  find offset between the end of the first file and the start of
c   the next
      igap = iscnsp(kend,ist,isample,mode)
c
c  now combine edits
      do i=1,nchan
        call edcomb(icflb(i),nchf(i),ioff,len,igap)
      enddo
c-----------------------------------------
c  finish up by recovering and then modifying the base header
c-----------------------------------------
      call headco(ihd1,1)
      scans=len
      call headco(ihd1,0)
      stop
      end
      subroutine edcomb(if1,if2,idiff,lened,ihole)
c
c  combine the edits in file if1 with those in file if2, which are offset
c    by idiff. lened is returned as the length of the output edits file
c    ihole is the size of the "hole" between data files--this is included
c    as an edit
c
      dimension kgap(2,2,10000),koff(2,10000),igap(2,10000),ioff(10000)
      dimension ned(2),ndc(2)
      ned(1)=10000
      call edcon3(if1,ned(1),igap,ioff,1,0)
      do i=1,ned(1)
        kgap(1,1,i) = igap(1,i)
        kgap(1,2,i) = igap(2,i)
        koff(1,i) = ioff(i)
      enddo
      iexed=0
c  insert the edit (if present) for the gap between files
      if(ihole.gt.1) then
        iexed=1
        kgap(2,1,1) = idiff-ihole+1
        kgap(2,2,1) = idiff+1
        koff(2,1) = 0
      endif
      ned(2)=10000
      call edcon3(if2,ned(2),igap,ioff,1,0)
      if(ned(2).ne.0) then
        do i=1,ned(2)
          kgap(2,1,i+iexed) = igap(1,i)+idiff
          kgap(2,2,i+iexed) = igap(2,i)+idiff
          koff(2,i+iexed) = ioff(i)
        enddo
      endif
      ned(2)=ned(2)+iexed
c  if no new edits, return
      if(ned(2).eq.0) return
c  if no old edits, copy edits back to arrys, write out, and return
      if(ned(1).eq.0) then
        do i=1,ned(2)
          igap(1,i) = kgap(2,1,i)
          igap(2,i) = kgap(2,2,i)
          ioff(i) = koff(2,i)
        enddo
        call edcon3(if1,ned(2),igap,ioff,0,0)
        lened=max(3*ned(2)+1,1441)
        return
      endif
c-------------------------------------------
c
c    Both old and new have edits: merge them
c
c-------------------------------------------
      ndc(1) = 1
      ndc(2) = 1
      nt=1
c at this point compare start points of the next edits to be looked
c  at (one from each series), and set ifl to be the index to the
c  one which starts first (the 'lower' one). load this start point
c  into the output array
 5    ifl = 1
      if(kgap(1,1,ndc(1)).gt.kgap(2,1,ndc(2))) ifl = 2
      ifh = 3 - ifl
      igap(1,nt) = kgap(ifl,1,ndc(ifl))
 7    if(kgap(ifl,2,ndc(ifl)).lt.kgap(ifh,1,ndc(ifh))) then
c  edits do not overlap (start of higher falls after end of lower),
c  so copy all of lower, bump the counter for it up, and loop.
        igap(2,nt) = kgap(ifl,2,ndc(ifl))
        ioff(nt) = koff(ifl,ndc(ifl))
        ndc(ifl) = ndc(ifl) + 1
        nt = nt + 1
        iff = ifh
        if(ndc(ifl).gt.ned(ifl)) go to 15
        go to 5
      endif
      if(kgap(ifh,2,ndc(ifh)).le.kgap(ifl,2,ndc(ifl))) then
c  higher edit is within lower - discard it (but add offset if requested)
c  and loop
        if(iadd.eq.1)
     1    koff(ifl,ndc(ifl)) = koff(ifh,ndc(ifh)) + koff(ifl,ndc(ifl))
        ndc(ifh) = ndc(ifh) + 1
        iff = ifl
        if(ndc(ifh).gt.ned(ifh)) go to 13
        go to 5
      endif
c  edits overlap - use upper end of higher (which is the later one)
c  as the new end, add offsets, switch flags, and look at the next edit
c  in the other series (previously the 'lower' series, now the 'higher')
      koff(ifh,ndc(ifh)) = koff(ifh,ndc(ifh)) + koff(ifl,ndc(ifl))
      ifl = ifh
      ifh = 3 - ifl
      ndc(ifh) = ndc(ifh) + 1
      iff = ifl
      if(ndc(ifh).gt.ned(ifh)) go to 13
      go to 7
c one edits file is exhausted - finish up from the other one
c 13 is the entry point if we have not put the end on yet, 15 if we have;
c iff is the index showing which edits are not exhausted
 13   igap(2,nt) = kgap(iff,2,ndc(iff))
      ioff(nt) = koff(iff,ndc(iff))
      nt = nt + 1
      ndc(iff) = ndc(iff) + 1
c  copy edits over, looping until exhausted
 15   if(ndc(iff).gt.ned(iff)) go to 17
      igap(1,nt) = kgap(iff,1,ndc(iff))
      igap(2,nt) = kgap(iff,2,ndc(iff))
      ioff(nt) = koff(iff,ndc(iff))
      nt = nt + 1
      ndc(iff) = ndc(iff) + 1
      go to 15
 17   nt = nt - 1
c  write out the merged edits
      call edcon3(if1,nt,igap,ioff,0,0)
      lened=max(3*nt+1,1441)
      return
      end
