c  program hartid
c
c    finds tides by summing harmonics; the amp and phase of these are
c  specified in subroutine admint
c
c    $calls genlib,tidlib,iolib
c
      character*1 ipht
      character*80 dumm
      character*1 not,itd,ished
      double precision f,p,dr,pi,scr
      dimension a(141),f(141),p(141),x(600),hc(282),scr(423),it2(5),
     1 wf(141),y(600)
      dimension idt(6,20),amp(20),phase(20)
      common/date/it(5)
      data itd/'d'/,nt/141/,dr/.01745329252d0/,pi/3.1415926535898d0/,
     1 irlo/1/,irli/1/
      data nin/1/,maxc/20/
      write(6,100)
 100  format(' Start time (y,d,h,m,s, or nnnh for header); ',$)
      it(1) = ffin(1,ished)
      if(ished.ne.'h') then
         do i=2,5
            it(i) = ffin(1,not)
         enddo
         if(it(1).lt.1900) stop
         write(6,102)
 102     format(' Number of terms; ',$)
         irnt = ffin(1,not)
         write(6,104)
 104     format(' Sample interval (sec); ',$)
         samp = ffin(1,not)
      endif
      if(ished.eq.'h') then
c   get time from header (it2 will have end time--not used)
         nfl=it(1)
         call hedtim(nfl,it,it2,irnt,samp)
      endif
      write(6,106)
 106  format(' Input file (0 if none); ',$)
      ifin = ffin(1,not)
      if(ifin.ne.0) then
         if(irnt.le.0) irnt=longis(ifin)
         write(6,107)
 107     format(' First term to take (start time assumed @ term 1); ',$)
         irli = ffin(1,not)
         if(irli.gt.1) then
            irnt = irnt + irli - 1
            call timfnd(it,irli-1,nint(samp),it2,itd)
            do 7 i=1,5
 7          it(i) = it2(i)
         endif
      endif
      write(6,108)
 108  format(' Output file; ',$)
      ifout = ffin(1,not)
c
c   get haromonics information 
c
      write(6,120)
 120  format(' Name of harmonics file ',$)
      read(5,122) dumm
 122  format(a)
      open(1,file=dumm,status='old')
      read(1,124) ipht
 124  format(a1)
      if(ipht.eq.'l') read(1,126) rlong
 126  format(f8.0)
 13   read(1,128,end=17) (idt(i,nin),i=1,6),amp(nin),phase(nin)
C      write(6,*) (idt(i,nin),i=1,6),amp(nin),phase(nin),nin
 128  format(6i2,2f9.0)
      if(ipht.eq.'l') phase(nin) = phase(nin) + idt(1,nin)*rlong
      nin=nin+1
c  stop reading on a flag or if arrays are full
      if(idt(1,nin-1).ge.0.and.nin.le.maxc) go to 13
 17   nin=nin-1
      if(idt(1,nin).lt.0) nin=nin-1
c
c  interpolate to larger set of harmonics
c
      call admint(amp,idt,phase,a,f,p,nin,nt)
C      write(6,*) 'nt',nt
c
c  set up for first recursion, and normalize frequencies
c
      do 23 i=1,nt
      p(i) = dr*p(i)
      f(i) = samp*pi*f(i)/43200.d0
 23   wf(i) = f(i)
      call realio(x,1,1,ifout,1)
 31   irhi = min(irli+599,irnt)
      np = irhi - irli + 1
      irho = irlo + np - 1
c set up harmonic coefficients
      do 33 i=1,nt
      hc(2*i-1) = a(i)*dcos(p(i))
 33   hc(2*i)  = -a(i)*dsin(p(i))
      call recurs(x,np,hc,nt,wf,scr)
      if(ifin.ne.0) then
         call realio(y,irli,irhi,ifin,0)
         do 35 i=1,np
 35      x(i) = y(i) - x(i)
      endif
      call realio(x,irlo,irho,ifout,-1)
      if(irhi.eq.irnt) go to 37
      irli = irhi + 1
      irlo = irho + 1
c  reset phases to the start of the new section
      do 36 i=1,nt
      p(i) = p(i) + np*f(i)
 36   p(i) = dmod(p(i),2.d0*pi)
      go to 31
 37   write(6,130) irho
 130  format(i8,' terms written out')
      end
      subroutine admint(ampin,idtin,phin,amp,f,p,nin,nout)
c  Returns the amplitude, frequency, and phase of a set of tidal
c  constituents. n is input as the number wanted, and returned as the number
c  provided.  The constituents used are stored in the arrays idd (doodson
c  number) and tamp (Cartwright-Edden amplitude).  The actual amp and
c  phase of each of these are determined by spline interpolation of the
c  real and imaginary part of the admittance, as specified at a subset
c  of the constituents.
c  The phase is determined for a time set in common block /date/ (see
c  subroutine tdfrph), outside of this subroutine.
c   Note that the arrays f and p must be specified as double precision.
c
c   $$$$calls tdfrph,spline,eval,shells
c
      double precision f,p,fr,pr
      dimension ampin(*),idtin(6,*),phin(*)
      dimension amp(*),f(*),p(*)
c  arrays containing information about all stored constituents
      dimension idd(6,141),tamp(141)
c  arrays containing information about the subset whose amp and phase may
c  be specified, and scratch arrays for the spline routines
c   at most 20 constituents may be specified.
      dimension rl(20),aim(20),rf(20),key(20),scr(20),
     1 zdi(20),zdr(20),di(20),dr(20),sdi(20),sdr(20),tdi(20),tdr(20)
      common/locat/rlong
      data dtr/.017453293/
      data nt/141/,ncon/20/
      data rl/20*0.0/,aim/20*0.0/,rf/20*0.0/
      data zdi/20*0.0/,zdr/20*0.0/,di/20*0.0/,dr/20*0.0/
      data sdi/20*0.0/,sdr/20*0.0/,tdi/20*0.0/,tdr/20*0.0/
      data tamp/
     1 0.63221, .29411, .12105, .07991, .02382,-.02359, .02299, .01933,
     1 -.01787, .01719, .01602, .00467,-.00466,-.00452, .00447, .00447,
     1 0.00259,-.00246,-.00217, .00197, .00195, .00191,-.00190, .00180,
     1 0.00130, .00117, .00113, .00106,-.00102,-.00102, .00101, .00090,
     1 -.00086, .00085, .00085, .00077, .00074, .00074,-.00072, .00070,
     1 0.00066, .00065,-.00065, .00063, .00063,-.00060, .00059, .00054,
     1 0.00048,-.00046, .00041, .36864,-.26223,-.12200,-.05021, .05003,
     1 -.04947, .02062, .02061, .01128,-.00953,-.00947,-.00801, .00741,
     1 -.00730, .00723,-.00713,-.00664, .00525, .00414, .00409, .00394,
     1 0.00394, .00342, .00342, .00289, .00288, .00216,-.00194, .00193,
     1 -.00180, .00169, .00169, .00152, .00151,-.00151, .00138, .00137,
     1 0.00137,-.00125,-.00107, .00102, .00090, .00087,-.00079, .00079,
     1 0.00078,-.00075,-.00075, .00067,-.00060,-.00060, .00054, .00054,
     1 -.00054,-.00047,-.00044, .00044, .00042, .00041,-.06661,-.03518,
     1 -.03099, .02793,-.02762,-.01275,-.00673,-.00584,-.00529,-.00492,
     1 -.00288,-.00258,-.00242, .00231, .00228,-.00204, .00188,-.00181,
     1 -.00169,-.00100,-.00093,-.00084, .00077, .00077,-.00070,-.00050,
     1 -.00049, .00049, .00048, .00044,-.00042/
      data idd/
     1  2, 0, 0, 0, 0, 0,   2, 2,-2, 0, 0, 0,   2,-1, 0, 1, 0, 0,  
     1  2, 2, 0, 0, 0, 0,   2, 2, 0, 0, 1, 0,   2, 0, 0, 0,-1, 0,  
     1  2,-1, 2,-1, 0, 0,   2,-2, 2, 0, 0, 0,   2, 1, 0,-1, 0, 0,  
     1  2, 2,-3, 0, 0, 1,   2,-2, 0, 2, 0, 0,   2,-3, 2, 1, 0, 0,  
     1  2, 1,-2, 1, 0, 0,   2,-1, 0, 1,-1, 0,   2, 3, 0,-1, 0, 0,  
     1  2, 1, 0, 1, 0, 0,   2, 2, 0, 0, 2, 0,   2, 2,-1, 0, 0,-1,  
     1  2, 0,-1, 0, 0, 1,   2, 1, 0, 1, 1, 0,   2, 3, 0,-1, 1, 0,  
     1  2, 0, 1, 0, 0,-1,   2, 0,-2, 2, 0, 0,   2,-3, 0, 3, 0, 0,  
     1  2,-2, 3, 0, 0,-1,   2, 4, 0, 0, 0, 0,   2,-1, 1, 1, 0,-1,  
     1  2,-1, 3,-1, 0,-1,   2, 2, 0, 0,-1, 0,   2,-1,-1, 1, 0, 1,  
     1  2, 4, 0, 0, 1, 0,   2,-3, 4,-1, 0, 0,   2,-1, 2,-1,-1, 0,  
     1  2, 3,-2, 1, 0, 0,   2, 1, 2,-1, 0, 0,   2,-4, 2, 2, 0, 0,  
     1  2, 4,-2, 0, 0, 0,   2, 0, 2, 0, 0, 0,   2,-2, 2, 0,-1, 0,  
     1  2, 2,-4, 0, 0, 2,   2, 2,-2, 0,-1, 0,   2, 1, 0,-1,-1, 0,  
     1  2,-1, 1, 0, 0, 0,   2, 2,-1, 0, 0, 1,   2, 2, 1, 0, 0,-1,  
     1  2,-2, 0, 2,-1, 0,   2,-2, 4,-2, 0, 0,   2, 2, 2, 0, 0, 0,  
     1  2,-4, 4, 0, 0, 0,   2,-1, 0,-1,-2, 0,   2, 1, 2,-1, 1, 0,  
     1  1, 1, 0, 0, 0, 0,   1,-1, 0, 0, 0, 0,   1, 1,-2, 0, 0, 0,  
     1  1,-2, 0, 1, 0, 0,   1, 1, 0, 0, 1, 0,   1,-1, 0, 0,-1, 0,  
     1  1, 2, 0,-1, 0, 0,   1, 0, 0, 1, 0, 0,   1, 3, 0, 0, 0, 0,  
     1  1,-2, 2,-1, 0, 0,   1,-2, 0, 1,-1, 0,   1,-3, 2, 0, 0, 0,  
     1  1, 0, 0,-1, 0, 0,   1, 1, 0, 0,-1, 0,   1, 3, 0, 0, 1, 0,  
     1  1, 1,-3, 0, 0, 1,   1,-3, 0, 2, 0, 0,   1, 1, 2, 0, 0, 0,  
     1  1, 0, 0, 1, 1, 0,   1, 2, 0,-1, 1, 0,   1, 0, 2,-1, 0, 0,  
     1  1, 2,-2, 1, 0, 0,   1, 3,-2, 0, 0, 0,   1,-1, 2, 0, 0, 0,  
     1  1, 1, 1, 0, 0,-1,   1, 1,-1, 0, 0, 1,   1, 4, 0,-1, 0, 0,  
     1  1,-4, 2, 1, 0, 0,   1, 0,-2, 1, 0, 0,   1,-2, 2,-1,-1, 0,  
     1  1, 3, 0,-2, 0, 0,   1,-1, 0, 2, 0, 0,   1,-1, 0, 0,-2, 0,  
     1  1, 3, 0, 0, 2, 0,   1,-3, 2, 0,-1, 0,   1, 4, 0,-1, 1, 0,  
     1  1, 0, 0,-1,-1, 0,   1, 1,-2, 0,-1, 0,   1,-3, 0, 2,-1, 0,  
     1  1, 1, 0, 0, 2, 0,   1, 1,-1, 0, 0,-1,   1,-1,-1, 0, 0, 1,  
     1  1, 0, 2,-1, 1, 0,   1,-1, 1, 0, 0,-1,   1,-1,-2, 2, 0, 0,  
     1  1, 2,-2, 1, 1, 0,   1,-4, 0, 3, 0, 0,   1,-1, 2, 0, 1, 0,  
     1  1, 3,-2, 0, 1, 0,   1, 2, 0,-1,-1, 0,   1, 0, 0, 1,-1, 0,  
     1  1,-2, 2, 1, 0, 0,   1, 4,-2,-1, 0, 0,   1,-3, 3, 0, 0,-1,  
     1  1,-2, 1, 1, 0,-1,   1,-2, 3,-1, 0,-1,   1, 0,-2, 1,-1, 0,  
     1  1,-2,-1, 1, 0, 1,   1, 4,-2, 1, 0, 0,   0, 2, 0, 0, 0, 0,  
     1  0, 1, 0,-1, 0, 0,   0, 0, 2, 0, 0, 0,   0, 0, 0, 0, 1, 0,  
     1  0, 2, 0, 0, 1, 0,   0, 3, 0,-1, 0, 0,   0, 1,-2, 1, 0, 0,  
     1  0, 2,-2, 0, 0, 0,   0, 3, 0,-1, 1, 0,   0, 0, 1, 0, 0,-1,  
     1  0, 2, 0,-2, 0, 0,   0, 2, 0, 0, 2, 0,   0, 3,-2, 1, 0, 0,  
     1  0, 1, 0,-1,-1, 0,   0, 1, 0,-1, 1, 0,   0, 4,-2, 0, 0, 0,  
     1  0, 1, 0, 1, 0, 0,   0, 0, 3, 0, 0,-1,   0, 4, 0,-2, 0, 0,  
     1  0, 3,-2, 1, 1, 0,   0, 3,-2,-1, 0, 0,   0, 4,-2, 0, 1, 0,  
     1  0, 0, 2, 0, 1, 0,   0, 1, 0, 1, 1, 0,   0, 4, 0,-2, 1, 0,  
     1  0, 3, 0,-1, 2, 0,   0, 5,-2,-1, 0, 0,   0, 1, 2,-1, 0, 0,  
     1  0, 1,-2, 1,-1, 0,   0, 1,-2, 1, 1, 0,   0, 2,-2, 0,-1, 0/
      k = 0
      nlp = 0
      ndi = 0
      nsd = 0
      ntd = 0
      do 16 ll=1,nin
c  see if Doodson numbers match
      do 14 kk=1,nt
      ii = 0
      do 13 i=1,6
 13   ii = ii + iabs(idd(i,kk)-idtin(i,ll))
      if(ii.eq.0) go to 15
 14   continue
c  have a match - put line into array
 15   if(ii.eq.0.and.k.lt.ncon) then
         k = k + 1
         rl(k) = ampin(ll)*cos(dtr*phin(ll))/abs(tamp(kk))
         aim(k)= ampin(ll)*sin(dtr*phin(ll))/abs(tamp(kk))
C         write(6,*) k,rl(k),aim(k),ll,phin(ll)
c  Now have real and imaginary parts of admittance, scaled by C-E
c  amplitude. Admittance phase is whatever was used in the original
c  expression. (Usually phase is given relative to some reference
c  but amplitude is in absolute units). Next get frequency.
         call tdfrph(idd(1,kk),fr,pr)
         rf(k) = fr
      endif
 16   continue
c  done going through constituents--there are k of them
c  have specified admittance at a number of points. sort these by frequency
c  and separate diurnal and semidiurnal, recopying admittances to get them in
c  order
      call shells(rf,key,k)
      do 21 i=1,k
      if(rf(i).lt.0.5) nlp = nlp + 1
      if(rf(i).lt.1.5.and.rf(i).gt.0.5) ndi = ndi + 1
      if(rf(i).lt.2.5.and.rf(i).gt.1.5) nsd = nsd + 1
      if(rf(i).lt.3.5.and.rf(i).gt.2.5) ntd = ntd + 1
 21   scr(i) = rl(key(i))
      do 23 i=1,k
      rl(i) = scr(i)
 23   scr(i) = aim(key(i))
      do 25 i=1,k
 25   aim(i) = scr(i)
c  now set up splines (8 cases - four species, each real and imag)
c  we have to allow for the case when there are no constituent amplitudes
c  for the long-period or terdiurnal.
      if(nlp.ne.0) call spline(nlp,rf,rl,zdr,scr)
      if(nlp.ne.0) call spline(nlp,rf,aim,zdi,scr)
      call spline(ndi,rf(nlp+1),rl(nlp+1),dr,scr)
      call spline(ndi,rf(nlp+1),aim(nlp+1),di,scr)
      call spline(nsd,rf(nlp+ndi+1),rl(nlp+ndi+1),sdr,scr)
      call spline(nsd,rf(nlp+ndi+1),aim(nlp+ndi+1),sdi,scr)
      if(ntd.ne.0) 
     1   call spline(ntd,rf(nlp+ndi+nsd+1),rl(nlp+ndi+nsd+1),tdr,scr)
      if(ntd.ne.0) 
     1   call spline(ntd,rf(nlp+ndi+nsd+1),aim(nlp+ndi+nsd+1),tdi,scr)
c  evaluate all harmonics using the interpolated admittance
      j = 1
      do 31 i=1,nt
      if((idd(1,i).eq.0.and.nlp.eq.0).or.(idd(1,i).eq.3.and.ntd.eq.0))
     1  go to 31
      call tdfrph(idd(1,i),f(j),p(j))
c  equilibrium phase corrections (including to local phase)
c  (LP tides corrected 1 Aug 2009)
      if(idd(1,i).eq.0) p(j) = p(j) + 180.
      if(idd(1,i).eq.1) p(j) = p(j) + 90.
      sf = f(j)
      if(idd(1,i).eq.0) re = eval(sf,nlp,rf,rl,zdr)
      if(idd(1,i).eq.0) am = eval(sf,nlp,rf,aim,zdi)
      if(idd(1,i).eq.1) re = eval(sf,ndi,rf(nlp+1),rl(nlp+1),dr)
      if(idd(1,i).eq.1) am = eval(sf,ndi,rf(nlp+1),aim(nlp+1),di)
      if(idd(1,i).eq.2) re =
     1   eval(sf,nsd,rf(nlp+ndi+1),rl(nlp+ndi+1),sdr)
      if(idd(1,i).eq.2) am =
     1   eval(sf,nsd,rf(nlp+ndi+1),aim(nlp+ndi+1),sdi)
      if(idd(1,i).eq.3) re =
     1   eval(sf,ntd,rf(nlp+ndi+nsd+1),rl(nlp+ndi+nsd+1),tdr)
      if(idd(1,i).eq.3) am =
     1   eval(sf,ntd,rf(nlp+ndi+nsd+1),aim(nlp+ndi+nsd+1),tdi)
      amp(j) = tamp(i)*sqrt(re**2+am**2)
      p(j) = p(j) + atan2(am,re)/dtr
      j = j + 1
 31   continue
      nout = j - 1
      return
      end
