      program hist
c  prints a histogram of data in a file - values and locations
c  of extreme outliers are given individually
c
c      calls realio
c
c     integer*4 np,mpc
      dimension x(20000),np(20000),xp(60000),yp(60000)
      character*1 isym(61),icty,not,incout
c     character*4 fmt(3)
      data isym/61*'*'/,np/20000*0/izc/1/
c     data fmt/'(1x,','    ','a1)'/
      write(6,100)
 100  format(' input file; ',$)
      ifl = ffin(1,not)
 5    write(6,102)
 102  format(' start and end terms (0,0 to quit); ',$)
      irl = ffin(1,not)
      if(irl.le.0) stop
      ien = ffin(1,not)
      if(ien.lt.0) ien=longis(ifl)
 7    write(6,104)
 104  format(' center value; ',$)
      cen = ffin(1,not)
      write(6,106)
 106  format(' bin size; ',$)
      bs = ffin(1,not)
 9    write(6,108)
 108  format(' lower and upper limits (relative to center); ',$)
      bl = ffin(1,not)
      ul = ffin(1,not)
      if(bl.ge.ul) go to 9
 11   write(6,110)
 110  format(' should the center to be an edge (e) or center (c); ',$)
      idum = ffin(1,icty)
      if(icty.ne.'e'.and.icty.ne.'c') go to 11
      if(icty.eq.'e') nu = ul/bs
      if(icty.eq.'e') nl = bl/bs
      if(icty.eq.'e') nb = nu - nl + 2
      if(icty.eq.'c') nu = ul/bs - .5
      if(icty.eq.'c') nl = bl/bs + .5
      if(icty.eq.'c') nb = nu - nl + 3
      if(nb.le.20000) go to 13
      write(6,112) nb
 112  format(i7,' groups is more than 20000 - too many')
      go to 9
 13   if(icty.eq.'e') bl = cen+nl*bs
      if(icty.eq.'c') bl = cen+(nl-.5)*bs
      if(icty.eq.'e') ul = cen+nu*bs
      if(icty.eq.'c') ul = cen+(nu+.5)*bs
      if(icty.eq.'e') write(6,114) nb-2, bl,cen+(nl+1)*bs,
     1 cen+(nu-1)*bs,ul
 114  format(i3,' bins. bottom is ',g13.5,' to ',g13.5,' and top is',/
     1 ,1x,g13.5,' to ',g13.5,' is this ok (y/n)?; ',$)
      if(icty.eq.'c') write(6,116) nb-2, bl,cen+(nl+.5)*bs,
     1 cen-.5*bs,cen+.5*bs,cen+(nu-.5)*bs,ul
 116  format(i3,' bins. bottom is ',g13.5,' to ',g13.5,', center is',/
     1 ,1x,g13.5,' to ',g13.5,' and top is ',g13.5,' to ',g13.5,/,
     2 ' is this ok (y/n)?; ',$)
      idum = ffin(1,not)
      if(not.ne.'y') go to 7
c  reset center if needed
      if(icty.eq.'c') cen = cen + .5*bs
      do 15 i=1,nb
 15   np(i) =0
      write(6,118)
 118  format(' include outliers in listings (y/n)?; ',$)
      idum = ffin(1,incout)
 17   irh = min0(irl+5999,ien)
      ie = irh - irl + 1
      call realio(x,irl,irh,ifl,0)
      do 21 i = 1,ie
      npc = int((x(i)-cen)/bs) - nl + 1
      if(icty.eq.'c') npc = npc + 1
      if(x(i).gt.cen) npc = npc + 1
c  values on center are put on either side alternately
      if(x(i).eq.cen.and.izc.eq.0) npc = npc + 1
      izc = 1 - izc
      if(x(i).le.ul.and.x(i).ge.bl) go to 19
c  we have an outlier
      if(incout.eq.'y') write(6,120) irl+i-1, x(i)
 120  format(' point number',i7,' has value',g13.5)
      if(npc.le.1) npc = 1
      if(npc.ge.nb) npc = nb
 19   np(npc) = np(npc) + 1
 21   continue
      irl = irh + 1
      if(irh.ne.ien) go to 17
c  print out results
      write(6,122)
 122  format(//,1x,'range of values',15x,'number of points',/)
      do 29 i = 1,nb-1
      if(icty.eq.'e') x(i) = cen + (i+nl-1)*bs
 29   if(icty.eq.'c') x(i) = cen + (i+nl-2)*bs
      write(6,124) x(1), np(1)
 124  format(12x,'below',g13.5,' - ',i8)
      do 31 i = 2,nb-1
      write(6,126) x(i-1),x(i),np(i)
 126  format(1x,g13.5,' to ',g13.5,' - ',i8)
 31   continue
      write(6,128) x(nb-1), np(nb)
 128  format(12x,'above',g13.5,' - ',i8)
      write(6,130)
 130  format(1x)
      write(6,132)
 132  format(' do you want a bar graph (y/n)?; ',$)
      idum = ffin(1,not)
      if(not.eq.'n') go to 37
c  scale maximum bin size to be 60 spaces over
      mpc = 1
      il = 2
      ih = nb-1
      if(incout.eq.'y') il = 1
      if(incout.eq.'y') ih = nb
      do 33 i=il,ih
 33   mpc = max0(mpc,np(i))
      scl = 60./mpc
      do 35 i=il,ih
      kk = int(np(i)*scl) + 1
134   format(1x,61a1)
c  put in blank lines for np=0 and to delimit the end bins
      if(np(i).ne.0) write(6,134) (isym(j),j=1,kk)
 35   if(i.eq.1.or.i.eq.nb-1.or.np(i).eq.0) write(6,130)
      write(6,130)
 37   write(6,136)
 136  format(' do you want to write data to disk (y/n)?; ',$)
      idum = ffin(1,not)
      if(not.eq.'n') go to 5
      write(6,138)
 138  format(' files for x and y; ',$)
      ifx = ffin(1,not)
      ify = ffin(1,not)
      do 39 j=1,nb-1
      k = 3*j - 2
      xp(k) = x(j)
      xp(k+1) = x(j)
      xp(k+2) = x(j)
      yp(k) = np(j)
      yp(k+1) = 0
 39   yp(k+2) = np(j+1)
      mt = 3*(nb-1)
      yp(1) = 0
      yp(mt) = 0
      call realio(xp,1,mt,ifx,1)
      call realio(yp,1,mt,ify,1)
      call retnio(ifx)
      call retnio(ify)
      write(6,140) mt,x(1),x(nb-1)
 140  format(1x,i4,' terms written out - x range',g13.5,' to',g13.5)
      go to 5
      end

