
       program hlth
c
c  produces a series of local highs and lows and their times,
c  or alternatively two series that will give a 'clean' plot of a file
c  (i.e. with corners)
c
c   $$$calls genlib,iolib
c
      dimension x(1200),d(1200),t(1200),ist(5),itmpt(5)
      character*1 mode,not,iun
      data irlo/1/,tout/0./,inout/1/,iflag/1/,ifrst/0/,ilst/0/,nopt/3/,
     1 mode/'d'/
 1    write(6,98)
 98   format(' what option (h for help); ',$)
      iopt = ffin(1,not)
      if(iopt.gt.0.and.iopt.le.nopt) go to 2
      if((iopt.eq.0.and.not.ne.'h').or.iopt.gt.nopt.or.iopt.lt.0)
     1  go to 1
      write(6,99)
 99   format(' options are:',/,10x,
     1 '1 - produce highs and lows',/,10x,
     2 '2 - produce files for plot with corners',/,10x,
     3 '3 - produce files for plot with boxes')
      go to 1
 2    write(6,100)
 100  format(' number of input file; ',$)
      ifi = ffin(1,not)
      write(6,101)
 101  format(' start and end terms; ',$)
      ilis = ffin(1,not)
      irnt = ffin(1,not)
      if(irnt.lt.ilis) irnt=longis(ifi)
      irnt = irnt - ilis + 1
      write(6,102)
 102  format(' output files for x-coordinate and data (real); ',$)
      ift = ffin(1,not)
      ifd = ffin(1,not)
      if(iopt.lt.3) go to 3
      write(6,1025)
 1025 format(' base level for boxes; ',$)
      floor = ffin(1,not)
 3    write(6,103)
 103  format(' x coordinate (0 for #, 1 for time); ',$)
      ixco = ffin(1,not)
      if(ixco.lt.0.or.ixco.gt.1) go to 3
      if(ixco.eq.0) go to 6
      write(6,104)
 104  format(' time of term 1 (y,d,h,m,s, or nnnh for header); ',$)
      ist(1)=ffin(1,not)
      if(not.eq.'h') then
        nfl=ist(1)
        call hedtim(nfl,ist,itmpt,idum,samp)
      else
        do i=2,5
          ist(i) = ffin(1,not)
        enddo
        write(6,106)
 106    format(' sample interval in seconds; ',$)
        samp = ffin(1,not)
      endif
      isamp=samp
 5    write(6,110)
 110  format(' units of time (y or d); ',$)
      idum = ffin(1,iun)
      if(iun.ne.'y'.and.iun.ne.'d') go to 5
 6    if(iopt.ge.2) go to 13
c
c   done with setup - now make two passes through data, the first to see
c   how many points will be written out, the second to do so.
c   different options are done in different sections, though with
c   considerable similarity in code
c
 7    irli = ilis
 8    irhi = min(irli+1199,irnt)
      nt = irhi - irli + 1
      call realio(x,irli,irhi,ifi,0)
      do 10 i = 2,nt-1
      if ((x(i).eq.x(i-1).and.x(i).eq.x(i+1)).or.
     1    (x(i).gt.x(i-1).and.x(i).lt.x(i+1)).or.
     2    (x(i).lt.x(i-1).and.x(i).gt.x(i+1))) go to 10
c  have a local minimum or maximum (or a corner)
      if(iflag.eq.1) tout = tout + 1.
      if(iflag.eq.1) go to 10
      d(inout) = x(i)
      t(inout) = irli+i-1.
      if(ixco.eq.0) go to 9
      call timfnd(ist,irli+i-2,isamp,itmpt,mode)
      leap = 1 - (mod(itmpt(1),4)+3)/4
      df = itmpt(3)/24. + itmpt(4)/1440. + itmpt(5)/86400.
      if(iun.eq.'d') t(inout) = ist(2) + ndays(ist,itmpt,mode) + df
      if(iun.eq.'y') t(inout) = itmpt(1) + (itmpt(2)-1+df)/(365.+leap)
 9    inout = inout + 1
 10   continue
      if(iflag.eq.1) go to 11
      irho = irlo + inout - 2
      inout = 1
      call realio(d,irlo,irho,ifd,-1)
      call realio(t,irlo,irho,ift,-1)
      irlo = irho + 1
 11   irli = irhi - 1
      if(irhi.lt.irnt) go to 8
      if(iflag.eq.2) go to 25
      call realio(t,1,1,ift,1)
      call realio(d,1,1,ifd,1)
      iflag = 2
      go to 7
c
c  section for putting out a series that will plot as a bar graph
c
 13   irli = ilis
 15   irhi = min0(irli+1199,irnt)
      nt = irhi - irli + 1
      call realio(x,irli,irhi,ifi,0)
      if(ifrst.eq.1) go to 17
c  need to put in first value of series at start
      ifrst = 1
      d(1) = x(1)
      k = 2
      tout = 3
      t(1) = irli
      if(ixco.eq.0) go to 17
      call timfnd(ist,irli-1,isamp,itmpt,mode)
      leap = 1 - (mod(itmpt(1),4)+3)/4
      df = itmpt(3)/24. + itmpt(4)/1440. + itmpt(5)/86400.
      if(iun.eq.'d') t(1) = ist(2) + ndays(ist,itmpt,mode) + df
      if(iun.eq.'y') t(1) = itmpt(1) + (itmpt(2)-1+df)/(365.+leap)
 17   do 19 i = 1,nt-1
      if(x(i).eq.x(i+1)) go to 19
c  have a corner
      if(iflag.eq.1) tout = tout + 2.
      if(iflag.eq.1.and.iopt.eq.3) tout = tout + 3
      if(iflag.eq.1) go to 19
      if(irli+i.eq.irnt) ilst = 1
      d(k) = x(i)
      if(iopt.eq.2) d(k+1) = x(i+1)
      if(iopt.eq.3) d(k+1) = floor
      if(iopt.eq.3) d(k+2) = x(i+1)
      tf = irli+i
      if(ixco.eq.0) go to 18
      call timfnd(ist,irli+i-1,isamp,itmpt,mode)
      leap = 1 - (mod(itmpt(1),4)+3)/4
      df = itmpt(3)/24. + itmpt(4)/1440. + itmpt(5)/86400.
      if(iun.eq.'d') tf = ist(2) + ndays(ist,itmpt,mode) + df
      if(iun.eq.'y') tf = itmpt(1) + (itmpt(2)-1+df)/(365.+leap)
 18   t(k) = tf
      t(k+1) = tf
      if(iopt.eq.3) t(k+2) = tf
      k = k + 2
      if(iopt.eq.3) k = k + 1
      if(k.lt.1100) go to 19
c  output as needed
      irho = irlo + k - 2
      call realio(d,irlo,irho,ifd,-1)
      call realio(t,irlo,irho,ift,-1)
      irlo = irho + 1
      k = 1
 19   continue
      irli = irhi
      if(irhi.lt.irnt) go to 15
      if(iflag.eq.2) go to 21
c  after first pass, create files of appropriate length
      call realio(t,1,1,ift,1)
      call realio(d,1,1,ifd,1)
      iflag = 2
      ifrst = 0
      go to 13
 21   if(ilst.eq.1) go to 23
c  put in a final point, unless there was a transition there
      tf = irnt
      if(ixco.eq.0) go to 22
      call timfnd(ist,irnt-1,isamp,itmpt,mode)
      leap = 1 - (mod(itmpt(1),4)+3)/4
      df = itmpt(3)/24. + itmpt(4)/1440. + itmpt(5)/86400.
      if(iun.eq.'d') tf = ist(2) + ndays(ist,itmpt,mode) + df
      if(iun.eq.'y') tf = itmpt(1) + (itmpt(2)+df)/(365.+leap)
 22   t(k) = tf
      d(k) = d(k-1)
      k = k + 1
c  write out any remaining terms
 23   k = k - 1
      if(k.eq.1) go to 25
      irho = irlo + k - 1
      call realio(d,irlo,irho,ifd,-1)
      call realio(t,irlo,irho,ift,-1)
 25   write(6,112) irho,ift,ifd
 112  format(i7,' terms written to files ',i7,' and ',i7)
      call realio(ts,1,1,ift,0)
      write(6,114) ts,tf
 114  format(' x values run from ',f20.3,' to ',f20.3)
      stop
      end
