      dimension x(1000),y(1000),ifl(20),irnt(20),flt(1000),offs(20)
c  program for convolving weights in flt with data
c  in a series of files. the file numbers are in ifl, and their
c  lengths in irnt.  the files are assumed to be contiguous (i.e.,
c  to produce a continuous data series one would simply join them).
c  however, the series may have offsets between them; these are put
c  in offs
c  at most two files can be read from at one time, so the buffer
c  length is 1000, but less if there is a file shorter than this.
c
c    calls toffs2, iolib (realio)
c
      character*1 not,howoff
      common/time/idat(4),sam
      data irl/0/,ibufl/1000/,jc/1/,irlo/1/,iend/0/
      write(6,100)
 100  format(' number of files to process; ',$)
      nf = ffin(1,not)
 3    write(6,101)
 101  format(' offset automatically (a) or manually (m)?; ',$)
      idum = ffin(1,howoff)
      if(howoff.ne.'a'.and.howoff.ne.'m') go to 3
      do 5 i = 1,nf
      if(howoff.eq.'m') write(6,102) i
 102  format(' number, length, and noncumulative offset of file',
     1 i3,'; ',$)
      if(howoff.eq.'a') write(6,103) i
 103  format(' number and length of file',i3,'; ',$)
      ifl(i) = ffin(1,not)
      irnt(i) = ffin(1,not)
      if(irnt(i).lt.0) irnt(i)=longis(ifl(i))
      if(howoff.eq.'m') offs(i) = ffin(1,not)
      if(howoff.eq.'m'.and.i.gt.1) offs(i) = offs(i-1) + offs(i)
      ibufl = min(ibufl,irnt(i))
 5    irl = irl + irnt(i)
      if(howoff.eq.'a') call finoff(ifl,irnt,nf,offs)
      write(6,104)
 104  format(' output file; ',$)
      ifo = ffin(1,not)
      write(6,106)
 106  format(' decimation factor; ',$)
      idec = ffin(1,not)
      write(6,108)
 108  format(' filter file and length; ',$)
      ift = ffin(1,not)
      ifn = ffin(1,not)
      if(ifn.ge.ibufl) go to 31
      call realio(flt,1,ifn,ift,0)
      call retnio(ift)
      write(6,110)
 110  format(' start term of first file (le 0 for timed); ',$)
      is = ffin(1,not)
      if(is.ge.1) go to 6
      write(6,111)
 111  format(' start time of series (yr,day,hr,min,sec); ',$)
      itheyear= ffin(1,not)
      do 7 i = 1,4
  7   idat(i) = ffin(1,not)
      write(6,113)
 113  format(' sample interval (sec); ',$)
      sam = ffin(1,not)
      call toffs2(ifn,idec,is,itheyear)
 6    irl = irl/idec
      nr = (irl+59)/60
      call realio(x,1,2,ifo,1)
      irl = is
      nbo = (ibufl-ifn)/idec + 1
      ieffl = ifn + (nbo-1)*idec - 1
      np = ieffl + 1
      off = nbo*idec
 8    irh = irl + ieffl
      if(irh.gt.irnt(jc)) go to 11
 9    call realio(x,irl,irh,ifl(jc),0)
      do 10 k = 1,np
 10   x(k) = x(k) + offs(jc)
      go to 13
c  buffer straddles two files
 11   if(jc.eq.nf) go to 21
      nbs = irnt(jc) - irl + 1
      isur = ieffl - nbs + 1
      call realio(x,irl,irnt(jc),ifl(jc),0)
      call realio(x(nbs+1),1,isur,ifl(jc+1),0)
      do 12 k = 1,nbs
 12   x(k) = x(k) + offs(jc)
      do 14 k = nbs+1,np
 14   x(k) = x(k) + offs(jc+1)
c  input buffer filled - do convolution
 13   do 17 i = 1,nbo
      y(i) = 0.
      do 15 j = 1,ifn
 15   y(i) = y(i) + flt(j)*x((i-1)*idec+j)
 17   continue
      irho = irlo + nbo -1
      call realio(y,irlo,irho,ifo,-1)
      if(iend.eq.1) go to 25
      irlo = irho + 1
      irl = irl + off
      if(irl.le.irnt(jc)) go to 8
c  bottom of buffer has crossed a file boundary
      call retnio(ifl(jc))
      irl = irl - irnt(jc)
      jc = jc + 1
      go to 8
c  full buffer would go off the end of the last file - shorten it.
 21   irh = irnt(jc)
      np = irh - irl + 1.
      if(np.lt.ifn) go to 25
      nbo = (np - ifn)/idec + 1
      iend = 1
      go to 9
 25   write(6,116) irho,ifo
 116  format(1x,i8,' points written to file',i6)
      stop
 31   write(6,118)
 118  format(' filter longer than shortest file - cannot do')
      stop
      end
      subroutine finoff(ifl,itlen,nf,offs)
c  If we have nf data files to be joined, whose file numbers are 
c  in ifl, lengths in itlen, then this subroutine returns in offs the
c  number to be added to the i-th file to make it continuous with
c  the first (offs(1) = 0). To determine the offsets between files,
c  a parabola is fit to the six points surrounding the boundary
c  (actually done as a linear fit of the first differences)
c
c    calls realio, return
c
      dimension ifl(nf),itlen(nf),offs(nf),data(6)
      offs(1) = 0.
      if(nf.eq.1) return
      do 5 i = 1,nf-1
      call realio(data,itlen(i)-2,itlen(i),ifl(i),0)
      call realio(data(4),1,3,ifl(i+1),0)
      call retnio(ifl(i))
 5    offs(i+1) = .25*(data(1)-data(6)+5.*(data(4)-data(3)))
      call retnio(ifl(nf))
      do 7 i = 2,nf
 7    offs(i) = offs(i-1) - offs(i)
      return
      end
