c
c  reads in julian date, writes out Gregorian date;
c  or the reverse
c
      character*1 mode,dire
      double precision rjd,f
      dimension it(3),it2(2)
      data mode/'m'/
      if(iargc().lt.1.or.iargc().gt.2) call errmess
      call getarg(1,dire)
      if(iargc().eq.2) call getarg(2,mode)
      if(dire.ne.'j'.and.dire.ne.'c') call errmess
      if(mode.ne.'m'.and.mode.ne.'d') call errmess
      if(dire.eq.'c') then
  3     read(5,*,end=7) rjd
c add 0.5 to convert to Julian day and fraction of day
        rjd=rjd+0.5d0
        jd=int(rjd)
        call datjul(jd,it)
        f=rjd-jd
        h=24*f
        ih=int(h)
        f=h-ih
        rm=60*f
        im=int(rm)
        f=rm-im
        s=60*f
        is=nint(s)
        if(is.eq.60) then
          is=0
          im=im+1
          if(im.eq.60) then
            im=0
            ih=ih+1
            if(ih.eq.24) then
              ih=0
              it(3)=it(3)+1
            endif
          endif
        endif
        if(mode.eq.'m') write(6,100) it,ih,im,is
 100    format(2x,i5,5(1x,i2.2))
        if(mode.eq.'d') then
           call toyd(it,it2)
           write(6,102) it2,ih,im,is
 102       format(2x,i5,i4.3,3(1x,i2.2))
        endif
        go to 3
      endif
      if(dire.eq.'j') then
  5     continue
        if(mode.eq.'m') read(5,*,end=7) it,ih,im,is
        if(mode.eq.'d') then
           read(5,*,end=7) it2,ih,im,is
           call toymd(it2,it)
        endif
        jd=juldat(it)
        f=ih/24.d0+im/1440.d0+is/86400.d0
        rjd=jd+f-0.5d0
        write(6,104) rjd
 104    format(f14.6)
        go to 5
      endif
 7    stop
      end
      subroutine errmess
      write(6,100)
 100  format(/,' Usage is    julcon j|c [d|m] ',/,' where j is to JD+f,'
     1  ,' c is to calendar, d/m is mode (m default)',/)
      stop
      end
      subroutine datjul(jd,it)
c
c  Converts Julian Date jd into year-month-day (Gregorian calendar) in
c    array it. Algorithm from p. 6??, Explanatory Supplement Amer Ephemeris
c    & Nautical Almanac
c
      dimension it(*)
      k = jd+68569
      n = 4*k/146097
      k = k - (146097*n+3)/4
      it(1) = 4000*(k+1)/1461001
      k = k - 1461*it(1)/4 + 31
      it(2) = 80*k/2447
      it(3) = k - 2447*it(2)/80
      k = it(2)/11
      it(2) = it(2) + 2 - 12*k
      it(1) = it(1) + 100*(n-49) + k 
      return
      end
      subroutine toyd(it1,it2)
      dimension it1(*),it2(*)
c
c  converts times in it1 given as year-month-day to year and day in it2
c
      idn(m) = mod((367*(m-2-12*((m-14)/12)))/12+29,365)
      it2(1)=it1(1)
      it2(2) = it1(3) + idn(it1(2)) + leap(it1(1))*((9+it1(2))/12)
      return
      end
      function leap(iy)
c
c returns 1 if year is a leap year, by Clavian (Gregorian) rule
c
      leap = 1 - (mod(iy,4)+3)/4
      if(mod(iy,100).eq.0.and.mod(iy,400).ne.0) leap=0
      return
      end
      subroutine toymd(it1,it2)
      dimension it1(*),it2(*)
c
c  converts times in it1 given as year and day to year-month-day in it2
c
      idn(m) = mod((367*(m-2-12*((m-14)/12)))/12+29,365)
      mon(jj,m) = (12*(jj-29-m))/367 + 2 + (jj-200)/169
      it2(1)=it1(1)
      it2(2)=mon(it1(2),leap(it1(1)))
      it2(3) = it1(2) - idn(it2(2)) - leap(it2(1))*((9+it2(2))/12)
      return
      end
      function juldat(it)
      dimension it(*)
c
c  Julian Date from Gregorian date, Algorithm from p. 604, Explanatory
c    Supplement Amer Ephemeris & Nautical Almanac (cf Comm CACM, 11, 657 (1968)
c    and 15, 918 (1972)) Valid for all positive values of Julian Date
c
      juldat=(1461*(it(1)+4800+(it(2)-14)/12))/4
     1     + (367*(it(2)-2-12*((it(2)-14)/12)))/12
     2     - (3*((it(1)+4900+(it(2)-14)/12)/100))/4+it(3)-32075
      return
      end


