c    program keyit
c
c     performs miscellaneous operations on data files:
c
c         c - create file, either by typing in numbers or just filling
c             the file with zeros
c
c         e - edit a file, for example
c             s - alter single terms
c             i - insert term(s) into a file
c             r - remove term(s) from a file (old end terms zero'd)
c             f - fill an interval with linear interpolation
c             o - offset sections of a file
c             d - display data
c             p - change decimation factor for display
c
c         t - transfer a file to another, optionally padding zeros
c             on either end
c
c     $$$$$calls niolib, termlib
c
c    written by D. Agnew December 1985, following earlier versions
c            by F. Wyatt and N. P. Trung
c
      character*1 not,mopt,sopt,eopt,ifill
      dimension aux(1000),x(1000),ix(1000),eopt(7)
      data lenbuf/1000/,ll/1/,irl/1/,j/1/,ieopt/7/,idec/1/
      data eopt/'p','d','s','r','i','o','f'/
 5    write(6,100)
 100  format(' Option (c: create, e: edit, t: transfer); ',$)
      idum = ffin(1,mopt)
      if(mopt.ne.'c'.and.mopt.ne.'e'.and.mopt.ne.'t') go to 5
      if(mopt.eq.'e') go to 31
      if(mopt.eq.'t') go to 95
c
c   file creation
c
      write(6,102)
 102  format(' Output file number; ',$)
      ifout = ffin(1,not)
 7    write(6,104)
 104  format(' Type numbers in at terminal (y/n) ?; ',$)
      idum = ffin(1,not)
      if(not.ne.'y'.and.not.ne.'n') go to 7
      if(not.eq.'n') then
        write(6,106)
 106    format(' File length; ',$)
        len = ffin(1,not)
        if(ifout.gt.0) call intio(ix,len,len,ifout,1)
        if(ifout.lt.0) call realio(x,len,len,ifout,1)
        stop
      endif
c  open file for typing in numbers
      if(ifout.gt.0) call intio(ix,1,1,ifout,1)
      if(ifout.lt.0) call realio(x,1,1,ifout,1)
      write(6,108)
 108  format(' Enter numbers, one per line: b backs up, s stops')
 13   write(6,110) ll
 110  format(' term ',i6,';  ',$)
      xx = ffin(1,not)
      if(not.ne.'s'.and.not.ne.'b'.and.not.ne.'0') then
        write(6,111)
 111    format(' beg pardon? ')
        go to 13
      endif
      if(not.eq.'s'.and.irl.lt.ll) then
c  done with entering numbers - write out last batch
        irh = ll - 1
        if(ifout.gt.0) call intio(ix,irl,irh,ifout,-1)
        if(ifout.lt.0) call realio(x,irl,irh,ifout,-1)
        write(6,112) irh,ifout
 112    format(i7,' terms written to file ',i6)
        stop
      endif
      if(not.eq.'b'.and.j.eq.1) then
        write(6,114)
 114    format(' Sorry - cannot back over buffer boundaries (1000''s)')
        go to 13
      endif
      if(not.eq.'b'.and.j.gt.1) then
c  back up
        ll = ll - 1
        j = j - 1
        go to 13
      endif
c  normal entry of another term - write out buffer if it is time
      if(ifout.gt.0) ix(j) = nint(xx)
      if(ifout.lt.0) x(j) = xx
      if(j.eq.lenbuf) then
        irh = irl + lenbuf - 1
        if(ifout.gt.0) call intio(ix,irl,irh,ifout,-1)
        if(ifout.lt.0) call realio(x,irl,irh,ifout,-1)
        irl = irh + 1
        j = 0
      endif
      ll = ll + 1
      j = j + 1
      go to 13
c
c  edit option
c             s - alter single terms
c             i - insert term(s) into a file
c             r - remove term(s) from a file (old end terms zero'd)
c             f - fill an interval with linear interpolation
c             o - offset sections of a file
c             d - display data
c
c
 31   write(6,120)
 120  format(' Input file; ',$)
      ifin = ffin(1,not)
      write(6,121)
 121  format(' Output file (0 to edit input file); ',$)
      ifout = ffin(1,not)
      if(ifout.ne.0.and.ifout.ne.ifin) then
        len = longis(ifin)
        if(ifout.gt.0) call intio(ix,len,len,ifout,1)
        if(ifout.lt.0) call realio(x,len,len,ifout,1)
        call filcop(ifin,1,len,ifout,1)
        write(6,122) len
 122    format(i7,' terms copied')
        call retnio(ifin)
        ifin = ifout
      endif
 33   write(6,123)
 123  format(' Edit option (h for help); ',$)
      idum = ffin(1,sopt)
      if(sopt.eq.'x') stop
      iopt = 0
      do 35 i=1,ieopt
 35   if(sopt.eq.eopt(i)) iopt = i
c                           p  d  s  r  i  o  f
      if(iopt.gt.0) go to (39,41,47,51,61,81,91) iopt
      if(sopt.ne.'h') go to 33
      write(6,124)
 124  format(' Editing options are: '
     1 ,/,'    s - alter single terms'
     2 ,/,'    i - insert term(s) into a file'
     3 ,/,'    r - remove term(s) from a file (old end terms zeroed)'
     4 ,/,'    f - fill an interval with linear interpolation'
     5 ,/,'    o - offset sections of a file'
     6 ,/,'    d - display data'
     7 ,/,'    p - change decimation factor for display'
     8 ,/,'    x - exit',//)
      go to 33
c
c  change decimation factor
c
 39   write(6,130)
 130  format(' New decimation factor for display; ',$)
      idec = ffin(1,not)
      go to 33
c
c  display data
c
 41   if(idec.ne.1) write(6,131) idec
 131  format(' current decimation factor is ',i5)
 43   write(6,132)
 132  format(' Start and end terms (0,0 ends); ',$)
      ist = ffin(1,not)
      ien = ffin(1,not)
      if(ist.le.0) go to 33
      npb = lenbuf/idec
      irl = ist
 45   irh = min0(ien,irl+idec*(npb-1))
      if(ifin.gt.0) call intio(ix,irl,irh,ifin,0)
      if(ifin.lt.0) call realio(x,irl,irh,ifin,0)
      lter = idec*((irh-irl)/idec) + 1
      if(ifin.gt.0) write(6,134) (ix(i),i=1,lter,idec)
 134  format(2x,10i7)
      if(ifin.lt.0) write(6,136) (x(i),i=1,lter,idec)
 136  format(2x,5g13.5)
      irl = irh + idec
      if(irl.le.ien) go to 45
      go to 43
c
c   single point editing
c
 47   write(6,140)
 140  format(' Term number (0 to end) and new value; ',$)
      irl = ffin(1,not)
      if(irl.le.0) go to 33
      x(1) = ffin(1,not)
      if(ifin.gt.0) ix(1) = x(1)
      if(ifin.gt.0) call intio(ix,irl,irl,ifin,-1)
      if(ifin.lt.0) call realio(x,irl,irl,ifin,-1)
      go to 47
c
c  remove terms from a series
c
 51   write(6,150)
 150  format(' Start and end terms to remove (inclusive, 0,0 ends); ',$)
      irlo = ffin(1,not)
      irli = ffin(1,not) + 1
      if(irlo.le.0) go to 33
      length = longis(ifin)
 53   irhi = min0(length,irli+lenbuf-1)
      irho = irlo + irhi - irli
      if(ifin.gt.0) call intio(ix,irli,irhi,ifin,0)
      if(ifin.lt.0) call realio(x,irli,irhi,ifin,0)
      if(ifin.gt.0) call intio(ix,irlo,irho,ifin,-1)
      if(ifin.lt.0) call realio(x,irlo,irho,ifin,-1)
      irli = irhi + 1
      irlo = irho + 1
      if(irli.le.length) go to 53
c  fill the back of the file with zeros
      do 55 i=1,lenbuf
      x(i) = 0
 55   ix(i) = 0
 57   irho = min0(length,irlo+lenbuf-1)
      if(ifin.gt.0) call intio(ix,irlo,irho,ifin,-1)
      if(ifin.lt.0) call realio(x,irlo,irho,ifin,-1)
      irlo = irho + 1
      if(irlo.le.length) go to 57
      if(iopt.eq.5) go to 61
      go to 51
c
c   insert points
c
 61   write(6,160)
 160  format(' Number of terms to insert (0 to end); ',$)
      nt = ffin(1,not)
      if(nt.eq.0) go to 33
      write(6,162)
 162  format(' Term after which they are to be inserted; ',$)
      ist = ffin(1,not)
      if(nt.lt.0) then
c  inserting negative points is removing them - set parameters and go to
c  previous section
        irlo = ist + 1
        irli = irlo - nt
        length = longis(ifin)
        go to 53
      endif
 63   write(6,164)
 164  format(' Type in filler terms (t), interpolate (i), or'
     1,' fill with a constant (c); ',$)
      idum = ffin(1,ifill)
      if(ifill.ne.'t'.and.ifill.ne.'i'.and.ifill.ne.'c') go to 63
      if(ifill.eq.'t'.and.nt.gt.1000) then
        write(6,166) lenbuf
 166    format(' no more than ',i5,' terms may be entered manually')
        go to 61
      endif
      if(ifill.eq.'t') then
c  enter numbers manually before shifting file
        write(6,108)
        i = 0
 65     i = i + 1
        write(6,110) ist + i
        aux(i) = ffin(1,not)
        if(not.ne.'s'.and.not.ne.'b'.and.not.ne.'0') then
          write(6,111)
          go to 65
        endif
        if(not.eq.'b') then
          i = i - 1
          go to 65
        endif
        if(not.eq.'0'.and.i.lt.nt) go to 65
c    next statement causes correct behavior when an 's' ends the list early
        if(not.eq.'s') nt = i - 1
      endif
      if(ifill.eq.'c') then
        write(6,168)
 168    format(' Fill value; ',$)
        xf = ffin(1,not)
      endif
c  now shift file over, working from the back
      irhi = longis(ifin)
 67   irli = max0(irhi-lenbuf+1,ist+1)
      irho = irhi + nt
      irlo = irho - irhi + irli
      if(ifin.gt.0) call intio(ix,irli,irhi,ifin,0)
      if(ifin.lt.0) call realio(x,irli,irhi,ifin,0)
      if(ifin.gt.0) call intio(ix,irlo,irho,ifin,-1)
      if(ifin.lt.0) call realio(x,irlo,irho,ifin,-1)
      irhi = irli - 1
      irho = irlo - 1
      if(irhi.ge.ist+1) go to 67
c   fill in the new gap
      irl = ist+1
      irh = irl+nt-1
      if(ifill.eq.'t'.and.ifin.gt.0) then
        do 69 i=1,nt
 69     ix(i) = nint(aux(i))
        call intio(ix,irl,irh,ifin,-1)
      endif
      if(ifill.eq.'t'.and.ifin.lt.0) call realio(aux,irl,irh,ifin,-1)
      if(ifill.eq.'i') call linter(ifin,irl-1,irh+1)
      if(ifill.eq.'c') then
        do 71 i=1,lenbuf
        x(i) = xf
 71     ix(i) = nint(xf)
        irlo = irl
 73     irho = min0(irlo+lenbuf-1,irh)
        if(ifin.gt.0) call intio(ix,irlo,irho,ifin,-1)
        if(ifin.lt.0) call realio(x,irlo,irho,ifin,-1)
        irlo = irho + 1
        if(irlo.le.irh) go to 73
      endif
      go to 61
c
c  offset part of a file (or to the end)
c
 81   write(6,172)
 172  format(' Amount of offset (0 when done); ',$)
      off = ffin(1,not)
      if(off.eq.0) go to 33
      write(6,174)
 174  format(' Start and end terms (if end term i, do to EOF); ',$)
      ist = ffin(1,not)
      ien = ffin(1,not)
      if(not.eq.'i') ien = longis(ifin)
      irl = ist
 83   irh = min0(irl+lenbuf-1,ien)
      nt = irh - irl + 1
      if(ifin.lt.0) then
        call realio(x,irl,irh,ifin,0)
        do 85 i = 1,nt
 85     x(i) = x(i) + off
        call realio(x,irl,irh,ifin,-1)
      endif
      if(ifin.gt.0) then
        call intio(ix,irl,irh,ifin,0)
        do 87 i = 1,nt
 87     ix(i) = nint(ix(i) + off)
        call intio(ix,irl,irh,ifin,-1)
      endif
      irl = irh + 1
      if(irl.le.ien) go to 83
      go to 81
c
c  fill part of a file with linear interpolation
c
 91   write(6,132)
      irl = ffin(1,not)
      irh = ffin(1,not)
      if(irl.le.0) go to 33
      call linter(ifin,irl,irh)
      go to 91
c
c  copy part of a file to another one
c
 95   write(6,120)
      ifin = ffin(1,not)
      write(6,102)
      ifout = ffin(1,not)
      write(6,180)
 180  format(' Start and end terms to take from input; ',$)
      ist = ffin(1,not)
      ien = ffin(1,not)
      write(6,182)
 182  format(' Number of zeros to pad on front; ',$)
      izs = ffin(1,not)
      write(6,184)
 184  format(' Number of zeros to pad on rear; ',$)
      ize = ffin(1,not)
      len = izs+ize+ien-ist+1
      if(ifout.gt.0) call intio(ix,len,len,ifout,1)
      if(ifout.lt.0) call realio(x,len,len,ifout,1)
      call filcop(ifin,ist,ien,ifout,izs+1)
      write(6,186) ien-ist+1,len
 186  format(i6,' terms copied, ',i6,' written out')
      stop
      end
