c  program loessl1
c
c     Given an x-y series from standard input, writes out a smoothed version,
c  where the smoothing is done by fitting a regression line at each x value
c  using the L1 criterion. Parameters read from the command line are
c
c    forw - range of x values to take forward of each term
c    back - range of x values to take backwards of each term
c    nmin - minimum number of x values to require for fit
c
      character*20 dumm
      dimension x(50000),y(50000)
      dimension xf(200),yf(200),f(200),wt(200),ind(200)
      if(iargc().lt.3.or.iargc().gt.4) then
         write(6,100)
 100     format(/,'Usage:',/,
     1    '       cat xyfile | loessl1 nmin back forw ',/)
         stop
      endif
      call getarg(1,dumm)
      read(dumm,102) nmin
 102  format(i6)
      call getarg(2,dumm)
      read(dumm,*) back
      call getarg(3,dumm)
      read(dumm,*) forw
      np=1
 5    read(5,*,end=7) x(np),y(np)
      np=np+1
      go to 5
 7    np=np-1 
      do i=1,np
        cen=x(i)
        nf=0
        do l=1,np
          diff=x(l)-cen
          if(diff.ge.-back.and.diff.le.forw) then
            nf=nf+1
            xf(nf)=diff
            yf(nf)=y(l)
          endif
        enddo
C        write(6,*) cen,nf,back,forw,np
        if(nf.ge.nmin) then
          iter=-1
          call desl1m(xf,yf,nf,f,wt,ind,a,b,iter)
c output diagnostic parameters if there is a 4th argument on the
c command line, for backwards compatibility
          if(iargc().eq.4) write(6,*) cen,y(i),a,y(i)-a,nf,iter
          if(iargc().ne.4) write(6,*) cen,a
        endif
      enddo
      stop
      end
