c$$$$$$$ tkb with iolib/lb, qrseq
c  finds coefficients in a linear combination of given
c  time series that best fits a given data series in a least-squares
c  sense.  the time series may be provided multiplexed or separately,
c  and the program is not limited to systems that will fit in store
c  at one time.  it brings in blocks of data sequentially and uses
c  sequential qr.  the present version will not handle data series
c  longer than 32k.  to fix this make  m  in this program integer *4,
c  and also in the routine  qrseq.
c
      character*1 not
      common // a(10000),x(15)
      common /info/ mode,mem,nfile,ifile(15),istrt(15),iprint,ismrt(15)
      data maxmem/10000/
c
c
 1000 write(6,100)
 100  format(' enter number of free model parameters to be fit '
     +,'(0 to stop); ',$)
      n=ffin(1,not)
      if (n.eq.0) stop
      write(6,105)
 105  format(' enter number of data ; ',$)
      m=ffin(1,not)
 1010 write(6,110)
 110  format(' enter file mode number (0 for help) ; ',$)
      mode=ffin(1,not)
      if (mode.ne.0) go to 1020
 115  format(/'   consider the least-squares equation a x = b'/
     &' if mode=1 there is only 1 file containing the matrix  a'
     &/'  and data  b.  the matrix and data should be arranged'
     &/'  by rows - a(i,1),a(i,2),...a(i,n),b(i), with i=1,2...m'
     &/' if mode=2 there are 2 files, one for the data the other'
     &/'  for the matrix  a held by row')
 116  format(
     & ' if mode=3 there are n+1 files, one for the data, and '
     &/'  one each for the separate functions to be fitted'/)
      write(6,115)
      write(6,116)
      go to 1010
 1020 go to (1100,1200,1300),mode
 1100  write(6,111)
 111  format(' enter file number, start term ; ',$)
      ifile(1)=ffin(1,not)
      istrt(1)=ffin(1,not)
      go to 2000
 1200 write(6,121)
 121  format(' enter matrix file, start term ; ',$)
      ifile(2)=ffin(1,not)
      istrt(2)=ffin(1,not)
 1300 write(6,122)
 122  format(' enter data file, start term   ; ',$)
      ifile(1)=ffin(1,not)
      istrt(1)=ffin(1,not)
      go to (2000,2000,1310),mode
 1310  write(6,131)
 131  format(' enter list of files of fitting functions '
     &/' enter file no, start term, file no, start term, ...')
      do 1320 i=1,n
      ifile(i+1)=ffin(1,not)
 1320 istrt(i+1)=ffin(1,not)
c
 2000 ms=maxmem/(n+1) - n - 1
      if (mode.ne.3) ms=ms/2
      msub=min0(m,ms)
      mem=(n+1)*(n+1+msub)
c     write(6,200) msub
c200  format(/' size of blocks brought into memory ',i5)
c     write(6,210)
c210  format(' enter 1 if you want each block printed ; ',$)
c     iprint=ffin(1,not)
c
c   initialize the ismrt(i) array
c
      do 2011 ik=1,15
      ismrt(ik)=istrt(ik)
 2011 continue
c
c
      call qrseq(a,x,esq,m,msub,n,1)
c
      esq=sqrt(esq/m)
      write(6,250) esq,(x(j),j=1,n)
 250  format(/' rms misfit',g13.5/
     +' parameters in best fit'/(10g18.10))
      write(6,300)
 300  format(' enter file for residual series (0 for none) ; ',$)
      iout=ffin(1,not)
      if (iout.eq.0) stop 
      call realio(a,1,1,iout,1)
        ic1=1
      n1=n+1
      x(n+1)=-1.0
c
c  reinitialize the istrt(i) array
c
      do 3011 ik=1,15
 3011 istrt(ik)=ismrt(ik)
c  fetch in arrays with  row  and compute residual in 1sr col
      do 3500 m1=1,m,msub
      l=min0(msub,m-m1+1)
      call rows(a,msub,l,n1)
      do 3300 i=1,l
 3300 a(i)=-a(i)*x(1)
      do 3400 j=2,n1
      is=(j-1)*msub
      do 3400 i=1,l
 3400 a(i)=a(i) - a(i+is)*x(j)
      ic2=ic1+l-1
       call realio(a,ic1,ic2,iout,-1)
 3500 ic1=ic1+l
c
       write(6,350) ic2
 350  format(' number of terms written ',i7)
      stop
      end
      subroutine rows(a,ma,m,n)
c  fetches blocks of the matrix and data off the disk for qrsec
      dimension a(ma,n)
      common /info/ mode,mem,nfile,ifile(15),istrt(15),iprint,ismrt(15)
      common // aa(1)
c
c  mode determines how the matrix/dat files are arranged
      iblk=m*(n+1-mode)
      go to (1000,2000,3000),mode
c
c  matrix and data multiplexed
 1000 call realio(aa(mem+1),istrt(1),istrt(1)+iblk-1,ifile(1),0)
c  read by rows the data is transposed. must be transposed back
      call trans(aa(mem+1),a,ma,m,n)
      istrt(1)=istrt(1)+iblk
      go to 5000
c
c  only matrix is multiplexed
 2000 call realio(a(1,n),istrt(1),istrt(1)+m-1,ifile(1),0)
      call realio(aa(mem+1),istrt(2),istrt(2)+iblk-1,ifile(2),0)
      call trans(aa(mem+1),a,ma,m,n-1)
      istrt(1)=istrt(1)+m
      istrt(2)=istrt(2)+iblk
      go to 5000
c
c   data and matrix all held as separate col vectors
 3000 call realio(a(1,n),istrt(1),istrt(1)+m-1,ifile(1),0)
      istrt(1)=istrt(1)+m
c  read in fitting functions, with a special feature: a file number
c  of 0 means a constant (all 1's) and a file number of 1 means a
c  ramp 
      do 3100 j=2,n
      if(abs(ifile(j)).gt.2) then
	 call realio(a(1,j-1),istrt(j),istrt(j)+m-1,ifile(j),0)
      endif
      if(ifile(j).eq.0) then
	 do 3050 kd=1,m
 3050    a(kd,j-1)=1
      endif
      if(ifile(j).eq.1) then
	 do 3055 kd=1,m
 3055    a(kd,j-1)=istrt(j)+kd-1
      endif
 3100 istrt(j)=istrt(j)+m
c
 5000 continue
      write(6,500)
 500  format(' data block read in')
      if (iprint.ne.1) return
      do 1100 i=1,m
 1100 write(6,510) (a(i,j),j=1,n)
 510  format(10g13.5)
      return
      end
      subroutine trans(a,b,mb,m,n)
      dimension b(mb,n),a(n,m)
c  puts transpose of a into b, whose cols a length mb
      do 1100 i=1,m
      do 1100 j=1,n
 1100 b(i,j)=a(j,i)
      return
      end
