      subroutine mccor(al,be)
c   computes alpha and beta "radiational potential" coefficients as
c   in munk and cartwright 1966, in watts/(meter)**2
c   coefficients are returned in al and be, in order of increasing l
c   (l = 1 or 2) and for each l in order of increasing m.  be(1) and be(3)
c   are zero.
c            $$$$$$$$calls no other routines
c
      dimension al(5),be(5),c(5),cl(4),sl(4),rnorm(5),rk(2)
c   common with solar and lunar positions (the latter are not used)
      common/bpos/coor(8),par,sdist
c   solar constant
      data sk/1353./
      data cl(1)/1./,sl(1)/0./,ifl/0/,fpi/12.566370614/,c(1)/1./
c   on first call compute normalizing coefficients
      if(ifl.ne.0) go to 3
      ifl = 1
      rk(1) = sk/2.
      rk(2) = 5*sk/16.
      do 1 i = 2,5
 1    c(i) = (i-1.)*c(i-1)
      do 2 l = 1,2
      mu = l + 1
      do 2 m = 1,mu
      i = 2*(l/2) + m
      t = 1. + (m+1)/3
 2    rnorm(i) =((-1)**(m+1))*t*sqrt((fpi*c(l-m+2))/((2.*l+1)*c(l+m)))
 3    do 4 i = 1,5
      al(i) = 0.
 4    be(i) = 0.
      n = 2
c   n = 1 for lunar part, 2 for solar
      do 5 i = 1,3
      cl(i+1) = coor(4*n)*cl(i) - coor(4*n-1)*sl(i)
 5    sl(i+1) = coor(4*n)*sl(i) + coor(4*n-1)*cl(i)
      cz = coor(4*n-2)
      sz = coor(4*n-3)
      c(1) = cz
      c(2) = sz
      c(3) = (3.*cz*cz - 1.)/2.
      c(4) = 3.*cz*sz
      c(5) = 3.*sz*sz
      do 6 l = 1,2
      mu = l + 1
      do 6 m = 1,mu
      k = 2*(l/2) + m
      c(k) = rnorm(k)*rk(l)*c(k)/sdist
      al(k) = al(k) + c(k)*cl(m)
      be(k) = be(k) + c(k)*sl(m)
 6    continue
      return
      end
