c   program passoff
c
c     Reads ascii edits file, finds the offset to be applied to a
c   data file from all edits preceding it and after a time specified
c   on the command line. Start time, sample interval, and length of data
c   are is taken from header file.
c     If data file is 0, prints value.
c
c   calls timsubs, headco, niolib
c
      character*80 line
      character*20 dumm
      character*8 source,chanid
      character*4 stc,commen
      double precision scans
      character*1 reason,mode
      dimension iedst(5),lgp(5),lfgp(5),mgp(6),mfgp(6),mst(6)
      dimension x(1000),ix(1000)
      common/head/scans,calc(4),clkc(2),sampin,nchann,iblock,istart(5),
     1     iend(5),nchf(17),ichnm(16),ncal(4),source,chanid(16),stc,
     2     commen(200)
      data mode/'d'/,total/0.0/
c
c  get information from command line
c
      if(iargc().lt.8) call userr
      call getarg(1,dumm)
      read(dumm,100) ifh
 100  format(i6)
      if(ifh.lt.0) call userr
      call headco(ifh,1)
      isamp=sampin
      len=nint(scans)
      call getarg(2,dumm)
      read(dumm,100) ifl
      call getarg(3,mode)
      if(mode.ne.'d'.and.mode.ne.'m') call userr
      call getarg(4,dumm)
      read(dumm,100) iedst(1)
      if(mode.eq.'d') then
        do i=2,5
           call getarg(i+3,dumm)
           read(dumm,100) iedst(i)
        enddo
      endif
      if(mode.eq.'m') then
         mst(1)=iedst(1)
         do i=2,6
           call getarg(i+3,dumm)
           read(dumm,100) mst(i)
         enddo
         call toyd(mst,iedst)
         do i=3,5
           iedst(i)=mst(i+1)
         enddo
      endif
c
c   read edits, converting times to ydhms
c
      ned=1
 7    read(5,102,end=13) line
 102  format(a80)
      if(line(1:1).ne." ") go to 7
      if(mode.eq.'d') then
         read(line,104) stc,chanid(1),lgp,lfgp,ioff,reason
 104     format(1x,a4,1x,a8,1x,i4,i4,3i3,3x,i4,i4,3i3,2x,i8,2x,a1)
      endif
      if(mode.eq.'m') then
         read(line,106) stc,chanid(1),mgp,mfgp,ioff,dr
 106     format(1x,a4,1x,a8,1x,i4,5i3,3x,i4,5i3,2x,i8,2x,a1)
         call toyd(mgp,lgp)
         do i=3,5
           lgp(i)=mgp(i+1)
         enddo
         call toyd(mfgp,lfgp)
         do i=3,5
           lfgp(i)=mfgp(i+1)
         enddo
      endif
c
c  find locations of edit relative to reference start time, and start time
c   of series, and if appropriate increment the total offset 
c
      igapl = iscnsp(iedst,lgp,isamp,'d')+1
      igaph = iscnsp(iedst,lfgp,isamp,'d')+1
      jgapl = iscnsp(istart,lgp,isamp,'d')+1
      jgaph = iscnsp(istart,lfgp,isamp,'d')+1
      if(igapl.ge.1.and.jgapl.lt.1) total=total+ioff
      go to 7
c
c  print the offset
c
 13   if(iabs(ifl).lt.100) then
         write(6,110) total
 110     format('total offset is ',g16.5)
         stop
      endif
c
c  offset the series
c
      irl=1
 17   irh=min(irl+999,len)
      nt=irh-irl+1
      call realio(x,irl,irh,ifl,0)
      do i=1,nt
        x(i)=x(i)+total
      enddo
      if(ifl.lt.0) call realio(x,irl,irh,ifl,-1)
      if(ifl.gt.0) then
        do i=1,nt
          ix(i)=nint(x(i))
        enddo
        call intio(ix,irl,irh,ifl,-1)
      endif
      irl=irh+1
      if(irl.le.len) go to 17
      stop
      end
      subroutine userr
c
c  error message, giving usage
c
      write(6,100)
 100  format(/,'Usage:',/,
     1 '   cat ascii-edits | passoff headerfile datafile mode ',
     2 'styr [stmonth] stday sthr stmin stsec',/,
     5 '      to offset data in datafile (parameters in headerfile)',/,
     6 '      by accumulated offset from start time on command line',/,
     6 '      to start time of data',/,
     8 '      mode must be m or d, for ascii edits (and start time)',/,
     8 '        as y-m-d or y-d respectively',/,
     9 '      if datafile is 0, result is printed',/)
      stop
      end
