c      program pinjoy
c   joins together parts (or wholes) of cassettes with headers
c  does not decimate and assumes all files to be at the same sample interval
c  writes out header(s) for final output files. will handle up to 32 files
c  of data.
c
c    $$$$calls timsubs,iosubs,hedlib,iolib
c
      character*8 name,chid,namtry,namtmp,chnbf
      character*4 stc,comm
      character*1 mode,not,iinntr,okover
      double precision scans
      dimension ichwnt(32),icnmb(32),icflb(32),chnbf(32)
      dimension jchfl(32,50),irlo(50),irli(50),irhi(50),ihd(2,50)
      dimension ibeg(5),ifin(5),init(5)
      common/head/scans,calc(4),clkc(2),samp,nchan,iblock,ist(5),
     1     ien(5),nchf(17),ichnm(16),ncal(4),name,chid(16),stc,
     2     comm(200)
C old    common/head/stc,name,calc(4),clkc(2),nchan,iblock,ist(5)
C old   1     ien(5),scans,samp,nchf(17),ichnm(16),chid(16),ncal(4)
C old   2     comm(200
c      common/head/stc,name(4),calc(4),clk(2),nchan,iblk,ist(5),ien(5),
c     1 scans,samp,nchf(17),ichnm(16),chid(16,2),ncal(4),comm(200)
      data mode/'d'/,iolrho/1/,iinntr/'n'/,npc/50/
      write(6,100) npc
 100  format(' How many pieces to join (max ',i3,'); ',$)
      npc = ffin(1,not)
      write(6,102)
 102  format(' sample interval (sec); ',$)
      isamp = ffin(1,not)
      write(6,104)
 104  format(' what channel numbers (0 to end)::; ',$)
      call listin(ichwnt,nchwn,0)
c
c  now loop through pieces, getting header for each one, finding file numbers
c  of channels to read, and getting and checking times wanted
c
      do 43 i = 1,npc
 3    write(6,106)
 106  format(/,' number(s) of header files (0 for 2nd if none) ',
C     1  t50,'; ',$)
     1  '; ',$)
      ihd(1,i) = ffin(1,not)
      ihd(2,i) = ffin(1,not)
      write(6,108)
 108  format(' name of source cassette ',t50,';; ',$)
      read(5,110) namtry
 110  format(a8)
      call headco(ihd(1,i),1)
c fill up buffers with channel numbers and names, needed for later use
      namtmp = name
      do 7 j=1,nchan
      icnmb(j) = ichnm(j)
      chnbf(j) = chid(j)
 7    icflb(j) = nchf(j)
      nc = nchan
      if(ihd(2,i).eq.0) go to 11
      call headco(ihd(2,i),1)
      do 9 j=1,nchan
      icnmb(nc+j) = ichnm(j)
      chnbf(nc+j) = chid(j)
 9    icflb(nc+j) = nchf(j)
      nc = nc + nchan
c  check first 4 characters of the names for agreement;
c  if they disagree, try again or go on.
 11   iok = 1
      do 13 j=1,4
 13   if(namtmp(j:j).ne.namtry(j:j).or.name(j:j).ne.namtry(j:j)) iok = 0
      if(iok.eq.1) go to 17
      if(ihd(2,i).eq.0) write(6,112) namtry,name
 112  format(' names disagree: you say ',a8,' but cassette is ',a8)
      if(ihd(2,i).ne.0) write(6,114) namtry,namtmp,name
 114  format(' names disagree: you say ',a8,' but cassettes are '
     1 ,a8,3x,a8)
 15   write(6,116)
 116  format(' try again (t), stop (s), or continue (c)?; ',$)
      idum = ffin(1,not)
      if(not.eq.'s') stop
      if(not.eq.'t') go to 3
      if(not.ne.'c') go to 15
c  now check to be sure that channel numbers asked for are present, and if
c  found put them in the array jchfl for later use.  if a channel number is
c  not present, the choices are to loop back and retype the header file
c  numbers, or else to go on, in which case the file number will be set to
c  zero and that channel will be linearly interpolated through the time
c  interval.  note that because of the possibility of 2 headers the complete
c  set of numbers available has been put in a buffer before checking begins
 17   do 25 k = 1,nchwn
      iok = 1
      do 19 l=1,nc
 19   if(icnmb(l).eq.ichwnt(k)) go to 23
      write(6,118) ichwnt(k)
 118  format(' cannot find channel ',i2,' in list of channels')
 21   write(6,116)
      idum = ffin(1,not)
      if(not.eq.'s') stop
      if(not.eq.'t') go to 3
      if(not.ne.'c') go to 21
      jchfl(k,i) = 0
      go to 25
 23   jchfl(k,i) = icflb(l)
 25   continue
 27   write(6,122)
 122  format(' start time (y,d,h,m,s, or 0, or p) ',t50,'; ',$)
      istrt = ffin(1,okover)
      if(istrt.ne.0) then
	 ibeg(1) = istrt
         if(i.eq.1) init(1) = ibeg(1)
         do 29 j=2,5
         ibeg(j) = ffin(1,not)
 29      if(i.eq.1) init(j) = ibeg(j)
      elseif(istrt.eq.0) then
	 do 30 j=1,5
         ibeg(j) = ist(j)
 30      if(i.eq.1) init(j)=ist(j)
      endif
      write(6,124)
 124  format(' end time (y,d,h,m,s, or 0) ',t50,'; ',$)
      iendt = ffin(1,not)
      if(iendt.ne.0) then
	 ifin(1) = iendt
         do 31 j=2,5
 31      ifin(j) = ffin(1,not)
      elseif(iendt.eq.0) then
         do 32 j=1,5
 32      ifin(j) = ien(j)
      endif
c  check that times are in increasing order
      if(iscnsp(ibeg,ifin,isamp,mode).lt.0) go to 27
c  now check to see that times fall within cassette boundaries. if they do
c  not we can retype the times or (once again) get a new header - but this
c  condition must eventually be fufilled
      if(iscnsp(ist,ibeg,isamp,mode).ge.0.and.
     1   iscnsp(ifin,ien,isamp,mode).ge.0)  go to 41
      if(iscnsp(ist,ibeg,isamp,mode).lt.0) write(6,128) ist
 128  format(' cassette starts at',i5,i4,3i3,' which is later than'
     1,' time requested')
      if(iscnsp(ifin,ien,isamp,mode).lt.0) write(6,130) ien
 130  format(' cassette ends at',i5,i4,3i3,' which is earlier than'
     1,' time requested')
 33   write(6,132)
 132  format(' c for new times, h for new header, s for stop); ',$)
      idum = ffin(1,not)
      if(not.eq.'h') go to 3
      if(not.eq.'c') go to 27
      if(not.ne.'s') go to 33
      stop
c  find places to start and end copying
 41   irli(i) = iscnsp(ist,ibeg,isamp,mode) + 1
      irhi(i) = iscnsp(ist,ifin,isamp,mode) + 1
      irlo(i) = iscnsp(init,ibeg,isamp,mode) + 1
c  check that start does not fall on or before previous end - if so loop
      if(i.eq.1.or.okover.eq.'p') go to 43
      if(irlo(i).gt.irlo(i-1)+irhi(i-1)-irli(i-1)) go to 43
      call timfnd(init,irlo(i-1)+irhi(i-1)-irli(i-1)-1,
     1 isamp,ifin,mode)
      write(6,134) ibeg,ifin
 134  format(' start time of',i5,i4,3i3,' precedes end time of',
     1 /,13x,i5,i4,3i3,' for previous piece')
      go to 27
 43   continue
c
c  end of loop through pieces - have all input information
c
      write(6,138)
 138  format(' maximum gap size to interpolate across (<=0 none)?; ',$)
      maxgap = ffin(1,iinntr)
      if(maxgap.gt.0) iinntr = 'y'
 44   write(6,140)
 140  format(' header file for output (1 number) ',t50,'; ',$)
      ihout = ffin(1,not)
      do i=1,npc
        if(ihout.eq.ihd(1,i).or.ihout.eq.ihd(2,i)) then
           write(6,141) ihout
 141       format('Header file ',i6,' already used--try again')
           go to 44
        endif
      enddo
      write(6,142)
 142  format(' name of output ',t50,';; ',$)
      read(5,110) name
      sctot = iscnsp(init,ifin,isamp,mode) + 1.
c
c  now copy, looping through channels, and for each channel through the pieces
c    (going in this order, only need one output open at a time)
c
      do 53 i=1,nchwn
      ifout = ihout + i
      if(i.gt.16) ifout = ifout + 1
      call intio(idum,1,1,ifout,1)
      do 51 j=1,npc
      if(jchfl(i,j).ne.0)
     1  call filcop(jchfl(i,j),irli(j),irhi(j),ifout,irlo(j))
      if(jchfl(i,j).ne.0) call retnio(jchfl(i,j))
c  linear interpolation between last point of previous piece and start of this
c  one - nbad is number of 'bad' (missing) points
      nbad = irlo(j) - iolrho - 1
      if(j.ne.1.and.iinntr.eq.'y'.and.nbad.le.maxgap)
     1  call linter(ifout,iolrho,irlo(j))
      if(jchfl(i,j).ne.0) iolrho = irlo(j) + irhi(j) - irli(j)
 51   continue
      call retnio(ifout)
 53   continue
c
c  end of copying loop - write out header(s), using names from header
c  for last piece, and blanking name should channel be missing. the
c  header information is left over from the copying above (loops 7 and 9)
c
      samp = isamp
      scans = sctot
      do 61 i=1,5
      ist(i) = init(i)
 61   ien(i) = ifin(i)
      nc1 = min0(nchwn,16)
      ioff = 0
      if(nc1.ne.nchwn) name(8:8) = 'a'
 71   nchf(17) = ihout
      nchan = nc1
      do 75 i=1,nc1
      nchf(i) = ihout + i
      ichnm(i) = ichwnt(i+ioff)
      chid(i) = '        '
c  search through channel numbers to find name - nc is number of channels
c   to look through, nchwn is the number wanted
      do 73 j=1,nc
      if(icnmb(j).ne.ichnm(i)) go to 73
      chid(i) = chnbf(j)
 73   continue
 75   continue
      call headco(ihout,0)
      if(nc1+ioff.eq.nchwn) stop
c  set up for second header
      ihout = ihout + 17
      ioff = 16
      nc1 = nchwn - 16
      name(8:8) = 'b'
      go to 71
      end
