c  program ramped
c
c  given an edits file, creates a correction series which is
c made up of a series of ramps, running between offsets (gaps
c with no offsets are ignored). These ramps may:
c  1. start with the value of the offset, and go to 0
c  2. start at 0, and end with the value of the following
c     offset.
c
c in each case, the value may be the value of the offset, or
c -1 times this.
c
c  calls edcon (editlib), linter (niolib), realio (niolib),
c  ffin (termlib)
c
      character*1 not,dirram,flip,slist
      dimension gap(2,500),ioff(500)
      data ned/500/
      write(6,100)
 100  format(' Length of file to generate correction series for; ',$)
      fl = ffin(1,not)
      write(6,101)
 101  format(' Number of file (real) for correction series; ',$)
      ifo = ffin(1,not)
 3    write(6,102)
 102  format(' Does ramp grow to offset (g) or decay from it (d); ',$)
      dum = ffin(1,dirram)
      if(dirram.ne.'g'.and.dirram.ne.'d') go to 3
 5    write(6,104)
 104  format(' Flip sign of offsets (y/n); ',$)
      dum = ffin(1,flip)
      if(flip.ne.'y'.and.flip.ne.'n') go to 5
 6    write(6,105)
 105  format(' List slopes? (y/n); ',$)
      dum = ffin(1,slist)
      if(slist.ne.'y'.and.slist.ne.'n') go to 6
      call edcon(ned,gap,ioff,1,fl)
c first strip out all edits with no offsets
      do 11 n=1,ned
      if(ioff(n).eq.0) then
         if(n.ne.ned) then
            do 7 j=n,ned-1
            ioff(j) = ioff(j+1)
            gap(1,j) = gap(1,j+1)
            gap(2,j) = gap(2,j+1)
 7          continue
         endif
         ned = ned-1
      endif
 11   continue
c flip offsets if need be
      if(flip.eq.'y') then
         do 13 i=1,ned
 13      ioff(i) = -ioff(i)
      endif
c now create a file which has spikes at the start of each edit,
c and then interpolate between this spike and the value (zero) at the
c other end of the ramp (or the first term).
      if(dirram.eq.'g') then
         do 17 n=1,ned
         irh=gap(1,n)
         if(n.eq.1) irl=1
         if(n.ne.1) irl=gap(2,n-1)
         x=ioff(n)
         call realio(x,irh,irh,ifo,1)
         call linter(ifo,irl,irh,slist)
 17      continue
      endif
c or, create a file which has spikes at the end of each edit,
c and then interpolate between this spike and the value (zero) at the
c other end of the ramp (except that in this case there is no ramp
c either at the start or end)
      if(dirram.eq.'d') then
         do 27 n=1,ned-1
         irl=gap(2,n)
         irh=gap(1,n+1)
         x=ioff(n)
         call realio(x,irl,irl,ifo,1)
         call realio(0.0,irh,irh,ifo,1)
         call linter(ifo,irl,irh,slist)
 27      continue
      endif
      irh=fl
      x=0.0
      call realio(x,irh,irh,ifo,1)
      stop
      end
      subroutine linter(ifile,irl,irh,slist)
c  replace data in file ifile, terms irl+1 through irh-1, with a linear
c  interpolation between the values at irl and irh.  interpolation is done
c  in real, with rounding to integer if needed
c
c  $$$$calls realio,intio
c
      character*1 slist
      dimension x(600),ix(600)
      if(irh-irl.le.1) return
      if(ifile.gt.0) call intio(ist,irl,irl,ifile,0)
      if(ifile.gt.0) call intio(ien,irh,irh,ifile,0)
      st = ist
      en = ien
      if(ifile.lt.0) call realio(st,irl,irl,ifile,0)
      if(ifile.lt.0) call realio(en,irh,irh,ifile,0)
      slp = (en-st)/(irh-irl)
      if(slist.eq.'y') write(6,100) irl,irh,slp
 100  format(' Slope from',i6,' to',i6,' is ',g14.4)
      irlo = irl+1
 1    irho = min(irlo+599,irh-1)
      np = irho - irlo + 1
      do 3 i=1,np
      x(i) = st + slp*(irlo+i-irl-1)
 3    ix(i) = nint(x(i))
      if(ifile.gt.0) call intio(ix,irlo,irho,ifile,-1)
      if(ifile.lt.0) call realio(x,irlo,irho,ifile,-1)
      irlo = irho + 1.
      if(irlo.le.irh-1) go to 1
      return
      end
