c     program sarit
c      performs series arithmetic with a variety of functions
c      on two input series and outputs one series (of either type).
c      the functions available are:
c
c      1      out=x*log(abs(ser1)) + y
c      2      out=x*10.**(ser1 /y)
c      3      out=x*10.((ser2-ser1))/y
c      4      out=x*ser1**y        (where y is an integer)
c      5      out=x*abs(ser1)**y
c      6      out=arctan(x*ser1/y*ser2)
c      7      out=sqrt((x*ser1)**2 + (y*ser2)**2)
c      8      out(i)=x * (ser1(i+1) - ser1(i)) + y
c      9      out=x*cabs(ser1) + y*i*arg(ser1)   (complex out,ser1,ser2)
c      +      out=x*ser1 + y*ser2
c      -      out=x*ser1 - y*ser2
c      *      out=x*ser1*ser2 + y
c      /      out=x*ser1/ser2 + y
c      m      out=(x+iy)*ser1*ser2        (complex ser1,ser2,out)
c      d      out=(x+iy)*ser1/ser2        (complex ser1,ser2,out)
c      c      out=(x+iy)*conj(ser1)       (complex ser1,ser2,out)
c      e      out(j)=ser1*cexp(i*(j*x+y)) (complex ser1,out)
c      s      out(i)=x*sum[ser1(j)]+y   j=1 to i-1; y is value of first term
c      t      out(i)=ser1(i) + x + y*i
c      r      out(i)=ser1(i)*cos(x*ser2(i) + y) (x*s + y in deg)
c      l      out(i)=min(x*ser1(i),y*ser2(i))
c      u      out(i)=max(x*ser1(i),y*ser2(i))
c      z      out=x*ser1 + i*y*ser2   (complex out, real ser1, ser2!)
c
c      to add more functions change:
c                 nopt
c                 the dimension of iopt
c                 format statement 104
c                 the comment block above
c                 the assigned go to just before statement 500
c                 and of course add the function to the code
c
c
c             !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c             !                                         !
c             !             important change            !
c             !                26-may-82                !
c             ! integer files now rounded not truncated !
c             !                                         !
c             !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c
c
c  coded by j berger, march 1976.  revised r l parker, nov 1977, oct 1987
c                                          d c agnew,  jun 1981, may 1982
c                                                      aug 1984, mar 1985
c                                          k g schmalbach,       may 1982
c                                          f k wyatt,            nov 1987
c...................................................
c
      character*1 ifcn,not,iopt
      complex z
      dimension io(2),iopt(23),ifil(3),ser(601,4),ibuf(1202)
      data irl/1/,ser/2404*1.0/,jfcn/0/,iof/0/,nserin/0/
      data nopt/23/,iopt/'1','2','3','4','5','6','7','8','9',
     & '+','-','*','/','m','d','s','t','e','c','r','l','u','z'/
c
c
 3    write(6,100)
 100  format(' What option? (? for help);; ',$)
      read(5,102) ifcn
 102  format(a1)
      if(ifcn.eq.'0') stop
      if(ifcn.ne.'?') go to 5
      write(6,103)
 103  format(' Options are:',//,10x,'+-',10x,
     1'x*ser1 +- y*ser2',/,
     210x,'*',10x,'x*ser1*ser2 + y',/,10x,'/',10x,
     3'x*ser1/ser2 + y',/,10x,'1',10x,'x*log(ser1) + y',
     4/,10x,'2',10x,'x*10.**(ser1 / y)',/,10x,
     5'3',10x,'x*10.**((ser2 - ser1))/y',/,10x,
     6'4',10x,'x*ser1**y  (where y is an integer)',/,10x,
     7'5',10x,'x*abs(ser1)**y',/,10x,
     8'6',10x,'arctan(x*ser1/y*ser2)  (typ. ser1 is "y" data)',/,10x,
     9'7',10x,'sqrt((x*ser1)*2 + (y*ser2)**2)',/,10x,
     1'8',10x,'x*(ser1(i+1)-ser1(i))+y',/,10x,
     2'9',10x,'x*cabs(ser1) + i*y*arg(ser1) ',/,t20,
     3 ' (input complex, output alternating amp and phase)',/,10x,
     4'm',10x,'(x+iy)*ser1*ser2  (all series complex)',/,10x,
     5'd',10x,'(x+iy)*ser1/ser2  (all series complex)',/,10x,
     6'c',10x,'(x+iy)*conj(ser1) (all series complex)',/,10x,
     7'e',10x,'ser1*cexp(i*(j*x+y))  (all series complex)',/,10x,
     8's',10x,'x*sum[ser1(k)]+y  k=1 to j-1, y is first term',/,10x,
     9't',10x,'ser1+x+j*y (j is the term number)')
      write(6,104)
 104  format(10x,
     1'r',10x,'ser1*cos(x*ser2 + y)    (x*s+y in degrees)'/,10x,
     2'l',10x,'min(x*ser1(i),y*ser2(i))'/,10x,
     3'u',10x,'max(x*ser1(i),y*ser2(i))'/,10x,
     4'z',10x,'x*ser1+i*y*ser2 (out complex, ser1,ser2 real)',/,10x)
      go to 3
 5    do 7 i=1,nopt
 7    if(ifcn.eq.iopt(i)) jfcn=i
      if(jfcn.ne.0) go to 9
      write(6,106) ifcn
 106  format(' You have attempted a non-existent option: ',a2
     &/'  try again')
      go to 3
c
c some options need only one input series (+, -, l, u may or may not)
c
 9    if(jfcn.eq.1.or.jfcn.eq.2.or.jfcn.eq.4.or.jfcn.eq.5.or.
     1  jfcn.eq.8.or.jfcn.eq.9.or.jfcn.eq.16.or.jfcn.eq.17.or.
     2  jfcn.eq.18.or.jfcn.eq.19) nserin = 1
      write(6,108)
 108  format(' Enter number, start term, end term of series 1;   ',$)
      ifil(1) = ffin(1,not)
      io(1) = ffin(1,not) - 1.
      iie = ffin(1,not)
      if(iie-1.lt.io(1)) iie=longis(ifil(1))
      len = iie - io(1)
      if(nserin.eq.1) go to 11
      write(6,110)
 110  format(' Enter number, start term of series 2 (0 if none); ',$)
      ifil(2) = ffin(1,not)
      if(ifil(2).ne.0) io(2) = ffin(1,not) - 1.
 11   write(6,112)
 112  format(' Enter output file number; ',$)
      ifil(3) = ffin(1,not)
      if((ifil(1).eq.ifil(3).and.io(1).ne.0.0).or.
     1 (ifil(2).eq.ifil(3).and.io(2).ne.0.0)) write(6,114)
 114  format(' WARNING - you may be over-writing data before using it')
      write(6,116)
 116  format(' Enter x and y; ',$)
      x = ffin(1,not)
      y = ffin(1,not)
c
c
      nrec=1
      if(jfcn.eq.4) ky = y
      if(jfcn.eq.11) y=-y
      if(jfcn.eq.16) sum = y
      if(jfcn.eq.16) iof = 1
      irho=iof
c
 400  irh = min(irl+599,len)
      if(jfcn.eq.8) irh = min0(irl+600,len)
      call realio(ser(1,1),irl+io(1),irh+io(1),ifil(1),0)
      if (ifil(2).ne.0)
     1  call realio(ser(1,2),irl+io(2),irh+io(2),ifil(2),0)
c
      go to(500,600,700,800,900,1000,1100,1200,1300,
     1 1400,1400,1500,1600,1700,1800,1900,2000,2100,
     2 2200,2300,2400,2500,2600) jfcn
c
c         x*log(ser1) +y
c
  500 do 520 j=1,600
  520 ser(j,3)=x*alog10(abs(ser(j,1))+1.e-37)+y
      go to 9000
c
c         x*10.**(ser1/y)
c
  600 do 620 j=1,600
  620 ser(j,3)=x*10.**(ser(j,1)/y)
      go to 9000
c
c       x*10.**((ser2-ser1)/y)
c
  700 do 720 j=1,600
  720 ser(j,3)=x*10.**((ser(j,2)-ser(j,1))/y)
      go to 9000
c
c            x*ser1**y
c
  800 do 820 j=1,600
  820 ser(j,3)=x*(ser(j,1)**ky)
      go to 9000
c
c             x*abs(ser1)**y
c
  900 do 920 j=1,600
  920 ser(j,3)=x*(abs(ser(j,1))**y)
      go to 9000
c
c           arctan(x*ser1/y*ser2)
c
 1000 do 1020 j=1,600
 1020 ser(j,3)=atan2(x*ser(j,1),y*ser(j,2))
      go to 9000
c
c           sqrt((x*ser1)**2 + (y*ser2)**2)
c
 1100 do 1120 j=1,600
 1120 ser(j,3)=sqrt((x*ser(j,1))**2 + (y*ser(j,2))**2)
      go to 9000
c
c       first differencer
c
 1200 do 1220 j=2,601
 1220 ser(j-1,3)=x*(ser(j,1)-ser(j-1,1))+y
      go to 9000
c
c          x*cabs(ser1) + i*y*arg(ser1)  (complex (ser1,ser2,out)
c
 1300 do 1320 j=1,600,2
      ser(j,3)=x * sqrt(ser(j,1)**2 + ser(j+1,1)**2)
 1320 ser(j+1,3)=y * 57.29578*atan2(ser(j+1,1),ser(j,1)+1.e-35)
      go to 9000
c
c        add/sub
c
 1400 do 1420 j=1,600
 1420 ser(j,3)=x*ser(j,1)+y*ser(j,2)
      go to 9000
c
c        multiply
c
 1500 do 1520 j=1,600
 1520 ser(j,3)=x*ser(j,1)*ser(j,2) + y
      go to 9000
c
c          divide
c
 1600 do 1620 j=1,600
 1620 ser(j,3)=x*ser(j,1)/ser(j,2) + y
      go to 9000
c
c          (x+iy)*ser1*ser2  (complex ser1,ser2,out)
c
 1700 do 1720 j=1,600,2
      if(ifil(2).ne.0) z=cmplx(ser(j,1),ser(j+1,1))*
     & cmplx(ser(j,2),ser(j+1,2))*cmplx(x,y)
      if(ifil(2).eq.0) z=cmplx(ser(j,1),ser(j+1,1))*cmplx(x,y)
      ser(j,3)=real(z)
 1720 ser(j+1,3)=aimag(z) 
      go to 9000
c
c          (x+iy)*ser1/ser2  (complex ser1,ser2,out)
c
 1800 do 1820 j=1,600,2
      z=cmplx(x,y)*cmplx(ser(j,1),ser(j+1,1))/
     &  cmplx(ser(j,2),ser(j+1,2))
      ser(j,3)=real(z)
 1820 ser(j+1,3)=aimag(z)
      go to 9000
c
c           sum[ser(j)]  j=1to i
c
 1900 do 1920 j=1,600
      ser(j,3)=sum + x*ser(j,1)
 1920 sum=ser(j,3)
      go to 9000
c
c           ser(i) + x + i*y (add a trend)
c
 2000 do 2020 j=1,600
 2020 ser(j,3) = ser(j,1) + x + y*(j-1.+irl+io(1))
      go to 9000
c
c           ser(j)*cexp(i*(j*x+y))
c
 2100 do 2120 j=1,600,2
      tn = (j+irl+io(1))/2.
      z = cmplx(ser(j,1),ser(j+1,1))*cexp((0.,1.)*(x*tn + y))
      ser(j,3)=real(z)
 2120 ser(j+1,3)=aimag(z)
      go to 9000
c
c           (x+iy)*cong(ser(j))  (complex ser1,out)
c
 2200 do 2220 j=1,600,2
      z =  cmplx(ser(j,1),ser(j+1,1))
      z =  cmplx(x,y)*conjg(z)
      ser(j,3)=real(z)
 2220 ser(j+1,3)=aimag(z)
      go to 9000
c
c           ser1*cos(x*ser2+y)  (argument in degrees)
c
 2300 do 2320 j=1,600
 2320 ser(j,3) = ser(j,1)*cos(.0174532*(x*ser(j,2)+y))
      go to 9000
c
c           min(x*ser1,y*ser2)
c
 2400 do 2420 j=1,600
 2420 ser(j,3) = amin1(x*ser(j,1),y*ser(j,2))
      go to 9000
c
c           max(x*ser1,y*ser2)
c
 2500 do 2520 j=1,600
 2520 ser(j,3) = amax1(x*ser(j,1),y*ser(j,2))
      go to 9000
c
c    complex out = x*ser1 + i*y*ser2
c
c  Out is twice as long as each input ser. Excess goes into ser(.,4)
 2600 do 2610 j=1,600
      ser(2*j-1,3)=x*ser(j,1)
 2610 ser(2*j,  3)=y*ser(j,2)
      goto 9000
c
c  load an integer buffer if the output file is to be integer
c
 9000 iadd = irh - irl + 1
      if (jfcn .eq. 23) iadd=2*iadd
      if(ifil(3).lt.0) go to 9020
      do 9010 k=1, iadd
 9010 ibuf(k) = nint(ser(k,3))
c9020 irlo = irl + iof
c     irho = irh + iof
 9020 irlo = irho + 1
      irho = irlo + iadd - 1
      if(jfcn.eq.8) irho = irho - 1
      if(ifil(3).lt.0) call realio(ser(1,3),irlo,irho,ifil(3),nrec)
      if(ifil(3).gt.0) call intio(ibuf,irlo,irho,ifil(3),nrec)
      nrec=-1
      irl = irl + 600
      if (irl.le.len) go to 400
c
c    finish up (if summing, write out the first term)
c
      if(jfcn.ne.16) go to 9200
      ibuf(1) = y
      ser(1,3) = y
      if(ifil(3).lt.0) call realio(ser(1,3),1,1,ifil(3),-1)
      if(ifil(3).gt.0) call intio(ibuf,1,1,ifil(3),-1)
 9200 write(6,120) irho,ifil(3)
  120 format(i8,' terms written to file ',i7)
      stop
      end
