      program shred
c    takes edits files and 
c     1. rewrites them to apply to a series with different start time 
c        and sample interval.  the offsets are used where edits are kept.
c        more than one edits file may be processed, and the results combined
c        later using merged
c     2. lists edits within a range of term numbers
c     3. converts edits file to be that for a first-differnced series,
c        and vice versa
c     4. adds, removes, or changes edits file (including padding it with
c        zeroes when writing to disk)
c     5. deletes edits less than a given length and combines those separated
c        by less than a given amount of data
c     6. produces an edits file that selects only certain times of day
c     7. removes all offset information
c     8. scales all offset information
c
c    calls edlib,genlib,iolib
c
      character*1 mode,lmod,mopt,not,itmgt
      character*8 source,chanid
      character*4 stc,commen
      double precision scans
      dimension ioff(64000),igap(2,64000),isti(6),isto(5),
     1 igapo(2,64000),itim(6),ig(2),itim2(6)
      common/head/scans,calc(4),clkc(2),sampin,nchann,iblock,istart(5),
     1     iend(5),nchf(17),ichnm(16),ncal(4),source,chanid(16),stc,
     2     commen(200)
      common/minedt/mlen
      data nopt/8/,mode/'d'/,maxed/64000/,mlen/0/
  1   write(6,100) nopt
 100  format('What option (1-',i1,')                      ; ',$)
      iopt = ffin(1,not)
      if(iopt.ge.1.and.iopt.le.nopt) go to 3
      write(6,102)
 102  format(' options are: 1 - reset edits to new time and interval',
     1 /,4x,'2 - list edits',/,4x,
     2 '3 - convert between standard and first-diff edits files',/,4x,
     3 '4 - add, remove, or change edits',/,4x,
     4 '5 - delete edits or data segments less than some length',/,4x,
     5 '6 - make an edits file to select times of day',/,4x,
     6 '7 - remove all offset information from an edits file',/,4x,
     7 '8 - scale  all offset information from an edits file')
      go to 1
 3    go to (5,31,51,71,201,15,301,311) iopt
c
c  reset edits to new time and sample interval - if interval increases,
c  short edits are lost
c
 5    write(6,110)
 110  format('Start time of output (ydhms, or nnnh for header); ',$)
      isto(1)=ffin(1,not)
      if(not.eq.'h') then
	call headco(isto(1),1)
        do i=1,5
          isto(i) = istart(i)
        enddo
	isampo = sampin
        lofl = scans
      else
        do i=2,5
          isto(i) = ffin(1,not)
        enddo
        write(6,112)
 112    format('Sample interval of output series (sec) ; ',$)
        isampo = ffin(1,not)
        write(6,114)
 114    format('Length of output series                ; ',$)
        lofl = ffin(1,not)
      endif
 15   write(6,116)
 116  format('Start time of input (s to stop, [file]h to use header ',
     1  ' e.g. 400h )'/' (Use data, **NOT EDITS**, header number)  ;',
     2   $)
      isti(1) = ffin(1,itmgt)
      if(itmgt.eq.'s'.or.itmgt.eq.'S'.or.isti(1).eq.0) stop
      if(itmgt.eq.'h') then
	 call headco(isti(1),1)
         do i=1,5
           isti(i) = istart(i)
         enddo
	 isampi = sampin
         lfl = scans
      else
         do i=2,5
           isti(i) = ffin(1,not)
         enddo
         write(6,118)
 118     format('Sample interval of input series (sec) ; ',$)
         isampi = ffin(1,not)
         write(6,120)
 120     format('Length of input series                ; ',$)
         lfl = ffin(1,not)
      endif
      write(6,*) isto,isti,isampo,isampi,lofl,lfl
      if(iopt.eq.6) go to 231
      ned = maxed
      call edcon4(ned,igap,ioff,1,lfl)
      newed = 0
      do 21 j=1,ned
c  find new gap positions corresponding to the same times
      do 19 k=1,2
      call timfnd(isti,igap(k,j)-1,isampi,itim,mode)
 19   ig(k) = iscnsp(isto,itim,isampo,mode) + 1.
c  ignore edits that fall before start or after end of output series,
c  or would be less than one term long
      if(ig(2).le.1.or.ig(1).ge.lofl.or.ig(2)-ig(1).lt.1) go to 21
      newed = newed + 1
c  boundary-crossing edits are truncated to the start and end
      if(ig(1).le.1) ig(1) = 1
      if(ig(2).gt.lofl) ig(2) = lofl
c  put new gap numbers into output array
      do 20 k=1,2
 20   igapo(k,newed) = ig(k)
      ioff(newed) = ioff(j)
 21   continue
      if(newed.ne.0) go to 22
      write(6,122)
 122  format(' NO edits in new interval ')
      go to 15
c  now go through list and combine edits which have less than one term of
c  good data between them, also converting gap edges to integers using the
c  nearest integer rule
 22   ned = newed
      if(ned.eq.1) go to 27
      j=1
 24   if(igapo(1,j+1).ge.igapo(2,j)+1) go to 26
      igapo(2,j) = igapo(2,j+1)
      ioff(j) = ioff(j) + ioff(j+1)
      ned = ned - 1
      if(j.eq.ned) go to 27
      do 25 l=j+1,ned
      do 25 k=1,2
      ioff(l) = ioff(l+1)
 25   igapo(k,l) = igapo(k,l+1)
      go to 24
 26   j = j + 1
      if(j.lt.ned) go to 24
 27   continue
      call edcon4(ned,igapo,ioff,-1,lofl)
      go to 15
c
c   list edits
c
 31   write(6,130)
 130  format('Term numbers within which edits of interest fall; ',$)
      rl = ffin(1,not)
      if(rl.le.0) stop
      rh = ffin(1,not)
      if(rl.ge.rh) go to 31
      ned = maxed
      call edcon4(ned,igap,ioff,1,rh)
      if(ned.eq.0) write(6,132)
 132  format(' NO edits in this interval ')
      if(ned.eq.0) go to 31
 33   write(6,134)
 134  format('List by number (n) or time (t); ',$)
      idum = ffin(1,lmod)
      if(lmod.ne.'n'.and.lmod.ne.'t') go to 33
      if(lmod.eq.'n') write(6,136)
 136  format(' number   last good point   first good point     # bad',
     1 '   offset')
      if(lmod.eq.'n') go to 37
 35   write(6,138)
 138  format('Mode for times (d for day number, m for month; ',$)
      idum=ffin(1,mode)
      write(6,140)
 140  format('Start time of input ([file]h to use data header); ',$)
      isti(1)=ffin(1,itmgt)
      if(itmgt.eq.'h') then
         ifed=isti(1)
	 call headco(ifed,1)
         if(mode.eq.'d') then
           do i=1,5
             isti(i) = istart(i)
           enddo
         endif
         if(mode.eq.'m') call toymd(istart,isti)
	 isampi = sampin
         lfl = scans
      else
         do 36 i=2,5
 36      isti(i) = ffin(1,not)
         if(mode.eq.'m') isti(6)=ffin(1,not)
         write(6,118)
         isampi = ffin(1,not)
      endif
      write(6,142)
 142  format(/,'       start time            end time        length ',
     1 '     offset')
 37   do 41 i=1,ned
      if(igap(2,i).lt.rl.or.igap(1,i).gt.rh) go to 41
      if(lmod.eq.'n') write(6,144) i,igap(1,i),igap(2,i),
     1 igap(2,i)-igap(1,i)-1,ioff(i)
 144  format(1x,i4,6x,i8,11x,i8,8x,i8,3x,i6)
C     write(6,*) "1 ",i,ned,igap(1,i),igap(2,i),ioff(i)
      if(lmod.eq.'t') call timfnd(isti,igap(1,i)-1,isampi,itim,mode)
C     write(6,*) "2 ",i,ned,igap(1,i),igap(2,i),ioff(i)
      if(lmod.eq.'t') call timfnd(isti,igap(2,i)-1,isampi,itim2,mode)
C     write(6,*) "3 ",i,ned,igap(1,i),igap(2,i),ioff(i)
      if(lmod.eq.'t'.and.mode.eq.'d') write(6,146) (itim(k),k=1,5),
     1 (itim2(k),k=1,5),int(igap(2,i)-igap(1,i)-1.),ioff(i)
 146  format(1x,i5,i4,3i3,4x,i5,i4,3i3,4x,i6,6x,i6)
      if(lmod.eq.'t'.and.mode.eq.'m') write(6,147) itim,itim2,
     1 igap(2,i)-igap(1,i)-1,ioff(i)
 147  format(1x,i5,5i3,2x,i5,5i3,2x,i6,6x,i6)
 41   continue
      write(6,148)
 148  format(/)
      go to 31
c
c   converts edits for a regular file to be those appropriate to the
c   same file if first-differenced, or vice versa
c
 51   write(6,150)
 150  format('Are input edits for standard (s) or differenced (d)'
     1,' files?; ',$)
      idum = ffin(1,lmod)
      if(lmod.ne.'d'.and.lmod.ne.'s') go to 51
      write(6,120)
      lfl = ffin(1,not)
      ned = maxed
      call edcon4(ned,igap,ioff,1,lfl)
      do 53 i=1,ned
      if(lmod.eq.'s') igap(1,i) = igap(1,i) - 1
 53   if(lmod.eq.'d') igap(1,i) = igap(1,i) + 1
      call edcon4(ned,igap,ioff,0,lfl)
      stop
c
c   adds, removes, or changes edits file (changes are handled by removing
c   the edit asked for, and then adding it back in; either way, a new
c   edit may include older ones, whose offsets will be added
c
 71   write(6,120)
      lfl = ffin(1,not)
      ned = maxed
      call edcon4(ned,igap,ioff,1,lfl)
 73   write(6,160)
 160  format('Type of operation (h for help); ',$)
      idum = ffin(1,mopt)
      if(mopt.ne.'r'.and.mopt.ne.'a'.and.mopt.ne.'c'.and.mopt.ne.'l'.
     1 and.mopt.ne.'x'.and.mopt.ne.'h') go to 73
      if(mopt.eq.'r'.or.mopt.eq.'c') go to 77
      if(mopt.eq.'a') go to 83
      if(mopt.eq.'l') go to 97
      if(mopt.eq.'x') go to 99
      write(6,162)
 162  format(' Options are:',/,5x,
     1 'a - add a new edit to the file',/,5x,
     2 'r - remove an edit',/,5x,
     3 'c - change an edit (possibly more)',/,5x,
     4 'l - list edits',/,5x,
     5 'x - write out altered edits and exit')
      go to 73
 77   write(6,164)
 164  format('Number of edit; ',$)
      nnedt = ffin(1,not)
      ig1 = igap(1,nnedt)
      ig2 = igap(2,nnedt)
      moffs = ioff(nnedt)
c  remove an edit
      if(nnedt.eq.ned) go to 80
      do 79 i=nnedt+1,ned
      igap(1,i-1) = igap(1,i)
      igap(2,i-1) = igap(2,i)
 79   ioff(i-1) = ioff(i)
 80   ned = ned - 1
      if(mopt.eq.'c') go to 81
      go to 73
c  if we are going to change an edit, list old bounding points (already
c  removed)
 81   write(6,166) ig1,ig2,moffs
 166  format(' old bounding points ',i7,' to ',i7,', offset ',i7)
c  change or add an edit - we put it wherever it fits, which may
c  entail devouring one or more older edits
 83   write(6,168)
 168  format('New bounding points and offset; ',$)
      ig1 = ffin(1,not)
      ig2 = ffin(1,not)
      moffs = ffin(1,not)
      if(ig2-ig1.ge.32767) write(6,169)
 169  format(' edit will be long (ge 32767) - use long-integer',
     1 ' edits file')
c  now search through edits file until start of new edit is before
c  end of an old edit
 84   if(ned.eq.0) i = 1
      if(ned.eq.0) go to 91
      do 85 i=1,ned
      if(ig1.ge.igap(2,i)) go to 85
c  new edit overlaps or is before old edit - if no overlap, go to 87
      if(ig2.lt.igap(1,i)) go to 87
c  have overlap
      go to 93
 85   continue
c  new edit is after all old edits
      i = ned + 1
      go to 91
c  no overlap, so move old edits and insert new one
 87   do 89 j=i,ned
      k = ned + i - j + 1
      igap(1,k) = igap(1,k-1)
      igap(2,k) = igap(2,k-1)
 89   ioff(k) = ioff(k-1)
 91   igap(1,i) = ig1
      igap(2,i) = ig2
      ioff(i) = moffs
      ned = ned + 1
      go to 73
c  have overlap - combine new and old edit
 93   igap(1,i) = min(igap(1,i),ig1)
      igap(2,i) = max(igap(2,i),ig2)
      ioff(i) = ioff(i) + moffs
      if(i.eq.ned) go to 73
c  see if new gap covers any later ones - read in the next one,
c  shift down, and loop
      if(igap(2,i).lt.igap(1,i+1)) go to 73
      ig1 = igap(1,i+1)
      ig2 = igap(2,i+1)
      moffs = ioff(i+1)
      ned = ned - 1
      if(i.eq.ned) go to 93
      do 95 j=i+1,ned
      igap(1,j) = igap(1,j+1)
      igap(2,j) = igap(2,j+1)
 95   ioff(j) = ioff(j+1)
      go to 93
c  list the gaps
 97   write(6,136)
      write(6,144) (i,igap(1,i),igap(2,i),igap(2,i)-igap(1,i)-1,
     1 ioff(i),i=1,ned)
      go to 73
c  write out the file (padding, if requested, done to make output file 1441
c  terms long)
 99   write(6,170)
 170  format('Pad edits file for writing to tape (y/n)?; ',$)
      idum = ffin(1,not)
      if(not.eq.'y') mlen = 480
      call edcon4(ned,igap,ioff,0,lfl)
      stop
c
c  remove edits less than some length, after first combining those
c  with less than some amount of data between them.  both processes
c  reduce the total number of edits
c
 201  write(6,120)
      lfl = ffin(1,not)
      ned = maxed
      call edcon4(ned,igap,ioff,1,lfl)
      write(6,180)
 180  format('Minimum length of data to keep; ',$)
      iscsz = ffin(1,not)
c  go through the array and combine edits that are not separated
      i=1
 203  if(igap(1,i+1)-igap(2,i)-1.ge.iscsz) go to 209
      igap(2,i) = igap(2,i+1)
      ioff(i) = ioff(i) + ioff(i+1)
      if(i.ge.ned-1) go to 207
      do 205 j=i+1,ned-1
      igap(1,j) = igap(1,j+1)
      igap(2,j) = igap(2,j+1)
 205  ioff(j) = ioff(j+1)
 207  ned = ned - 1
      if(i.lt.ned) go to 203
 209  i= i + 1
      if(i.lt.ned) go to 203
      write(6,182)
 182  format('Minimum length of edit to keep; ',$)
      igpsz = ffin(1,not)
c  go through the array; if we find an edit that is too short,
c  remove it and copy the arrays forward, leaving our pointer
c  in the same place.
      i=1
 213  if(igap(2,i)-igap(1,i)-1.ge.igpsz) go to 219
      if(i.eq.ned) go to 217
      do 215 j=i,ned-1
      igap(1,j) = igap(1,j+1)
      igap(2,j) = igap(2,j+1)
 215  ioff(j) = ioff(j+1)
 217  ned = ned - 1
      if(i.le.ned) go to 213
 219  i= i + 1
      if(i.le.ned) go to 213
      call edcon4(ned,igap,ioff,0,lfl)
      stop
c
c   writes out an edits file which rejects all data not falling
c   in the hours of x through y (inclusive) for a given file.
c   note that for data sampled more often than once per two seconds
c   the edits file format may not work
c
 231  write(6,190)
 190  format('Times wanted (start hm, end hm); ',$)
      ihs = ffin(1,not)
      ims = ffin(1,not)
      ihe = ffin(1,not)
      ime = ffin(1,not)
      if(ihs.eq.ihe) stop
      if(ihs.gt.ihe) ihe = ihe + 24
      iscpd = 86400/isampi
      ned = 1
      isto(1) = isti(1)
      isto(2) = isti(2)
      isto(3) = ihs
      isto(4) = ims
      isto(5) = 0
      iscst = iscnsp(isti,isto,isampi,mode) + 1
      isto(3) = ihe
      isto(4) = ime
      iscen = iscnsp(isti,isto,isampi,mode) + 1
c  if start and end are too early reset them to after the start of the series
      if(iscen.lt.1) iscst = iscst + iscpd
      if(iscen.lt.1) iscen = iscen + iscpd
      if(iscst.le.1) go to 233
c  first gap runs from 1 (or earlier scan) to iscst
      igap(1,ned) = max(1,iscen-iscpd)
      igap(2,ned) = iscst
      ned = ned + 1
 233  igap(1,ned) = iscen
      igap(2,ned) = iscst + iscpd
      iscst = iscst + iscpd
      iscen = iscen + iscpd
      ned = ned + 1
      if(iscst+iscpd.le.lfl) go to 233
      if(iscen.ge.lfl) ned = ned - 1
      if(iscen.ge.lfl) go to 235
      igap(1,ned) = iscen
      igap(2,ned) = lfl
 235  call edcon4(ned,igap,ioff,0,lfl)
      stop
c
 301  write(6,120)
      lfl = ffin(1,not)
      ned = maxed
      call edcon4(ned,igap,ioff,1,lfl)
      do 303 i=1,ned
 303  ioff(i)=0
      mlen = 480
      call edcon4(ned,igap,ioff,0,lfl)
      stop
 311  write(6,120)
      lfl = ffin(1,not)
      ned = maxed
      write(6,192)
 192  format('Scale factor for edits; ',$)
      sc=ffin(1,not)
      call edcon4(ned,igap,ioff,1,lfl)
      do 313 i=1,ned
 313  ioff(i)=sc*ioff(i)
      mlen = 480
      call edcon4(ned,igap,ioff,0,lfl)
      end
