c  Program to take sections of data and window them for later processing
c  by power.  Sections may be overlapped, and if data has been edited
c  with credit, the edits file so produced may be used to skip sections
c  of bad data.  Types of tapering available are given in statement
c  106.
c
c  calls prol,edcon,iolib,dtren,hann,filcop
c
      character*1 not
      dimension gap(2,600),x(6000),ioff(600)
      data ned/600/,irlo/1/,x/6000*1./,nsec/0/,idm/0/
      write(6,100)
 100  format(' Data file number (0 for test), start and end terms; ',$)
      ifin = ffin(1,not)
      st = ffin(1,not)
      fl = ffin(1,not)
      if(fl.le.0) fl=longis(ifin)
      write(6,102)
 102  format(' Section length (le 6000, 0 for copy) and % overlap; ',$)
      ns = ffin(1,not)
      if(ns.eq.0) go to 51
      if(ns.lt.0) then
        idm=1
        ns=-ns
      endif
      pov = ffin(1,not)
      pov = (100.-pov)/100.
      hf = (ns+1.)/2.
 3    write(6,104)
 104  format(' Taper wanted (-1 for summary):; ',$)
      iw = ffin(1,not)
      if(iw.ge.0) go to 5
      write(6,106)
 106  format(' Available tapers are:'/t20,'0 - none'/t20,
     $'1 - hanning'/t20,'2 - 4pi prolate spheroidal'/)
      go to 3
c  find normalizing factor for weights used
 5    if(iw.eq.1) call hann(x,ns)
      if(iw.eq.2) call prol(x,ns)
      smsq = 0.
      do 6 i=1,ns
 6    smsq = smsq + x(i)**2
      smsq = sqrt(ns/smsq)
      call edcon(ned,gap,ioff,1,fl)
c  put a dummy gap on the end
      ned = ned + 1
      gap(1,ned) = fl
      gap(2,ned) = fl + ns + 100.
c
c  go through gaps and combine those separated by fewer than ns terms
c  so that the resulting edits file has only sections of data big enough
c  to be analyzed
c
      i = 1
 7    if(nint(gap(1,i+1)-gap(2,i)-1.).ge.ns) go to 13
      gap(2,i) = gap(2,i+1)
      ioff(i) = ioff(i) + ioff(i+1)
      if(i.ge.ned-1) go to 11
      do 9 j = i+1,ned-1
      gap(1,j) = gap(1,j+1)
      gap(2,j) = gap(2,j+1)
 9    ioff(j) = ioff(j+1)
 11   ned = ned -1
      if(i.lt.ned) go to 7
 13   i = i + 1
      if(i.lt.ned) go to 7
c
c  now run through edits and find the first one after the start term
c  if the start term is within an edit (or close to the start of one)
c  reset it to the end of that edit
c
      do 15 kg = 1,ned
      if(st.lt.gap(2,kg)) go to 17
 15   continue
 17   if(st.gt.gap(1,kg).or.gap(1,kg)-st.le.ns) st = gap(2,kg)
      if(ifin.ne.0) then
         write(6,114)
 114     format(' output file number; ',$)
         ifout = ffin(1,not)
         call realio(x,1,1,ifout,1)
      endif
      if(st.gt.gap(1,kg)) go to 27
c  process first section (start to first gap)
      irl = st
 25   irh = irl + ns - 1
      if(ifin.ne.0) then
         call realio(x,irl,irh,ifin,0)
         if(idm.ne.1) call dtren(x,ns)
         if(iw.eq.1) call hann(x,ns)
         if(iw.eq.2) call prol(x,ns)
         do 26 kk=1,ns
 26      x(kk) = smsq*x(kk)
      endif
      irho = irlo + ns - 1
      nsec = nsec + 1
      if(ifin.ne.0) then
         call realio(x,irlo,irho,ifout,-1)
      endif
      irlo = irho + 1
      irl = irl + int(pov*ns)
      if(irl+ns-1.le.gap(1,kg)) go to 25
c  now do all sections between gaps
 27   do 33 i = kg,ned-1
      irl = gap(2,i)
 29   irh = irl + ns - 1
      if(ifin.ne.0) then
         call realio(x,irl,irh,ifin,0)
         if(idm.ne.1) call dtren(x,ns)
         if(iw.eq.1) call hann(x,ns)
         if(iw.eq.2) call prol(x,ns)
         do 31 kk=1,ns
 31      x(kk) = smsq*x(kk)
      endif
      irho = irlo + ns - 1
      nsec = nsec + 1
      if(ifin.ne.0) then
         call realio(x,irlo,irho,ifout,-1)
      endif
      irlo = irho + 1
      irl = irl + int(pov*ns)
      if(irl+ns-1.le.gap(1,i+1)) go to 29
 33   continue
      write(6,116) irho ,nsec, ifout
 116  format(i9,' points (',i4,' sections) written to file',i8,/,1x,
     $'now run power with no detrending and taper 0')
      stop
c
c  this section simply copies all 'ok' data to another file
c
 51   call edcon(ned,gap,ioff,1,fl)
      do 55 kg = 1,ned
      if(st.lt.gap(2,kg)) go to 57
 55   continue
 57   if(st.gt.gap(1,kg)) st = gap(2,kg)
      ned = ned + 1
      gap(1,ned) = fl
      write(6,114)
      ifout = ffin(1,not)
      if(ifout.lt.0) call realio(x,1,1,ifout,1)
      if(ifout.gt.0) call intio(ioff,1,1,ifout,1)
      if(st.gt.gap(1,kg)) go to 61
      call filcop(ifin,int(st),int(gap(1,kg)),ifout,irlo)
      irlo = irlo + gap(1,kg) - st + 1.
 61   do 63 i=kg,ned-1
      call filcop(ifin,int(gap(2,i)),int(gap(1,i+1)),ifout,irlo)
 63   irlo = irlo + gap(1,i+1) - gap(2,i) + 1.
      write(6,120) irlo-1,ifout
 120  format(i8,' terms written to file ',i5)
      stop
      end
