c    Program tfind
c   Program to convert between the position of a term in a time series
c   and the time at which it occurs.  Calendar algorithms used assume
c   Gregorian calendar
c
c     Written by D. C. Agnew  Nov 1980
c     Rewritten by D. C. Agnew Jul 2004 to use new calendar algoritms
c
c       calls ffin, timsubs
c
      character*1 mode,not,heduse,endsca
      character*4 month 
      dimension jt(6),kt(6),month(12),ktm(5)
      data month/'Jan ','Feb ','Mar ','Apr ','May ','June','July',
     1 'Aug ','Sept','Oct ','Nov ','Dec '/,iopt,iflg/2*0/
 3    write(6,98)
 98   format(' Mode for times (h for help); ',$) 
      dum = ffin(1,mode) 
      if(mode.eq.'d'.or.mode.eq.'m') go to 5
      if(mode.ne.'h') go to 3
      write(6,100) 
 100  format(' Modes are:',/,5x, 
     1   'm - enter year, month, day, hour, minute, second',/5x,
     2   'd - enter year, day-number, hour, minute, second')
      go to 3
 5    write(6,99)
 99   format(' Time of term 1: ',t33,'; ',$)
      jt(1) = ffin(1,heduse) 
      if(heduse.eq.'h') then
         call spec1(jt,isamp,mode)
      else 
         if(mode.eq.'d') then
           do i = 2,4
             jt(i) = ffin(1,not)
           enddo
           sec = ffin(1,not) 
           jt(5) = sec
           rem = sec - jt(5)
         endif
         if(mode.eq.'m') then
           do i = 2,5
             jt(i) = ffin(1,not)
           enddo
           sec = ffin(1,not) 
           jt(6) = sec
           rem = sec - jt(6)
         endif
      endif
      if((iopt.eq.0.or.iopt.eq.4).and.heduse.eq.'0') then
         write(6,101)
 101     format(' Sample interval (sec): ',t33,'; ',$) 
         samp = ffin(1,not)
         isamp=samp
         sampr=samp-isamp
      endif
c  set flag to show if we are dealing with fractional seconds, either
c  in start time or sample interval (but intervals exceeding 100 seconds
c  are assumed to be integer).
      iflg=0
      if(rem.gt.1.e-3) iflg = 1 
      if(samp.lt.100.and.samp-isamp.gt.1.e-3) iflg = 1
 11   write(6,102)
 102  format(' Option (h for help):; ',$)
      iopt = ffin(1,not)
      if(not.ne.'0'.and.not.ne.'h') go to 11
      if(iopt.lt.0.or.iopt.gt.4) go to 11 
      if(not.eq.'0') go to (21,13,15,5,5) iopt+1
      write(6,103)
 103  format(' Options are:',/,5x,'0 - exit',/,5x,
     1 '1 - program will give the time of a term',/,5x,
     2 '2 - program will give the term number for a time',/,5x, 
     3 '3 - reset start time',/,5x,
     4 '4 - reset start time and sample interval')
      go to 11
 13   write(6,104)
 104  format(' Term number (or xxxe): ',t33,'; ',$)
      itn=0
c  note use of ffin option to get large integers
      dum = ffin(itn,endsca)
      if(endsca.eq.'e') call spec2(itn,itn)
      call timfnd(jt,itn-1,isamp,kt,mode)
      if(mode.eq.'m') then
         min=kt(2)
         mday=kt(3)
         call toyd(kt,ktm)
         jday=ktm(2)
         ktm(3)=kt(4)
         ktm(4)=kt(5)
         ktm(5)=kt(6)
         df = ((kt(6)/60. + kt(5))/60. + kt(4))/24.
         ddf = ktm(2) + df
         yf = ktm(1) + (ktm(2)+df-1.)/(365.+leap(ktm(1)))
         write(6,105) (ktm(i),i=1,5),yf
      endif
      if(mode.eq.'d') then
         call toymd(kt,ktm)
         min=ktm(2)
         mday=ktm(3)
         jday=kt(2)
         df = ((kt(5)/60. + kt(4))/60. + kt(3))/24.
         ddf = kt(2) + df
         yf = kt(1) + (kt(2)+df-1.)/(365.+leap(kt(1)))
         write(6,105) (kt(i),i=1,5),yf
      endif
 105  format(' Time is ',t35,i5,i4,3i3,10x,'(',f9.4,')') 
C     if(iflg.eq.1) write(6,106) kyr,kt(1),kct(2),kct(3),
C    1 kct(4)+rem,yf
C106  format(' Time is ',t35,i5,i4,2i3,f7.3,10x,'(',f9.4,')')
      if(jday.lt.182) write(6,107) month(min),mday, ddf
 107  format(38x,'(',a4,i3,')',18x,f8.4) 
      if(jday.ge.182) write(6,108) month(min),mday, ddf,ddf-(365+l)
 108  format(38x,'(',a4,i3,')',9x,f8.4,' or ',f9.4) 
      go to 11
 15   write(6,109)
 109  format(' Time of term: ',t33,'; ',$)
      do i=1,5
        kt(i)=ffin(1,not)
      enddo
      if(mode.eq.'m') kt(6)=ffin(1,not)
      itn= iscnsp(jt,kt,isamp,mode)+1
      write(6,110) itn 
 110  format(' Term number is ',t35,i11) 
      go to 11
 21   stop
      end
      subroutine spec1(jt,isamp,mode)
      character*1 mode
      character*8 source,chanid
      character*4 stc,commen
      double precision scans
      dimension jt(*)
      common/head/scans,calc(4),clkc(2),sampin,nchann,iblock,istart(5),
     1     iend(5),nchf(17),ichnm(16),ncal(4),source,chanid(16),stc,
     2     commen(200)
      write(6,100)
 100  format(' Header file number           ; ',$)
      ifl = ffin(1,not)
      call headco(ifl,1)
      isamp = sampin
      if(mode.eq.'d') then
        do i=1,5
          jt(i) = istart(i)
        enddo
      endif
      if(mode.eq.'m') then
        call toymd(istart,jt)
        do i=4,6
          jt(i) = istart(i-1)
        enddo
      endif
      end
      subroutine spec2(ifl,itn)
      character*8 source,chanid
      character*4 stc,commen
      double precision scans
      common/head/scans,calc(4),clkc(2),sampin,nchann,iblock,istart(5),
     1     iend(5),nchf(17),ichnm(16),ncal(4),source,chanid(16),stc,
     2     commen(200)
C old    common/head/stc,source,calc(4),clkc(2),nchann,iblock,istart(5)
C old   1     iend(5),scans,sampin,nchf(17),ichnm(16),chanid(16),ncal(4)
C old   2     commen(200
      call headco(itn,1)
      itn = nint(scans)
      return
      end
