        program tidhar
c  fits a sum of tidal harmonics (as many as allowed by the
c  record length), and a constant and trend.  the least-square
c  coefficients may then be used to fill gaps in the series, and
c  may be printed out as well (in the form of amplitude and phase,
c  referred to the start time).  if gap-filling is to be done, the
c  series must be real.  the fitted tide may be subtracted out
c  to leave a residual series. this is written to another file. in
c  computing the residual, data in gaps is included, though it is 
c  not used in doing the fit. the removal of the constant and trend
c  from the residual is optional
c   the tidal frequencies used are ordinarily chosen from a list in
c  the data statement, in which they are ranked according to
c  potential amplitude. frequencies chosen by the user may be input also.
c
c    **calls tidnor,chol,recurs,realio
c
c  program changed to fiddle the parameters for ocean loading.
c  done by dca,fkw,tgm   4/24/81
c   reading from edits file added by dca 7/24/81
c   option to output fit instead of residual added by dca 10/1/81
c   optional removal of mean/trend from residual added by dca 11/3/81
c   display modified and input made consistent by dca 12/22/89
c   number of hamonics increased by dca 4/25/01
c
      complex ocld,fcdum
      double precision y2,arg
      dimension f(24),tf(24),a(2500),dat(60),fc(50),y2(75),y(50),
     1  tn(400),s(24),c(24),si(24),ci(24),nhar(2),d2(60),
     2   gap(2,1000),idumy(1000)
      character*4 rnme(24),rname(24)
      character*1 iynme,iyntr,not,ifl1,ifl2,ifl4,ihc,timspc
      data tn(1)/1./,nhar/12,12/,iedf/1/,iedfst/0/,ned/1000/,
     1 iynme,iyntr/2*'y'/,ifl2/'n'/
c  tidal lines included are for the major groups; semidiurnals
c  and diurnals are scanned separately.
      data rnme/24*'    '/
      data rname/'K1  ','O1  ','P1  ','Q1  ','M1  ','J1  ','OO1 ',
     1           'RHO1','SIG1','PI1 ','2Q1 ','PHI1','M2  ','S2  ',
     2           'N2  ','K2  ','NU2 ','MU2 ','L2  ','T2  ','2N2 ',
     3           'EPS2','LDA2','ETA2'/
      data tf/1.0027379,0.9295357,0.9972621,0.8932441,0.9664463,
     1        1.0390296,1.0759401,0.8981010,0.8618093,0.9945243,
     2        0.8569524,1.0082137,1.9322736,2.0000000,1.8959820,
     3        2.0054758,1.9008389,1.8645472,1.9685653,1.9972622,
     4        1.8596903,1.8282556,1.9637084,2.0417675/
  95  write(6,100)
 100  format(' File to be analyzed/interpolated (h for help); ',$)
      ifl = ffin(1,not)
      if(not.eq.'h') then 
        write(6,98 )
  98  format('  tidhar is used to fit sums of sinusoids (usually tides)',
     1' to all or part ',/2x,'of a series, which may contain gaps. ',
     2'the results of the analysis may be',/2x,'printed out, and also '
     3,'used in one of two ways:',/5x,
     4'1. to produce a residual series, which will be written to ',
     5'another file.',/5x,'2. to fill the gaps in the data.',
     6' since this writes into the file',/5x,'analysed, this file ',
     7 'must be real.')
       write(6,99)
  99   format(' the frequencies of the sinusoids',
     1' may be specified by the user or',/,'  chosen from a list',
     2' of large tidal lines. in the latter',/,'  case the tidal'
     3,' lines will be chosen to have a frequency separation',/,
     4'  of at least x/(record length), with x set by the user.'/)
        go to 95
      endif
      ifres = ifl
      write(6,102)
 102  format(' Do you want a printout of the tidal analysis (y/n); ',$)
      idum = ffin(1,ifl1)
      write(6,103)
 103  format(' Type 1 to write residuals (-1 for fit) to another ',
     1 'file; ',$)
      ifl3 = ffin(1,not)
      if(iabs(ifl3).ne.1) ifl3 = 0
      if (ifl3.ne.0) then
 51      write(6,590)
 590     format(' Do you want the residual demeaned? (y/n)      ; ',$)
         idum = ffin(1,iynme)
         if(idum.ne.0.or.(iynme.ne.'y'.and.iynme.ne.'n')) go to 51
 53      write(6,595)
 595     format(' Do you want the residual detrended? (y/n)     ; ',$)
         idum = ffin(1,iyntr)
         if(idum.ne.0.or.(iyntr.ne.'y'.and.iyntr.ne.'n')) go to 53
         write(6,600)
 600     format(' Make ocean loading corrections (y/n)?         ; ',$)
         idum = ffin(1,ifl4)
      endif
      if(ifl.gt.0.or.ifl3.ne.0) go to 1
      write(6,104)
 104  format(' Do you want to fill gaps (y/n)?               ; ',$)
      idum = ffin(1,ifl2)
c gap filling of integer files not allowed
      if(ifl2.eq.'y'.and.ifl.gt.0) stop
      if(ifl2.ne.'y') ifl2 = 'n'
 1    if(ifl1.ne.'y') ifl1 = 'n'
      write(6,106)
 106  format(' Sample interval (sec, or append m, h, or d)   ; ',$)
      sam = ffin(1,timspc)
      if(timspc.eq.'m') sam = 60*sam
      if(timspc.eq.'h') sam = 3600*sam
      if(timspc.eq.'d') sam = 86400*sam
      sam = sam/86400.
      write(6,651)
 651  format(' Use preselected tidal lines (y/n)?            ; ',$)
      idum= ffin(1,ihc)
      if(ihc.ne.'y') ihc='n'
      if(ihc.ne.'n') then 
         write(6,107)
 107     format(' Minimum spacing between harmonics (usually 1) ; ',$)
         spc = ffin(1,not)
         spc = abs(spc)
      elseif(ihc.eq.'n') then
         write(6,105)
 105     format(' Number of harmonics to use, frequencies in cpd; ',$)
         nsd = ffin(1,not)
         do 1000 i = 1,nsd
         f(i) = ffin(1,not)
 1000    f(i) = 6.283185307*sam*f(i)
      endif
 2    write(6,108)
 108  format(' Start and end terms (0,0 to stop)             ; ',$)
      st = ffin(1,not)
      en = ffin(1,not)
      if(st.eq.0.and.en.eq.0) stop
      if(en.lt.st) en=longis(ifl)
      rnt = en - st + 1
      if(ifl3.ne.0) then
	 write(6,109)
 109     format(' File for residuals (must be real)             ; ',$)
         ifres = ffin(1,not)
         if(ifres.ne.ifl) call realio(d2,1,1,ifres,1)
      endif   
      if(iedf.lt.0.and.iedfst.eq.1) go to 71
      write(6,110)
 110  format(' Number of gaps (le 1000)                      ; ',$)
      ngp = ffin(1,not)
      if(ngp.eq.0) go to 5
      if(ngp.lt.0) call edcon(ned,gap,idumy,1,1.e6)
      if(ngp.lt.0) iedf = -1
      if(ngp.lt.0) iedfst = 1
 71   write(6,112)
 112  format(' Enter bounding points of gaps (0,0 for all)   ; ',$)
      if(iedf.gt.0) go to 75
      ngp = 0
      dowgap = ffin(1,not)
      upgap = ffin(1,not)
      if(upgap.le.dowgap) then
         dowgap=st
         upgap=en
      endif
      do 73 i=1,ned
      if(gap(1,i).gt.upgap.or.gap(2,i).lt.dowgap) go to 73
      ngp = ngp + 1
      tn(2*ngp) = gap(1,i) - st + 1.
      tn(2*ngp+1) = gap(2,i) - st + 1.
      write(6,666) gap(1,i), gap(2,i)
 666  format(' gap found - ',f7.0,' to ',f7.0)
 73   continue
      go to 5
 75   do 3 i =1,ngp
      tn(2*i) = ffin(1,not) - st + 1
 3    tn(2*i+1) = ffin(1,not) - st + 1
 5    tn(2*ngp+2) = rnt
      ngp = ngp + 1
      tn(2*ngp+1) = 0
      tn(2*ngp+2) = 0
      if(ihc.eq.'n') go to 13
c  scan through harmonics (which are listed in order of potential
c  amplitude for each species), eliminating those too close in frequency
c  to one already chosen
      df = spc/(sam*rnt)
      nsd = 0
      ind = 1
      do 11 i = 1,2
      if (i.gt.1) ind = ind + nhar(i-1)
      f(nsd+1) = tf(ind)
      rnme(nsd+1)=rname(ind)
      nh = 1
      do 9 j = 1,nhar(i)-1
      do 7 k = 1,nh
      if(abs(f(nsd+k)-tf(ind+j)).lt.df) go to 9
 7    continue
c  harmonic is acceptable
      f(nsd+nh+1) = tf(ind+j)
      rnme(nsd+nh+1)=rname(ind+j)
      nh = nh + 1
 9    continue
      if(i.eq.1) nsds = nh
      nsd = nsd + nh
 11   continue
c  nsd is now the number of harmonics used
c   nsds is the number of diurnals used
 13   do 15 i = 1,nsd
      if(ihc.ne.'n') f(i) = 2.*3.1415926536*sam*f(i)
      ci(i) = cos(f(i))
 15   si(i) = sin(f(i))
      write(6,114) nsd, nsds, nsd-nsds
 114  format(1x,i4,' harmonics will be used:',4x,i4,' diurnal,',
     1 i4,' semidiurnal')
      do 18 j = 1,2*nsd+2
 18   y2(j) = 0.
      do 31 j = 1,ngp
      irl = st + tn(2*j-1) - 1
      rf = st + tn(2*j) -1.
 19   irh = min0(irl+59,int(rf))
      np = irh - irl + 1
      call realio(dat,irl,irh,ifl,0)
c  set up sine and cosine at start point of buffer
      do 21 i = 1,nsd
      arg = f(i)*(irl-st+1.d0)
      arg = dmod(arg,6.283185308d0)
      s(i) = dsin(arg)
 21   c(i) = dcos(arg)
c  add terms to right vector
      do 29 k = 1,np
      y2(1) = y2(1) + dat(k)
      y2(2) = y2(2) + dat(k)*(irl+k-st)
      do 23 l = 1,nsd
      y2(2*l+1) = y2(2*l+1) + dat(k)*c(l)
 23   y2(2*l+2) = y2(2*l+2) + dat(k)*s(l)
c  recur sine and cosine to next step
      do 25 l = 1,nsd
      d = c(l)*ci(l) - s(l)*si(l)
      s(l) = s(l)*ci(l) + c(l)*si(l)
 25   c(l) = d
 29   continue
      irl = irh + 1
      if(irl.le.rf) go to 19
 31   continue
c
c  do the inversion
c
      m = 2*nsd + 2
      do 33 i = 1,m
 33   y(i) = y2(i)
      call tidnor(a,m,f,nsd,tn,2*ngp)
      call chol(m,a,fc,y,iflag)
      if(iflag.ne.0) stop
c
c  the following section is for ocean loading corrections
c
      if(ifl4.ne.'y') go to 660
      write(6,605)
 605  format(1x,'for the following tidal frequencies type'/
     #1x,'in the admittance amplitude and phase corrections'/)
      do 610 iap=1,nsd
      write(6,615) rnme(iap)
 615  format(3x,a4,'; ',$)
      ampl=ffin(1,not)
      phas=ffin(1,not)
c convert to radians
      phrd=1.74533e-2*phas
      tmprl=ampl*cos(phrd)
      tmpim=ampl*sin(phrd)
      ocld=cmplx(tmprl,tmpim)
      ocld=conjg(ocld)
      fcdum=cmplx(fc(2*iap+1),fc(2*iap+2))
c fiddle coordinates for ocean loading
      fcdum=fcdum*ocld
      fc(2*iap+1)=real(fcdum)
 610  fc(2*iap+2)=aimag(fcdum)
 660  if(ifl3.eq.0.and.(ifl2.eq.'n'.or.ngp.eq.1)) go to 43
c
c  fill the gaps, or subtract out the fitted tides
c
      if(ifl3.ne.0) ngp = 2
      do 41 i = 1,ngp-1
      irl = tn(2*i) + st
      if(ifl3.ne.0) irl = st
      rf = tn(2*i+1) + st - 2
      if(ifl3.ne.0) rf = en
 35   irh = min0(irl+59,int(rf))
      np = irh-irl+1
      irlo = irl
      irho = irh
c  convert coefficients to their values at start of bad segment,
c  handling the mean and trend as appropriate
      off = irl-st+1
      con = 0.
      if(iynme.eq.'y') con = fc(1)
      slope = 0.
      if(iyntr.eq.'y') slope = fc(2)
      con = con + off*slope
      do 37 j = 1,nsd
      arg = dble(off)*f(j)
      sar = dmod(arg,6.28318530717959d0)
      y(2*j-1) = fc(2*j+1)*cos(sar) + fc(2*j+2)*sin(sar)
 37   y(2*j)   = fc(2*j+2)*cos(sar) - fc(2*j+1)*sin(sar)
      call recurs(dat,np,y,nsd,f,y2)
c   dat now contains the tidal terms - add in the mean and trend
      do 38 j = 1,np
 38   dat(j) = dat(j) + con + slope*(j-1.)
      if(ifl3.eq.0) go to 40
c  prepare to write out residuals or completely fit tide to
c  another file, in which case the output always starts at term 1
      if(ifl.ne.ifres) irlo = irl - st + 1
      if(ifl.ne.ifres) irho = irh - st + 1
      if(ifl3.lt.0) go to 40
c   read in data from which fit is to be subtracted to produce residual
      call realio(d2,irl,irh,ifl,0)
      do 39 j = 1,np
 39   dat(j) = d2(j) - dat(j)
 40   call realio(dat,irlo,irho,ifres,-1)
      irl = irh + 1
      if(irl.le.rf) go to 35
 41   continue
 43   if(ifl1.eq.'n') go to 2
c
c  convert harmonic coefficients to amp and phase, and print out
c   (the convention for phase is that negative phase indicates a
c    lag.  also, the phase is that for the first point.)
c
      do 45 i = 1,nsd
      y(2*i-1) = sqrt(fc(2*i+1)**2+fc(2*i+2)**2)
      cp = ci(i)*fc(2*i+1) + si(i)*fc(2*i+2)
      sp = ci(i)*fc(2*i+2) - si(i)*fc(2*i+1)
      y(2*i) = 57.2958*atan2(-sp,cp)
 45   c(i) = 48.*3.1415926536*sam/f(i)
      write(6,118) fc(1),fc(2)
 118  format(' Constant is ',g13.5,' and slope is',g13.5,/)
      write(6,120)
 120  format(10x,'Sym    period     amp        phase  ')
      write(6,122) (rnme(i),c(i),y(2*i-1),y(2*i),i=1,nsds)
 122  format(10x,a4,f8.3,g15.5,1x,f8.2)
      write(6,123)
 123  format(1x)
      write(6,122) (rnme(i),c(i),y(2*i-1),y(2*i),i=nsds+1,nsd)
      write(6,124)
 124  format(/)
      go to 2
      end
