c   program timefind
c
c      given a mode (d or m), start time (y,d,h,m,s for mode d, y,m,d,h,m,s
c    for mode m) and sample interval (sec) on the command line, reads in more
c    terms from the standard input, and writes times on the standard output
c
c      calls timfnd, getarg (the latter is Unix)
c
       character*40 arg
       character*3 wday,month
       character*1 mode
       dimension ist(6),iloc(6),iyd(3)
       if(iargc().lt.6) then
         write(6,100)
 100     format(/,'Usage: timefnd d yr day hr min sec   samp',/,
      1           '  or   timefnd m yr mon day hr min sec   samp',/,
      2           '    reads term numbers from standard input',/)
         stop
       endif
       call getarg(1,arg)
       read(arg,*) mode
       if(mode.eq.'m') narg = 7
       if(mode.eq.'d') narg = 6
       if(iargc().ne.narg+1) then
         write(6,100)
         stop
       endif
       do 3 i=2,narg
       call getarg(i,arg)
       read(arg,*) ist(i-1)
 3     continue
       call getarg(narg+1,arg)
       read(arg,*) isam
 5     read(5,*,end=7) iscans
       iscans = iscans-1
       call timfnd(ist,iscans,isam,iloc,mode)
       df = ((iloc(narg-1)/60. + iloc(narg-2))/60. + iloc(narg-3))/24.
       if(mode.eq.'d') then
         ddf = iloc(2) + df
         yf = iloc(1) + (iloc(2)+df-1.)/(365.+leap(iloc(1)))
         call toymd(iloc,iyd)
       elseif(mode.eq.'m') then
         call toyd(iloc,iyd)
         ddf = iyd(2) + df
         yf = iloc(1) + (iyd(2)+df-1.)/(365.+leap(iloc(1)))
       endif
       ddfn=ddf-(365+leap(iloc(1)))
       call monnam(iloc,month,mode)
       call weekday(iloc,wday,mode)
       if(mode.eq.'d')then
         write(6,102) (iloc(i),i=1,5),yf,month,iyd(3),ddf,ddfn,wday
 102     format(4i4,i3,1x,f10.5,1x,a3,i3,2x,f7.3,1x,f8.3,2x,a3)
       elseif(mode.eq.'m') then
         write(6,104) (iloc(i),i=1,6),yf,iyd(2),ddf,ddfn,wday
 104     format(i4,5i3,1x,f10.5,1x,'(day',1x,i3,')',
      1                                   2x,f7.3,1x,f8.3,2x,a3)
       endif
       go to 5
 7     stop
       end
