c  program totimed
c
c   writes to an ASCII file the data from an niolib file, omitting
c   data that are bad. For each term, gives the calendar date
c    GMT   yyy-jjjThh:mm:ss.xxx
c    or    yyy-mm-ddThh:mm:ss.xxx
c
c      calls flaged, edcon (editlib), timsubs
c
      character*1 not,mode,used,oform
      character*40 fout
      double precision fyr,fday
      dimension x(1000),ibad(1000)
      dimension itd1(5),itd2(5),itm1(6),itm2(6)
      data irl/1/,ibl/1000/,mode/'m'/,nout/1/
      data ibad/1000*0/
      data itm2/1970,1,0,0,0,0/
      write(6,100)
 100  format(' Data file and length; ',$)
      ifl = ffin(1,not)
      ntot = ffin(1,not)
      if(ntot.le.0) ntot=longis(ifl)
      write(6,102)
 102  format(' Start time (y-d-h-m-s, or nnnh for header);  ',$)
      itd1(1) = ffin(1,not)
      if(not.ne.'h') then
        do i=2,5
          itd1(i) = ffin(1,not)
        enddo
        write(6,104)
 104    format(' Sample interval (sec); ',$)
        samp = ffin(1,not)
      endif
      if(not.eq.'h') then
         ifh=itd1(1)
         call hedtim(ifh,itd1,itd2,irnt,samp)
      endif
      isamp=samp
      iunoff=iscnsp(itm2,itd1,1,'d')
      call toymd(itd1,itm1)
      do i=3,5
        itm1(i+1)=itd1(i)
      enddo
      write(6,108)
 108  format(' Name of output (ASCII) file; ',$)
      read(5,*) fout
      luo = 1
      open(luo,status='unknown',file=fout)
      write(6,110)
 110  format(' Skip data gaps (or fill with NaN) using edits',
     1   ' file? (y/n); ',$)
      idum = ffin(1,used)
 7    write(6,112)
 112  format(' Output format (h for list); ',$)
      idum = ffin(1,oform)
      if(oform.eq.'h') then
        write(6,114)
 114    format('Options for times are:',/,
     1         '   m: yyyy/mm/dd hh:mm:ss',/,
     2         '   d: yyyy:ddd hh:mm:ss',/,
     3         '   y: yyyy.yyyyyyyyyyy',/,
     4         '   j: ddddddd.dddddd (Julian date)',/,
     5         '   J:   ddddd.dddddd (modified Julian date)',/,
     6         '   g: yyy-dddThh:mm:ss   (for GMT--fill with Nan)',/,
     7         '   G: yyy-mm-ddThh:mm:ss (for GMT--fill with Nan)',/,
     8         '   u: ssssssssssss (Unix epoch time)')
        go to 7
      endif
c    GMT   yyy-jjjThh:mm:ss.xxx
c    or    yyy-mm-ddThh:mm:ss.xxx
c    gnuplot can read d with   set timefmt "%Y:%j %H:%M:%S"
c    gnuplot can read m with   set timefmt "%Y/%m/%d %H:%M:%S"
      if(oform.eq.'d') mode='d'
      if(oform.eq.'y') mode='d'
      if(oform.eq.'g') mode='d'
c
c   loop through data, 1000 points at a time; flag data gaps, and
c     write out data according to the format chosen
c
 11   irh = min(ntot,irl+ibl-1)
      npts = irh -irl + 1
      call realio(x,irl,irh,ifl,0)
      if(used.eq.'y') call flaged(irl,irh,rnt,ibad)
      do i=1,npts
         isc = i + irl - 2
         if(ibad(i).eq.0) then
            if(oform.eq.'m'.or.oform.eq.'G') then
               call timfnd(itm1,isc,isamp,itm2,mode)
               if(oform.eq.'m') write(luo,120)
     1          itm2(1),itm2(2),itm2(3),itm2(4),itm2(5),itm2(6),x(i)
 120           format(i4,'/',i2.2,'/',i2.2,' ',i2.2,':',i2.2,':',i2.2,
     1           '  ',f14.3)
               if(oform.eq.'G') write(luo,121)
     1          itm2(1),itm2(2),itm2(3),itm2(4),itm2(5),itm2(6),x(i)
 121           format(i4,'-',i2.2,'-',i2.2,'T',i2.2,':',i2.2,':',i2.2,
     1           '  ',f14.3)
            endif
            if(oform.eq.'d'.or.oform.eq.'g') then
               call timfnd(itd1,isc,isamp,itm2,mode)
               if(oform.eq.'d') write(luo,122)
     1           itm2(1),itm2(2),itm2(3),itm2(4),itm2(5),x(i)
 122           format(i4,':',i3.3,' ',i2.2,':',i2.2,':',i2.2,'  ',f14.3)
               if(oform.eq.'g') write(luo,123)
     1           itm2(1),itm2(2),itm2(3),itm2(4),itm2(5),x(i)
 123           format(i4,'-',i3.3,'T',i2.2,':',i2.2,':',i2.2,'  ',f14.3)
            endif
            if(oform.eq.'y') then
               call timfnd(itd1,isc,isamp,itd2,mode)
               fday=itd2(3)/24.d0 + itd2(4)/1440.d0 + itd2(5)/86400.d0
               fyr=itd2(1) + (itd2(2)+fday)/(365.d0+leap(itd2(1)))
               write(luo,124) fyr,x(i)
 124           format(f20.11,f14.3)
            endif
            if(oform.eq.'J'.or.oform.eq.'j') then
               call timfnd(itm1,isc,isamp,itm2,mode)
               fday=itm2(4)/24.d0 + itm2(5)/1440.d0 + itm2(6)/86400.d0
               jd=juldat(itm2)
               fyr=jd-0.5d0+fday
               if(oform.eq.'j') fyr=fyr-2400000.5
               write(luo,126) fyr,x(i)
 126           format(f20.6,f14.3)
            endif
            if(oform.eq.'u') then
               write(luo,128) iunoff+isc*isamp,x(i)
 128           format(i12,f14.3)
            endif
            nout = nout + 1
         endif
         if(ibad(i).eq.1) then
            if(oform.eq.'G') then
               call timfnd(itm1,isc,isamp,itm2,mode)
               write(luo,131)
     1          itm2(1),itm2(2),itm2(3),itm2(4),itm2(5),itm2(6)
 131           format(i4,'-',i2.2,'-',i2.2,'T',i2.2,':',i2.2,':',i2.2,
     1           '  ','NaN')
            nout = nout + 1
            endif
            if(oform.eq.'g') then
               call timfnd(itd1,isc,isamp,itm2,mode)
               write(luo,133)
     1           itm2(1),itm2(2),itm2(3),itm2(4),itm2(5)
 133           format(i4,'-',i3.3,'T',i2.2,':',i2.2,':',i2.2,'  ','NaN')
            nout = nout + 1
            endif
         endif
      enddo
      irl = irh + 1
      if(irl.le.ntot) go to 11
      write(6,140) nout-1
 140  format(i9,' terms written out')
      stop
      end
