      subroutine shoget(x,erase,iid)
      logical iblank,allblk,blnkit,sync
      common/edits/igap(2,4000),ioff(4000),ned
c   gets a data series off disc file ifl and displays it on screen,
c   decimating as necessary to get it to one screen's worth.  data
c   shown is returned in x.  screen is erased if erase ne 0.  if iid ne
c   0, call a program to edit data before displaying it.
      common/sam/itl,ith,idec,ie,ymin,ymax,isc,ifl,irntot
c   itl, ith are input as beginning, end term numbers of series as wanted
c   and are returned as beginning and end terms displayed
c   idec is decimation factor
c   ie is number of points in x
c   ymin, ymax are limits on series as plotted
c   if isc = 1, data is self-scaled, and ymin and ymax are set from it
c   if isc not = 1, data is clipped to fall between ymin and ymax
c   irntot is the total number of terms in the file
      common/tkcon/isp,nmsec
c   isp governs positioning of alpha cursor.
      common/fade/iblank(1020),allblk,blnkit,sync
c   if iblank(i) is true, lift pen when plotting to the i-th point
c   if allblk is true, plot no points; if blnkit is false, ignore
c   both of these and plot everything
      common/scrpd/ibadpt(500),ibpind,numbad,modepr
c   used for predetermined bad points -- see predic
c
c  calls send12 (in grafic), realio (in libnio), xedit
c
      dimension x(1020),buf(510)
c  check for file readability and return if not OK (plotting other files only)
      lll = longis(ifl)
      if(erase.ne.0.or.(ith.le.lll.and.lll.gt.0)) go to 25
      if(lll.le.0) write(6,102) ifl
 102  format(' File ',i8,' could not be found')
      if(lll.gt.0.and.ith.gt.lll) write(6,104) ifl
 104  format(' File ',i8,' is too short')
      return
 25   do 23 i=2,1020
 23   iblank(i) = .false.
      iblank(1) = .true.
      allblk = .false.
c  if necessary the above will be reset by xedit
      itl = max0(itl,1)
      ith = min0(ith,irntot)
      if(sync)call crsync(itl,ith,iedtot,1)
c   blank screen (if requested) before getting data, reset alpha
c   cursor counter, and wait after blanking screen
      if(erase.eq.0) go to 1
      call send12(-9,0,0)
      isp = 3
      do 21 i=1,96
 21   call send12(-10,0,0)
 1    idec = (ith-itl)/1020 +1
      if(idec.eq.1) go to 5
c   decimate
      l = 1
      ie = 1
      ib1 = itl
 2    ib2 = min0(ib1+509,ith)
      nt = ib2 - ib1 + 1
      if(l.gt.nt) go to 4
      call realio(buf,ib1,ib2,ifl,0)
      m = idec*((nt-l)/idec) + l
      do 3 k = l,m,idec
      x(ie) = buf(k)
 3    ie = ie + 1
      l = m - 510 + idec
      ib1 = ib2 + 1
      if(ib1.le.ith) go to 2
 4    ie = ie - 1
      ith = itl + (ie-1)*idec
      go to 7
c   get data without decimating
 5    call realio(x,itl,ith,ifl,0)
      if(ierror.eq.1) return
      ie = ith - itl + 1.
 7    if(iid.ne.0) call xedit(x)
      if(isc.ne.1) go to 9
c   self-scale limits
      ymin = x(1)
      ymax = ymin
      do 8 i = 2,ie
      ymin = amin1(ymin,x(i))
  8   ymax = amax1(ymax,x(i))
      go to 13
c   clip data to limits
  9   do 11 i = 1,ie
      x(i) = amin1(x(i),ymax)
 11   x(i) = amax1(x(i),ymin)
c   prepare to plot
 13   dy = ymax - ymin
      if (dy.le.0.) dy = 1.
      fac = 780./dy
      delx = 1020./(ie-1.)
      write(6,110) ymin,ymax,itl,ith
 110  format(3x,'plot lying between ',2g12.5/
     1  2x,'sample ',i8,' to sample ',i8)
c   go into graphics mode and display data, unless there are only
c   edited points to plot and they will be blanked
      if(allblk.and.blnkit) go to 20
      do 19 j = 1, ie
      if((.not.blnkit.or.(.not.iblank(j))).and.j.ne.1)
     1  call send12(int(delx*(j-1)),int((x(j)-ymin)*fac),1)
      if((blnkit.and.iblank(j)).or.j.eq.1)
     1  call send12(int(delx*(j-1)),int((x(j)-ymin)*fac),2)
c   return to alpha mode
 19   continue
      call send12(-11,0,0)
      call send12(0,0,-1)
 20   if(erase.eq.0.and.iid.eq.0) call retnio(ifl)
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Subroutine predic(x,ibpl,res)
c  scans a data series with a predictor error filter, exiting 
c  when the residual exceeds a preset amount.  ibpl is the term
c  number of the bad point, res the residual.  scanning begins
c  at a set point in the series.
c
c   calls iolib, and is meant to be called by credit
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine predic(x,ibpl,res)
      character*1 not
      dimension x(1),psw(14,2),wt(40),nwprs(2)
c  psw holds preset weights.  wt is array actually used; number
c  of weights is nw; nwprs is number in preset weights series.
      common/sam/itl,ith,idec,ie,ymin,ymax,isc,ifil,irntot
      common/pred/errmax,ibef,iaft,ibecon,fml,sd,tsd,ivrj,sumsq
c  errmax is the maximum acceptable residual.  ibef and iaft
c  govern how much data is displayed before and after a bad point.
c  ibecon is the point at which the convolution starts (the first
c  term checked is thus ibecon+nw.
c  ivrj governs whether or not the error criterion is varied
c  by forming a filtered version of the residual variance.
c  fml governs the "filter length", sd is the standard deviation,
c  tsd the number of standard deviations that is acceptable, and
c  sumsq the current value of the sum of squares of residuals
c  (as these should have zero mean, this is a good estimate of
c  the variance).
      common/scrpd/ibadpt(500),ibpind,numbad,modepr
c  scrpd is used for keeping a list of possible bad points, 
c  previously flagged using the cursor.  numbad is the number of
c  such points still to be looked at (they are assumed
c  to be in increasing order), and ibpind the pointer to the next
c  one. If modepr is < 0, this is the only edits check used; the
c  prediction-error filtering is disabled.
c
      data psw/.20173,-.066239,-.066611,-.0668,-.066805,-.066628
     1,-.066268,-.065726,-.065004,-.064105,1.3925,-1.,2*0.
     2,.16813,-.045148,-.045383,-.045530,-.045591,-.045566,-.045453,
     3-.045254,-.044969,-.044598,-.044143,-.043603,1.3271,-1./,
     4 nwprs/12,14/
      data iflg/0/,tn/1./
      if(modepr.lt.0) go to 41
      if(iflg.ne.0) go to 21
      iflg = 1
c  ask startup questions
 2    write(6,100)
 100  format(' Weights to use (0 for external file,',
     & ' -1 for explanation) ',$)
      iw = 2 + ffin(1,not)
      go to (3,6,9,12,12) iw
 3    write(6,102)
 102  format(' Available weights are',/t10,
     &'1 - linear predictor',/t10,'2 - six minute tidal',
     &' (12 points)',/t10,'3 - five minute tidal (14 points)',/)
      go to 2
 6    write(6,104)
 104  format(' File number, start term, number of terms ',$)
      ifwt = ffin(1,not)
      ist = ffin(1,not)
      inw = ffin(1,not)
      call realio(wt,ist,ist+inw-1,ifwt,0)
      call retnio(ifwt)
      nw = ist+inw-1
      go to 15
c  compute linear predictor weights
 9    write(6,106)
 106  format(' Number of weights (le.40) ',$)
      nw = ffin(1,not)
      if(nw.gt.40) go to 9
      wt(nw+1) = -1
      wt(nw) = 4./nw
      do 10 i = 1,nw-1
 10   wt(nw-i) = wt(nw-i+1)- (6./float(nw*(nw-1)))
      nw = nw + 1
      go to 15
c  put in preset weights
 12   nw = nwprs(iw-3)
      do 13 i = 1,nw
 13   wt(i) = psw(i,iw-3)
 15   write(6,108)
 108  format(' Largest o.k. residual (- for adaptive) ',$)
      errmax = ffin(1,not)
      if(errmax.gt.0) go to 20
      errmax = -errmax
      ivrj = 1
      write(6,110)
 110  format(' Averaging length for variance estimate ',$)
      fml = ffin(1,not)
      gamma = (fml-1)/fml
      write(6,112)
 112  format(' Rejection level (st. dev.''s) ',$)
      tsd = ffin(1,not)
      sd = errmax/tsd
 20   write(6,114)
 114  format(' Number of terms to show before, and after, '
     1,'bad point ',4x,' ',$)
      ibef = ffin(1,not)
      iaft = ffin(1,not)
      ibef = abs(ibef)
c
c  begin convolution, starting with "last good point" (ibecon)
c
 21   irl = ibecon
 22   irh = min0(irl+999,irntot)
      le = irh - irl + 1
      call realio(x,irl,irh,ifil,0)
      do 27 i = nw,le
      ibpl = irl+i-1
      res = 0.
      do 24 j = 1,nw
 24   res = res + wt(j)*x(i-nw+j)
      if(abs(res).gt.errmax) go to 33
c  have passed the convolution test - now see if the point is one
c  previously labelled as bad.  if we are beyond the currenitly
c  labelled bad point, increment the counter.
      if(numbad.eq.0.or.ibadpt(ibpind).gt.ibpl) go to 25
      if(ibadpt(ibpind).eq.ibpl) go to 33
      numbad = numbad -1
      ibpind = mod(ibpind,500) + 1
c  update estimate of the varince.  until fml terms have been
c  processed, use preset value of errmax as rejection level.
 25   if(ivrj.eq.0) go to 27
      sumsq = sumsq + res*res
      tn = amin1(tn+1,fml)
      if(tn.ne.fml) go to 27
      sd = sqrt(sumsq/fml)
      errmax = tsd*sd
      sumsq = sumsq*gamma
 27   continue
      if(irh.lt.irntot) go to 30
c  at end of file - return with ibpl flagged
      ibpl = -1
      return
c  get another buffer load, leaving overlap for filter
 30   irl = irh - nw + 2
      go to 22
c  found a bad point - return, presetting limits for shoget
 33   itl = ibpl - ibef
      ith = ibpl + iaft
      return
 41   if(iflg.eq.0) then
         iflg = 1
         write(6,114)
         ibef = ffin(1,not)
         iaft = ffin(1,not)
         ibef = abs(ibef)
      endif
      ibpl=ibadpt(ibpind)
      ibpind=ibpind+1
      itl = ibpl - ibef
      ith = ibpl + iaft
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Subroutine xedit
c   subroutine for editing a (possibly decimated) series, described
c   by the data in common block sam, according to the edit
c   commands in common block edits.  the number of edits is ned,
c   and the bounding points of the edits are in igap
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine xedit(x)
      logical iblank,allblk,blnkit,sync
      dimension x(1020)
      common/edits/igap(2,4000),ioff(4000),ned
      common/sam/itl,ith,idec,ie,ymin,ymax,isc,ifil,irntot
      common/fade/iblank(1020),allblk,blnkit,sync
      nt0 = 1
      offset = 0.
c
c   loop through edits
c
      do 5 i = 1,ned
      isted = igap(1,i)
      iened = igap(2,i)
c
c  if all of data is in a gap, exit loop and flag this
c
      if(isted.lt.itl.and.iened.gt.ith) go to 19
c
c   if end of edit falls before start of series, go to next one
c
      if(iened.le.itl) go to 5
c
c   if start of edit falls after end of series, exit loop
c
      if(isted.gt.ith) go to 15
c
c   compute where in array edit edges fall
c
      nt1 = (isted-itl)/idec + 1
      nt2 = (iened-itl+idec-1)/idec + 1
c
c   gap starts before start of data shown -- make data constant,
c    and blanked. Here and later we blank the point at nt2, so that
c    the first visible line is from that point to the next one
c
      if(isted.lt.itl) then
         do n = 1,nt2-1
            x(n) = x(nt2)
            iblank(n) = .true.
         enddo
         iblank(nt2) = .true.
         nt0 = nt2
         go to 5
      endif
c
c offset the data from the last edit (nt0) to the start of the current one
c
      do n = nt0, nt1
         x(n) = x(n) + offset
      enddo
c
c current edit runs off end of data shown--can return when done
c
      if(iened.gt.ith) then
         do n = nt1+1,ie
            x(n) = x(nt1)
            if(n.ne.ie) iblank(n) = .true.
         enddo
         return
      endif
c
c  current edit falls within data span--interpolate and blank the data
c  nt1 and nt2 are start and end of the current edit
c
      offset = offset + ioff(i)
      do n = nt1+1,nt2-1
         iblank(n) = .true.
         x(n) = x(nt1) + (n-nt1)*((x(nt2)+offset-x(nt1))/(nt2-nt1))
      enddo
      iblank(nt2) = .true.
      nt0 = nt2
 5    continue
c
c   either next edit is out of range, or we have used them all -
c   offset remaining points, to the end
c
 15   do n = nt0,ie
         x(n) = x(n) + offset
      enddo
      return
c
c   no data in range
c
 19   do n = 1,min0(nt2,1000)
          x(n) = 666.
      enddo
      allblk = .true.
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Subroutine showedits
c
c  This routine plots a line across the top of the screen which goes
c  up to show the edits contained in the file  infile  with file length
c   ifirntt. Two levels of line are 750 and 775
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine showedits(infile,ifirntt)
      common/sam/itl,ith,idec,ie,ymin,ymax,isc,ifl,irntot
      dimension lgap(2,4000), iioff(4000)
      data idown,iup/750,775/
      nned = 4000
      call fedcon(nned,lgap,iioff,1,ifirntt,infile)
      itl = max0(itl,1)
      ith = min0(ith,irntot)
      fdec = (float (ith-itl+1))/1020.0 
      do i=1,96
        call send12(-10,0,0)
      enddo
      call send12(0,iup,2)
      i=1
      iwhereami=0
      if (nned.eq.0) then 
         call send12(0000,idown,2)
         call send12(1020,idown,1)
         go to 5
      endif
 3    if (lgap(1,i).gt.ith) then
         call send12(iwhereami,idown,2)
         call send12(1020,idown,1)
         go to 5
      endif
      if (lgap(1,i).ge.itl) then
         call send12(iwhereami,idown,2)
         iwhereami = int((lgap(1,i)-itl+0.5)/fdec) 
         call send12(iwhereami,idown,1)
         call send12(iwhereami+(int (1.0/fdec)),iup,1)
      endif
      if (lgap(2,i).gt.ith) then
         call send12(1020,iup,1)
         go to 5
      endif
      if (lgap(2,i).ge.itl) then
         iwhereami = int((lgap(2,i)-itl+0.5)/fdec) 
         call send12(iwhereami - (int (1.0/fdec)),iup,1)
         call send12(iwhereami,idown,1)
      endif
      i=i+1
      if (i.gt.nned) then
         call send12(iwhereami,idown,2)
         call send12(1020,idown,1)
         go to 5
      endif
      go to 3
 5    do i=1,96
         call send12(-10,0,0)
      enddo
      call send12(-11,0,0)
      call send12(0,0,-1)
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Subroutine limset
c ymin and ymax are the limits; if isc is ne 0 they are ignored and the
c  data will be self-scaled. the operations done are:
c     iopt = 1   set limits and permanent limits
c            0   set limits
c           -1   reset limits from permanent limits
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine limset(ymin,ymax,isc,iopt)
      character*1 not
      save savmin,savmax,isav
      data savmin/0.0/,savmax/0.0/,isav/1/
      if(iopt.lt.0) then
         ymin = savmin
         ymax = savmax
         isc = isav
         return
      endif
      write(6,100)
 100  format(' Plot limits        ',$)
      ymin = ffin(1,not)
      ymax = ffin(1,not)
      isc = 0
      if(ymin.ge.ymax) isc = 1
      if(iopt.eq.0) return
      savmin = ymin
      savmax = ymax
      isav = isc
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Subroutine getlinfit
c
c   reads in data from file between terms i1 and i2, skipping any edited
c    parts (but including any offsets), and fits a line a+bx to the data
c    for the L1 norm; iz is the term number taken to be the "zero" point
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine getlinfit(i1,i2,iz,a,b)
      integer ioff
      dimension x(10000),y(10000),d1(10000),in1(10000),d2(10000)
      common/sam/itl,ith,idec,ie,ymin,ymax,isc,ifil,irntot
      common/edits/igap(2,4000),ioff(4000),ned
      off=0.
      ind=0
c
c  loop through edits, identifying stretches of good data and reading 
c    them in with the appropriate offset
c
      do j=1,ned+1
         if(j.eq.1) il=1
         if(j.gt.1) il=igap(2,j-1)
         if(j.le.ned) ih=igap(1,j)
         if(j.gt.ned) ih=irntot
         if(ih.gt.i1.and.il.lt.i2) then
           il=max(il,i1)
           ih=min(ih,i2)
           call realio(y(ind+1),il,ih,ifil,0)
           do i=1,ih-il+1
             y(ind+i)=y(ind+i)+off
             x(ind+i)=i+il-1-iz
           enddo
           ind=ind+ih-il+1
         endif
         off=off+ioff(j)
      enddo
      iter=-1
      call desl1m(x,y,ind-1,d1,d2,in1,a,b,iter)
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Subroutine crsync
c
c  passes limits into or out of a file; when limits are written in, the
c    file is deleted first, to prevent accumulation
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine crsync(itl,ith,iedone,idir)
      data lu/3/
      logical isit
      if(idir.gt.0) then
        open(lu,file="tmp.credsync")
        rewind(lu)
        write(lu,100) itl,ith,iedone
 100    format(3i8)
        close(lu)
      endif
      if(idir.lt.0) then
        inquire(file="tmp.credsync",exist=isit)
        if(isit) then
          open(lu,file="tmp.credsync")
          read(lu,100) itl,ith,iedone
          close(lu)
        else
         stop
        endif
      endif
c remove the file
      if(idir.eq.0) then
        call system("rm tmp.credsync")
      endif
      return
      end
