       program nscale
c      modified 7/9/80   by f. wyatt  to properly intergerize, etc
c
c      rewritten to include new features :
c      * option to read in an edit file to nscale a large
c        number of data files which need the same editing.
c      * in manual entries of editing data, allows repeat
c        entries of a section if it is not contiguous with
c        or overlapped the preceeding section.
c      note : when overwriting, sections must be contiguous
c             and non-overlapping.
c             for non-overwritting case, sections don't have
c             to be contiguous but they can't overlap each
c             other.
c      * real or integer output regardless of type of input.
c      * offsets don't accummulate.
c      * integer overflow checking. will write out which first
c        term of the original data file will cause overflow
c        (nscale term will be out of range +-2147483647), and will
c        write out last term affected by nscale.
c        of course, this check only applies to integer output.
c
c      feb-15-1983   nguyen-phan-trung.
c      jun-07-1983   nguyen-phan-trung.
c      oct-13-2004   D. C. Agnew
c
c
      dimension x(600),ix(600),it1(50),it2(0:50),scale(50),offset(50)
      character*1 ians,iovw,iyn
      data nout,it2(0),icod1,icod2,iterm1,iterm2/0.0,5*0/
      data iovw/'n'/
10    write(6,500)
500   format(' program to scale  1 to n sections of the same file '
     *,/,    ' what option (n for normal, a auto, & h for help)?; ',$)
      idum=ffin(1,ians)
      if(ians.eq.'m'.or.ians.eq.'n'.or.ians.eq.'0') go to 20
      if(ians.eq.'a') go to 150
      write(6,510)
510   format(' scaling operation allows overwriting of input.')
      write(6,520)
520   format(' options are :',/,6x,'m for manual entries of
     * sections',1h',' data',/,6x,'a for automatic reading of
     * a file which',/,8x,'has these entries (the first term of
     * this',/,8x,'data file is the # of sections, then first'
     * ,/,8x,'and last term, scale factor, and offset).',/,8x,
     *'this option allows you to use the same edit',/,8x,'file to
     * nscale an infinite # of data file.')
      go to 10
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c this section does option 'm'                                       c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
20    write(6,540)
540   format(' input  file #                                   ; ',$)
      infile=ffin(1,not)
      write(6,560)
560   format(' output file #   (real(neg #) or int(pos #))     ; ',$)
      ioufi=ffin(1,not)
      if(ioufi.eq.infile)iovw='y'
40    write(6,620)
620   format(' number of sections (50 maximum)                 ; ',$)
      nsect=ffin(1,not)
      if(nsect.gt.50) go to 40
c looping through sections and checking
      do 60 i=1,nsect
50    write(6,640)i
640   format(1x,i2,') first term, last, scale factor, offset  ; ',$)
      it1(i)=ffin(1,not)
      it2(i)=ffin(1,not)
      if(it2(i).le.0) it2(i)=longis(infile)
      scale(i)=ffin(1,not)
      offset(i)=ffin(1,not)
c check for overlapping
      if( (i.gt.1).and.(it1(i).lt.(it2(i-1)+1)) ) then
         write(6,680)
680      format(' no overlapping allowed')
         go to 50
      endif
c when overwriting, sections must be contiguous and the first term
c of the first section must be the first term of input file.
c overwriting and contiguous. keep going.
      if(iovw.eq.'y'.and.it1(i).eq.(it2(i-1)+1))go to 60
c overwriting and non-contiguous. re-do the section.
      if(iovw.eq.'y'.and.it1(i).gt.(it2(i-1)+1))write(6,700)
700   format(' overwriting. sections must be contiguous.')
      if(iovw.eq.'y'.and.it1(i).gt.(it2(i-1)+1))go to 50
c not overwriting and sections are not contiguous.
c user can change data of just-entered section and make it
c contiguous with the preceeding one.
c in this case, all sections are joined and written to output
c file after being nscaled.
      if(iovw.eq.'n'.and.it1(i).eq.(it2(i-1)+1))go to 60
      write(6,720)
720   format(' section not contiguous. want it this way (y/n)?; ',$)
      idum=ffin(1,iyn)
      if(iyn.eq.'n')go to 50
c normal case : no overwriting, contiguous sections.
60    continue
c overwriting, don't want to open output file.
      if(iovw.eq.'y')go to 70
      terms=it2(nsect)-it1(1)+1.0
      if(ioufi.lt.0)call realio(x,1,1,ioufi,1)
      if(ioufi.gt.0)call intio(ix,1,1,ioufi,1)
70    iword1=it1(1)
c
c   begin scaling procedure
c
      do 140 i=1,nsect
      if(scale(i).eq.1.0.and.offset(i).eq.0.0.and.iovw.eq.'y')
     * iterm2=it2(i)
      if(scale(i).eq.1.0.and.offset(i).eq.0.0.and.iovw.eq.'y')
     * goto 139
80    iword2=min0(iword1+599,int(it2(i)))
      length=iword2-iword1+1
      if(infile.lt.0)call realio(x,iword1,iword2,infile,0)
      if(infile.lt.0)go to 100
      if(infile.gt.0)call intio(ix,iword1,iword2,infile,0)
      do 90 j=1,length
90    x(j)=float(ix(j))
100   do 110 j=1,length
      x(j)=x(j)*scale(i)+offset(i)
110   continue
      iterm1=iterm2+1
      iterm2=iterm1+length-1
      nout=nout+(iterm2-iterm1+1)
      if(ioufi.lt.0)call realio(x,iterm1,iterm2,ioufi,-1)
      if(ioufi.lt.0)go to 130
      do 120 j=1,length
      if(abs(x(j)).gt.2147483647.0)iyn='o'
      if(abs(x(j)).gt.2147483647.0)go to 145
      ix(j)=nint(x(j))
120   continue
      call intio(ix,iterm1,iterm2,ioufi,-1)
130   iword1=iword2+1
      if(iword1.le.it2(i))go to 80
139   iword1=it1(i+1)
140   continue
      if(ioufi.eq.infile) write(6,760)nout,ioufi
      if(ioufi.ne.infile) write(6,740)nout,infile,ioufi
740   format('  **> ',i8,' terms from file ',i7,'  have been scaled',
     */,     '    and written to output file ',i7)
760   format(' **> ',i8,' terms in file ',i7,' were scaled.')  
      stop
145   iterm1=iword1-1
      if((iword2-it1(i)).le.600.0)iterm1=it2(i-1)
      write(6,770)iword1-1+j,iterm1
770   format(' *** term ',i7,' will cause integer overflow.',/,
     *5x,'(output will be out of range +-2147483647)',/,
     *5x,'last nscale was done on term ',i7)
      stop
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c this section does option 'a'                                     c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
150   write(6,780)
780   format(' enter edit file number  ; ',$)
      iedi=ffin(1,not)
      call realio(x,1,1,iedi,0)
      nsect=int(x(1))
      call realio(x,2,nsect*4,iedi,0)
      call retnio(iedi)
      j=1
      do 160 i=1,nsect
      it1(i)=x(j)
      it2(i)=x(j+1)
      scale(i)=x(j+2)
      offset(i)=x(j+3)
      j=j+4
160   continue
      do 170 i=1,nsect
c check for overlapping
      if(it1(i).lt.(it2(i-1)+1))write(6,800)i,i-1,i-1,it2(i-1),i,it1(i)
800   format(' section ',i2,' overlaps section ',i2,/,8x,
     *'section ',i2,' ends at term',f7.0,/,8x,'section ',i2,'
     * starts at term',f7.0)
      if(it1(i).lt.(it2(i-1)+1))icod1=-1
c check for non-contiguous
      if(it1(i).gt.(it2(i-1)+1))icod2=1
      if(it1(i).gt.(it2(i-1)+1))write(6,820)i,i-1,i-1,it2(i-1),i,it1(i)
820   format(' section ',i2,' is not contiguous with section ',i2,
     */,8x,'section ',i2,' ends at term',f7.0,/,8x,'section ',i2,'
     * starts at term',f7.0)
170   continue
      if(icod1.eq.-1)stop ' ***> overlapping sections. can not do.'
180   write(6,840)
840   format(' input file #                              ; ',$)
      infile=ffin(1,not)
      write(6,880)
880   format(' output file #                             ; ',$)
      ioufi=ffin(1,not)
      if(ioufi.eq.infile)iovw='y'
      if(iovw.eq.'y'.and.icod2.ne.0)stop ' ***> sections are not
     * contiguous. can not overwrite.'
      if(iovw.eq.'y')go to 200
c overwriting, don't want to open output file.
      terms=it2(nsect)-it1(1)+1.0
      if(ioufi.lt.0)call realio(x,1,1,ioufi,1)
      if(ioufi.gt.0)call intio(ix,1,1,ioufi,1)
200   iword1=it1(1)
c
c   begin scaling procedure
c
      do 270 i=1,nsect
      if(scale(i).eq.1.0.and.offset(i).eq.0.0.and.iovw.eq.'y')
     * iterm2=it2(i)
      if(scale(i).eq.1.0.and.offset(i).eq.0.0.and.iovw.eq.'y')
     * goto 269
210   iword2=min0(iword1+599,int(it2(i)))
      length=iword2-iword1+1
      if(infile.lt.0)call realio(x,iword1,iword2,infile,0)
      if(infile.lt.0)go to 230
      if(infile.gt.0)call intio(ix,iword1,iword2,infile,0)
      do 220 j=1,length
220   x(j)=float(ix(j))
230   do 240 j=1,length
      x(j)=x(j)*scale(i)+offset(i)
240   continue
      iterm1=iterm2+1
      iterm2=iterm1+length-1
      nout=nout+(iterm2-iterm1+1)
      if(ioufi.lt.0)call realio(x,iterm1,iterm2,ioufi,-1)
      if(ioufi.lt.0)go to 260
      do 250 j=1,length
      if(abs(x(j)).gt.2147483647.0)iyn='o'
      if(abs(x(j)).gt.2147483647.0)go to 280
      ix(j)=nint(x(j))
250   continue
      call intio(ix,iterm1,iterm2,ioufi,-1)
260   iword1=iword2+1
      if(iword1.le.it2(i))go to 210
269   iword1=it1(i+1)
270   continue
c closing input and output files
      call retnio(infile)
      if(ioufi.ne.infile) call retnio(ioufi)
      if(ioufi.eq.infile) write(6,940)nout,ioufi
      if(ioufi.ne.infile) write(6,920)nout,infile,ioufi
920   format(1x,i8,' terms from file ',i7,' have been scaled',/,1x,
     *' and written to output file ',i7,//)
940   format(1x,i8,' terms in file ',i7,' were scaled.',//)
      iterm1=0
      iterm2=0
      nout=0
      iovw='n'
      write(6,960)iedi
960   format(' **> type 1 to nscale another data file using edit
     * file ',i4,/,10x,'2 to nscale with a different edit file',/,
     *10x,'0 to exit ',/,4x,' your choice ?; ',$)
      idum=ffin(1,not)
      if(idum.eq.1)go to 180
      if(idum.eq.2)go to 150
      stop
280   iterm1=iword1-1
      if((iword2-it1(i)).le.600)iterm1=it2(i-1)
      write(6,770)iword1-1+j,iterm1
      stop
      end

