      program select 
c
c version 2.0    8/85 dh
c  1) added option d, straight decimation with demultiplexing
c  2) added option f
c  3) removed option s (straight decimation, no multiplexing)
c modified 8/86 dh: various format changes; list of files for input
c
c this is a decimation program with three options :
c     option d straight decimation with demultiplexing
c     option m picks out and saves the maximum and
c              minimum values of a range of data
c              points. the range is defined by 2
c              times the given decimation factor.
c     option f uses a file to select terms from an
c              input file and places these terms in
c              an output file
c the program converts data from real to integer or
c vice versa when input file type is different from
c output file type (negative file number is considered
c as real and positive as integer).
c
c written from existing sort and seive programs.
c jan 19 1983, nguyen-phan-trung
c
c
      parameter (MAXINF=20)
      dimension iy(600),x(600),y(600)
      dimension infile(MAXINF)
      integer enterm
      character*1 ians
      data iterm1,iterm2,ispace/3*0/
      data nfiles/-1/
3     write(6,560)
560   format(' what option (h for help); ',$)
      idum=ffin(1,ians)
      if(ians.eq.'h')go to 4
      if (ians .eq. 'd' .or. ians .eq. 'm' .or. ians .eq. 'f') goto 5
4     write(6,570)
570   format(' options are :',/,10x,
     2 'd for straight decimation with demultiplexing',/,10x,
     3 'm for maximum-minimum value decimation',/,10x,
     4 'f for term selection using a pointer file')
      go to 3
5     write(6,500)
500   format(' input files (0 to end list)::; ',$)
      call listin(infile,nfiles,0)
c
c loop for all the input files
c
      do 900 il=1,nfiles
c
c if demultiplexing option chosen go to it
c
      if (ians .ne. 'd') goto 6
      call demux(infile(il),il)
      goto 900
c
c get output file (options m and f)
c
6     write(6,580)infile(il)
580   format(1x,'*** INPUT FILE # ',i5,' ***',/,
     1       1x,'output file; ',$)
      ioufi=ffin(1,not)
      if(ioufi.eq.infile(il))write(6,600)
600   format(' output file must be different from input file')
      if(ioufi.eq.infile(il))go to 5
c
c start and end terms, decimation not relevant to option 'f'
c
      if (ians .ne. 'f') goto 7
      dterms = filopt(infile(il),ioufi,il)
      goto 110 
c
c if here then 'm' chosen
c only ask questions first time thru
7     if (il .ne. 1) goto 10
      write(6,520)
520   format(' start term and end term; ',$)
      start=ffin(1,not)
      enterm=ffin(1,not)
      if(enterm.le.0) enterm=longis(infile(1))
      write(6,540)
540   format(' decimation factor; ',$)
      dfac=ffin(1,not)
c
c calculating the interval for option m.
c
      idfac=int(dfac)*2
c
10    iword1=start
      dterms=0.0
c
c opening output file.
c
      if (ioufi.lt.0)call realio(y,1,1,ioufi,1)
      if (ioufi.gt.0)call intio(iy,1,1,ioufi,1)
c looping through input data, loops start here.
c preparing word2 of input data.
15    iword2=min0(iword1+599,enterm)
      nterms=(iword2-iword1)+1
c reading a buffer of input to real array.
      call realio(x,iword1,iword2,infile(il),0)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c this section does maximum-minimum decimation.                    c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      if(nterms.lt.idfac)go to 109
c getting the maximum number of intervals out of the buffer.
c ispace is also used as the adjusting number for the next word1.
      ispace=-(mod(nterms,idfac))
      nterms=nterms+ispace
c decimation.
      ii=1
      do 50 i=1,nterms,idfac
      y(ii)=x(i)
      y(ii+1)=x(i)
      do 45 j=i,i+idfac-1
      y(ii)=amax1(x(j),y(ii))
      y(ii+1)=amin1(x(j),y(ii+1))
45    continue
      ii=ii+2
      dterms=dterms+2
50    continue
      ii=ii-1
c
c writing the decimation array to output file.
c conversion from real to integer or vice versa is also done here.
c
70    iterm1=iterm2+1
      iterm2=iterm1+(ii-1)
      if(ioufi.lt.0)call realio(y,iterm1,iterm2,ioufi,-1)
      if(ioufi.lt.0)go to 105
      do 80 i=1,ii
      iy(i)=nint(y(i))
80    continue
      call intio(iy,iterm1,iterm2,ioufi,-1)
c calculating the next word1 of input data.
105   iword1=iword2+ispace+1
      if(iword1.lt.enterm) go to 15
c
c option m is done...close input and output files
109   call retnio(infile(il))
      call retnio(ioufi) 
c
c options m and f end up here to indicate output file size
110   write(6,620)dterms,ioufi
620   format(1x,'a decimated series of ',f8.0,' has been written to
     * file ',i7)
c
c main loop (il) end
900   continue
120   stop
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c subroutine demux performs straight decimation with demultiplexing
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine demux(infile,inum)
      dimension idecs(32),ist(32),ifiles(32),y(640),x(640),ix(640)
      dimension iterms(32)
      save icycl,istm,iendm,idecs,nchans
      data iterms/32*0/
c
c only get input parameters on first time thru
      if (inum .ne. 1) goto 601
c
      write(6,500)
500   format(' enter cycle length, start term, and end term; ',
     1 $)
      icycl = ffin(1,not)
      istm = ffin(1,not)
      iendm = ffin(1,not)
10    write(6,600) icycl
600   format(' enter positions within cycle (<= ',i5,')',/,
     1 ' there may be no more than 32 of these.',/,
     2 ' terminate list with -1::; ',$)
c let listin sort the positions
      nchans = 0
      call listin(idecs,nchans,-1)
      if (nchans .gt. 32) goto 10
c
c check correctness of positions; get corresponding output files
c
601   itemp = nchans
c ist array keeps track of where we are in each file
      do 602 i=1,32
602   ist(i) = 1
      write(6,605)infile
605   format(' *** INPUT FILE # ',i5)
      do 15 i=1,nchans
      if (idecs(i) .gt. icycl) goto 14
      write(6,610) idecs(i) 
610   format(' enter n(',i2,') term output file; ',$)
      ifiles(i) = ffin(1,not)
      goto 15
14    write(6,615) idecs(i)
615   format(' illegal position (',i3,'), ignoring')
      itemp = itemp-1
15    continue
      nchans = itemp
c
c check for really screwy input
c
      if (nchans .gt. 0) goto 16
      write(6,616)
616   format(' no output file written')
      return
c
c read input file in units of 'even' cycles that will fit in buffer
c
16    idiv = (640/icycl)*icycl-1
      i1 = istm
20    i2 = min0(i1+idiv,iendm)
      nterms = i2 - i1 + 1
      call realio(y,i1,i2,infile,0)
c
c for each 'cycle' grab desired terms
c
      ichan = 1
25    j = 1
      k = 0
      index = idecs(ichan) 
30    k = k+1
      x(k) = y(index)
      j = j+1
      index = idecs(ichan) + (j-1)*icycl
      if (index .le. nterms) goto 30
c
c write to output file for this channel
c
      iterms(ichan) = iterms(ichan) + k
      if (ifiles(ichan) .lt. 0) goto 35
      do 32 i=1,k
      ix(i) = nint(x(i))
32    continue
      call intio(ix,ist(ichan),ist(ichan)+k-1,ifiles(ichan),1)
      goto 36
35    call realio(x,ist(ichan),ist(ichan)+k-1,ifiles(ichan),1)
36    ist(ichan) = ist(ichan)+k
c
c get next channel
c
      ichan = ichan+1
      if (ichan .le. nchans) goto 25
c
c done yet?
c
      if (i2 .ge. iendm) goto 50
      i1 = i2+1
      goto 20
c
c all done; close files and return
c
50    call retnio(infile)
      do 60 i=1,nchans
      call retnio(ifiles(i))
c      write(6,620)         k,ifiles(i)   changed to this (bad) 3/87
      write(6,620) iterms(i),ifiles(i)
620   format(i6,' terms written to file ',i6)
60    continue
c
      return
      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c function filopt uses a file of pointers to indicate selected
c terms. Return value is # of terms written to output file.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      function filopt(infile,ioufil,il)
      dimension ipts(600)
      save ipf,ist,iend
c
c only get input arguments first time thru
      if (il .ne. 1) goto 15
c
10    write(6,700)
700   format(' enter pointer file (integer) number; ',$)
      ipf = ffin(1,not)
      if (ipf .lt. 0) goto 10
c get number of terms in pointer file
      write(6,710)
710   format(' enter pointer file start and end terms; ',$)
      ist = ffin(1,not)
      iend = ffin(1,not)
c
c iout is the output file position pointer
c
15    iout = 1
c
c read pointer file
c
      i1 = ist
20    i2 = min0(i1+599,iend)
      call intio(ipts,i1,i2,ipf,0)
c
c write selected points to output file by first reading the
c selected point from the input file.
c this is conceptually simple but inefficient.
c
      nterms = i2 - i1 + 1
      do 30 i=1,nterms
      call realio(xin,ipts(i),ipts(i),infile,0)
      in = nint(xin) 
      if (ioufil .lt. 0) call realio(xin,iout,iout,ioufil,1)
      if (ioufil .gt. 0) call intio(in,iout,iout,ioufil,1)
      iout = iout+1
30    continue
c
c have we depleted the pointer file yet?
c if yes goto 50
c
      if (i2 .ge. iend) goto 50
      i1 = i2 + 1
      goto 20
c
c all done; close files, compute return value and return
c
50    call retnio(infile)
      call retnio(ioufil)
      filopt = iend - ist + 1.0
c
      return
      end
