      program squash
c
c   goes through a data file and reduces all first differences
c   exceeding a specified value to that value.
c
c   modified to use clipping and handle real files
c   10-16-81  tgm, 10-16-82 dca
c
c   modified to handle 3 options :
c   d - for de-spike, removes single-point spikes of specified height
c       and of specified acceptable difference between two good points
c       which reside on both sides of the spike.
c   f - alter all terms of the first difference series which fall in
c       the specified ranges. currently up to 10 ranges can be input.
c       the first number of the range is the smaller number, if the
c       character i is entered this number will be set to -1.e37. the
c       second number of the range is the larger number, it is set to
c       +1.e37 if i is entered.
c   c - clips the file to be atmost + and - some values. besides the
c       regular reassign option in normal clipping, there are other
c       options within this option which will add or multiply the
c       terms of the series which exceeds the lower and upper bounds
c       by the specified value.
c   both options c and f use the same input format.
c       nguyen-phan-trung, jan 12 1983
c                          feb 11 1983
c     calls intio,realio
c
      dimension ix(60),x(60),df(60),rdata(10,3)
      character*1 ians,not,iopt
      data count,xl,startf,irl/3*0.0,1/
 5    write(6,500)
 500  format('Type c to clip',/,6x,'f to alter first difference',/,
     *6x,'s to show replacement first-diff',/,
     *6x,'d to de-spike',/,' your choice ?; ',$)
      idum = ffin(1,ians)
      if(ians.ne.'c'.and.ians.ne.'f'.and.ians.ne.'d'.and.ians.ne.'s')
     1  go to 5
      write(6,520)
 520  format('Input file and length; ',$)
      ifl = ffin(1,not)
      irntot = ffin(1,not)
      if(irntot.le.0) irntot=longis(ifl)
 10   write(6,540)
 540  format('Output file; ',$)
      ifo = ffin(1,not)
c if overwritting, you don't want to open new output file.
      if(ifo.eq.ifl)go to 11
      if(ifo.lt.0)call realio(x,1,1,ifo,1)
      if(ifo.gt.0)call intio(ix,1,1,ifo,1)
 11   if(ians.eq.'d')go to 140
      write(6,580)
 580  format('How many ranges do you wish to alter?; ',$)
      nrange = ffin(1,not)
      write(6,600)
 600  format('Enter lower limit, upper limit, and correction'
     1,' number for each range:; ')
      do 20 i=1,nrange
 15   write(6,620) i
 620  format('Range ',i2,' :; ',$)
      rdata(i,1)=ffin(1,not)
      if(not.eq.'i') rdata(i,1)=-1.e37
      rdata(i,2)=ffin(1,not)
      if(not.eq.'i') rdata(i,2)=1.e37
      rdata(i,3)=ffin(1,not)
      if(rdata(i,2).lt.rdata(i,1)) write(6,640)
 640  format(' ****upper limit must be greater than or equal
     1 to lower limit****')
      if(rdata(i,2).lt.rdata(i,1)) go to 15
c      write(6,590)rdata(i,1),rdata(i,2),rdata(i,3)
c 590  format(' lower, upper and corr. : ',3e15.5)
 20   continue
      write(6,660)
 660  format('Option (r reassign, a add, m multiply); ',$)
      idum=ffin(1,iopt)
      if(ians.eq.'c')go to 90
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c this section is for altering the first difference series   c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 25   irh = min0(irl+59,irntot)
      nterms = irh - irl + 1
      if(ifl.lt.0)call realio(x,irl,irh,ifl,0)
      if(ifl.lt.0)go to 35
      if(ifl.gt.0)call intio(ix,irl,irh,ifl,0)
      do 30 i=1,nterms
      x(i)=float(ix(i))
 30   continue
 35   df(1) = x(1) - startf
      startf = x(nterms)
      do 40 i = 2,nterms
      df(i) = x(i) - x(i-1)
 40   continue
c checking each term of the first difference series against all given
c ranges, and altering according to specified option when necessary
      do 55 i = 1,nterms
      dft=df(i)
      if(ians.eq.'s')df(i)=0.
      do 50 ir=1,nrange
      if(dft.ge.rdata(ir,1).and.dft.le.rdata(ir,2)) then
        if(iopt.eq.'r')df(i)=rdata(ir,3)
        if(iopt.eq.'a')df(i)=df(i)+rdata(ir,3)
        if(iopt.eq.'m')df(i)=df(i)*rdata(ir,3)
        count = count + 1.0
      endif
 50   continue
 55   continue
c reconstructing the series
      x(1) = xl+df(1)
      do 70 i = 2,nterms
      x(i) = x(i-1) + df(i)
 70   continue
c saving the last term for the next reconstruction
      xl = x(nterms)
c writing to output file
      if(ifo.lt.0)call realio(x,irl,irh,ifo,-1)
      if(ifo.lt.0)go to 85
      do 80 i=1,nterms
      ix(i)=nint(x(i))
 80   continue
      call intio(ix,irl,irh,ifo,-1)
 85   irl = irh + 1
      if(irl.le.irntot) go to 25
      write(6,680) count
 680  format(1x,f8.1,' first differences altered')
      stop
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  this section is for clipping the original data series    c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 90   irh=min0(irl+59,irntot)
      nterms=irh-irl+1
      if(ifl.lt.0)call realio(x,irl,irh,ifl,0)
      if(ifl.lt.0)go to 98
      if(ifl.gt.0)call intio(ix,irl,irh,ifl,0)
      do 95 i=1,nterms
      x(i)=float(ix(i))
 95   continue
 98   do 105 i=1,nterms
      do 100 ir=1,nrange
      if(x(i).lt.rdata(ir,1).or.x(i).gt.rdata(ir,2))go to 100
      if(iopt.eq.'r')x(i)=rdata(ir,3)
      if(iopt.eq.'a')x(i)=x(i)+rdata(ir,3)
      if(iopt.eq.'m')x(i)=x(i)*rdata(ir,3)
      count=count+1.0
 100  continue
 105  continue
      if(ifo.lt.0)call realio(x,irl,irh,ifo,-1)
      if(ifo.lt.0)go to 135
      do 115 i=1,nterms
      ix(i)=nint(x(i))
 115  continue
      call intio(ix,irl,irh,ifo,-1)
 135  irl=irh+1
      if(irl.le.irntot)go to 90
      write(6,690)count
 690  format(' ***> clipping completed,',f7.1,' terms clipped')
      stop
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c this section is for de-spiking the original data series  c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 140  write(6,700)
 700  format(' enter height of smallest spike to be removed :',$)
      spik=ffin(1,not)
      write(6,720)
 720  format(' enter the maximum acceptable difference',/,17x,'
     *between two good points : ',$)
      toler=ffin(1,not)
c getting a buffer of 60 terms of the series
 145  irh=min0(irl+59,irntot)
      nterms=irh-irl+1
      if(ifl.lt.0)call realio(x,irl,irh,ifl,0)
      if(ifl.lt.0)go to 148
      if(ifl.gt.0)call intio(ix,irl,irh,ifl,0)
      do 146 i=1,nterms
      x(i)=float(ix(i))
 146  continue
c replacing the first two terms by the last two of the previous buffer,
c which has been written out. this action has no effect in overwriting case,
c but it is necessary for non-overwriting.
 148  if(irl.gt.1)x(1)=t1
      if(irl.gt.1)x(2)=t2
c looking for spikes.
      do 150 i=1,nterms-2
      t1=abs(x(i+1)-x(i))
      t2=abs(x(i+2)-x(i))
      if(t1.ge.spik.and.t2.le.toler)x(i+1)=(x(i)+x(i+2))/2.0
      if(t1.ge.spik.and.t2.le.toler)count=count+1.0
 150  continue
      if(ifo.lt.0)call realio(x,irl,irh,ifo,-1)
      if(ifo.lt.0)go to 175
      do 160 i=1,nterms
 160  ix(i)=nint(x(i))
      call intio(ix,irl,irh,ifo,-1)
c saving the last two terms for use as the first two of the next buffer.
 175  t1=x(nterms-1)
      t2=x(nterms)
c the first term of the next buffer is the last term of the last buffer
c one removed.
      irl=irh-1
      if((irl+1).lt.irntot)go to 145
      write(6,740)count
 740  format(' ***> de-spike completed,',f7.1,' spikes removed.')
      stop
      end

